<?php
/*
Plugin Name: Restrict Access
Plugin URI: none
Description: This restricts access to entire blog to registered users only AND to certain IP addresses
Author: Bill Bellon
Author URI: http://www.ssec.wisc.edu/~billb/
*/ 

/*---------------------------------------------------------------------------
VERSION 1.1

Notes:
* other resources / ways to do this / plugins:
http://search.wordpress.org/auth_redirect
http://codex.wordpress.org/Function_Reference/get_currentuserinfo
http://blog.taragana.com/index.php/archive/angsumans-authenticated-wordpress-plugin-password-protection-for-your-wordpress-blog/
http://wordpress.org/support/topic/8560
---------------------------------------------------------------------------*/

function restrictAccess() {
  $allowedDomains = array('128.104.108', '128.104.109', '128.104.110', '128.104.111', '144.92.130', '144.92.131', '71.142.210');
//   $allowedDomains = array('128.104.108', '128.104.109', '128.104.110', '144.92.130', '144.92.131');

  //-----------------------------------
  // DETERMINE If IP ADDRESS IS ALLOWED
  //-----------------------------------
  $ip = getenv('REMOTE_ADDR');  
  if ($ip != '') {
    preg_match('/^([0-9]{3}\.[0-9]{2,3}\.[0-9]{3})\.[0-9]{1,3}$/', $ip, $matches);
    if (count($matches) == 2) {
      $domain = $matches[1];
    }  else {
      $domain = 'INVALID_IP';
    }
  } else {
    $domain = 'INVALID_IP';
  }

  //-----------------------------------
  // IF NOT INSIDE SSEC, ASK FOR LOGIN/PASSWORD
  //-----------------------------------
  if ( !in_array($domain, $allowedDomains) ) {
    auth_redirect();
  }

}

/////add_action(wp_head, restrictAccess);
if('wp-login.php' != $pagenow && 'wp-register.php' != $pagenow) add_action('template_redirect', 'restrictAccess');

?>
