<?php
/*
Plugin Name: Restrict Access
Plugin URI: none
Description: This restricts access to entire blog to registered users only AND to certain IP addresses
Author: Bill Bellon
Author URI: http://www.ssec.wisc.edu/~billb/
*/ 

/*---------------------------------------------------------------------------
Notes:
* other resources / ways to do this / plugins:
http://search.wordpress.org/auth_redirect
http://codex.wordpress.org/Function_Reference/get_currentuserinfo
http://blog.taragana.com/index.php/archive/angsumans-authenticated-wordpress-plugin-password-protection-for-your-wordpress-blog/
http://wordpress.org/support/topic/8560
---------------------------------------------------------------------------*/

function restrictAccess() {
/*
  global $user_level;
  global $user_ID; 
  
  $user_data = get_userdata($user_ID);

  if ($user_level == '' || $user_ID == '' || get_userdata($user_ID) == '') {
    echo "<!--redirecting-->\n";
    wp_redirect('wp-login.php');
  }
*/

  $allowedDomains = array('128.104.108', '128.104.109', '128.104.110', '128.104.111', '144.92.130', '144.92.131');

  // determine if IP address is allowed
  $ip = getenv('REMOTE_ADDR');  
  if ($ip != '') {
    preg_match('/^([0-9]{3}\.[0-9]{2,3}\.[0-9]{3})\.[0-9]{1,3}$/', $ip, $matches);
    if (count($matches) == 2) {
      $domain = $matches[1];
    }  else {
      $domain = 'INVALID_IP';
    }
  } else {
    $domain = 'INVALID_IP';
  }

  // if not inside SSEC, ask for login/password
  if ( !in_array($domain, $allowedDomains) ) {
    auth_redirect();
  }

}

add_action(wp_head, restrictAccess);
?>
