-- MySQL dump 10.11
--
-- Host: localhost    Database: goesr_blog
-- ------------------------------------------------------
-- Server version	5.0.77

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `awg_categories`
--

DROP TABLE IF EXISTS `awg_categories`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `awg_categories` (
  `cat_ID` bigint(20) NOT NULL auto_increment,
  `cat_name` varchar(55) NOT NULL default '',
  `category_nicename` varchar(200) NOT NULL default '',
  `category_description` longtext NOT NULL,
  `category_parent` int(4) NOT NULL default '0',
  PRIMARY KEY  (`cat_ID`),
  KEY `category_nicename` (`category_nicename`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `awg_categories`
--

LOCK TABLES `awg_categories` WRITE;
/*!40000 ALTER TABLE `awg_categories` DISABLE KEYS */;
INSERT INTO `awg_categories` VALUES (1,'Uncategorized','uncategorized','',0),(2,'Announcements','announcements','',0);
/*!40000 ALTER TABLE `awg_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `awg_comments`
--

DROP TABLE IF EXISTS `awg_comments`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `awg_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL auto_increment,
  `comment_post_ID` int(11) NOT NULL default '0',
  `comment_author` tinytext NOT NULL,
  `comment_author_email` varchar(100) NOT NULL default '',
  `comment_author_url` varchar(200) NOT NULL default '',
  `comment_author_IP` varchar(100) NOT NULL default '',
  `comment_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL default '0000-00-00 00:00:00',
  `comment_content` text NOT NULL,
  `comment_karma` int(11) NOT NULL default '0',
  `comment_approved` enum('0','1','spam') NOT NULL default '1',
  `comment_agent` varchar(255) NOT NULL default '',
  `comment_type` varchar(20) NOT NULL default '',
  `comment_parent` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`comment_ID`),
  KEY `comment_approved` (`comment_approved`),
  KEY `comment_post_ID` (`comment_post_ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `awg_comments`
--

LOCK TABLES `awg_comments` WRITE;
/*!40000 ALTER TABLE `awg_comments` DISABLE KEYS */;
/*!40000 ALTER TABLE `awg_comments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `awg_linkcategories`
--

DROP TABLE IF EXISTS `awg_linkcategories`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `awg_linkcategories` (
  `cat_id` bigint(20) NOT NULL auto_increment,
  `cat_name` tinytext NOT NULL,
  `auto_toggle` enum('Y','N') NOT NULL default 'N',
  `show_images` enum('Y','N') NOT NULL default 'Y',
  `show_description` enum('Y','N') NOT NULL default 'N',
  `show_rating` enum('Y','N') NOT NULL default 'Y',
  `show_updated` enum('Y','N') NOT NULL default 'Y',
  `sort_order` varchar(64) NOT NULL default 'rand',
  `sort_desc` enum('Y','N') NOT NULL default 'N',
  `text_before_link` varchar(128) NOT NULL default '<li>',
  `text_after_link` varchar(128) NOT NULL default '<br />',
  `text_after_all` varchar(128) NOT NULL default '</li>',
  `list_limit` int(11) NOT NULL default '-1',
  PRIMARY KEY  (`cat_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `awg_linkcategories`
--

LOCK TABLES `awg_linkcategories` WRITE;
/*!40000 ALTER TABLE `awg_linkcategories` DISABLE KEYS */;
INSERT INTO `awg_linkcategories` VALUES (1,'Blogroll','N','Y','N','Y','Y','rand','N','<li>','<br />','</li>',-1),(2,'Other Resources','N','N','N','N','N','name','N','<li>','<br />','</li>',-1),(3,'Mailing Lists','N','N','N','N','N','name','N','<li>','<br />','</li>',-1);
/*!40000 ALTER TABLE `awg_linkcategories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `awg_links`
--

DROP TABLE IF EXISTS `awg_links`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `awg_links` (
  `link_id` bigint(20) NOT NULL auto_increment,
  `link_url` varchar(255) NOT NULL default '',
  `link_name` varchar(255) NOT NULL default '',
  `link_image` varchar(255) NOT NULL default '',
  `link_target` varchar(25) NOT NULL default '',
  `link_category` int(11) NOT NULL default '0',
  `link_description` varchar(255) NOT NULL default '',
  `link_visible` enum('Y','N') NOT NULL default 'Y',
  `link_owner` int(11) NOT NULL default '1',
  `link_rating` int(11) NOT NULL default '0',
  `link_updated` datetime NOT NULL default '0000-00-00 00:00:00',
  `link_rel` varchar(255) NOT NULL default '',
  `link_notes` mediumtext NOT NULL,
  `link_rss` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`link_id`),
  KEY `link_category` (`link_category`),
  KEY `link_visible` (`link_visible`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `awg_links`
--

LOCK TABLES `awg_links` WRITE;
/*!40000 ALTER TABLE `awg_links` DISABLE KEYS */;
INSERT INTO `awg_links` VALUES (10,'http://cimss.ssec.wisc.edu/','CIMSS','','',2,'','Y',1,0,'0000-00-00 00:00:00','','',''),(11,'https://mailserv.ssec.wisc.edu/Lists/goesr_awg_leads/List.html?Language=','AWG Leads','','',3,'AWG Leads Mailing List','Y',1,0,'0000-00-00 00:00:00','','',''),(12,'https://mailserv.ssec.wisc.edu/Lists/goesr_awg/List.html?Language=','AWG','','',3,'AWG Mailing List','Y',1,0,'0000-00-00 00:00:00','','',''),(9,'http://www.ssec.wisc.edu','SSEC','','',2,'','Y',1,0,'0000-00-00 00:00:00','','','');
/*!40000 ALTER TABLE `awg_links` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `awg_options`
--

DROP TABLE IF EXISTS `awg_options`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `awg_options` (
  `option_id` bigint(20) NOT NULL auto_increment,
  `blog_id` int(11) NOT NULL default '0',
  `option_name` varchar(64) NOT NULL default '',
  `option_can_override` enum('Y','N') NOT NULL default 'Y',
  `option_type` int(11) NOT NULL default '1',
  `option_value` longtext NOT NULL,
  `option_width` int(11) NOT NULL default '20',
  `option_height` int(11) NOT NULL default '8',
  `option_description` tinytext NOT NULL,
  `option_admin_level` int(11) NOT NULL default '1',
  `autoload` enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (`option_id`,`blog_id`,`option_name`),
  KEY `option_name` (`option_name`)
) ENGINE=MyISAM AUTO_INCREMENT=72 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `awg_options`
--

LOCK TABLES `awg_options` WRITE;
/*!40000 ALTER TABLE `awg_options` DISABLE KEYS */;
INSERT INTO `awg_options` VALUES (1,0,'siteurl','Y',1,'http://cimss.ssec.wisc.edu/goes_r/awg',20,8,'WordPress web address',1,'yes'),(2,0,'blogname','Y',1,'GOES-R Algorithm Working Group',20,8,'Blog title',1,'yes'),(3,0,'blogdescription','Y',1,'CIMSS GOES-R AWG Activities',20,8,'Short tagline',1,'yes'),(4,0,'new_users_can_blog','Y',1,'0',20,8,'',1,'yes'),(5,0,'users_can_register','Y',1,'',20,8,'',1,'yes'),(6,0,'admin_email','Y',1,'billb@ssec.wisc.edu',20,8,'',1,'yes'),(7,0,'start_of_week','Y',1,'1',20,8,'',1,'yes'),(8,0,'use_balanceTags','Y',1,'1',20,8,'',1,'yes'),(9,0,'use_smilies','Y',1,'1',20,8,'',1,'yes'),(10,0,'require_name_email','Y',1,'1',20,8,'',1,'yes'),(11,0,'comments_notify','Y',1,'1',20,8,'',1,'yes'),(12,0,'posts_per_rss','Y',1,'10',20,8,'',1,'yes'),(13,0,'rss_excerpt_length','Y',1,'50',20,8,'',1,'yes'),(14,0,'rss_use_excerpt','Y',1,'0',20,8,'',1,'yes'),(15,0,'use_fileupload','Y',1,'1',20,8,'',1,'yes'),(16,0,'fileupload_realpath','Y',1,'/var/apache/amrc/htdocs/blog/wp-content',20,8,'',1,'yes'),(17,0,'fileupload_url','Y',1,'http://amrc.ssec.wisc.edu/blog/wp-content',20,8,'',1,'yes'),(18,0,'fileupload_allowedtypes','Y',1,'jpg jpeg gif png php',20,8,'',1,'yes'),(19,0,'fileupload_maxk','Y',1,'300',20,8,'',1,'yes'),(20,0,'fileupload_minlevel','Y',1,'6',20,8,'',1,'yes'),(21,0,'mailserver_url','Y',1,'mail.example.com',20,8,'',1,'yes'),(22,0,'mailserver_login','Y',1,'login@example.com',20,8,'',1,'yes'),(23,0,'mailserver_pass','Y',1,'password',20,8,'',1,'yes'),(24,0,'mailserver_port','Y',1,'110',20,8,'',1,'yes'),(25,0,'default_category','Y',1,'1',20,8,'',1,'yes'),(26,0,'default_comment_status','Y',1,'closed',20,8,'',1,'yes'),(27,0,'default_ping_status','Y',1,'closed',20,8,'',1,'yes'),(28,0,'default_pingback_flag','Y',1,'',20,8,'',1,'yes'),(29,0,'default_post_edit_rows','Y',1,'9',20,8,'',1,'yes'),(30,0,'posts_per_page','Y',1,'10',20,8,'',1,'yes'),(31,0,'what_to_show','Y',1,'posts',20,8,'',1,'yes'),(32,0,'date_format','Y',1,'F j, Y',20,8,'',1,'yes'),(33,0,'time_format','Y',1,'g:i a',20,8,'',1,'yes'),(34,0,'links_updated_date_format','Y',1,'F j, Y g:i a',20,8,'',1,'yes'),(35,0,'links_recently_updated_prepend','Y',1,'<em>',20,8,'',1,'yes'),(36,0,'links_recently_updated_append','Y',1,'</em>',20,8,'',1,'yes'),(37,0,'links_recently_updated_time','Y',1,'120',20,8,'',1,'yes'),(38,0,'comment_moderation','Y',1,'1',20,8,'',1,'yes'),(39,0,'moderation_notify','Y',1,'1',20,8,'',1,'yes'),(40,0,'permalink_structure','Y',1,'/%year%/%monthnum%/%day%/%postname%/',20,8,'',1,'yes'),(41,0,'gzipcompression','Y',1,'0',20,8,'',1,'yes'),(42,0,'hack_file','Y',1,'',20,8,'',1,'yes'),(43,0,'blog_charset','Y',1,'UTF-8',20,8,'',1,'yes'),(44,0,'moderation_keys','Y',1,'',20,8,'',1,'no'),(45,0,'active_plugins','Y',1,'a:4:{i:0;s:0:\"\";i:1;s:33:\"restrictAccess/restrictAccess.php\";i:2;s:17:\"show_overview.php\";i:3;s:25:\"uploadplus/uploadplus.php\";}',20,8,'',1,'yes'),(46,0,'home','Y',1,'http://cimss.ssec.wisc.edu/goes_r/awg',20,8,'',1,'yes'),(47,0,'category_base','Y',1,'',20,8,'',1,'yes'),(48,0,'ping_sites','Y',1,'',20,8,'',1,'yes'),(49,0,'advanced_edit','Y',1,'0',20,8,'',1,'yes'),(50,0,'comment_max_links','Y',1,'2',20,8,'',1,'yes'),(51,0,'default_email_category','Y',1,'1',20,8,'Posts by email go to this category',1,'yes'),(52,0,'recently_edited','Y',1,'a:5:{i:0;s:37:\"wp-content/themes/classic/sidebar.php\";i:2;s:35:\"wp-content/themes/classic/style.css\";i:3;s:36:\"wp-content/themes/goes_r/mystyle.css\";i:4;s:44:\"wp-content/plugins/uploadplus/uploadplus.php\";i:5;s:28:\"wp-content/plugins/hello.php\";}',20,8,'',1,'no'),(53,0,'use_linksupdate','Y',1,'',20,8,'',1,'yes'),(54,0,'template','Y',1,'goes_r',20,8,'',1,'yes'),(55,0,'stylesheet','Y',1,'goes_r',20,8,'',1,'yes'),(56,0,'comment_whitelist','Y',1,'1',20,8,'',1,'yes'),(57,0,'page_uris','Y',1,'a:19:{s:55:\"proxy_awg_project/deliverables/toa-radiances-quicklooks\";s:24:\"toa-radiances-quicklooks\";s:20:\"science-awg/sounding\";s:8:\"sounding\";s:29:\"science-awg/ozone-air-quality\";s:17:\"ozone-air-quality\";s:22:\"science-awg/cryosphere\";s:10:\"cryosphere\";s:19:\"science-awg/aerosol\";s:7:\"aerosol\";s:20:\"science-awg/aviation\";s:8:\"aviation\";s:24:\"science-awg/land-surface\";s:12:\"land-surface\";s:17:\"science-awg/winds\";s:5:\"winds\";s:18:\"science-awg/clouds\";s:6:\"clouds\";s:30:\"proxy_awg_project/deliverables\";s:12:\"deliverables\";s:46:\"proxy_awg_project/satellite-derived-proxy-data\";s:28:\"satellite-derived-proxy-data\";s:40:\"proxy_awg_project/nwp-derived-proxy-data\";s:22:\"nwp-derived-proxy-data\";s:13:\"meeting-notes\";s:13:\"meeting-notes\";s:11:\"science-awg\";s:11:\"science-awg\";s:17:\"proxy_awg_project\";s:17:\"proxy_awg_project\";s:9:\"file-list\";s:9:\"file-list\";s:8:\"overview\";s:8:\"overview\";s:30:\"algorithm-integration-team-awg\";s:30:\"algorithm-integration-team-awg\";s:13:\"geocat-manual\";s:13:\"geocat-manual\";}',20,8,'',1,'yes'),(58,0,'blacklist_keys','Y',1,'',20,8,'',1,'no'),(59,0,'comment_registration','Y',1,'1',20,8,'',1,'yes'),(60,0,'open_proxy_check','Y',1,'1',20,8,'',1,'yes'),(61,0,'rss_language','Y',1,'en',20,8,'',1,'yes'),(62,0,'html_type','Y',1,'text/html',20,8,'',1,'yes'),(63,0,'use_trackback','Y',1,'0',20,8,'',1,'yes'),(64,0,'gmt_offset','Y',1,'-5',20,8,'',1,'yes'),(65,0,'rss_08c28bc54b421e2408f5562f5310d34a','Y',1,'O:9:\"MagpieRSS\":19:{s:6:\"parser\";i:0;s:12:\"current_item\";a:0:{}s:5:\"items\";a:10:{i:0;a:9:{s:5:\"title\";s:46:\"Watch Bolton vs Arsenal Preview and Livestream\";s:6:\"author\";s:17:\"samaddavidbeckham\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/jxsbc02kxss/\";s:4:\"guid\";s:73:\"http://technorati.com/sports/article/watch-bolton-vs-arsenal-preview-and/\";s:11:\"description\";s:129:\"Bolton vs Arsenal, Premier League match<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/jxsbc02kxss\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 12:05:57 +0000\";s:8:\"category\";s:23:\"SportsBolton vs Arsenal\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:73:\"http://technorati.com/sports/article/watch-bolton-vs-arsenal-preview-and/\";}s:7:\"summary\";s:129:\"Bolton vs Arsenal, Premier League match<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/jxsbc02kxss\" height=\"1\" width=\"1\"/>\";}i:1;a:9:{s:5:\"title\";s:40:\"Watch Barcelona vs Osasuna - Live Stream\";s:6:\"author\";s:17:\"samaddavidbeckham\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/sdJyQC_Q-Qc/\";s:4:\"guid\";s:76:\"http://technorati.com/sports/article/watch-barcelona-vs-osasuna-live-stream/\";s:11:\"description\";s:142:\"Spanish League fixture between Barcelona and Osasuna<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/sdJyQC_Q-Qc\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 12:02:38 +0000\";s:8:\"category\";s:26:\"Sportsbarcelona vs Osasuna\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:76:\"http://technorati.com/sports/article/watch-barcelona-vs-osasuna-live-stream/\";}s:7:\"summary\";s:142:\"Spanish League fixture between Barcelona and Osasuna<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/sdJyQC_Q-Qc\" height=\"1\" width=\"1\"/>\";}i:2;a:9:{s:5:\"title\";s:52:\"Valencia vs Real Madrid - Live Stream and Highlights\";s:6:\"author\";s:17:\"samaddavidbeckham\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/NMorDfzNyOA/\";s:4:\"guid\";s:73:\"http://technorati.com/sports/article/valencia-vs-real-madrid-live-stream/\";s:11:\"description\";s:129:\"Valencia vs Real Madrid, Spanish League<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/NMorDfzNyOA\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 12:01:20 +0000\";s:8:\"category\";s:29:\"SportsValencia vs Real Madrid\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:73:\"http://technorati.com/sports/article/valencia-vs-real-madrid-live-stream/\";}s:7:\"summary\";s:129:\"Valencia vs Real Madrid, Spanish League<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/NMorDfzNyOA\" height=\"1\" width=\"1\"/>\";}i:3;a:9:{s:5:\"title\";s:55:\"Chelsea vs West Ham United - Live Stream and Highlights\";s:6:\"author\";s:17:\"samaddavidbeckham\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/iiVXFKFfabU/\";s:4:\"guid\";s:69:\"http://technorati.com/sports/article/chelsea-vs-west-ham-united-live/\";s:11:\"description\";s:154:\"English Premier League match between Chelsea and West Ham Untied<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/iiVXFKFfabU\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 11:59:34 +0000\";s:8:\"category\";s:25:\"SportsChelsea vs west ham\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:69:\"http://technorati.com/sports/article/chelsea-vs-west-ham-united-live/\";}s:7:\"summary\";s:154:\"English Premier League match between Chelsea and West Ham Untied<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/iiVXFKFfabU\" height=\"1\" width=\"1\"/>\";}i:4;a:9:{s:5:\"title\";s:41:\"Liverpool vs Birmingham City - Highlights\";s:6:\"author\";s:17:\"samaddavidbeckham\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/CWDQj8x_lek/\";s:4:\"guid\";s:77:\"http://technorati.com/sports/article/liverpool-vs-birmingham-city-highlights/\";s:11:\"description\";s:151:\"English Premier League match between Liverpool and Birmingham<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/CWDQj8x_lek\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 11:57:26 +0000\";s:8:\"category\";s:29:\"SportsLiverpool vs Birmingham\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:77:\"http://technorati.com/sports/article/liverpool-vs-birmingham-city-highlights/\";}s:7:\"summary\";s:151:\"English Premier League match between Liverpool and Birmingham<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/CWDQj8x_lek\" height=\"1\" width=\"1\"/>\";}i:5;a:9:{s:5:\"title\";s:45:\"Japan Still Reeling from Earthquake Aftermath\";s:6:\"author\";s:7:\"nellisa\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/dEV67-Vqsc0/\";s:4:\"guid\";s:85:\"http://technorati.com/politics/article/japan-still-reeling-from-earthquake-aftermath/\";s:11:\"description\";s:109:\"Where will it end??<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/dEV67-Vqsc0\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 11:56:28 +0000\";s:8:\"category\";s:120:\"PoliticsDaiichiearthquakeevacuee shelterfukushimahomelessjapanJapanese peoplenuclearpower plantradiationsufferingtsunami\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:85:\"http://technorati.com/politics/article/japan-still-reeling-from-earthquake-aftermath/\";}s:7:\"summary\";s:109:\"Where will it end??<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/dEV67-Vqsc0\" height=\"1\" width=\"1\"/>\";}i:6;a:9:{s:5:\"title\";s:41:\"Manchester United vs Everton - Highlights\";s:6:\"author\";s:17:\"samaddavidbeckham\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/jwEG3uvkofA/\";s:4:\"guid\";s:77:\"http://technorati.com/sports/article/manchester-united-vs-everton-highlights/\";s:11:\"description\";s:155:\"English Premier League match between Manchester united vs Everton<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/jwEG3uvkofA\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 11:52:29 +0000\";s:8:\"category\";s:24:\"Sportsman utd vs everton\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:77:\"http://technorati.com/sports/article/manchester-united-vs-everton-highlights/\";}s:7:\"summary\";s:155:\"English Premier League match between Manchester united vs Everton<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/jwEG3uvkofA\" height=\"1\" width=\"1\"/>\";}i:7;a:9:{s:5:\"title\";s:29:\"That\'s it....Enough is Enough\";s:6:\"author\";s:8:\"oalmasri\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/1NI2R0qHE5E/\";s:4:\"guid\";s:64:\"http://technorati.com/politics/article/thats-itenough-is-enough/\";s:11:\"description\";s:120:\"Protests and crisis in Bahrain<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/1NI2R0qHE5E\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 11:51:01 +0000\";s:8:\"category\";s:49:\"Politicsbahraincrisisissuespoliticsprotestssocial\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:64:\"http://technorati.com/politics/article/thats-itenough-is-enough/\";}s:7:\"summary\";s:120:\"Protests and crisis in Bahrain<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/1NI2R0qHE5E\" height=\"1\" width=\"1\"/>\";}i:8;a:9:{s:5:\"title\";s:54:\"The Ongoing Normal: Taxpayer Fraud in L.A. Foster Care\";s:6:\"author\";s:11:\"joshuaallen\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/MMSKD-dD870/\";s:4:\"guid\";s:77:\"http://technorati.com/lifestyle/article/the-ongoing-normal-taxpayer-fraud-in/\";s:11:\"description\";s:244:\"Foster Agency Heads know they can do what they want in Los Angeles, as long as nothing too bad happens to the Abused and Neglected Children in their care.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/MMSKD-dD870\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 11:49:00 +0000\";s:8:\"category\";s:54:\"Lifestylechild abusecorruptioneds-pickfoster carefraud\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:77:\"http://technorati.com/lifestyle/article/the-ongoing-normal-taxpayer-fraud-in/\";}s:7:\"summary\";s:244:\"Foster Agency Heads know they can do what they want in Los Angeles, as long as nothing too bad happens to the Abused and Neglected Children in their care.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/MMSKD-dD870\" height=\"1\" width=\"1\"/>\";}i:9;a:9:{s:5:\"title\";s:40:\"4/20: The Recap of an Unofficial Holiday\";s:6:\"author\";s:13:\"christinevega\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/mKLuyRYH0Ho/\";s:4:\"guid\";s:71:\"http://technorati.com/lifestyle/article/420-the-recap-of-an-unofficial/\";s:11:\"description\";s:377:\"When Mayor Michael Bloomberg asked if he ever tried marijuana, he was pretty blunt: \"You bet I did! And I enjoyed it!\". Pot is the only thing Barack Obama, your classmate, and your hippie grandmother enjoy. Who celebrated 4/20? Christine Vega, resident college journalist, has the scoop!<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/mKLuyRYH0Ho\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 11:39:02 +0000\";s:8:\"category\";s:123:\"Lifestyle4/20cannabiscannabis culturecollegemarijuanamarijuana policy projectMary Janepop-culturepotsnoop-doggWillie Nelson\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:71:\"http://technorati.com/lifestyle/article/420-the-recap-of-an-unofficial/\";}s:7:\"summary\";s:377:\"When Mayor Michael Bloomberg asked if he ever tried marijuana, he was pretty blunt: \"You bet I did! And I enjoyed it!\". Pot is the only thing Barack Obama, your classmate, and your hippie grandmother enjoy. Who celebrated 4/20? Christine Vega, resident college journalist, has the scoop!<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/mKLuyRYH0Ho\" height=\"1\" width=\"1\"/>\";}}s:7:\"channel\";a:9:{s:5:\"title\";s:26:\"All articles at Technorati\";s:4:\"link\";s:22:\"http://technorati.com/\";s:11:\"description\";s:29:\"Bloggers write for Technorati\";s:7:\"pubdate\";s:31:\"Sat, 23 Apr 2011 12:05:57 +0000\";s:9:\"copyright\";s:29:\"Copyright 2011 by the authors\";s:9:\"generator\";s:6:\"Scrive\";s:8:\"language\";s:5:\"en-us\";s:4:\"docs\";s:37:\"http://blogs.law.harvard.edu/tech/rss\";s:7:\"tagline\";s:29:\"Bloggers write for Technorati\";}s:9:\"textinput\";a:0:{}s:5:\"image\";a:0:{}s:9:\"feed_type\";s:3:\"RSS\";s:12:\"feed_version\";s:3:\"2.0\";s:5:\"stack\";a:0:{}s:9:\"inchannel\";b:0;s:6:\"initem\";b:0;s:9:\"incontent\";b:0;s:11:\"intextinput\";b:0;s:7:\"inimage\";b:0;s:13:\"current_field\";s:0:\"\";s:17:\"current_namespace\";b:0;s:19:\"_CONTENT_CONSTRUCTS\";a:6:{i:0;s:7:\"content\";i:1;s:7:\"summary\";i:2;s:4:\"info\";i:3;s:5:\"title\";i:4;s:7:\"tagline\";i:5;s:9:\"copyright\";}s:4:\"etag\";s:29:\"MAe24raRt01UE7bMmlZI+bi/8bk\r\n\";s:13:\"last_modified\";s:31:\"Sat, 23 Apr 2011 15:10:01 GMT\r\n\";}',20,8,'',1,'no'),(66,0,'rss_08c28bc54b421e2408f5562f5310d34a_ts','Y',1,'1303573532',20,8,'',1,'no'),(67,0,'rss_0ff4b43bd116a9d8720d689c80e7dfd4','Y',1,'O:9:\"magpierss\":19:{s:6:\"parser\";i:0;s:12:\"current_item\";a:0:{}s:5:\"items\";a:10:{i:0;a:12:{s:5:\"title\";s:25:\"WordCamp in San Francisco\";s:4:\"link\";s:55:\"http://wordpress.org/development/2006/07/wordcamp-2006/\";s:8:\"comments\";s:64:\"http://wordpress.org/development/2006/07/wordcamp-2006/#comments\";s:7:\"pubdate\";s:31:\"Tue, 11 Jul 2006 07:00:55 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:14:\"EventsWordCamp\";s:4:\"guid\";s:55:\"http://wordpress.org/development/2006/07/wordcamp-2006/\";s:11:\"description\";s:333:\"On August 5th, 2006, we&#8217;re planning a WordPress user conference called WordCamp. The idea is to bring WordPress users and developers so we can meet each other face to face, share stories, and try to figure out the future of our little corner of the online publishing revolution.\nThe conference will be a 1-day event, with [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:1024:\"<p>On August 5th, 2006, we&#8217;re planning a WordPress user conference called <a href=\"http://wordcamp.org/\">WordCamp</a>. The idea is to bring WordPress users and developers so we can meet each other face to face, share stories, and try to figure out the future of our little corner of the online publishing revolution.</p>\n<p>The conference will be a 1-day event, with a party that night, and be free to anyone and everyone. We&#8217;re aiming to do it in the style of BarCamp, so the agenda will be largely determined by you guys. I&#8217;ve posted a <a href=\"http://photomatt.net/2006/07/09/wordcamp/\">little bit more about the ideas behind WordCamp on my blog</a>.</p>\n<p>I know it&#8217;s relatively short notice, especially for folks in other countries, but if you think you can make it or if you just want more information <a href=\"http://wordcamp.org/\">check out WordCamp.org</a>, where we&#8217;ll coordinating the event. I&#8217;m really looking forward to meeting people I interact with online every day.\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:60:\"http://wordpress.org/development/2006/07/wordcamp-2006/feed/\";}s:7:\"summary\";s:333:\"On August 5th, 2006, we&#8217;re planning a WordPress user conference called WordCamp. The idea is to bring WordPress users and developers so we can meet each other face to face, share stories, and try to figure out the future of our little corner of the online publishing revolution.\nThe conference will be a 1-day event, with [...]\";s:12:\"atom_content\";s:1024:\"<p>On August 5th, 2006, we&#8217;re planning a WordPress user conference called <a href=\"http://wordcamp.org/\">WordCamp</a>. The idea is to bring WordPress users and developers so we can meet each other face to face, share stories, and try to figure out the future of our little corner of the online publishing revolution.</p>\n<p>The conference will be a 1-day event, with a party that night, and be free to anyone and everyone. We&#8217;re aiming to do it in the style of BarCamp, so the agenda will be largely determined by you guys. I&#8217;ve posted a <a href=\"http://photomatt.net/2006/07/09/wordcamp/\">little bit more about the ideas behind WordCamp on my blog</a>.</p>\n<p>I know it&#8217;s relatively short notice, especially for folks in other countries, but if you think you can make it or if you just want more information <a href=\"http://wordcamp.org/\">check out WordCamp.org</a>, where we&#8217;ll coordinating the event. I&#8217;m really looking forward to meeting people I interact with online every day.\n</p>\n\";}i:1;a:12:{s:5:\"title\";s:22:\"2.0.4 and 2.1 Bug Hunt\";s:4:\"link\";s:61:\"http://wordpress.org/development/2006/06/204-and-21-bug-hunt/\";s:8:\"comments\";s:70:\"http://wordpress.org/development/2006/06/204-and-21-bug-hunt/#comments\";s:7:\"pubdate\";s:31:\"Thu, 29 Jun 2006 16:43:04 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Ryan\";}s:8:\"category\";s:11:\"Development\";s:4:\"guid\";s:61:\"http://wordpress.org/development/2006/06/204-and-21-bug-hunt/\";s:11:\"description\";s:295:\"Bug Independence Day is July 4th! To help shake the bugs out of the upcoming 2.0.4 and 2.1 releases, we&#39;re holding a Bug Hunt next week.  We&#39;ll be finding and fixing bugs and cleaning up the bug tracker. All are welcome to join us in the #wordpress-bugs IRC channel as we go on the [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:1105:\"<p>Bug Independence Day is July 4th! To help shake the bugs out of the upcoming 2.0.4 and 2.1 releases, we&#39;re holding a <a href=\"http://codex.wordpress.org/WordPress_Bug_Hunts\" title=\"July 5th Bug Hunt\">Bug Hunt</a> next week.  We&#39;ll be finding and fixing bugs and cleaning up the <a href=\"http://trac.wordpress.org/\">bug tracker</a>. All are welcome to join us in the <a href=\"irc://irc.freenode.net/wordpress-bugs\">#wordpress-bugs</a> IRC channel as we go on the hunt.  We&#39;ll get things started <a href=\"http://www.timeanddate.com/worldclock/fixedtime.html?month=7&amp;day=05&amp;year=2006&amp;hour=0&amp;min=0&amp;sec=0&amp;p1=224\">at Midnight between Tuesday, July 4, 2006 and Wednesday, July 5, 2006 San Francisco time</a> and keep going for 24 hours or until everyone gets tired. We&#39;ll have folks keepng vigil at all hours so drop by at whatever time is convenient to you.</p>\n<p>All you need to help out is the ability to install and run WordPress, folks of all skill levels are invited to join. We need people testing as much as we need people coding. (If not a little more.)\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:66:\"http://wordpress.org/development/2006/06/204-and-21-bug-hunt/feed/\";}s:7:\"summary\";s:295:\"Bug Independence Day is July 4th! To help shake the bugs out of the upcoming 2.0.4 and 2.1 releases, we&#39;re holding a Bug Hunt next week.  We&#39;ll be finding and fixing bugs and cleaning up the bug tracker. All are welcome to join us in the #wordpress-bugs IRC channel as we go on the [...]\";s:12:\"atom_content\";s:1105:\"<p>Bug Independence Day is July 4th! To help shake the bugs out of the upcoming 2.0.4 and 2.1 releases, we&#39;re holding a <a href=\"http://codex.wordpress.org/WordPress_Bug_Hunts\" title=\"July 5th Bug Hunt\">Bug Hunt</a> next week.  We&#39;ll be finding and fixing bugs and cleaning up the <a href=\"http://trac.wordpress.org/\">bug tracker</a>. All are welcome to join us in the <a href=\"irc://irc.freenode.net/wordpress-bugs\">#wordpress-bugs</a> IRC channel as we go on the hunt.  We&#39;ll get things started <a href=\"http://www.timeanddate.com/worldclock/fixedtime.html?month=7&amp;day=05&amp;year=2006&amp;hour=0&amp;min=0&amp;sec=0&amp;p1=224\">at Midnight between Tuesday, July 4, 2006 and Wednesday, July 5, 2006 San Francisco time</a> and keep going for 24 hours or until everyone gets tired. We&#39;ll have folks keepng vigil at all hours so drop by at whatever time is convenient to you.</p>\n<p>All you need to help out is the ability to install and run WordPress, folks of all skill levels are invited to join. We need people testing as much as we need people coding. (If not a little more.)\n</p>\n\";}i:2;a:12:{s:5:\"title\";s:15:\"WordPress 2.0.3\";s:4:\"link\";s:55:\"http://wordpress.org/development/2006/06/wordpress-203/\";s:8:\"comments\";s:64:\"http://wordpress.org/development/2006/06/wordpress-203/#comments\";s:7:\"pubdate\";s:31:\"Thu, 01 Jun 2006 07:49:38 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:11:\"Development\";s:4:\"guid\";s:55:\"http://wordpress.org/development/2006/06/wordpress-203/\";s:11:\"description\";s:321:\"The latest in the stable 2.0 series, 2.0.3, is now available for download. This is a bug fix and security release, and is recommended for all WordPress users. In addition to an issue that was raised on Bugtraq a few days ago, we&#8217;ve also backported a number of security enhancements from 2.1 to further enhance [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:886:\"<p>The latest in the stable 2.0 series, 2.0.3, <a href=\"http://wordpress.org/download/\">is now available for download</a>. This is a bug fix and security release, and is recommended for all WordPress users. In addition to an issue that was raised on Bugtraq a few days ago, we&#8217;ve also backported a number of security enhancements from 2.1 to further enhance and protect your blog.</p>\n<p>For the curious, this <a href=\"http://trac.wordpress.org/query?status=closed&#038;milestone=2.0.3\">release includes</a>:</p>\n<ul>\n<li>Small performance enhancements</li>\n<li>Movable Type / Typepad importer fix</li>\n<li>Enclosure (podcasting) fix</li>\n<li>The aforementioned security enhancements (nonces)</li>\n</ul>\n<p>Upgrading is fairly simple, just overwrite your old files with the latest from the download. When you go to your admin it will give you a link to update your database.\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:60:\"http://wordpress.org/development/2006/06/wordpress-203/feed/\";}s:7:\"summary\";s:321:\"The latest in the stable 2.0 series, 2.0.3, is now available for download. This is a bug fix and security release, and is recommended for all WordPress users. In addition to an issue that was raised on Bugtraq a few days ago, we&#8217;ve also backported a number of security enhancements from 2.1 to further enhance [...]\";s:12:\"atom_content\";s:886:\"<p>The latest in the stable 2.0 series, 2.0.3, <a href=\"http://wordpress.org/download/\">is now available for download</a>. This is a bug fix and security release, and is recommended for all WordPress users. In addition to an issue that was raised on Bugtraq a few days ago, we&#8217;ve also backported a number of security enhancements from 2.1 to further enhance and protect your blog.</p>\n<p>For the curious, this <a href=\"http://trac.wordpress.org/query?status=closed&#038;milestone=2.0.3\">release includes</a>:</p>\n<ul>\n<li>Small performance enhancements</li>\n<li>Movable Type / Typepad importer fix</li>\n<li>Enclosure (podcasting) fix</li>\n<li>The aforementioned security enhancements (nonces)</li>\n</ul>\n<p>Upgrading is fairly simple, just overwrite your old files with the latest from the download. When you go to your admin it will give you a link to update your database.\n</p>\n\";}i:3;a:12:{s:5:\"title\";s:26:\"WordPattern (April Fools!)\";s:4:\"link\";s:53:\"http://wordpress.org/development/2006/04/wordpattern/\";s:8:\"comments\";s:62:\"http://wordpress.org/development/2006/04/wordpattern/#comments\";s:7:\"pubdate\";s:31:\"Sat, 01 Apr 2006 16:22:38 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:19:\"DevelopmentReleases\";s:4:\"guid\";s:53:\"http://wordpress.org/development/2006/04/wordpattern/\";s:11:\"description\";s:377:\"On behalf of the WordPress community, I&#8217;m proud to announce a merger we&#8217;ve had on our minds since the first time we saw Dean Allen&#8217;s dog &#8212; WordPress and Textpattern are joining forces to create the greatest CMSMS ever, WordPattern. &#8220;WordPress and Textpattern: Two great tastes that taste great together.&#8221;\nAs with any great union, there [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:1008:\"<p>On behalf of the WordPress community, I&#8217;m proud to announce a merger we&#8217;ve had on our minds since <a href=\"http://textism.com/oliver/daily/\">the first time we saw Dean Allen&#8217;s dog</a> &#8212; WordPress and Textpattern are joining forces to create the greatest CMSMS ever, <a href=\"http://wordpattern.org/\">WordPattern</a>. &#8220;WordPress and Textpattern: Two great tastes that taste great together.&#8221;</p>\n<p>As with any great union, there were compromises involved. &#8220;I&#8217;m going all-Georgia, all the time. And blue is the new yellow.&#8221; said Dean Allen. Matt Mullenweg mused &#8220;Ten custom fields should be enough for anybody!&#8221;</p>\n<p>We have a list of <a href=\"http://wordpattern.org/features\">new features</a>, <a href=\"http://wordpattern.org/download\">downloads</a>, and <a href=\"http://wordpattern.org/\">much more available on WordPattern.org</a>. Our respective websites are being decommisioned so it&#8217;s best to go there for new information.\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:58:\"http://wordpress.org/development/2006/04/wordpattern/feed/\";}s:7:\"summary\";s:377:\"On behalf of the WordPress community, I&#8217;m proud to announce a merger we&#8217;ve had on our minds since the first time we saw Dean Allen&#8217;s dog &#8212; WordPress and Textpattern are joining forces to create the greatest CMSMS ever, WordPattern. &#8220;WordPress and Textpattern: Two great tastes that taste great together.&#8221;\nAs with any great union, there [...]\";s:12:\"atom_content\";s:1008:\"<p>On behalf of the WordPress community, I&#8217;m proud to announce a merger we&#8217;ve had on our minds since <a href=\"http://textism.com/oliver/daily/\">the first time we saw Dean Allen&#8217;s dog</a> &#8212; WordPress and Textpattern are joining forces to create the greatest CMSMS ever, <a href=\"http://wordpattern.org/\">WordPattern</a>. &#8220;WordPress and Textpattern: Two great tastes that taste great together.&#8221;</p>\n<p>As with any great union, there were compromises involved. &#8220;I&#8217;m going all-Georgia, all the time. And blue is the new yellow.&#8221; said Dean Allen. Matt Mullenweg mused &#8220;Ten custom fields should be enough for anybody!&#8221;</p>\n<p>We have a list of <a href=\"http://wordpattern.org/features\">new features</a>, <a href=\"http://wordpattern.org/download\">downloads</a>, and <a href=\"http://wordpattern.org/\">much more available on WordPattern.org</a>. Our respective websites are being decommisioned so it&#8217;s best to go there for new information.\n</p>\n\";}i:4;a:12:{s:5:\"title\";s:14:\"Widgets Plugin\";s:4:\"link\";s:56:\"http://wordpress.org/development/2006/03/widgets-plugin/\";s:8:\"comments\";s:65:\"http://wordpress.org/development/2006/03/widgets-plugin/#comments\";s:7:\"pubdate\";s:31:\"Wed, 29 Mar 2006 14:31:35 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:18:\"DevelopmentWidgets\";s:4:\"guid\";s:56:\"http://wordpress.org/development/2006/03/widgets-plugin/\";s:11:\"description\";s:326:\"Widgets are an easy way for you to arrange and rearrange your sidebar to your hearts content without touching a line of code. We first launched WordPress Widgets (WPW) it on WordPress.com a month ago and the response was great. Now we&#8217;re ready to release the plugin to the world. If adoption goes well, we&#8217;ll [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:1589:\"<p><a href=\"http://automattic.com/code/widgets/\">Widgets</a> are an easy way for you to arrange and rearrange your sidebar to your hearts content without touching a line of code. We first launched WordPress Widgets (WPW) it on WordPress.com a month ago and <a href=\"http://wordpress.com/blog/2006/02/25/wordpress-widgets/\">the response</a> <a href=\"http://wordpress.com/blog/2006/03/07/recent-widgets/\">was</a> <a href=\"http://wordpress.com/blog/2006/03/10/more-widgets/\">great</a>. Now we&#8217;re ready to release the plugin to the world. If adoption goes well, we&#8217;ll consider rolling it into the next version of WordPress.</p>\n<p>You can find out more information and <a href=\"http://automattic.com/code/widgets/\">download the plugin on the new Widgets page</a>.</p>\n<p>If you&#8217;re a developer, writing a WordPress Widget is <a href=\"http://markjaquith.wordpress.com/2006/03/04/wp-tutorial-your-first-wp-plugin/\">as easy as a plugin</a> and we&#8217;ve even <a href=\"http://automattic.com/code/widgets/api/\">documented all the APIs for you</a>, as well as including guides for <a href=\"http://automattic.com/code/widgets/themes/\">theme authors</a> and <a href=\"http://automattic.com/code/widgets/plugins/\">current plugin authors</a>.</p>\n<p><strong>What&#8217;s the potential audience for widgets?</strong> In addition to the <strong>130,000+</strong> blogs on WordPress.com, you have the potential to tap in to the <strong>5,000</strong> people downloading WordPress every single day and the <strong>hundreds of thousands</strong> of existing WordPress blogs out there.\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:61:\"http://wordpress.org/development/2006/03/widgets-plugin/feed/\";}s:7:\"summary\";s:326:\"Widgets are an easy way for you to arrange and rearrange your sidebar to your hearts content without touching a line of code. We first launched WordPress Widgets (WPW) it on WordPress.com a month ago and the response was great. Now we&#8217;re ready to release the plugin to the world. If adoption goes well, we&#8217;ll [...]\";s:12:\"atom_content\";s:1589:\"<p><a href=\"http://automattic.com/code/widgets/\">Widgets</a> are an easy way for you to arrange and rearrange your sidebar to your hearts content without touching a line of code. We first launched WordPress Widgets (WPW) it on WordPress.com a month ago and <a href=\"http://wordpress.com/blog/2006/02/25/wordpress-widgets/\">the response</a> <a href=\"http://wordpress.com/blog/2006/03/07/recent-widgets/\">was</a> <a href=\"http://wordpress.com/blog/2006/03/10/more-widgets/\">great</a>. Now we&#8217;re ready to release the plugin to the world. If adoption goes well, we&#8217;ll consider rolling it into the next version of WordPress.</p>\n<p>You can find out more information and <a href=\"http://automattic.com/code/widgets/\">download the plugin on the new Widgets page</a>.</p>\n<p>If you&#8217;re a developer, writing a WordPress Widget is <a href=\"http://markjaquith.wordpress.com/2006/03/04/wp-tutorial-your-first-wp-plugin/\">as easy as a plugin</a> and we&#8217;ve even <a href=\"http://automattic.com/code/widgets/api/\">documented all the APIs for you</a>, as well as including guides for <a href=\"http://automattic.com/code/widgets/themes/\">theme authors</a> and <a href=\"http://automattic.com/code/widgets/plugins/\">current plugin authors</a>.</p>\n<p><strong>What&#8217;s the potential audience for widgets?</strong> In addition to the <strong>130,000+</strong> blogs on WordPress.com, you have the potential to tap in to the <strong>5,000</strong> people downloading WordPress every single day and the <strong>hundreds of thousands</strong> of existing WordPress blogs out there.\n</p>\n\";}i:5;a:12:{s:5:\"title\";s:22:\"2.0.2 Security Release\";s:4:\"link\";s:54:\"http://wordpress.org/development/2006/03/security-202/\";s:8:\"comments\";s:63:\"http://wordpress.org/development/2006/03/security-202/#comments\";s:7:\"pubdate\";s:31:\"Fri, 10 Mar 2006 06:43:52 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:19:\"DevelopmentReleases\";s:4:\"guid\";s:54:\"http://wordpress.org/development/2006/03/security-202/\";s:11:\"description\";s:360:\"An important security issue has been brought to the attention of the WordPress team and we have worked diligently to bring you a new stable release that addresses it. Our latest version 2.0.2 contains several bugfixes and security fixes.\nThe problems addressed are unannounced XSS issues privately discovered and reported to the WordPress team. Thanks to [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:1054:\"<p>An important security issue has been brought to the attention of the WordPress team and we have worked diligently to bring you a new stable release that addresses it. Our <a href=\"http://wordpress.org/download/\">latest version 2.0.2</a> contains several bugfixes and security fixes.</p>\n<p>The problems addressed are unannounced XSS issues privately discovered and reported to the WordPress team. Thanks to Michael Boman, Mark Jaquith, Robert Deaton, and David House for assisting with this release.</p>\n<p>Just a quick note: this is different than the snake-oil reports that went out on some security lists a few days ago. There were a couple, but they were either not actual security problems, too small to warrant a release, or just patently false. Remember: just because you read it on a mailing list doesn&#8217;t mean that it&#8217;s true. We&#8217;d be the first people to panic if there was an actual problem.</p>\n<p>As always, when something serious crosses our desks we jump on it and get a well-tested release out as soon as possible.\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:59:\"http://wordpress.org/development/2006/03/security-202/feed/\";}s:7:\"summary\";s:360:\"An important security issue has been brought to the attention of the WordPress team and we have worked diligently to bring you a new stable release that addresses it. Our latest version 2.0.2 contains several bugfixes and security fixes.\nThe problems addressed are unannounced XSS issues privately discovered and reported to the WordPress team. Thanks to [...]\";s:12:\"atom_content\";s:1054:\"<p>An important security issue has been brought to the attention of the WordPress team and we have worked diligently to bring you a new stable release that addresses it. Our <a href=\"http://wordpress.org/download/\">latest version 2.0.2</a> contains several bugfixes and security fixes.</p>\n<p>The problems addressed are unannounced XSS issues privately discovered and reported to the WordPress team. Thanks to Michael Boman, Mark Jaquith, Robert Deaton, and David House for assisting with this release.</p>\n<p>Just a quick note: this is different than the snake-oil reports that went out on some security lists a few days ago. There were a couple, but they were either not actual security problems, too small to warrant a release, or just patently false. Remember: just because you read it on a mailing list doesn&#8217;t mean that it&#8217;s true. We&#8217;d be the first people to panic if there was an actual problem.</p>\n<p>As always, when something serious crosses our desks we jump on it and get a well-tested release out as soon as possible.\n</p>\n\";}i:6;a:12:{s:5:\"title\";s:13:\"2.0.1 Release\";s:4:\"link\";s:53:\"http://wordpress.org/development/2006/01/201-release/\";s:8:\"comments\";s:62:\"http://wordpress.org/development/2006/01/201-release/#comments\";s:7:\"pubdate\";s:31:\"Tue, 31 Jan 2006 21:10:40 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:8:\"Releases\";s:4:\"guid\";s:53:\"http://wordpress.org/development/2006/01/201-release/\";s:11:\"description\";s:370:\"It&#8217;s been exactly one month since we released the well-received WordPress 2.0 release. In the past 4 weeks we&#8217;ve been listening closely to feedback, squashing bugs wherever we find them, and watching how 2.0 handled under different loads.\nWe&#8217;ve rolled up all the most important fixes into a 2.0.1 release, which is now available for download.\nAll [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:1182:\"<p>It&#8217;s been exactly one month since we released <a href=\"http://wordpress.org/development/2005/12/wp2/\">the well-received WordPress 2.0 release</a>. In the past 4 weeks we&#8217;ve been listening closely to feedback, squashing bugs wherever we find them, and watching how 2.0 handled under different loads.</p>\n<p>We&#8217;ve rolled up all the most important fixes into a 2.0.1 release, <a href=\"http://wordpress.org/download/\">which is now available for download</a>.<br />\nAll in all <a href=\"http://trac.wordpress.org/milestone/2.0.1\">we&#8217;ve closed 114 bugs in the 2.0.1 release</a>, which you&#8217;re welcome to check out if you&#8217;re curious about every fix. To summarize:</p>\n<ul>\n<li>You can now specify an upload directory, and whether to use date-based storage or not.</li>\n<li>Caching has been fixed under certain PHP enviroments.</li>\n<li>Permalinks have been fixed for weird enviroments as well.</li>\n<li>XML-RPC uploading works.</li>\n<li>Compatibility with older versions of PHP.</li>\n<li>Several WYSIWYG fixes and cleanups.</li>\n<li>Imports now use much less memory.</li>\n<li>Now works with MySQL 5.0 in strict mode.</li>\n</ul>\n<p>Happy blogging!\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:58:\"http://wordpress.org/development/2006/01/201-release/feed/\";}s:7:\"summary\";s:370:\"It&#8217;s been exactly one month since we released the well-received WordPress 2.0 release. In the past 4 weeks we&#8217;ve been listening closely to feedback, squashing bugs wherever we find them, and watching how 2.0 handled under different loads.\nWe&#8217;ve rolled up all the most important fixes into a 2.0.1 release, which is now available for download.\nAll [...]\";s:12:\"atom_content\";s:1182:\"<p>It&#8217;s been exactly one month since we released <a href=\"http://wordpress.org/development/2005/12/wp2/\">the well-received WordPress 2.0 release</a>. In the past 4 weeks we&#8217;ve been listening closely to feedback, squashing bugs wherever we find them, and watching how 2.0 handled under different loads.</p>\n<p>We&#8217;ve rolled up all the most important fixes into a 2.0.1 release, <a href=\"http://wordpress.org/download/\">which is now available for download</a>.<br />\nAll in all <a href=\"http://trac.wordpress.org/milestone/2.0.1\">we&#8217;ve closed 114 bugs in the 2.0.1 release</a>, which you&#8217;re welcome to check out if you&#8217;re curious about every fix. To summarize:</p>\n<ul>\n<li>You can now specify an upload directory, and whether to use date-based storage or not.</li>\n<li>Caching has been fixed under certain PHP enviroments.</li>\n<li>Permalinks have been fixed for weird enviroments as well.</li>\n<li>XML-RPC uploading works.</li>\n<li>Compatibility with older versions of PHP.</li>\n<li>Several WYSIWYG fixes and cleanups.</li>\n<li>Imports now use much less memory.</li>\n<li>Now works with MySQL 5.0 in strict mode.</li>\n</ul>\n<p>Happy blogging!\n</p>\n\";}i:7;a:12:{s:5:\"title\";s:20:\"Help Out Development\";s:4:\"link\";s:50:\"http://wordpress.org/development/2006/01/help-out/\";s:8:\"comments\";s:59:\"http://wordpress.org/development/2006/01/help-out/#comments\";s:7:\"pubdate\";s:31:\"Thu, 19 Jan 2006 21:28:08 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:11:\"Development\";s:4:\"guid\";s:50:\"http://wordpress.org/development/2006/01/help-out/\";s:11:\"description\";s:343:\"Behind the scenes of WordPress there are dozens of people spending hundreds of hours a week keeping the WordPress community humming. There are many ways to contribute to WordPress but following the 2.0 release a lot more emphasis has been placed on the development and testing side.\nWe recently decided to split WordPress up into logical [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:811:\"<p>Behind the scenes of WordPress there are dozens of people spending hundreds of hours a week keeping the WordPress community humming. There are many ways <a href=\"http://codex.wordpress.org/Contributing_to_WordPress\">to contribute to WordPress</a> but following the 2.0 release a lot more emphasis has been placed on the development and testing side.</p>\n<p>We recently decided to split WordPress up into logical divisions and allow people to volunteer to help out with particular sections, be it as an organizer, a tester, or a coder. <a href=\"http://codex.wordpress.org/User:Matt/WordPress_Responsibilities\">You can view the various sections and sign up to help with one on the Codex</a>. In a week we&#8217;ll begin contacting the various rockstars who volunteer to coordinate and organize everybody.\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:55:\"http://wordpress.org/development/2006/01/help-out/feed/\";}s:7:\"summary\";s:343:\"Behind the scenes of WordPress there are dozens of people spending hundreds of hours a week keeping the WordPress community humming. There are many ways to contribute to WordPress but following the 2.0 release a lot more emphasis has been placed on the development and testing side.\nWe recently decided to split WordPress up into logical [...]\";s:12:\"atom_content\";s:811:\"<p>Behind the scenes of WordPress there are dozens of people spending hundreds of hours a week keeping the WordPress community humming. There are many ways <a href=\"http://codex.wordpress.org/Contributing_to_WordPress\">to contribute to WordPress</a> but following the 2.0 release a lot more emphasis has been placed on the development and testing side.</p>\n<p>We recently decided to split WordPress up into logical divisions and allow people to volunteer to help out with particular sections, be it as an organizer, a tester, or a coder. <a href=\"http://codex.wordpress.org/User:Matt/WordPress_Responsibilities\">You can view the various sections and sign up to help with one on the Codex</a>. In a week we&#8217;ll begin contacting the various rockstars who volunteer to coordinate and organize everybody.\n</p>\n\";}i:8;a:12:{s:5:\"title\";s:11:\"WordPress 2\";s:4:\"link\";s:45:\"http://wordpress.org/development/2005/12/wp2/\";s:8:\"comments\";s:54:\"http://wordpress.org/development/2005/12/wp2/#comments\";s:7:\"pubdate\";s:31:\"Sat, 31 Dec 2005 00:47:10 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:19:\"DevelopmentReleases\";s:4:\"guid\";s:45:\"http://wordpress.org/development/2005/12/wp2/\";s:11:\"description\";s:302:\"The WordPress community is very proud to present the next generation of WordPress to the   world, our 2.0 &#8220;Duke&#8221; release, named in honor of jazz pianist and composer Duke Ellington.   We&#8217;ve been working long and hard to bring you this release, and I hope you enjoy using it as   [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:1273:\"<p>The WordPress community is very proud to present the next generation of WordPress to the   world, our 2.0 &#8220;Duke&#8221; release, named in honor of jazz pianist and composer <a href=\"http://www.dukeellington.com/\">Duke Ellington</a>.   We&#8217;ve been working long and hard to bring you this release, and I hope you enjoy using it as   much as we&#8217;e enjoyed working on it. In this release we&#8217;ve focused a tremendous amount on what   we believe to be the core of blogging &#8212; the writing interface.  Before you upgrade from an earlier version, remember that this is a major release and   thousands of lines of code have changed. Before upgrading it&#8217;s always good, <em>just in   case</em>, to make a backup of your database and WordPress files. It only takes a few minutes   and gives you a total safety net if for whatever reason things don&#8217;t work. It is also probably   a good idea to turn off your plugins, and activate them one-by-one after you&#8217;ve upgraded.   Without further ado, you can <a href=\"http://wordpress.org/download/\">download WordPress 2   right now</a>. Read on for more information about what we think you&#8217;ll love about Duke.</p>\n<p> <a href=\"http://wordpress.org/development/2005/12/wp2/#more-177\"></a>\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:50:\"http://wordpress.org/development/2005/12/wp2/feed/\";}s:7:\"summary\";s:302:\"The WordPress community is very proud to present the next generation of WordPress to the   world, our 2.0 &#8220;Duke&#8221; release, named in honor of jazz pianist and composer Duke Ellington.   We&#8217;ve been working long and hard to bring you this release, and I hope you enjoy using it as   [...]\";s:12:\"atom_content\";s:1273:\"<p>The WordPress community is very proud to present the next generation of WordPress to the   world, our 2.0 &#8220;Duke&#8221; release, named in honor of jazz pianist and composer <a href=\"http://www.dukeellington.com/\">Duke Ellington</a>.   We&#8217;ve been working long and hard to bring you this release, and I hope you enjoy using it as   much as we&#8217;e enjoyed working on it. In this release we&#8217;ve focused a tremendous amount on what   we believe to be the core of blogging &#8212; the writing interface.  Before you upgrade from an earlier version, remember that this is a major release and   thousands of lines of code have changed. Before upgrading it&#8217;s always good, <em>just in   case</em>, to make a backup of your database and WordPress files. It only takes a few minutes   and gives you a total safety net if for whatever reason things don&#8217;t work. It is also probably   a good idea to turn off your plugins, and activate them one-by-one after you&#8217;ve upgraded.   Without further ado, you can <a href=\"http://wordpress.org/download/\">download WordPress 2   right now</a>. Read on for more information about what we think you&#8217;ll love about Duke.</p>\n<p> <a href=\"http://wordpress.org/development/2005/12/wp2/#more-177\"></a>\n</p>\n\";}i:9;a:12:{s:5:\"title\";s:18:\"WordPress on Yahoo\";s:4:\"link\";s:60:\"http://wordpress.org/development/2005/12/wordpress-on-yahoo/\";s:8:\"comments\";s:69:\"http://wordpress.org/development/2005/12/wordpress-on-yahoo/#comments\";s:7:\"pubdate\";s:31:\"Tue, 20 Dec 2005 17:53:06 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:18:\"DevelopmentHosting\";s:4:\"guid\";s:60:\"http://wordpress.org/development/2005/12/wordpress-on-yahoo/\";s:11:\"description\";s:328:\"As many of you know, we&#8217;re constantly tweaking and updating our web hosting page based on feedback we get from you. Well today we&#8217;re very excited to announce we&#8217;re adding a new host to the page with a familiar name - Yahoo! We&#8217;ve been working with the Yahoo Small Business team to create a solution [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:2569:\"<p>As many of you know, we&#8217;re constantly tweaking and updating our <a href=\"http://wordpress.org/hosting/\">web hosting page</a> based on feedback we get from you. Well today we&#8217;re very excited to announce we&#8217;re adding a new host to the page with a familiar name - <a href=\"http://yahoo.com/\">Yahoo!</a> We&#8217;ve been working with the Yahoo Small Business team to create a solution that gives professional bloggers exactly what they want from their hosting providers.</p>\n<p>When we started, Yahoo asked &#8220;What would the perfect blog host do?&#8221; and their team has been really amazing in executing on a really kick-ass platform for serious bloggers. It took a little while, but slow cooking makes good eating. (Like WordPress 2.0!)</p>\n<p>We think the hosting is good for all the baseline features you should expect &#8212; tons of storage, bandwidth, Yahoo reliability, etc. (You probably heard all about that in their <a href=\"http://www.siliconbeat.com/entries/2005/12/12/six_aparts_scores_deal_with_yahoo.html\">Movable Type announcement last week</a>.) However we think they&#8217;re worth featuring because of three key things:</p>\n<ul>\n<li>With just a few clicks, <a href=\"http://www.tkqlhce.com/click-1876573-10406412\">Yahoo Web Hosting will install WordPress 2.0 complete with a few choice plugins and themes</a>. Setup one blog or two dozen in seconds.</li>\n<li><strong>They will also upgrade your WordPress </strong>when a new stable release or update is available, meaning it is a zero-maintenance solution on par with <a href=\"http://wordpress.com/\">WordPress.com</a>.</li>\n<li>Finally, every Yahoo Hosting customer gets a free <a href=\"http://akismet.com/\">Pro-Blogger Akismet license</a> ($5/mo value) and Akismet is auto-enabled on new installations, meaning that spam is less of an issue on Yahoo WordPress blogs.  (Much like their stellar email spam handling.) <a href=\"http://akismet.com/blog/2005/12/yodel-if-you-hate-spam/\">Read more about this</a>.</li>\n</ul>\n<p>Guy Yalif from Yahoo says, &#8220;We believe that by adding WordPress&#8217; blogging application to our leading web hosting product, we are providing a top notch, scalable, and reliable solution for less than $12 per month.&#8221;</p>\n<p>We think the above makes a very compelling case for WordPress users <a href=\"http://wordpress.org/hosting/\">to check out Yahoo hosting</a>, and see what we believe is the best WordPress hosting experience on the Web. As always, if you have any feedback on Yahoo or any other host we feature, please let us know.\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:65:\"http://wordpress.org/development/2005/12/wordpress-on-yahoo/feed/\";}s:7:\"summary\";s:328:\"As many of you know, we&#8217;re constantly tweaking and updating our web hosting page based on feedback we get from you. Well today we&#8217;re very excited to announce we&#8217;re adding a new host to the page with a familiar name - Yahoo! We&#8217;ve been working with the Yahoo Small Business team to create a solution [...]\";s:12:\"atom_content\";s:2569:\"<p>As many of you know, we&#8217;re constantly tweaking and updating our <a href=\"http://wordpress.org/hosting/\">web hosting page</a> based on feedback we get from you. Well today we&#8217;re very excited to announce we&#8217;re adding a new host to the page with a familiar name - <a href=\"http://yahoo.com/\">Yahoo!</a> We&#8217;ve been working with the Yahoo Small Business team to create a solution that gives professional bloggers exactly what they want from their hosting providers.</p>\n<p>When we started, Yahoo asked &#8220;What would the perfect blog host do?&#8221; and their team has been really amazing in executing on a really kick-ass platform for serious bloggers. It took a little while, but slow cooking makes good eating. (Like WordPress 2.0!)</p>\n<p>We think the hosting is good for all the baseline features you should expect &#8212; tons of storage, bandwidth, Yahoo reliability, etc. (You probably heard all about that in their <a href=\"http://www.siliconbeat.com/entries/2005/12/12/six_aparts_scores_deal_with_yahoo.html\">Movable Type announcement last week</a>.) However we think they&#8217;re worth featuring because of three key things:</p>\n<ul>\n<li>With just a few clicks, <a href=\"http://www.tkqlhce.com/click-1876573-10406412\">Yahoo Web Hosting will install WordPress 2.0 complete with a few choice plugins and themes</a>. Setup one blog or two dozen in seconds.</li>\n<li><strong>They will also upgrade your WordPress </strong>when a new stable release or update is available, meaning it is a zero-maintenance solution on par with <a href=\"http://wordpress.com/\">WordPress.com</a>.</li>\n<li>Finally, every Yahoo Hosting customer gets a free <a href=\"http://akismet.com/\">Pro-Blogger Akismet license</a> ($5/mo value) and Akismet is auto-enabled on new installations, meaning that spam is less of an issue on Yahoo WordPress blogs.  (Much like their stellar email spam handling.) <a href=\"http://akismet.com/blog/2005/12/yodel-if-you-hate-spam/\">Read more about this</a>.</li>\n</ul>\n<p>Guy Yalif from Yahoo says, &#8220;We believe that by adding WordPress&#8217; blogging application to our leading web hosting product, we are providing a top notch, scalable, and reliable solution for less than $12 per month.&#8221;</p>\n<p>We think the above makes a very compelling case for WordPress users <a href=\"http://wordpress.org/hosting/\">to check out Yahoo hosting</a>, and see what we believe is the best WordPress hosting experience on the Web. As always, if you have any feedback on Yahoo or any other host we feature, please let us know.\n</p>\n\";}}s:7:\"channel\";a:7:{s:5:\"title\";s:26:\"WordPress Development Blog\";s:4:\"link\";s:32:\"http://wordpress.org/development\";s:11:\"description\";s:33:\"WordPress development and updates\";s:7:\"pubdate\";s:31:\"Tue, 11 Jul 2006 07:00:55 +0000\";s:9:\"generator\";s:34:\"http://wordpress.org/?v=2.1-alpha2\";s:8:\"language\";s:2:\"en\";s:7:\"tagline\";s:33:\"WordPress development and updates\";}s:9:\"textinput\";a:0:{}s:5:\"image\";a:0:{}s:9:\"feed_type\";s:3:\"RSS\";s:12:\"feed_version\";s:3:\"2.0\";s:5:\"stack\";a:0:{}s:9:\"inchannel\";b:0;s:6:\"initem\";b:0;s:9:\"incontent\";b:0;s:11:\"intextinput\";b:0;s:7:\"inimage\";b:0;s:13:\"current_field\";s:0:\"\";s:17:\"current_namespace\";b:0;s:19:\"_CONTENT_CONSTRUCTS\";a:6:{i:0;s:7:\"content\";i:1;s:7:\"summary\";i:2;s:4:\"info\";i:3;s:5:\"title\";i:4;s:7:\"tagline\";i:5;s:9:\"copyright\";}s:13:\"last_modified\";s:31:\"Tue, 11 Jul 2006 07:00:55 GMT\r\n\";s:4:\"etag\";s:36:\"\"317a1187ad9866dcf7d41422ff092d2e\"\r\n\";}',20,8,'',1,'no'),(68,0,'rss_0ff4b43bd116a9d8720d689c80e7dfd4_ts','Y',1,'1153143864',20,8,'',1,'no'),(69,0,'rss_867bd5c64f85878d03a060509cd2f92c','Y',1,'O:9:\"magpierss\":19:{s:6:\"parser\";i:0;s:12:\"current_item\";a:0:{}s:5:\"items\";a:50:{i:0;a:7:{s:5:\"title\";s:35:\"Weblog Tools Collection: Alexaholic\";s:4:\"guid\";s:64:\"http://weblogtoolscollection.com/archives/2006/07/16/alexaholic/\";s:4:\"link\";s:143:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F16%2Falexaholic%2F\";s:11:\"description\";s:141:\"<p><a href=\"http://www.alexaholic.com/\">Alexaholic</a>: A sort of <a href=\"http://www.googlefight.com/\">Google Fight</a> but with Alexa.\n</p>\";s:7:\"pubdate\";s:31:\"Sun, 16 Jul 2006 20:01:11 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:141:\"<p><a href=\"http://www.alexaholic.com/\">Alexaholic</a>: A sort of <a href=\"http://www.googlefight.com/\">Google Fight</a> but with Alexa.\n</p>\";}i:1;a:7:{s:5:\"title\";s:51:\"Weblog Tools Collection: WP Theme: Black Kryptonite\";s:4:\"guid\";s:79:\"http://weblogtoolscollection.com/archives/2006/07/16/wp-theme-black-kryptonite/\";s:4:\"link\";s:158:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F16%2Fwp-theme-black-kryptonite%2F\";s:11:\"description\";s:210:\"<p><a href=\"http://jtkconsulting.com/BlackKryptonite/?p=6\">WP Theme: Black Kryptonite</a> Two column, light on dark, left sidebar theme for Wordpress with focus on standards compliance, speed and reability.</p>\";s:7:\"pubdate\";s:31:\"Sun, 16 Jul 2006 14:30:21 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:210:\"<p><a href=\"http://jtkconsulting.com/BlackKryptonite/?p=6\">WP Theme: Black Kryptonite</a> Two column, light on dark, left sidebar theme for Wordpress with focus on standards compliance, speed and reability.</p>\";}i:2;a:7:{s:5:\"title\";s:40:\"Weblog Tools Collection: WP Theme: Preow\";s:4:\"guid\";s:68:\"http://weblogtoolscollection.com/archives/2006/07/16/wp-theme-preow/\";s:4:\"link\";s:147:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F16%2Fwp-theme-preow%2F\";s:11:\"description\";s:382:\"<p><a href=\"http://preow.com/design/free-fu/\">WP Theme: Preow</a> Two column, white on black border, rin-like header image theme for Wordpress that looks polished. Looks like the original came from <a href=\"http://www.sixshootermedia.com/\">SixShooterMedia</a> where you can find a few more free, modern looking, standards compliant templates to be converted to Wordpress themes.</p>\";s:7:\"pubdate\";s:31:\"Sun, 16 Jul 2006 14:30:21 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:382:\"<p><a href=\"http://preow.com/design/free-fu/\">WP Theme: Preow</a> Two column, white on black border, rin-like header image theme for Wordpress that looks polished. Looks like the original came from <a href=\"http://www.sixshootermedia.com/\">SixShooterMedia</a> where you can find a few more free, modern looking, standards compliant templates to be converted to Wordpress themes.</p>\";}i:3;a:7:{s:5:\"title\";s:56:\"Weblog Tools Collection: WP Plugin: Limited Use Password\";s:4:\"guid\";s:84:\"http://weblogtoolscollection.com/archives/2006/07/16/wp-plugin-limited-use-password/\";s:4:\"link\";s:163:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F16%2Fwp-plugin-limited-use-password%2F\";s:11:\"description\";s:290:\"<p><a href=\"http://blindmindseye.com/software-projects/wordpress-plugins/limited-use-password-plugin/\">WP Plugin: Limited Use Password</a> Send a &#8220;limited use&#8221; password to a password protected post on your Wordpress blog with this plugin without sharing the actual password.</p>\";s:7:\"pubdate\";s:31:\"Sun, 16 Jul 2006 09:58:02 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:290:\"<p><a href=\"http://blindmindseye.com/software-projects/wordpress-plugins/limited-use-password-plugin/\">WP Plugin: Limited Use Password</a> Send a &#8220;limited use&#8221; password to a password protected post on your Wordpress blog with this plugin without sharing the actual password.</p>\";}i:4;a:7:{s:5:\"title\";s:53:\"Weblog Tools Collection: Kubrick Glossy Header Images\";s:4:\"guid\";s:82:\"http://weblogtoolscollection.com/archives/2006/07/14/kubrick-glossy-header-images/\";s:4:\"link\";s:161:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F14%2Fkubrick-glossy-header-images%2F\";s:11:\"description\";s:143:\"<p><a href=\"http://www.glossydesign.com/archives/wordpress-glossy-header-images.html\">Kubrick Glossy Header Images</a> I like the blue one.</p>\";s:7:\"pubdate\";s:31:\"Fri, 14 Jul 2006 22:15:18 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:143:\"<p><a href=\"http://www.glossydesign.com/archives/wordpress-glossy-header-images.html\">Kubrick Glossy Header Images</a> I like the blue one.</p>\";}i:5;a:7:{s:5:\"title\";s:49:\"Weblog Tools Collection: WP Plugin: Image Gallery\";s:4:\"guid\";s:77:\"http://weblogtoolscollection.com/archives/2006/07/14/wp-plugin-image-gallery/\";s:4:\"link\";s:156:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F14%2Fwp-plugin-image-gallery%2F\";s:11:\"description\";s:435:\"<p><a href=\"http://www.internetvibes.net/wordpress-plugins-and-themes/wordpress-plugin-image-gallery-post-generator/\">WP Plugin: Image Gallery</a> Simply build small galleries within your Wordpress posts from photographs uploaded to a folder on your server. Judging from the code, I assume GD is is needed, but is not mentioned in the author&#8217;s post. <a href=\"http://www.internetvibes.net/gallery/\">Example galleries here</a>.</p>\";s:7:\"pubdate\";s:31:\"Fri, 14 Jul 2006 21:45:22 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:435:\"<p><a href=\"http://www.internetvibes.net/wordpress-plugins-and-themes/wordpress-plugin-image-gallery-post-generator/\">WP Plugin: Image Gallery</a> Simply build small galleries within your Wordpress posts from photographs uploaded to a folder on your server. Judging from the code, I assume GD is is needed, but is not mentioned in the author&#8217;s post. <a href=\"http://www.internetvibes.net/gallery/\">Example galleries here</a>.</p>\";}i:6;a:7:{s:5:\"title\";s:47:\"Weblog Tools Collection: Awesome Wordpress Tips\";s:4:\"guid\";s:76:\"http://weblogtoolscollection.com/archives/2006/07/14/awesome-wordpress-tips/\";s:4:\"link\";s:155:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F14%2Fawesome-wordpress-tips%2F\";s:11:\"description\";s:1620:\"<p>Blogging is more fun when it is quick, painless and still creates satisfying results. I use quite a few browser and Wordpress tools and tricks to make life simpler. Some of these are built into Wordpress (and might be lesser known) while others I have developed out of necessity or as a learning challenge.</p>\n	<p>I often wonder if there are new ways to use old tools or new methods to make an old task simpler or more bearable. I have a feeling that most Wordpress bloggers have a few of these up their sleeve. But since these have become habits, they rarely get shared with others. I know that I would not sing the praises of &#8220;Press It&#8221; after using it constantly for four years, but maybe I should.</p>\n	<p>So if you are using Wordpress, look for the little &#8220;Press It&#8221; Bookmarklet at the bottom of the &#8220;Write Post&#8221; page. Drag it to your bookmarks toolbar (or links toolbar in IE) and give it a smallish name. Now when you are browsing a page which you would like to cite in a post, you can click this link and get a small popup with a link to that page, waiting for you to add your thoughts and hit &#8220;Publish&#8221;. You can also highlight a portion of that page before clicking that link and the content that you highlighted will be copied into the body of the post. I have grown so accustomed to this little bookmarklet that I feel lost when I am at a computer where I do not have it. Consequently, I end up being lazy and losing my train of thought.</p>\n	<p>So what are your favorite Wordpress shortcuts? What tool inside Wordpress makes your blogging life simpler?\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 14 Jul 2006 21:01:04 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:1620:\"<p>Blogging is more fun when it is quick, painless and still creates satisfying results. I use quite a few browser and Wordpress tools and tricks to make life simpler. Some of these are built into Wordpress (and might be lesser known) while others I have developed out of necessity or as a learning challenge.</p>\n	<p>I often wonder if there are new ways to use old tools or new methods to make an old task simpler or more bearable. I have a feeling that most Wordpress bloggers have a few of these up their sleeve. But since these have become habits, they rarely get shared with others. I know that I would not sing the praises of &#8220;Press It&#8221; after using it constantly for four years, but maybe I should.</p>\n	<p>So if you are using Wordpress, look for the little &#8220;Press It&#8221; Bookmarklet at the bottom of the &#8220;Write Post&#8221; page. Drag it to your bookmarks toolbar (or links toolbar in IE) and give it a smallish name. Now when you are browsing a page which you would like to cite in a post, you can click this link and get a small popup with a link to that page, waiting for you to add your thoughts and hit &#8220;Publish&#8221;. You can also highlight a portion of that page before clicking that link and the content that you highlighted will be copied into the body of the post. I have grown so accustomed to this little bookmarklet that I feel lost when I am at a computer where I do not have it. Consequently, I end up being lazy and losing my train of thought.</p>\n	<p>So what are your favorite Wordpress shortcuts? What tool inside Wordpress makes your blogging life simpler?\n</p>\";}i:7;a:7:{s:5:\"title\";s:51:\"Weblog Tools Collection: Mouseover Transparent Dock\";s:4:\"guid\";s:80:\"http://weblogtoolscollection.com/archives/2006/07/14/mouseover-transparent-dock/\";s:4:\"link\";s:159:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F14%2Fmouseover-transparent-dock%2F\";s:11:\"description\";s:497:\"<p><a href=\"http://www.whalesalad.com/dock/\">Mouseover Transparent Dock</a>: Create a transparent (semi) dock-like menu on your page/blog with Javascript. I can see this becoming common on newer themes. Pretty cool if you are into this kind of thing. The only issue I see with this is that you have to let the user know that this exists, otherwise it would never occur to me know mouse over the header to get a new menu. Thanks <a href=\"http://javascript.weblogsinc.com/\">Javascript Weblog</a></p>\";s:7:\"pubdate\";s:31:\"Fri, 14 Jul 2006 14:30:11 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:497:\"<p><a href=\"http://www.whalesalad.com/dock/\">Mouseover Transparent Dock</a>: Create a transparent (semi) dock-like menu on your page/blog with Javascript. I can see this becoming common on newer themes. Pretty cool if you are into this kind of thing. The only issue I see with this is that you have to let the user know that this exists, otherwise it would never occur to me know mouse over the header to get a new menu. Thanks <a href=\"http://javascript.weblogsinc.com/\">Javascript Weblog</a></p>\";}i:8;a:7:{s:5:\"title\";s:40:\"Weblog Tools Collection: Feed Collectors\";s:4:\"guid\";s:69:\"http://weblogtoolscollection.com/archives/2006/07/14/feed-collectors/\";s:4:\"link\";s:148:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F14%2Ffeed-collectors%2F\";s:11:\"description\";s:486:\"<p><a href=\"http://feedcollectors.com/beta/\">Feed Collectors</a>: From their about page &#8230;  <em>Feed Collectors is a new web tool that collects and socializes your feeds.</em> So, it is a private Technorati of sorts? Thus the name Pulverati(look at the end of this post)? This is still in private beta but it sure would be an interesting way to skim hundreds of feeds to find clouds of information needed. Thanks to a link from <a href=\"http://www.pulverati.com/\">Pulverati</a></p>\";s:7:\"pubdate\";s:31:\"Fri, 14 Jul 2006 14:01:28 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:486:\"<p><a href=\"http://feedcollectors.com/beta/\">Feed Collectors</a>: From their about page &#8230;  <em>Feed Collectors is a new web tool that collects and socializes your feeds.</em> So, it is a private Technorati of sorts? Thus the name Pulverati(look at the end of this post)? This is still in private beta but it sure would be an interesting way to skim hundreds of feeds to find clouds of information needed. Thanks to a link from <a href=\"http://www.pulverati.com/\">Pulverati</a></p>\";}i:9;a:7:{s:5:\"title\";s:40:\"Andy Skelton: Generated Semantic Classes\";s:4:\"guid\";s:65:\"https://andy.wordpress.com/2006/07/14/generated-semantic-classes/\";s:4:\"link\";s:64:\"http://andy.wordpress.com/2006/07/14/generated-semantic-classes/\";s:11:\"description\";s:1766:\"<p>I&#8217;ve been working with <a href=\"http://plaintxt.org/\">Scott All<u>a</u>n Wallick</a> on a WordPress theme he calls Minimalist Sandbox. One of the things we&#8217;re trying to do is create a rich semantic markup pattern that will make it easier to customize the blog with CSS alone.</p>\n<p>For example, take the &lt;body&gt; tag. We know whether is_home or is_post or is_page by the time we render this tag, so why not drop some of this context into the body&#8217;s class? The distinction between &#8220;home&#8221; and &#8220;post&#8221; and &#8220;page&#8221; is simple and powerful. It utterly destroys the old widecolumn/narrowcolumn classes. A full-blown class list such as &#8220;wordpress author archive author-andy&#8221; also gives each author the ability to style their archives differently with just a bit of CSS.</p>\n<p>We can do similar things to the post div class list: &#8220;post publish author-andy category-asides category-funny&#8221; gives you tremendous power to shape your blog&#8217;s presentation with CSS. You could have a different style for certain categories or authors, attach a headshot to each of an author&#8217;s posts, use :before selectors to congratulate visitors on their wise choice of browsers&#8230;</p>\n<p>What&#8217;s more, this makes your semantic data accessible to javascript. You could use the classnames to place relevant ads in posts, collapse posts of a certain category according to the visitor&#8217;s cookies, attach category-targeted link submission buttons&#8230;</p>\n<p>There are all manner of tricks you can play when you have the right information in the right place. If you think of any other information that could enhance the semantic value of a theme&#8217;s markup, drop a note right here.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 14 Jul 2006 11:30:06 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Andy\";}s:7:\"summary\";s:1766:\"<p>I&#8217;ve been working with <a href=\"http://plaintxt.org/\">Scott All<u>a</u>n Wallick</a> on a WordPress theme he calls Minimalist Sandbox. One of the things we&#8217;re trying to do is create a rich semantic markup pattern that will make it easier to customize the blog with CSS alone.</p>\n<p>For example, take the &lt;body&gt; tag. We know whether is_home or is_post or is_page by the time we render this tag, so why not drop some of this context into the body&#8217;s class? The distinction between &#8220;home&#8221; and &#8220;post&#8221; and &#8220;page&#8221; is simple and powerful. It utterly destroys the old widecolumn/narrowcolumn classes. A full-blown class list such as &#8220;wordpress author archive author-andy&#8221; also gives each author the ability to style their archives differently with just a bit of CSS.</p>\n<p>We can do similar things to the post div class list: &#8220;post publish author-andy category-asides category-funny&#8221; gives you tremendous power to shape your blog&#8217;s presentation with CSS. You could have a different style for certain categories or authors, attach a headshot to each of an author&#8217;s posts, use :before selectors to congratulate visitors on their wise choice of browsers&#8230;</p>\n<p>What&#8217;s more, this makes your semantic data accessible to javascript. You could use the classnames to place relevant ads in posts, collapse posts of a certain category according to the visitor&#8217;s cookies, attach category-targeted link submission buttons&#8230;</p>\n<p>There are all manner of tricks you can play when you have the right information in the right place. If you think of any other information that could enhance the semantic value of a theme&#8217;s markup, drop a note right here.\n</p>\";}i:10;a:7:{s:5:\"title\";s:46:\"Weblog Tools Collection: Easthlink Feed Reader\";s:4:\"guid\";s:75:\"http://weblogtoolscollection.com/archives/2006/07/14/easthlink-feed-reader/\";s:4:\"link\";s:154:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F14%2Feasthlink-feed-reader%2F\";s:11:\"description\";s:758:\"<p><a href=\"http://www.techcrunch.com/2006/07/13/when-did-earthlink-get-so-cool/\">Earthlink Feed Reader</a>: I guess the cat got out of the bag before it really should have left the litter box, so to speak. Earthlink has been secretly developing an online and free <a href=\"http://reader.earthlink.net/\">feedreader</a> and <a href=\"http://myfavorites.earthlink.net/\">social bookmarking site</a>. Arrington details how they were found and some of the salient features, benefits, weaknesses and styling. I personally like the clean interface of the bookmarking site but most of these del.icio.us wannabes tend to have clean interfaces anyways. There is also an <a href=\"http://blogs.earthlink.net/\">Earthlink blog</a> that talks about the recent discovery.</p>\";s:7:\"pubdate\";s:31:\"Fri, 14 Jul 2006 09:45:44 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:758:\"<p><a href=\"http://www.techcrunch.com/2006/07/13/when-did-earthlink-get-so-cool/\">Earthlink Feed Reader</a>: I guess the cat got out of the bag before it really should have left the litter box, so to speak. Earthlink has been secretly developing an online and free <a href=\"http://reader.earthlink.net/\">feedreader</a> and <a href=\"http://myfavorites.earthlink.net/\">social bookmarking site</a>. Arrington details how they were found and some of the salient features, benefits, weaknesses and styling. I personally like the clean interface of the bookmarking site but most of these del.icio.us wannabes tend to have clean interfaces anyways. There is also an <a href=\"http://blogs.earthlink.net/\">Earthlink blog</a> that talks about the recent discovery.</p>\";}i:11;a:7:{s:5:\"title\";s:15:\"Matt: REI 5ives\";s:4:\"guid\";s:42:\"http://photomatt.net/2006/07/13/rei-5ives/\";s:4:\"link\";s:42:\"http://photomatt.net/2006/07/13/rei-5ives/\";s:11:\"description\";s:362:\"<p><a href=\"http://www.5ives.com/archives/2006/01/23/five-things-i-had-to-keep-explaining-to-the-guy-at-rei/\">Five things I had to keep explaining to the guy at REI</a>, my day yesterday. <cite>Hat tip: <a href=\"http://www.merlinmann.com/\">Merlin Mann</a> on my <a href=\"http://flickr.com/photos/photomatt/188477367/\">fake rock shoe tester photo</a>.</cite>\n</p>\";s:7:\"pubdate\";s:31:\"Thu, 13 Jul 2006 17:30:11 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:362:\"<p><a href=\"http://www.5ives.com/archives/2006/01/23/five-things-i-had-to-keep-explaining-to-the-guy-at-rei/\">Five things I had to keep explaining to the guy at REI</a>, my day yesterday. <cite>Hat tip: <a href=\"http://www.merlinmann.com/\">Merlin Mann</a> on my <a href=\"http://flickr.com/photos/photomatt/188477367/\">fake rock shoe tester photo</a>.</cite>\n</p>\";}i:12;a:7:{s:5:\"title\";s:47:\"Weblog Tools Collection: Microsoft on Blog Spam\";s:4:\"guid\";s:76:\"http://weblogtoolscollection.com/archives/2006/07/13/microsoft-on-blog-spam/\";s:4:\"link\";s:155:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F13%2Fmicrosoft-on-blog-spam%2F\";s:11:\"description\";s:338:\"<p><a href=\"http://blog.washingtonpost.com/securityfix/2006/07/microsoft_stabs_at_blogspam_po.html\">Microsoft on Blog Spam</a> It looks like they did a lot of searching of Blogger and Google&#8217;s related sites to try and dig up dirt. Akismet gets a mention. Sadly, all big talk and no solution or hint at a solution from Microsoft.</p>\";s:7:\"pubdate\";s:31:\"Thu, 13 Jul 2006 14:06:45 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:338:\"<p><a href=\"http://blog.washingtonpost.com/securityfix/2006/07/microsoft_stabs_at_blogspam_po.html\">Microsoft on Blog Spam</a> It looks like they did a lot of searching of Blogger and Google&#8217;s related sites to try and dig up dirt. Akismet gets a mention. Sadly, all big talk and no solution or hint at a solution from Microsoft.</p>\";}i:13;a:7:{s:5:\"title\";s:54:\"Weblog Tools Collection: Scrapblog - online scrapbooks\";s:4:\"guid\";s:81:\"http://weblogtoolscollection.com/archives/2006/07/13/scrapblog-online-scrapbooks/\";s:4:\"link\";s:160:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F13%2Fscrapblog-online-scrapbooks%2F\";s:11:\"description\";s:654:\"<p><a href=\"http://www.scrapblog.com/\">Scrapblog - online scrapbooks</a>: I was slightly apprehensive when I first came upon this link with the thinking that this is going to be another place to store photos and build slideshows. Another group of LLCers trying to break into the Flickr, YouTube hype.</p>\n	<p>I think I changed my mind after looking through the scrapblogs that are already created. This could be interesting and fun for the casual blogger. I think of these as photo albums on steroids. You can even embed your scrapblogs into existing blogs. Looks like you drag and drop peices into your &#8220;slideshow&#8221; from existing objects.</p>\";s:7:\"pubdate\";s:31:\"Thu, 13 Jul 2006 09:49:00 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:654:\"<p><a href=\"http://www.scrapblog.com/\">Scrapblog - online scrapbooks</a>: I was slightly apprehensive when I first came upon this link with the thinking that this is going to be another place to store photos and build slideshows. Another group of LLCers trying to break into the Flickr, YouTube hype.</p>\n	<p>I think I changed my mind after looking through the scrapblogs that are already created. This could be interesting and fun for the casual blogger. I think of these as photo albums on steroids. You can even embed your scrapblogs into existing blogs. Looks like you drag and drop peices into your &#8220;slideshow&#8221; from existing objects.</p>\";}i:14;a:7:{s:5:\"title\";s:14:\"Matt: dot info\";s:4:\"guid\";s:41:\"http://photomatt.net/2006/07/12/dot-info/\";s:4:\"link\";s:41:\"http://photomatt.net/2006/07/12/dot-info/\";s:11:\"description\";s:192:\"<p>Some days don\'t you want to just blacklist all of .info? More spam there than anything else except maybe .com or .be, and certainly a higher percentage than any other top-level domain.\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 12 Jul 2006 23:01:09 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:192:\"<p>Some days don\'t you want to just blacklist all of .info? More spam there than anything else except maybe .com or .be, and certainly a higher percentage than any other top-level domain.\n</p>\";}i:15;a:7:{s:5:\"title\";s:38:\"Ryan Boren: This One Time, At WordCamp\";s:4:\"guid\";s:62:\"http://boren.nu/archives/2006/07/11/this-one-time-at-wordcamp/\";s:4:\"link\";s:62:\"http://boren.nu/archives/2006/07/11/this-one-time-at-wordcamp/\";s:11:\"description\";s:666:\"<p>This one time, at <a href=\"http://2006.wordcamp.org/\">WordCamp</a>, I got a bit drunk off of all of the drinks people bought me in appreciation for writing the theme engine, adding i18n support, battling mod_rewrite, and being a swell guy and good tipper.</p>\n<p>But seriously, <a href=\"http://photomatt.net/2006/07/09/wordcamp/\">WordCamp</a> is coming soon and all of the <a href=\"http://automattic.com/about/\">Automattic crew</a> will be there.  I\'m sure I\'ll be buying drinks for some of the many people who have contributed to WP and made it so successful.  If you\'ve had a patch land in WP, mention your changeset or ticket number for a free beer on me.\n</p>\";s:7:\"pubdate\";s:31:\"Tue, 11 Jul 2006 23:30:13 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Ryan\";}s:7:\"summary\";s:666:\"<p>This one time, at <a href=\"http://2006.wordcamp.org/\">WordCamp</a>, I got a bit drunk off of all of the drinks people bought me in appreciation for writing the theme engine, adding i18n support, battling mod_rewrite, and being a swell guy and good tipper.</p>\n<p>But seriously, <a href=\"http://photomatt.net/2006/07/09/wordcamp/\">WordCamp</a> is coming soon and all of the <a href=\"http://automattic.com/about/\">Automattic crew</a> will be there.  I\'m sure I\'ll be buying drinks for some of the many people who have contributed to WP and made it so successful.  If you\'ve had a patch land in WP, mention your changeset or ticket number for a free beer on me.\n</p>\";}i:16;a:7:{s:5:\"title\";s:42:\"Weblog Tools Collection: FeedOnFeeds Redux\";s:4:\"guid\";s:71:\"http://weblogtoolscollection.com/archives/2006/07/11/feedonfeeds-redux/\";s:4:\"link\";s:150:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F11%2Ffeedonfeeds-redux%2F\";s:11:\"description\";s:246:\"<p><a href=\"http://fofredux.sourceforge.net/\">FeedOnFeeds Redux</a> New development team and new life in the stagnated FeedOnFeeds online aggregator. The version history is lacking major feature additions but something is better than nothing.</p>\";s:7:\"pubdate\";s:31:\"Tue, 11 Jul 2006 22:15:36 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:246:\"<p><a href=\"http://fofredux.sourceforge.net/\">FeedOnFeeds Redux</a> New development team and new life in the stagnated FeedOnFeeds online aggregator. The version history is lacking major feature additions but something is better than nothing.</p>\";}i:17;a:7:{s:5:\"title\";s:21:\"Matt: Airborne Mythes\";s:4:\"guid\";s:48:\"http://photomatt.net/2006/07/11/airborne-mythes/\";s:4:\"link\";s:48:\"http://photomatt.net/2006/07/11/airborne-mythes/\";s:11:\"description\";s:137:\"<p><a href=\"http://whohastimeforthis.blogspot.com/2006/04/created-by-school-teacher.html\">Airborne - created by a school teacher</a>\n</p>\";s:7:\"pubdate\";s:31:\"Tue, 11 Jul 2006 20:30:09 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:137:\"<p><a href=\"http://whohastimeforthis.blogspot.com/2006/04/created-by-school-teacher.html\">Airborne - created by a school teacher</a>\n</p>\";}i:18;a:7:{s:5:\"title\";s:52:\"Weblog Tools Collection: WordPress Theme Competition\";s:4:\"guid\";s:81:\"http://weblogtoolscollection.com/archives/2006/07/11/wordpress-theme-competition/\";s:4:\"link\";s:160:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F11%2Fwordpress-theme-competition%2F\";s:11:\"description\";s:689:\"<p><a href=\"http://theundersigned.net/2006/06/wordpress-theme-competition/\">WordPress Theme Competition</a> <em>Only new themes can be submitted, only themes not based on a previously released themes (K2 mods etc) will be accepted, and semantic code and cross browser capable themes will be weighed a lot to.</em> I feel much better about this competition than the pervious one and I like Thomas&#8217; work. I will definitely be keeping an eye out and I really like the &#8220;New Themes only&#8221; idea. Thomas, please let me know where I should send my share of the prize money. Also, I would suggest choosing a unique and small(ish) name for the competition to keep things fresh.\n</p>\";s:7:\"pubdate\";s:31:\"Tue, 11 Jul 2006 18:17:43 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:689:\"<p><a href=\"http://theundersigned.net/2006/06/wordpress-theme-competition/\">WordPress Theme Competition</a> <em>Only new themes can be submitted, only themes not based on a previously released themes (K2 mods etc) will be accepted, and semantic code and cross browser capable themes will be weighed a lot to.</em> I feel much better about this competition than the pervious one and I like Thomas&#8217; work. I will definitely be keeping an eye out and I really like the &#8220;New Themes only&#8221; idea. Thomas, please let me know where I should send my share of the prize money. Also, I would suggest choosing a unique and small(ish) name for the competition to keep things fresh.\n</p>\";}i:19;a:7:{s:5:\"title\";s:36:\"Weblog Tools Collection: Dell Weblog\";s:4:\"guid\";s:65:\"http://weblogtoolscollection.com/archives/2006/07/11/dell-weblog/\";s:4:\"link\";s:144:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F11%2Fdell-weblog%2F\";s:11:\"description\";s:1289:\"<p><a href=\"http://one2one.dell.com/\">Dell Weblog</a>: <a href=\"http://www.buzzmachine.com/index.php/2006/07/10/well-well-dell-2/\">Lots</a> <a href=\"http://andylark.blogs.com/andylark/2006/07/dell_launches_b.html\">has</a> <a href=\"http://blog.holtz.com/index.php/weblog/dell_launches_a_blog/\">been</a> <a href=\"http://scobleizer.wordpress.com/2006/07/10/dell-joins-the-bloggy-web/\">written</a> about Dell&#8217;s foray into the blogosphere. I am not privy to the insider information that many of the above authors are, but it seems as though this is an attempt by Dell to make things more personal. I see shades of <a href=\"http://channel9.msdn.com\">Channel 9</a> with the various vlog entries promoting new items and flashes of <a href=\"http://fastlane.gmblogs.com/\">GM&#8217;s blog</a>.  Even the &#8220;About&#8221; page link location and theme (content) looks similar to GMs. Maybe they used the <a href=\"http://www.hassmsl.com/\">same company</a>?</p>\n	<p>This smells more of cheap advertising than anything else. Maybe this is a start, but Dell could have done much better with the resources they must have at their disposal. Maybe Scoble is a rarity but I find it hard to believe that they could not find a CBO worth their salt to provide the sushi rice to hold it all together.\n</p>\";s:7:\"pubdate\";s:31:\"Tue, 11 Jul 2006 17:01:19 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:1289:\"<p><a href=\"http://one2one.dell.com/\">Dell Weblog</a>: <a href=\"http://www.buzzmachine.com/index.php/2006/07/10/well-well-dell-2/\">Lots</a> <a href=\"http://andylark.blogs.com/andylark/2006/07/dell_launches_b.html\">has</a> <a href=\"http://blog.holtz.com/index.php/weblog/dell_launches_a_blog/\">been</a> <a href=\"http://scobleizer.wordpress.com/2006/07/10/dell-joins-the-bloggy-web/\">written</a> about Dell&#8217;s foray into the blogosphere. I am not privy to the insider information that many of the above authors are, but it seems as though this is an attempt by Dell to make things more personal. I see shades of <a href=\"http://channel9.msdn.com\">Channel 9</a> with the various vlog entries promoting new items and flashes of <a href=\"http://fastlane.gmblogs.com/\">GM&#8217;s blog</a>.  Even the &#8220;About&#8221; page link location and theme (content) looks similar to GMs. Maybe they used the <a href=\"http://www.hassmsl.com/\">same company</a>?</p>\n	<p>This smells more of cheap advertising than anything else. Maybe this is a start, but Dell could have done much better with the resources they must have at their disposal. Maybe Scoble is a rarity but I find it hard to believe that they could not find a CBO worth their salt to provide the sushi rice to hold it all together.\n</p>\";}i:20;a:7:{s:5:\"title\";s:44:\"Weblog Tools Collection: WP Plugin: SB_Chart\";s:4:\"guid\";s:72:\"http://weblogtoolscollection.com/archives/2006/07/11/wp-plugin-sb_chart/\";s:4:\"link\";s:151:\"http://feeds.feedburner.com/~r/weblogtoolscollection/UXMP/~3/http%3A%2F%2Fweblogtoolscollection.com%2Farchives%2F2006%2F07%2F11%2Fwp-plugin-sb_chart%2F\";s:11:\"description\";s:270:\"<p><a href=\"http://smallestbusiness.com/2006/07/10/new-wrdpress-plugin-sb-charts\">WP Plugin: SB_Chart</a> Automagically create and include stock trend charts into your Wordpress blog. Stock data comes from Yahoo. Thanks <a href=\"http://wp-plugins.net/\">Plugin DB</a></p>\";s:7:\"pubdate\";s:31:\"Tue, 11 Jul 2006 14:30:13 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:270:\"<p><a href=\"http://smallestbusiness.com/2006/07/10/new-wrdpress-plugin-sb-charts\">WP Plugin: SB_Chart</a> Automagically create and include stock trend charts into your Wordpress blog. Stock data comes from Yahoo. Thanks <a href=\"http://wp-plugins.net/\">Plugin DB</a></p>\";}i:21;a:7:{s:5:\"title\";s:35:\"Dev Blog: WordCamp in San Francisco\";s:4:\"guid\";s:55:\"http://wordpress.org/development/2006/07/wordcamp-2006/\";s:4:\"link\";s:55:\"http://wordpress.org/development/2006/07/wordcamp-2006/\";s:11:\"description\";s:1023:\"<p>On August 5th, 2006, we&#8217;re planning a WordPress user conference called <a href=\"http://wordcamp.org/\">WordCamp</a>. The idea is to bring WordPress users and developers so we can meet each other face to face, share stories, and try to figure out the future of our little corner of the online publishing revolution.</p>\n<p>The conference will be a 1-day event, with a party that night, and be free to anyone and everyone. We&#8217;re aiming to do it in the style of BarCamp, so the agenda will be largely determined by you guys. I&#8217;ve posted a <a href=\"http://photomatt.net/2006/07/09/wordcamp/\">little bit more about the ideas behind WordCamp on my blog</a>.</p>\n<p>I know it&#8217;s relatively short notice, especially for folks in other countries, but if you think you can make it or if you just want more information <a href=\"http://wordcamp.org/\">check out WordCamp.org</a>, where we&#8217;ll coordinating the event. I&#8217;m really looking forward to meeting people I interact with online every day.\n</p>\";s:7:\"pubdate\";s:31:\"Tue, 11 Jul 2006 07:00:55 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:1023:\"<p>On August 5th, 2006, we&#8217;re planning a WordPress user conference called <a href=\"http://wordcamp.org/\">WordCamp</a>. The idea is to bring WordPress users and developers so we can meet each other face to face, share stories, and try to figure out the future of our little corner of the online publishing revolution.</p>\n<p>The conference will be a 1-day event, with a party that night, and be free to anyone and everyone. We&#8217;re aiming to do it in the style of BarCamp, so the agenda will be largely determined by you guys. I&#8217;ve posted a <a href=\"http://photomatt.net/2006/07/09/wordcamp/\">little bit more about the ideas behind WordCamp on my blog</a>.</p>\n<p>I know it&#8217;s relatively short notice, especially for folks in other countries, but if you think you can make it or if you just want more information <a href=\"http://wordcamp.org/\">check out WordCamp.org</a>, where we&#8217;ll coordinating the event. I&#8217;m really looking forward to meeting people I interact with online every day.\n</p>\";}i:22;a:7:{s:5:\"title\";s:21:\"Matt: WordCamp Update\";s:4:\"guid\";s:48:\"http://photomatt.net/2006/07/11/wordcamp-update/\";s:4:\"link\";s:48:\"http://photomatt.net/2006/07/11/wordcamp-update/\";s:11:\"description\";s:464:\"<p>So 1 day after <a href=\"http://photomatt.net/2006/07/09/wordcamp/\">the announcement</a>, 104 people have signed up that they\'re coming to <a href=\"http://wordcamp.org/\">WordCamp</a> and 58 have joined the mailing list. Wow! Thank you, as this has been a huge help in determining what sort of resources we\'re going to need to pull this thing off. Now the big challenge is finding a venue appropiate for the event, feel free to ping me if you have any ideas.\n</p>\";s:7:\"pubdate\";s:31:\"Tue, 11 Jul 2006 06:15:18 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:464:\"<p>So 1 day after <a href=\"http://photomatt.net/2006/07/09/wordcamp/\">the announcement</a>, 104 people have signed up that they\'re coming to <a href=\"http://wordcamp.org/\">WordCamp</a> and 58 have joined the mailing list. Wow! Thank you, as this has been a huge help in determining what sort of resources we\'re going to need to pull this thing off. Now the big challenge is finding a venue appropiate for the event, feel free to ping me if you have any ideas.\n</p>\";}i:23;a:7:{s:5:\"title\";s:23:\"Matt: WordPress Podcast\";s:4:\"guid\";s:50:\"http://photomatt.net/2006/07/10/wordpress-podcast/\";s:4:\"link\";s:50:\"http://photomatt.net/2006/07/10/wordpress-podcast/\";s:11:\"description\";s:155:\"<p>There is a new <a href=\"http://podcast.wp-community.org/\">WordPress podcast blog</a>, podcasting the various goings-on in the WP world. Subscribed!\n</p>\";s:7:\"pubdate\";s:31:\"Mon, 10 Jul 2006 22:45:13 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:155:\"<p>There is a new <a href=\"http://podcast.wp-community.org/\">WordPress podcast blog</a>, podcasting the various goings-on in the WP world. Subscribed!\n</p>\";}i:24;a:7:{s:5:\"title\";s:54:\"Weblog Tools Collection: WP plugin: Adsense Beautifier\";s:4:\"guid\";s:82:\"http://weblogtoolscollection.com/archives/2006/07/10/wp-plugin-adsense-beautifier/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=898\";s:11:\"description\";s:373:\"<p><a href=\"http://www.supriyadisw.net/2006/07/adsense-beautifier\">WP plugin: Adsense Beautifier</a> Increase your AdSense CTR with small pictures next to your AdSense ads. This plugin makes the process simpler. On a side note, AdSense has already started doing this on some of their ads. I have noticed it on my <a href=\"http://wltc.net/ebaytosms/\">eBayToSMS</a> page.</p>\";s:7:\"pubdate\";s:31:\"Mon, 10 Jul 2006 18:19:50 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:373:\"<p><a href=\"http://www.supriyadisw.net/2006/07/adsense-beautifier\">WP plugin: Adsense Beautifier</a> Increase your AdSense CTR with small pictures next to your AdSense ads. This plugin makes the process simpler. On a side note, AdSense has already started doing this on some of their ads. I have noticed it on my <a href=\"http://wltc.net/ebaytosms/\">eBayToSMS</a> page.</p>\";}i:25;a:7:{s:5:\"title\";s:40:\"Weblog Tools Collection: WP Theme: Water\";s:4:\"guid\";s:68:\"http://weblogtoolscollection.com/archives/2006/07/10/wp-theme-water/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=897\";s:11:\"description\";s:221:\"<p><a href=\"http://theundersigned.net/2006/07/water-10-has-been-released/\">WP Theme: Water</a> Two column, black on white, somewhat sparse theme for Wordpress with widgets support. Has a very distinct blog feel to it.</p>\";s:7:\"pubdate\";s:31:\"Mon, 10 Jul 2006 11:03:07 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:221:\"<p><a href=\"http://theundersigned.net/2006/07/water-10-has-been-released/\">WP Theme: Water</a> Two column, black on white, somewhat sparse theme for Wordpress with widgets support. Has a very distinct blog feel to it.</p>\";}i:26;a:7:{s:5:\"title\";s:47:\"Donncha: WordPress Gathering in  San Francisco!\";s:4:\"guid\";s:75:\"http://blogs.linux.ie/xeer/2006/07/10/wordpress-gathering-in-san-francisco/\";s:4:\"link\";s:75:\"http://blogs.linux.ie/xeer/2006/07/10/wordpress-gathering-in-san-francisco/\";s:11:\"description\";s:826:\"<p>I&#8217;m off to San Francisco at the end of the month! Matt is organising <a href=\"http://blogs.linux.ie/xeer/go.php?http://photomatt.net/2006/07/09/wordcamp/\">WordCamp</a>, a  free WordPress conference on August 5th in San Francisco and I&#8217;ll be there along with the rest of the <a href=\"http://blogs.linux.ie/xeer/go.php?http://automattic.com/\">Automattic</a> guys.</p>\n	<p>I&#8217;m really looking forward to it, meeting people I talk to every day online, hacking on WordPress stuff and taking lots and lots of <a href=\"http://blogs.linux.ie/xeer/go.php?http://inphotos.org/\">photos</a>. I&#8217;m not the only one making the trip across the Atlantic either; Podz is <a href=\"http://blogs.linux.ie/xeer/go.php?http://www.tamba2.org.uk/T2/archives/2006/07/10/this-happens-to-other-people/\">flying over</a> too!\n</p>\";s:7:\"pubdate\";s:31:\"Mon, 10 Jul 2006 09:41:44 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:7:\"Donncha\";}s:7:\"summary\";s:826:\"<p>I&#8217;m off to San Francisco at the end of the month! Matt is organising <a href=\"http://blogs.linux.ie/xeer/go.php?http://photomatt.net/2006/07/09/wordcamp/\">WordCamp</a>, a  free WordPress conference on August 5th in San Francisco and I&#8217;ll be there along with the rest of the <a href=\"http://blogs.linux.ie/xeer/go.php?http://automattic.com/\">Automattic</a> guys.</p>\n	<p>I&#8217;m really looking forward to it, meeting people I talk to every day online, hacking on WordPress stuff and taking lots and lots of <a href=\"http://blogs.linux.ie/xeer/go.php?http://inphotos.org/\">photos</a>. I&#8217;m not the only one making the trip across the Atlantic either; Podz is <a href=\"http://blogs.linux.ie/xeer/go.php?http://www.tamba2.org.uk/T2/archives/2006/07/10/this-happens-to-other-people/\">flying over</a> too!\n</p>\";}i:27;a:7:{s:5:\"title\";s:37:\"Matt: WordCamp - WordPress Conference\";s:4:\"guid\";s:41:\"http://photomatt.net/2006/07/09/wordcamp/\";s:4:\"link\";s:41:\"http://photomatt.net/2006/07/09/wordcamp/\";s:11:\"description\";s:1787:\"<p>The idea for an event for WordPress users has been bouncing around in my head for a long time, as there is a really interesting group of people around WP but we don\'t do nearly as many face-to-face interactions as some similar projects. A set of circumstances are coming together at the beginning of August, and I think we\'re going to give it a go.</p>\n<p><b>August 5th, 2006 is the date</b>, here in the lovely town of San Francisco, California. The idea is a one day <a href=\"http://barcamp.org/\">BarCamp</a>-style <b>free</b> conference with a party that night. There will be free BBQ for lunch, WordPress t-shirts, and a full day of both user and developer discussion. (\"BarCamp-style\" is a code phrase for \"last minute.\")</p>\n<p>There are still a few things to figure out, such as a venue, schedule, and other little things like that. (By the way, if you can help with any of these or have event experience, please drop me a note.) But mostly I wanted to get the date out there so people could start planning for it, buy tickets if they\'re travelling, and let us know if there are any huge conflicts that day. (Like a national holiday or something.)</p>\n<p>In the meantime, I\'ve <a href=\"http://wordcamp.org/\">put up a quick site where you can leave your email to signup for more information or let us know you\'re coming</a>. If you think you can make it, please say so as soon as possible so we can prepare for the right number of people. If you\'d like to help in any way, drop me a note via email or in the comments.</p>\n<p>Don\'t know if this will work or not, but it should be fun regardless. Podz is coming in all the way from England, and Donncha from Ireland. <img src=\"http://photomatt.net/blog/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" />\n</p>\";s:7:\"pubdate\";s:31:\"Sun, 09 Jul 2006 23:15:11 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:1787:\"<p>The idea for an event for WordPress users has been bouncing around in my head for a long time, as there is a really interesting group of people around WP but we don\'t do nearly as many face-to-face interactions as some similar projects. A set of circumstances are coming together at the beginning of August, and I think we\'re going to give it a go.</p>\n<p><b>August 5th, 2006 is the date</b>, here in the lovely town of San Francisco, California. The idea is a one day <a href=\"http://barcamp.org/\">BarCamp</a>-style <b>free</b> conference with a party that night. There will be free BBQ for lunch, WordPress t-shirts, and a full day of both user and developer discussion. (\"BarCamp-style\" is a code phrase for \"last minute.\")</p>\n<p>There are still a few things to figure out, such as a venue, schedule, and other little things like that. (By the way, if you can help with any of these or have event experience, please drop me a note.) But mostly I wanted to get the date out there so people could start planning for it, buy tickets if they\'re travelling, and let us know if there are any huge conflicts that day. (Like a national holiday or something.)</p>\n<p>In the meantime, I\'ve <a href=\"http://wordcamp.org/\">put up a quick site where you can leave your email to signup for more information or let us know you\'re coming</a>. If you think you can make it, please say so as soon as possible so we can prepare for the right number of people. If you\'d like to help in any way, drop me a note via email or in the comments.</p>\n<p>Don\'t know if this will work or not, but it should be fun regardless. Podz is coming in all the way from England, and Donncha from Ireland. <img src=\"http://photomatt.net/blog/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" />\n</p>\";}i:28;a:7:{s:5:\"title\";s:28:\"Matt: Hasselhoff Music Video\";s:4:\"guid\";s:55:\"http://photomatt.net/2006/07/09/hasselhoff-music-video/\";s:4:\"link\";s:55:\"http://photomatt.net/2006/07/09/hasselhoff-music-video/\";s:11:\"description\";s:174:\"<p><a href=\"http://www.youtube.com/watch?v=pgX-hiQdfFw\">This David Hasselhoff music video, Jump in My Car</a>, is a must-watch. There has to have a good story behind it.\n</p>\";s:7:\"pubdate\";s:31:\"Sun, 09 Jul 2006 18:15:12 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:174:\"<p><a href=\"http://www.youtube.com/watch?v=pgX-hiQdfFw\">This David Hasselhoff music video, Jump in My Car</a>, is a must-watch. There has to have a good story behind it.\n</p>\";}i:29;a:7:{s:5:\"title\";s:44:\"Weblog Tools Collection: WP Theme: Darkfrost\";s:4:\"guid\";s:72:\"http://weblogtoolscollection.com/archives/2006/07/09/wp-theme-darkfrost/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=896\";s:11:\"description\";s:155:\"<p><a href=\"http://levibuzolic.com/projects/fauna-darkfrost/\">WP Theme: Darkfrost</a> Dark, two column version of the famed Fauna theme for Wordpress.\n</p>\";s:7:\"pubdate\";s:31:\"Sun, 09 Jul 2006 11:50:01 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:155:\"<p><a href=\"http://levibuzolic.com/projects/fauna-darkfrost/\">WP Theme: Darkfrost</a> Dark, two column version of the famed Fauna theme for Wordpress.\n</p>\";}i:30;a:7:{s:5:\"title\";s:28:\"Akismet: One Hundred Million\";s:4:\"guid\";s:52:\"http://akismet.com/blog/2006/07/one-hundred-million/\";s:4:\"link\";s:52:\"http://akismet.com/blog/2006/07/one-hundred-million/\";s:11:\"description\";s:1463:\"<p>This will probably be the last spam milestone we blog for a while, but a few hours ago <a href=\"http://akismet.com/stats/\">Akismet passed <b>100,000,000 spams</b> blocked</a>. Whoa.</p>\n<p>When we hit <a href=\"http://akismet.com/blog/2005/12/one-meeelllion/\">one million spams blocked</a> I talked about how much time Akismet has saved its users if you made the assumption of 1 second per spam that Akismet caught and you never had to see. Going by that same formula, Akismet has now saved folks 27,777 hours or about <b>3.2 years of consectutive 24-hour days</b>.</p>\n<p>This of course doesn\'t include time saved by regular commenters not having to deal with difficult-to-read CAPTCHA images, boil-the-ocean authentication schemes, or complicated confirmation systems.</p>\n<p>I would like to take this opportunity to thank <a href=\"http://tamba2.org.uk/T2/\">Podz</a>, who has been helping out a tremendous amount on the support side of things, and <a href=\"http://akismet.com/development/\">all the developers who have built plugins or libraries</a> on top of the Akismet API, as they have brought the Akismet experience far beyond the world of WordPress.</p>\n<p>If we\'re doing our job right, you should <b>forget Akismet even exists</b>. Its presence should be defined much like silence &#8212; the absence of noisy spam.</p>\n<p><b>Update:</b> <a href=\"http://digg.com/security/Akismet_blocks_One_Hundred_Million_spam!\">You can Digg this story</a>.&nbsp;\n</p>\";s:7:\"pubdate\";s:31:\"Sat, 08 Jul 2006 17:30:11 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:14:\"Matt Mullenweg\";}s:7:\"summary\";s:1463:\"<p>This will probably be the last spam milestone we blog for a while, but a few hours ago <a href=\"http://akismet.com/stats/\">Akismet passed <b>100,000,000 spams</b> blocked</a>. Whoa.</p>\n<p>When we hit <a href=\"http://akismet.com/blog/2005/12/one-meeelllion/\">one million spams blocked</a> I talked about how much time Akismet has saved its users if you made the assumption of 1 second per spam that Akismet caught and you never had to see. Going by that same formula, Akismet has now saved folks 27,777 hours or about <b>3.2 years of consectutive 24-hour days</b>.</p>\n<p>This of course doesn\'t include time saved by regular commenters not having to deal with difficult-to-read CAPTCHA images, boil-the-ocean authentication schemes, or complicated confirmation systems.</p>\n<p>I would like to take this opportunity to thank <a href=\"http://tamba2.org.uk/T2/\">Podz</a>, who has been helping out a tremendous amount on the support side of things, and <a href=\"http://akismet.com/development/\">all the developers who have built plugins or libraries</a> on top of the Akismet API, as they have brought the Akismet experience far beyond the world of WordPress.</p>\n<p>If we\'re doing our job right, you should <b>forget Akismet even exists</b>. Its presence should be defined much like silence &#8212; the absence of noisy spam.</p>\n<p><b>Update:</b> <a href=\"http://digg.com/security/Akismet_blocks_One_Hundred_Million_spam!\">You can Digg this story</a>.&nbsp;\n</p>\";}i:31;a:7:{s:5:\"title\";s:50:\"Weblog Tools Collection: WP plugin: Bad Behavior 2\";s:4:\"guid\";s:78:\"http://weblogtoolscollection.com/archives/2006/07/08/wp-plugin-bad-behavior-2/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=895\";s:11:\"description\";s:545:\"<p><a href=\"http://error.wordpress.com/2006/07/04/bad-behavior-2/\">WP plugin: Bad Behavior 2</a> This new version of Bad Behavior has a bunch of new features including faster code, variable strictness of traffic filtering, lesser usage of the database (which is really important for higher traffic sites) and a new wrapper API. Bad Behavior is now also available for  ExpressionEngine, MediaWiki and generic non-database mode for any PHP script, forum, guestbook, Movable Type, etc.  Thanks <a href=\"http://ioerror.us\">Michael</a> va email.\n</p>\";s:7:\"pubdate\";s:31:\"Sat, 08 Jul 2006 09:06:53 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:545:\"<p><a href=\"http://error.wordpress.com/2006/07/04/bad-behavior-2/\">WP plugin: Bad Behavior 2</a> This new version of Bad Behavior has a bunch of new features including faster code, variable strictness of traffic filtering, lesser usage of the database (which is really important for higher traffic sites) and a new wrapper API. Bad Behavior is now also available for  ExpressionEngine, MediaWiki and generic non-database mode for any PHP script, forum, guestbook, Movable Type, etc.  Thanks <a href=\"http://ioerror.us\">Michael</a> va email.\n</p>\";}i:32;a:7:{s:5:\"title\";s:40:\"Weblog Tools Collection: WP Theme: Fleur\";s:4:\"guid\";s:68:\"http://weblogtoolscollection.com/archives/2006/07/07/wp-theme-fleur/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=894\";s:11:\"description\";s:224:\"<p><a href=\"http://www.kaushalsheth.com/fleur-wordpress-theme-released/\">WP Theme: Fleur</a> is a 2 column widget friendly fixed width layout. It makes use of subtle colour and overall has a clean blog layout structure.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 07 Jul 2006 04:02:40 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:7:\"Kaushal\";}s:7:\"summary\";s:224:\"<p><a href=\"http://www.kaushalsheth.com/fleur-wordpress-theme-released/\">WP Theme: Fleur</a> is a 2 column widget friendly fixed width layout. It makes use of subtle colour and overall has a clean blog layout structure.\n</p>\";}i:33;a:7:{s:5:\"title\";s:46:\"Weblog Tools Collection: Blogging is Addictive\";s:4:\"guid\";s:75:\"http://weblogtoolscollection.com/archives/2006/07/06/blogging-is-addictive/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=893\";s:11:\"description\";s:1831:\"<p><a href=\"http://findmeacure.com/\">Find Me A Cure</a>: I finally got my dad to blog about something that he cares deeply about and has a lot of good information on. I have been practicing yoga on and off all of my life and have been coached and coaxed by my dad to try alternative forms of medication, treatment and therapy for as long as I can remember. Some of these have worked wonders for me, others have failed to make much of a difference. But I trust his judgement, appreciate his knowledge and I really value his opinions on yoga, alternative medication and therapy.</p>\n	<p>My father is a complete Internet newbie. You could almost call him a perpetual newbie since most concepts of the Internet are beyond what he wants to learn or cares to understand. I made him buy his first computer for our Calcutta home approximately six years ago and he has come a long way since. He has always kept up with my blogs and tried to understand my Wordpress obsession but I wanted him to try and blog. Now my mom cannot get him away from the computer. She says that he is completely obsessed with his blog, checks his pageviews every couple of minutes and cannot stop talking about <a href=\"http://findmeacure.com\">findmeacure.com</a></p>\n	<p>He has trouble typing and his English is broken, but his zeal for the subject (of alternative medication) and his desire to reach out to people and help them is supreme. It really makes me proud that my father is not only helping others, he is doing so at his own pace, with a tool that I feel very strongly about and has gotten so intensely involved. I now have to teach him how to use the Google Spellchecker and to tweak and play with some of the more advanced features inside Wordpress. Visit his <a href=\"http://findmeacure.com\">blog</a> often and leave him a message if you will.\n</p>\";s:7:\"pubdate\";s:31:\"Thu, 06 Jul 2006 22:30:12 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:1831:\"<p><a href=\"http://findmeacure.com/\">Find Me A Cure</a>: I finally got my dad to blog about something that he cares deeply about and has a lot of good information on. I have been practicing yoga on and off all of my life and have been coached and coaxed by my dad to try alternative forms of medication, treatment and therapy for as long as I can remember. Some of these have worked wonders for me, others have failed to make much of a difference. But I trust his judgement, appreciate his knowledge and I really value his opinions on yoga, alternative medication and therapy.</p>\n	<p>My father is a complete Internet newbie. You could almost call him a perpetual newbie since most concepts of the Internet are beyond what he wants to learn or cares to understand. I made him buy his first computer for our Calcutta home approximately six years ago and he has come a long way since. He has always kept up with my blogs and tried to understand my Wordpress obsession but I wanted him to try and blog. Now my mom cannot get him away from the computer. She says that he is completely obsessed with his blog, checks his pageviews every couple of minutes and cannot stop talking about <a href=\"http://findmeacure.com\">findmeacure.com</a></p>\n	<p>He has trouble typing and his English is broken, but his zeal for the subject (of alternative medication) and his desire to reach out to people and help them is supreme. It really makes me proud that my father is not only helping others, he is doing so at his own pace, with a tool that I feel very strongly about and has gotten so intensely involved. I now have to teach him how to use the Google Spellchecker and to tweak and play with some of the more advanced features inside Wordpress. Visit his <a href=\"http://findmeacure.com\">blog</a> often and leave him a message if you will.\n</p>\";}i:34;a:7:{s:5:\"title\";s:44:\"Weblog Tools Collection: Online Regex Tester\";s:4:\"guid\";s:73:\"http://weblogtoolscollection.com/archives/2006/07/06/online-regex-tester/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=892\";s:11:\"description\";s:200:\"<p><a href=\"http://www.koralsoft.com/regextester/\">Online Regex Tester</a> Test your PCRE and POSIX dialect regular expressions online with this handy AJAXified page. It seems to break in Firefox.</p>\";s:7:\"pubdate\";s:31:\"Thu, 06 Jul 2006 18:14:15 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:200:\"<p><a href=\"http://www.koralsoft.com/regextester/\">Online Regex Tester</a> Test your PCRE and POSIX dialect regular expressions online with this handy AJAXified page. It seems to break in Firefox.</p>\";}i:35;a:7:{s:5:\"title\";s:14:\"Matt: Rapunzel\";s:4:\"guid\";s:41:\"http://photomatt.net/2006/07/06/rapunzel/\";s:4:\"link\";s:41:\"http://photomatt.net/2006/07/06/rapunzel/\";s:11:\"description\";s:429:\"<p>A little Thursday music treat to round out this short holiday week: <a href=\"http://photomatt.net/dropbox/2006/07/10%20-%20Dave%20Matthews%20Band%20-%20Rapunzel.mp3\">Rapunzel</a>. <a href=\"http://www.amazon.com/gp/product/B00005QD8E/sr=8-1/qid=1152205773/ref=pd_bbs_1/002-0297544-9229612?ie=UTF8\">Live in Chicago 1998</a> with the Dave Matthews band. The entire CD is fun, and this track has a particularly good sax solo.\n</p>\";s:7:\"pubdate\";s:31:\"Thu, 06 Jul 2006 17:15:09 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:429:\"<p>A little Thursday music treat to round out this short holiday week: <a href=\"http://photomatt.net/dropbox/2006/07/10%20-%20Dave%20Matthews%20Band%20-%20Rapunzel.mp3\">Rapunzel</a>. <a href=\"http://www.amazon.com/gp/product/B00005QD8E/sr=8-1/qid=1152205773/ref=pd_bbs_1/002-0297544-9229612?ie=UTF8\">Live in Chicago 1998</a> with the Dave Matthews band. The entire CD is fun, and this track has a particularly good sax solo.\n</p>\";}i:36;a:7:{s:5:\"title\";s:35:\"Weblog Tools Collection: Commentful\";s:4:\"guid\";s:64:\"http://weblogtoolscollection.com/archives/2006/07/06/commentful/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=889\";s:11:\"description\";s:116:\"<p><a href=\"http://commentful.com/\">Commentful</a> A <a href=\"http://www.cocomment.com/\">coComment</a> wannabe.\n</p>\";s:7:\"pubdate\";s:31:\"Thu, 06 Jul 2006 12:21:09 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:116:\"<p><a href=\"http://commentful.com/\">Commentful</a> A <a href=\"http://www.cocomment.com/\">coComment</a> wannabe.\n</p>\";}i:37;a:7:{s:5:\"title\";s:34:\"Weblog Tools Collection: Newshutch\";s:4:\"guid\";s:63:\"http://weblogtoolscollection.com/archives/2006/07/06/newshutch/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=890\";s:11:\"description\";s:372:\"<p><a href=\"http://newshutch.com/login\">Newshutch</a>: Web based, AJAXified news aggregator that shows some promise but is still buggy. I tried importing my feeds and it died with a rails error. I also wish they had a daily digest page like so many other news readers. I do like the interface and the initial speed though that might decay with users and/or popularity.</p>\";s:7:\"pubdate\";s:31:\"Thu, 06 Jul 2006 12:19:22 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:372:\"<p><a href=\"http://newshutch.com/login\">Newshutch</a>: Web based, AJAXified news aggregator that shows some promise but is still buggy. I tried importing my feeds and it died with a rails error. I also wish they had a daily digest page like so many other news readers. I do like the interface and the initial speed though that might decay with users and/or popularity.</p>\";}i:38;a:7:{s:5:\"title\";s:40:\"Weblog Tools Collection: WP Theme: Frost\";s:4:\"guid\";s:68:\"http://weblogtoolscollection.com/archives/2006/07/06/wp-theme-frost/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=891\";s:11:\"description\";s:144:\"<p><a href=\"http://www.macmanx.com/blog/frost/\">WP Theme: Frost</a> Two column &#8220;frost&#8221; version of the Fauna theme for Wordpress.</p>\";s:7:\"pubdate\";s:31:\"Thu, 06 Jul 2006 12:18:11 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:144:\"<p><a href=\"http://www.macmanx.com/blog/frost/\">WP Theme: Frost</a> Two column &#8220;frost&#8221; version of the Fauna theme for Wordpress.</p>\";}i:39;a:7:{s:5:\"title\";s:56:\"Weblog Tools Collection: The blogosphere is not credible\";s:4:\"guid\";s:76:\"http://weblogtoolscollection.com/archives/2006/07/06/the-blogosphere-is-not/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=888\";s:11:\"description\";s:290:\"<p><a href=\"http://www.businessweek.com/the_thread/blogspotting/archives/2006/07/the_blogosphere_1.html\">The blogosphere is not credible</a> I love this quote from the author &#8230; <em>The blogosphere by itself has no credibility. Individual bloggers build their own credibility.</em></p>\";s:7:\"pubdate\";s:31:\"Thu, 06 Jul 2006 00:03:50 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:290:\"<p><a href=\"http://www.businessweek.com/the_thread/blogspotting/archives/2006/07/the_blogosphere_1.html\">The blogosphere is not credible</a> I love this quote from the author &#8230; <em>The blogosphere by itself has no credibility. Individual bloggers build their own credibility.</em></p>\";}i:40;a:7:{s:5:\"title\";s:16:\"Matt: Vista Jump\";s:4:\"guid\";s:43:\"http://photomatt.net/2006/07/05/vista-jump/\";s:4:\"link\";s:43:\"http://photomatt.net/2006/07/05/vista-jump/\";s:11:\"description\";s:236:\"<p>I\'m installing <a href=\"http://www.microsoft.com/Windowsvista/\">Windows Vista</a> on my laptop. Wish me luck. I got a free DVD at Gnomedex, so figured why not? <b>Update:</b> Upgrade failed (froze), going to try a clean install.\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 05 Jul 2006 18:37:39 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:236:\"<p>I\'m installing <a href=\"http://www.microsoft.com/Windowsvista/\">Windows Vista</a> on my laptop. Wish me luck. I got a free DVD at Gnomedex, so figured why not? <b>Update:</b> Upgrade failed (froze), going to try a clean install.\n</p>\";}i:41;a:7:{s:5:\"title\";s:29:\"Matt: Photographing Fireworks\";s:4:\"guid\";s:56:\"http://photomatt.net/2006/07/04/photographing-fireworks/\";s:4:\"link\";s:56:\"http://photomatt.net/2006/07/04/photographing-fireworks/\";s:11:\"description\";s:210:\"<p>NY Institute of Photography on <a href=\"http://www.nyip.com/tips/current/firewksintro.php\">photographing fireworks</a>. (A <a href=\"http://photomatt.net/2003/07/03/good-fireworks-pictures/\">repeat</a>.)\n</p>\";s:7:\"pubdate\";s:31:\"Tue, 04 Jul 2006 18:13:02 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:7:\"summary\";s:210:\"<p>NY Institute of Photography on <a href=\"http://www.nyip.com/tips/current/firewksintro.php\">photographing fireworks</a>. (A <a href=\"http://photomatt.net/2003/07/03/good-fireworks-pictures/\">repeat</a>.)\n</p>\";}i:42;a:7:{s:5:\"title\";s:53:\"Weblog Tools Collection: WP Theme: Minimalist Sandbox\";s:4:\"guid\";s:81:\"http://weblogtoolscollection.com/archives/2006/07/04/wp-theme-minimalist-sandbox/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=886\";s:11:\"description\";s:267:\"<p><a href=\"http://www.plaintxt.org/themes/minimalist-sandbox/\">WP Theme: Minimalist Sandbox</a> Ultra minimalist two column theme for Wordpress from Plaintxt. Could be the beginning of other great minimalist themes or just a point of reference for theme authors.</p>\";s:7:\"pubdate\";s:31:\"Tue, 04 Jul 2006 15:30:12 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:267:\"<p><a href=\"http://www.plaintxt.org/themes/minimalist-sandbox/\">WP Theme: Minimalist Sandbox</a> Ultra minimalist two column theme for Wordpress from Plaintxt. Could be the beginning of other great minimalist themes or just a point of reference for theme authors.</p>\";}i:43;a:7:{s:5:\"title\";s:43:\"Weblog Tools Collection: Hot Dates with CSS\";s:4:\"guid\";s:72:\"http://weblogtoolscollection.com/archives/2006/07/04/hot-dates-with-css/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=887\";s:11:\"description\";s:284:\"<p><a href=\"http://www.christianmontoya.com/2006/07/03/hot-dates-with-css/\">Hot Dates with CSS</a> Use CSS to format the date of your posts into something that looks like a single page per day calendar. Interesting <a href=\"http://lab.christianmontoya.com/css-dates/\">results</a>.</p>\";s:7:\"pubdate\";s:31:\"Tue, 04 Jul 2006 15:30:12 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:284:\"<p><a href=\"http://www.christianmontoya.com/2006/07/03/hot-dates-with-css/\">Hot Dates with CSS</a> Use CSS to format the date of your posts into something that looks like a single page per day calendar. Interesting <a href=\"http://lab.christianmontoya.com/css-dates/\">results</a>.</p>\";}i:44;a:7:{s:5:\"title\";s:45:\"Weblog Tools Collection: 10 Killer Post Ideas\";s:4:\"guid\";s:74:\"http://weblogtoolscollection.com/archives/2006/07/04/10-killer-post-ideas/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=885\";s:11:\"description\";s:232:\"<p><a href=\"http://performancing.com/node/169\">10 Killer Post Ideas</a>: Some very good thoughts on killer posts on your blog. However, most of this is aimed at the tech/marketing type blogger and not the casual weekend blogger.</p>\";s:7:\"pubdate\";s:31:\"Tue, 04 Jul 2006 15:15:09 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:232:\"<p><a href=\"http://performancing.com/node/169\">10 Killer Post Ideas</a>: Some very good thoughts on killer posts on your blog. However, most of this is aimed at the tech/marketing type blogger and not the casual weekend blogger.</p>\";}i:45;a:7:{s:5:\"title\";s:72:\"Weblog Tools Collection: Why Blog Post Frequency Does Not Matter Anymore\";s:4:\"guid\";s:101:\"http://weblogtoolscollection.com/archives/2006/07/04/why-blog-post-frequency-does-not-matter-anymore/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=884\";s:11:\"description\";s:256:\"<p><a href=\"http://blog.marketingprofs.com/2006/06/w_why_blog_post_frequency_does.html\">Why Blog Post Frequency Does Not Matter Anymore</a> Posting frequently is not as important as one would think. Thanks <a href=\"http://www.nead.us\">Sam</a> via email</p>\";s:7:\"pubdate\";s:31:\"Tue, 04 Jul 2006 09:11:52 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:256:\"<p><a href=\"http://blog.marketingprofs.com/2006/06/w_why_blog_post_frequency_does.html\">Why Blog Post Frequency Does Not Matter Anymore</a> Posting frequently is not as important as one would think. Thanks <a href=\"http://www.nead.us\">Sam</a> via email</p>\";}i:46;a:7:{s:5:\"title\";s:39:\"Ryan Boren: Stalking the Wild Buguschka\";s:4:\"guid\";s:64:\"http://boren.nu/archives/2006/07/03/stalking-the-wild-buguschka/\";s:4:\"link\";s:64:\"http://boren.nu/archives/2006/07/03/stalking-the-wild-buguschka/\";s:11:\"description\";s:550:\"<p>As <a href=\"http://wordpress.org/development/2006/06/204-and-21-bug-hunt/\">announced</a> on the <a href=\"http://wordpress.org/development/\">dev blog</a>, we have a bug hunt coming up soon.  I\'ll be hanging out on the <a href=\"irc://irc.freenode.net/wordpress-bugs\">bugs channel</a> and applying patches for most of the 24 hour hunt.  The idea is to find and kill  bugs to make ready for the 2.0.4 and 2.1 releases.  Bugs found now won\'t be annoying you come release time, so drop by if you want to help test, code, or just hang out and watch.\n</p>\";s:7:\"pubdate\";s:31:\"Mon, 03 Jul 2006 20:51:11 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Ryan\";}s:7:\"summary\";s:550:\"<p>As <a href=\"http://wordpress.org/development/2006/06/204-and-21-bug-hunt/\">announced</a> on the <a href=\"http://wordpress.org/development/\">dev blog</a>, we have a bug hunt coming up soon.  I\'ll be hanging out on the <a href=\"irc://irc.freenode.net/wordpress-bugs\">bugs channel</a> and applying patches for most of the 24 hour hunt.  The idea is to find and kill  bugs to make ready for the 2.0.4 and 2.1 releases.  Bugs found now won\'t be annoying you come release time, so drop by if you want to help test, code, or just hang out and watch.\n</p>\";}i:47;a:7:{s:5:\"title\";s:45:\"Weblog Tools Collection: Air Force Blog Study\";s:4:\"guid\";s:149:\"http://weblogtoolscollection.com/archives/2006/07/03/blogs-study-may-provide-credible-information-us-department-of-defense-transformation-news-story/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=883\";s:11:\"description\";s:531:\"<p><a href=\"http://www.defenselink.mil/transformation/articles/2006-06/ta062906b.html\">Air Force Blog Study</a>: The Air Force has funded a $450,000 study on blogs and blogging as a part of the war on terror.</p>\n	<blockquote><p>We are developing an automated tool to tell analysts what bloggers are most interested in at a point in time.</p></blockquote>\n	<p>Sounds like Memeorandum (insert other web 2.0 news/meme/tag site). Thanks <a href=\"http://www.bloggersblog.com/cgi-bin/bloggersblog.pl?bblog=703061\">Blogging Blog</a>\n</p>\";s:7:\"pubdate\";s:31:\"Mon, 03 Jul 2006 17:00:14 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:531:\"<p><a href=\"http://www.defenselink.mil/transformation/articles/2006-06/ta062906b.html\">Air Force Blog Study</a>: The Air Force has funded a $450,000 study on blogs and blogging as a part of the war on terror.</p>\n	<blockquote><p>We are developing an automated tool to tell analysts what bloggers are most interested in at a point in time.</p></blockquote>\n	<p>Sounds like Memeorandum (insert other web 2.0 news/meme/tag site). Thanks <a href=\"http://www.bloggersblog.com/cgi-bin/bloggersblog.pl?bblog=703061\">Blogging Blog</a>\n</p>\";}i:48;a:7:{s:5:\"title\";s:45:\"Weblog Tools Collection: WP plugin: MoreMoney\";s:4:\"guid\";s:73:\"http://weblogtoolscollection.com/archives/2006/07/03/wp-plugin-moremoney/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=882\";s:11:\"description\";s:411:\"<p><a href=\"http://www.nopuedocreer.com/quelohayaninventado/?page_id=211\">WP plugin: MoreMoney</a> Display ads and a message to visitors from Google. The author also suggests that this plugin could be useful if you only want to display ads from search engine visitors and spare your regular patrons from viewing ads. Much like <a href=\"http://theundersigned.net/2006/06/landing-sites-11/\">Landing Sites</a>.</p>\";s:7:\"pubdate\";s:31:\"Mon, 03 Jul 2006 12:48:41 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:411:\"<p><a href=\"http://www.nopuedocreer.com/quelohayaninventado/?page_id=211\">WP plugin: MoreMoney</a> Display ads and a message to visitors from Google. The author also suggests that this plugin could be useful if you only want to display ads from search engine visitors and spare your regular patrons from viewing ads. Much like <a href=\"http://theundersigned.net/2006/06/landing-sites-11/\">Landing Sites</a>.</p>\";}i:49;a:7:{s:5:\"title\";s:40:\"Weblog Tools Collection: WP plugin: WPG2\";s:4:\"guid\";s:68:\"http://weblogtoolscollection.com/archives/2006/07/02/wp-plugin-wpg2/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=881\";s:11:\"description\";s:262:\"<p><a href=\"http://wpg2.galleryembedded.com/wiki/index.php/WPG2:Main_Page\">WP plugin: WPG2</a> Embed your Wordpress Gallery 2  into a Wordpress blog without much trouble. Looks like the help site is very well put together and there are some nice screenshots.</p>\";s:7:\"pubdate\";s:31:\"Sun, 02 Jul 2006 15:30:44 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Mark\";}s:7:\"summary\";s:262:\"<p><a href=\"http://wpg2.galleryembedded.com/wiki/index.php/WPG2:Main_Page\">WP plugin: WPG2</a> Embed your Wordpress Gallery 2  into a Wordpress blog without much trouble. Looks like the help site is very well put together and there are some nice screenshots.</p>\";}}s:7:\"channel\";a:5:{s:5:\"title\";s:16:\"WordPress Planet\";s:4:\"link\";s:28:\"http://planet.wordpress.org/\";s:8:\"language\";s:2:\"en\";s:11:\"description\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"tagline\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";}s:9:\"textinput\";a:0:{}s:5:\"image\";a:0:{}s:9:\"feed_type\";s:3:\"RSS\";s:12:\"feed_version\";s:3:\"2.0\";s:5:\"stack\";a:0:{}s:9:\"inchannel\";b:0;s:6:\"initem\";b:0;s:9:\"incontent\";b:0;s:11:\"intextinput\";b:0;s:7:\"inimage\";b:0;s:13:\"current_field\";s:0:\"\";s:17:\"current_namespace\";b:0;s:19:\"_CONTENT_CONSTRUCTS\";a:6:{i:0;s:7:\"content\";i:1;s:7:\"summary\";i:2;s:4:\"info\";i:3;s:5:\"title\";i:4;s:7:\"tagline\";i:5;s:9:\"copyright\";}s:4:\"etag\";s:24:\"\"bada-44bb90f1-568c2a\"\r\n\";s:13:\"last_modified\";s:31:\"Mon, 17 Jul 2006 13:30:25 GMT\r\n\";}',20,8,'',1,'no'),(70,0,'rss_867bd5c64f85878d03a060509cd2f92c_ts','Y',1,'1153143865',20,8,'',1,'no'),(71,0,'rewrite_rules','Y',1,'a:70:{s:23:\"(overview)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:43:\"(overview)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:38:\"(overview)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:31:\"(overview)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:23:\"(overview)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:30:\"overview/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:40:\"overview/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:60:\"overview/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:55:\"overview/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:24:\"(file-list)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:44:\"(file-list)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:39:\"(file-list)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:32:\"(file-list)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:24:\"(file-list)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:31:\"file-list/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:41:\"file-list/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:61:\"file-list/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\"file-list/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:32:\"(proxy_awg_project)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:52:\"(proxy_awg_project)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:47:\"(proxy_awg_project)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:40:\"(proxy_awg_project)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:32:\"(proxy_awg_project)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:39:\"proxy_awg_project/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:49:\"proxy_awg_project/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:69:\"proxy_awg_project/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:64:\"proxy_awg_project/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:29:\"comments/page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/trackback/?$\";s:85:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&tb=1\";s:77:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:65:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/page/?([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&paged=$matches[5]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)(/[0-9]+)?/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&page=$matches[5]\";s:47:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:57:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:77:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:68:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:88:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";}',20,8,'',1,'yes');
/*!40000 ALTER TABLE `awg_options` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `awg_post2cat`
--

DROP TABLE IF EXISTS `awg_post2cat`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `awg_post2cat` (
  `rel_id` bigint(20) NOT NULL auto_increment,
  `post_id` bigint(20) NOT NULL default '0',
  `category_id` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`rel_id`),
  KEY `post_id` (`post_id`,`category_id`)
) ENGINE=MyISAM AUTO_INCREMENT=29 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `awg_post2cat`
--

LOCK TABLES `awg_post2cat` WRITE;
/*!40000 ALTER TABLE `awg_post2cat` DISABLE KEYS */;
INSERT INTO `awg_post2cat` VALUES (10,9,1),(2,2,1),(13,12,1),(5,4,1),(6,5,1),(7,6,1),(15,14,1),(9,8,1),(12,11,2),(14,13,1),(16,15,1),(17,16,1),(18,17,1),(19,18,1),(20,19,1),(21,20,1),(23,22,1),(24,23,2),(25,24,1),(26,25,1),(27,26,1),(28,27,1);
/*!40000 ALTER TABLE `awg_post2cat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `awg_postmeta`
--

DROP TABLE IF EXISTS `awg_postmeta`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `awg_postmeta` (
  `meta_id` bigint(20) NOT NULL auto_increment,
  `post_id` bigint(20) NOT NULL default '0',
  `meta_key` varchar(255) default NULL,
  `meta_value` text,
  PRIMARY KEY  (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=23 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `awg_postmeta`
--

LOCK TABLES `awg_postmeta` WRITE;
/*!40000 ALTER TABLE `awg_postmeta` DISABLE KEYS */;
INSERT INTO `awg_postmeta` VALUES (1,2,'_wp_page_template','default'),(2,4,'_wp_page_template','default'),(3,5,'_wp_page_template','default'),(4,6,'_wp_page_template','default'),(12,14,'_wp_page_template','default'),(7,8,'_wp_page_template','default'),(8,9,'_wp_page_template','default'),(10,12,'_wp_page_template','default'),(11,13,'_wp_page_template','default'),(13,15,'_wp_page_template','default'),(14,16,'_wp_page_template','default'),(15,17,'_wp_page_template','default'),(16,18,'_wp_page_template','default'),(17,19,'_wp_page_template','default'),(18,20,'_wp_page_template','default'),(19,22,'_wp_page_template','default'),(20,24,'_wp_page_template','default'),(21,25,'_wp_page_template','default'),(22,27,'_wp_page_template','default');
/*!40000 ALTER TABLE `awg_postmeta` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `awg_posts`
--

DROP TABLE IF EXISTS `awg_posts`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `awg_posts` (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `post_author` int(4) NOT NULL default '0',
  `post_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL default '0000-00-00 00:00:00',
  `post_content` longtext NOT NULL,
  `post_title` text NOT NULL,
  `post_category` int(4) NOT NULL default '0',
  `post_excerpt` text NOT NULL,
  `post_status` enum('publish','draft','private','static','object') NOT NULL default 'publish',
  `comment_status` enum('open','closed','registered_only') NOT NULL default 'open',
  `ping_status` enum('open','closed') NOT NULL default 'open',
  `post_password` varchar(20) NOT NULL default '',
  `post_name` varchar(200) NOT NULL default '',
  `to_ping` text NOT NULL,
  `pinged` text NOT NULL,
  `post_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL default '0000-00-00 00:00:00',
  `post_content_filtered` text NOT NULL,
  `post_parent` int(11) NOT NULL default '0',
  `guid` varchar(255) NOT NULL default '',
  `menu_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `post_name` (`post_name`),
  KEY `post_status` (`post_status`)
) ENGINE=MyISAM AUTO_INCREMENT=28 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `awg_posts`
--

LOCK TABLES `awg_posts` WRITE;
/*!40000 ALTER TABLE `awg_posts` DISABLE KEYS */;
INSERT INTO `awg_posts` VALUES (9,2,'2007-01-05 16:10:28','2007-01-05 21:10:28','<p>This deliverable dated <strong>January 31st, 2007</strong> includes the following documentations, datasets and models.  It will be delivered to Dr. Weng of STAR-NOAA AWG Proxy team leader via the appropriate format.</p>\r\n\r\n<ul>\r\n	<li>NWP Model Fields\r\n           <ul>\r\n              <li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=5\">Documentation</a></li>\r\n	      <li><a href=\"http://www.ssec.wisc.edu/~jasono/goes-r-awg/fulldisk/index.html\">Quicklooks</a></li>\r\n           </ul></li>\r\n        <li>TOA Radiances\r\n           <ul>\r\n              <li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=4\">Documentation</a></li>\r\n              <li><a href=\"http://cimss.ssec.wisc.edu/goes_r/awg/proxy_awg_project/deliverables/toa-radiances-quicklooks/\">Quicklooks</a></li>\r\n           </ul></li>\r\n	<li>Fast RT Model\r\n           <ul>\r\n              <li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=6\">Documentation</a></li>\r\n           </ul></li>\r\n	<li>Test Datasets</li>\r\n</ul>\r\n\r\n<p>If you would like a copy of any of the above deliverables, please <a href=\"http://www.ssec.wisc.edu/cgi-bin/email_form.cgi?name=awg_proxy\">contact us</a>.</p>\r\n','Deliverables',0,'','static','closed','closed','','deliverables','','','2007-01-31 17:09:21','2007-01-31 22:09:21','',5,'http://cimss.ssec.wisc.edu/goes_r/awg/proxy_awg_project/deliverables/',0),(2,2,'2006-07-17 09:31:50','2006-07-17 14:31:50','<p>In support of the NOAA GOES-R mission and in concert with the ongoing GOES-R Risk Reduction effort, the Algorithm Working Group (AWG) was created by NESDIS/STAR to manage and coordinate development of GOES-R products and validation activities that will support preparation for GOES-R implementation and operations.  The role of the GOES-R AWG management team is to provide oversight of the schedules, activities, and budget needed for an integrated program of GOES-R science studies, data processing development and, most importantly, their transition into operation use.</p>\r\n<!-- OVERVIEW_END -->\r\n<p>The GOES-R AWG will work collaboratively with the System Prime Contractor to ensure that the new capabilities offered by the GOES-R Program are implemented optimally and economically.  In addition, the GOES-R AWG will work closely with its companion Risk Reduction project, which will address areas of high risk for the GOES-R program and assure that scientific solutions are readily available in time for operational implementation.  Specifically, the GOES-R AWG program is a government-led effort to:</p>\r\n<ol>\r\n  <li> broker algorithms between government, academic and commercial sources,</li>\r\n  <li>support the prototyping and demonstration of algorithm performance including algorithm/product metadata generation techniques, standards, and formats,</li>\r\n  <li>provide algorithm software, test data sets, and benchmarks as potential solutions for the product generation functions, and</li>\r\n  <li>review and assess applicable GOES Incident Reports (GIRs).</li>\r\n</ol>\r\n\r\n<p>CIMSS scientists have been actively collaborating with NOAA in AWG planning since its inception.  The assembled CIMSS AWG team consists of experienced researchers with varied areas of expertise and who are fully aware of and understand all the threads that are required to accomplish the end-to-end system.  In other words, CIMSS can contribute in all four major threads, described below, of an end-to-end system for which AWG is chartered. </p>\r\n','Overview',0,'','static','closed','closed','','overview','','','2007-01-23 15:42:57','2007-01-23 20:42:57','',0,'http://cimss.ssec.wisc.edu/goes_r/awg/overview/',0),(4,2,'2006-07-17 12:01:21','2006-07-17 17:01:21','<!--UPLOADPLUS ACTION=\"filelist\" NUM=\"all\"-->','All Documents',0,'','static','closed','closed','','file-list','','','2007-02-05 18:26:06','2007-02-05 23:26:06','',0,'http://cimss.ssec.wisc.edu/goes_r/awg/file-list/',5),(5,2,'2006-07-17 13:51:12','2006-07-17 18:51:12','By leveraging previous CIMSS research programs, such as our five-year U.S. Navy supported hyperspectral MURI project, the NASA EOS polar orbiting direct broadcast processing package, more than 20 years of GOES data processing algorithm development and research to operations support, and NOAAâ€™s GOES-R Risk Reduction, CIMSS is capable of creating and providing a complete data processing and validation system for the simulation thread.  For example, CIMSS can routinely create the simulation of hemispheric scale - full disk down to the mesoscale, CONUS or regional NWP fields of atmospheric profiles, clouds, surface properties, and thermal dynamic wind and mass at the appropriate time and space specifications.  The simulation of the top of atmosphere radiances for hyperspectral and multispectral instruments using those NWP fields have also been developed. The proxy team task will address the detailed planning of how to accomplish this thread in the most efficient way. \r\n\r\n<ul>\r\n	<li><a href=\"/goes_r/awg/proxy_awg_project/deliverables/\">Deliverables</a></li>\r\n	<li><a href=\"/goes_r/awg/proxy/nwp/\">NWP-Derived Proxy Data including model fields and TOA radiance (Jason Otkin)</a>\r\n        <ul>\r\n	<li><a href=\"http://www.ssec.wisc.edu/~jasono/goes-r-awg/request-data.php\">Download/Request Data</a></li></ul></li>\r\n	<li><a href=\"http://cimss.ssec.wisc.edu/goes_r/awg/proxy/satellite/\">Satellite Derived Proxy Data (Mat Gunshor)</a></li>\r\n\r\n</ul>\r\n\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=11\">2006 AWG Proxy Data Progress</a>\r\n','Proxy Data Set Development',0,'','static','closed','closed','','proxy_awg_project','','','2008-05-28 14:36:53','2008-05-28 19:36:53','',0,'http://cimss.ssec.wisc.edu/goes_r/awg/proxy_awg_project/',1),(6,2,'2007-01-05 13:17:03','2007-01-05 18:17:03','<ul>\r\n	<li><a href=\"/goes_r/awg/science-awg/clouds/\">Clouds</a></li>\r\n	<li><a href=\"/goes_r/awg/science-awg/sounding/\">Sounding</a></li>\r\n	<li><a href=\"/goes_r/awg/science-awg/winds/\">Winds</a></li>\r\n	<li><a href=\"/goes_r/awg/science-awg/land-surface/\">Biomass Burning/Land Surface</a></li>\r\n	<li><a href=\"/goes_r/awg/science-awg/ozone-air-quality/\">Ozone / Air Quality</a></li>\r\n	<li><a href=\"/goes_r/awg/science-awg/aerosol/\">Aerosol</a></li>\r\n	<li><a href=\"/goes_r/awg/science-awg/aviation/\">Aviation</a></li>\r\n	<li><a href=\"/goes_r/awg/science-awg/cryosphere/\">Cryosphere</a></li>\r\n</ul>\r\n\r\nScience AWG Summary Slides (09/2006 - 01/2007)\r\n\r\n<ul>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=20\">Clouds AWG Summary Slides</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=19\">Sounding</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=21\">Winds AWG Summary Slides</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=22\">Biomass Burning AWG Summary Slides</a></li>\r\n	<li>Ozone</li>\r\n	<li>Aerosol</li>\r\n	<li>Aviation</li>\r\n	<li>Cryosphere</li>\r\n</ul>','Science AWG',0,'','static','closed','closed','','science-awg','','','2007-02-28 15:12:36','2007-02-28 20:12:36','',0,'http://cimss.ssec.wisc.edu/goes_r/awg/science-awg/',2),(8,2,'2007-01-05 16:03:04','2007-01-05 21:03:04','<ul>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=2\">20060530 GOES-R AWG Meeting</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=3\">20061220 SSEC GOES-R AWG Meeting</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=16\">20070202 Meeting Minutes</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=15\">20070202 Meeting Agenda/Action Items</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=24\">20070329 Meeting Minutes</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=23\">20070329 Meeting Agenda/Action Items</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=27\">20070430 Meeting Minutes</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=28\">20070531 Meeting Minutes</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=29\">20070627 Meeting Minutes</a></li>\r\n	<li><a href=\"/goes_r/awg/wp-content/files/file.php?up_id=32\">20070802 Meeting Minutes</a></li>\r\n\r\n</ul>\r\n\r\n\r\n\r\n\r\n','Meeting Notes',0,'','static','closed','closed','','meeting-notes','','','2007-09-06 10:51:51','2007-09-06 15:51:51','',0,'http://cimss.ssec.wisc.edu/goes_r/awg/meeting-notes/',6),(11,2,'2007-02-05 14:47:39','2007-02-05 19:47:39','The next meeting will be held in Rm 351 from 1:30 pm - 2:30 pm on 18 October 2007.','SSEC GOES-R AWG Meeting',0,'','publish','closed','closed','','ssec-goes-r-awg-meeting','','','2007-09-06 10:28:10','2007-09-06 15:28:10','',0,'http://cimss.ssec.wisc.edu/goes_r/awg/?p=11',0),(12,2,'2007-01-23 15:24:24','2007-01-23 20:24:24','<a href=\"http://cimss.ssec.wisc.edu/goes_r/awg/proxy/nwp/\">http://cimss.ssec.wisc.edu/goes_r/awg/proxy/nwp/</a>','NWP-Derived Proxy Data',0,'','static','closed','closed','','nwp-derived-proxy-data','','','2007-03-26 15:51:47','2007-03-26 20:51:47','',5,'http://cimss.ssec.wisc.edu/goes_r/awg/proxy_awg_project/nwp-derived-proxy-data/',0),(13,4,'2007-01-23 15:25:40','2007-01-23 20:25:40','<a href=\"http://cimss.ssec.wisc.edu/goes_r/awg/proxy/satellite/\">http://cimss.ssec.wisc.edu/goes_r/awg/proxy/satellite/</a>','Satellite Derived Proxy Data',0,'','static','closed','closed','','satellite-derived-proxy-data','','','2007-02-07 14:59:43','2007-02-07 19:59:43','',5,'http://cimss.ssec.wisc.edu/goes_r/awg/satellite-derived-proxy-data/',0),(14,2,'2007-01-23 15:33:07','2007-01-23 20:33:07','This project involves the development of tools and analysis methods to allow for generation of optimal cloud algorithms for the GOES-R cloud application team.  The approach of the cloud application team is to develop and optimize the cloud algorithms using real data as opposed to simulated GOES-R data.  Given the timetable of the GOES-R AWG effort, there is not sufficient time for a distinct algorithm development and comparison phase.  While the physical basis of cloud algorithms is well established, we propose the best way to achieve consensus is through analysis of results from real data. Therefore, a critical component of the cloud application teamâ€™s efforts will be the testing of cloud algorithms on real data.  We are proposing that the data from SEVIRI imager from the MSG series of European Geostationary Satellites and data from the MODIS imager to serve as the basis for this prototype. \r\n\r\nIn addition, to developing the required prototype systems using SEVIRI and MODIS, the project requires the selection and development of appropriate cloud algorithms.  Many of these algorithms will come from other members of the cloud application team.  However, several algorithms, including cloud height from CO2 slicing, will require development under this proposal.  Lastly, this project activity will include validation of all algorithms and documentation of their performance. \r\n\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=8\">2006 AWG Cloud Progress</a>\r\n','Clouds',0,'','static','closed','closed','','clouds','','','2007-02-06 16:01:02','2007-02-06 21:01:02','',6,'http://cimss.ssec.wisc.edu/goes_r/awg/science-awg/clouds/',0),(15,2,'2007-01-23 15:33:34','2007-01-23 20:33:34','These activities provide essential validation datasets and analysis for assessing candidate ABI temperature and water vapor sounding algorithms.  The primary focus is on the production and use of highly accurate temperature and water vapor profiles from the Atmospheric Radiation Measurement (ARM) sites and from aircraft campaigns. \r\n\r\nAchieving temperature and water vapor soundings with high accuracy and optimal vertical resolution from ABI is a major goal of GOES-R.  The high accuracy and vertical resolution is required for various applications, such as nowcasting the onset of severe weather over CONUS.  Highly accurate validation and representative validation data is therefore required to assess the candidate sounding algorithms that are to be investigated by the AWG.  The ARM sites are perhaps the best sites in the world for providing atmospheric state, cloud, and radiation observations for this type of validation activity.  \r\n\r\n<a href=\"http://cimss.ssec.wisc.edu/goes_r/awg/sounding/\">Sounding Algorithm Evaluation and Selection</a>\r\n\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=12\">2006 AWG Sounding Progress</a>\r\n\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=13\">2006 AWG Validation Progress</a>','Sounding',0,'','static','closed','closed','','sounding','','','2007-03-26 15:53:42','2007-03-26 20:53:42','',6,'http://cimss.ssec.wisc.edu/goes_r/awg/science-awg/sounding/',1),(16,2,'2007-01-23 15:33:56','2007-01-23 20:33:56','We propose to adapt and optimize the CIMSS/NESDIS automated feature tracking algorithm for deriving atmospheric motion vectors (AMV) from sequential satellite imagery for applications to the GOES-R ABI.  This project will include software code modifications, testing on proxy datasets, validation, and documentation. This work will insure the readiness of the CIMSS/NESDIS automated AMV algorithm for operational implementation upon the deployment of GOES-R.\r\n\r\nThe development and automated processing of AMVs from satellites has its heritage at CIMSS (Velden et al. 2005).  The proposed research objectives seek to continue this heritage by adapting current methods and algorithms to NOAAâ€™s next generation of geostationary satellites, starting with GOES-R.  The ABI will provide both traditional and new spectral channels that the CIMSS AMV team will employ to test, process and validate using simulated and proxy datasets provided by other members of the GOES-R AWG project.\r\n\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=14\">2006 AWG Winds Progress</a>\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=25\">March 2007 Winds Progress</a>','Winds',0,'','static','closed','closed','','winds','','','2007-04-04 08:44:11','2007-04-04 13:44:11','',6,'http://cimss.ssec.wisc.edu/goes_r/awg/science-awg/winds/',2),(17,2,'2007-01-23 15:34:26','2007-01-23 20:34:26','The primary focus of this effort is to evaluate the current GOES Wildfire Automated Biomass Burning Algorithm (WF_ABBA) and adapt the algorithm for application with the GOES-R ABI.  This activity will build on historical and current expertise at CIMSS in fire algorithm development for the GOES Imager and the global geostationary fire observation network (MSG, MTSAT-1R, INSAT-3D, etc.).  CIMSS will revise the WF_ABBA to address GOES-R ABI observational requirements utilizing the improved fire monitoring capabilities on GOES-R.  This will include updating modules that identify and characterize sub-pixel fire activity, demonstrating and testing the prototype GOES-R ABI WF_ABBA using various GOES-R ABI proxy data sets, and providing a version of the algorithm for further evaluation by the AWG science team.  This effort will involve collaborating with MODIS and NPOESS VIIRS fire product development experts to maximize future use of multiple data sources (geo and leo) that take advantage of the strengths of each system to create improved fused fire products.  This activity will ensure enhanced future geostationary fire detection, diurnal monitoring, and characterization in the GOES-R era.\r\n\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=9\">2006 AWG Biomass Burning Progress</a>','Biomass Burning/Land Surface',0,'','static','closed','closed','','land-surface','','','2007-02-06 16:01:58','2007-02-06 21:01:58','',6,'http://cimss.ssec.wisc.edu/goes_r/awg/science-awg/land-surface/',3),(18,2,'2007-01-23 15:34:47','2007-01-23 20:34:47','New AWG Start, content coming soon.','Aviation',0,'','static','closed','closed','','aviation','','','2007-02-06 16:02:48','2007-02-06 21:02:48','',6,'http://cimss.ssec.wisc.edu/goes_r/awg/science-awg/aviation/',6),(19,2,'2007-01-23 15:35:09','2007-01-23 20:35:09','Through AWG, CIMSS can contribute to the evaluation and selection of aerosol retrieval algorithms.  Emphasis from CIMSS will be on the detection and characterization of dust, smoke and volcanic aerosols.  This activity builds on our historical and current expertise in algorithms developed for AVHRR, MODIS, and current GOES observations. \r\n\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=7\">2006 AWG Aerosol Progress</a>','Aerosol',0,'','static','closed','closed','','aerosol','','','2007-02-06 16:02:34','2007-02-06 21:02:34','',6,'http://cimss.ssec.wisc.edu/goes_r/awg/science-awg/aerosol/',5),(20,2,'2007-01-23 15:35:34','2007-01-23 20:35:34','New AWG start, content coming soon.','Cryosphere',0,'','static','closed','closed','','cryosphere','','','2007-02-05 11:03:32','2007-02-05 16:03:32','',6,'http://cimss.ssec.wisc.edu/goes_r/awg/science-awg/cryosphere/',7),(22,2,'2007-01-31 16:57:42','2007-01-31 21:57:42','<img src=\"http://cimss.ssec.wisc.edu/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0040_abi_band_11.png\" alt=\"sample\" style=\"width: 450px; height: 337px;\" />\r\n\r\n<p>This was released as part of the <a href=\"http://cimss.ssec.wisc.edu/goes_r/awg/proxy_awg_project/deliverables/\">Proxy Dataset Development Deliverables on January 31st, 2007</a>.</p>\r\n\r\n<p><strong> Click on the blue squares below to see the corresponding quicklook image.</strong></p>\r\n<table cellspacing=\"0\" cellpadding=\"0\" class=\"quicklookTable\">\r\n  <tr>\r\n    <th scope=\"col\">&nbsp;</th>\r\n    <th scope=\"col\">00:00 UTC </th>\r\n    <th scope=\"col\">00:40 UTC </th>\r\n    <th scope=\"col\">01:20 UTC </th>\r\n  </tr>\r\n  <tr>\r\n    <th scope=\"row\">Band 8</th>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0000_abi_band_08.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0040_abi_band_08.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0120_abi_band_08.png\">&nbsp;</a></td>\r\n  </tr>\r\n  <tr>\r\n    <th scope=\"row\">Band 9</th>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0000_abi_band_09.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0040_abi_band_09.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0120_abi_band_09.png\">&nbsp;</a></td>\r\n  </tr>\r\n  <tr>\r\n    <th scope=\"row\">Band 10</th>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0000_abi_band_10.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0040_abi_band_10.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0120_abi_band_10.png\">&nbsp;</a></td>\r\n  </tr>\r\n  <tr>\r\n    <th scope=\"row\">Band 11</th>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0000_abi_band_11.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0040_abi_band_11.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0120_abi_band_11.png\">&nbsp;</a></td>\r\n  </tr>\r\n  <tr>\r\n    <th scope=\"row\">Band 12</th>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0000_abi_band_12.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0040_abi_band_12.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0120_abi_band_12.png\">&nbsp;</a></td>\r\n  </tr>\r\n  <tr>\r\n    <th scope=\"row\">Band 13</th>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0000_abi_band_13.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0040_abi_band_13.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0120_abi_band_13.png\">&nbsp;</a></td>\r\n  </tr>\r\n  <tr>\r\n    <th scope=\"row\">Band 14</th>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0000_abi_band_14.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0040_abi_band_14.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0120_abi_band_14.png\">&nbsp;</a></td>\r\n  </tr>\r\n  <tr>\r\n    <th scope=\"row\">Band 15</th>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0000_abi_band_15.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0040_abi_band_15.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0120_abi_band_15.png\">&nbsp;</a></td>\r\n  </tr>\r\n  <tr>\r\n    <th scope=\"row\">Band 16</th>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0000_abi_band_16.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0040_abi_band_16.png\">&nbsp;</a></td>\r\n    <td><a href=\"/goes_r/awg/proxy/toa_radiances/2007jan_deliverable/fd8_2003_0625_0120_abi_band_16.png\">&nbsp;</a></td>\r\n  </tr>\r\n</table>','TOA Radiances Quicklooks',0,'','static','closed','closed','','toa-radiances-quicklooks','','','2007-08-21 14:25:02','2007-08-21 19:25:02','',9,'http://cimss.ssec.wisc.edu/goes_r/awg/proxy_awg_project/deliverables/toa-radiances-quicklooks/',0),(23,2,'2007-02-01 10:55:26','2007-02-01 15:55:26','The GOES-R AWG Proxy Dataset Development Team has delivered their first set of <a href=\"http://cimss.ssec.wisc.edu/goes_r/awg/proxy_awg_project/deliverables/\">deliverables</a> on January 31st, 2007.','Proxy Data Set Development Deliverables',0,'','publish','closed','closed','','proxy-data-set-development-deliverables','','','2007-02-01 10:55:55','2007-02-01 15:55:55','',0,'http://cimss.ssec.wisc.edu/goes_r/awg/2007/02/01/proxy-data-set-development-deliverables/',0),(24,2,'2007-02-05 18:25:32','2007-02-05 23:25:32','Placeholder','Ozone / Air Quality',0,'','static','closed','closed','','ozone-air-quality','','','2007-02-06 16:02:15','2007-02-06 21:02:15','',6,'http://cimss.ssec.wisc.edu/goes_r/awg/science-awg/ozone-air-quality/',4),(25,6,'2007-02-08 14:18:38','2007-02-08 19:18:38','<li>AIT-produced documents:\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=17\">Algorithm Working Group Code Standards</a>\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=18\">Walter Wolf AIT Presentation 20070111</a>\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=26\">GOES-R AWG Delivery Schedule (as of April 2007)</a>\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=30\">ATBD Template Example</a>\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=31\">AIT System Framework 20070725</a>\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=33\">Algorithm Acceptance Procedure 20070725</a>\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=38\">AIT Variable Naming Guidelines (draft)</a>\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=37\">AIT Basic Coding Standards (draft)</a>\r\n</li>\r\n<li>CIMSS-produced documents:\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=34\">SSEC/CIMSS GOES-R AWG AIT Deliverables Timeline</a>\r\n<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=35\">SSEC/CIMSS GOES-R Delivery Schedule</a>\r\n</li>','Algorithm Integration Team',0,'','static','closed','closed','','algorithm-integration-team-awg','','','2008-05-19 17:25:00','2008-05-19 22:25:00','',0,'http://cimss.ssec.wisc.edu/goes_r/awg/algorithm-integration-team-awg/',4),(26,1,'2007-02-21 10:39:07','2007-02-21 15:39:07','','',0,'','draft','closed','closed','','','','','2007-02-21 10:39:07','2007-02-21 15:39:07','',0,'http://cimss.ssec.wisc.edu/goes_r/awg/?p=26',0),(27,6,'2008-02-29 17:06:45','2008-02-29 22:06:45','<a href=\"/goes_r/awg/wp-content/files/file.php?up_id=36\">Geocat manual, version 0.5</a>','Geocat',0,'','static','closed','closed','','geocat-manual','','','2008-05-19 17:13:43','2008-05-19 22:13:43','',0,'http://cimss.ssec.wisc.edu/goes_r/awg/algorithm-integration-team-awg/geocat-manual/',0);
/*!40000 ALTER TABLE `awg_posts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `awg_uploadplus`
--

DROP TABLE IF EXISTS `awg_uploadplus`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `awg_uploadplus` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) default NULL,
  `filename` varchar(255) default NULL,
  `description` varchar(255) default NULL,
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `checkedout` varchar(20) default NULL,
  `v2` varchar(255) default NULL,
  `v3` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=39 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `awg_uploadplus`
--

LOCK TABLES `awg_uploadplus` WRITE;
/*!40000 ALTER TABLE `awg_uploadplus` DISABLE KEYS */;
INSERT INTO `awg_uploadplus` VALUES (2,'GOES-R AWG Meeting','Subject.doc','Notes for 14 July meeting','2006-07-17 13:58:34','2007-01-11 13:42:50','',NULL,NULL),(3,'20061220 SSEC GOES-R AWG Meeting','20061220_SSEC_AWGmeeting.pdf','PDF file containing agenda/notes','2007-01-11 13:43:52','2007-01-11 13:43:52','',NULL,NULL),(4,'Simulated TOA Proxy Dataset Documentation','radiance_data_description_2007Jan31.pdf','AWG Proxy Dataset Deliverable','2007-01-31 13:36:42','2007-01-31 13:43:20','',NULL,NULL),(5,'NWP Model Fields Proxy Dataset Documentation','nwp_model_proxy_documentation_2007Jan26.pdf','AWG Proxy Dataset Deliverable','2007-01-31 13:42:46','2007-01-31 13:42:46','',NULL,NULL),(6,'Fast RT Model Users Manual','fast_model_Users_Manual.2007Jan31.pdf','AWG Proxy Dataset Deliverable','2007-01-31 14:05:46','2007-01-31 14:05:46','',NULL,NULL),(7,'2006 AWG Aerosol Progress','GOES-R-AWG-Aerosols_2006.pdf','Progress 9/1/2006 - 12/31/2006','2007-02-05 09:55:53','2007-02-05 09:55:53','',NULL,NULL),(8,'2006 AWG Cloud Progress','GOES-R-AWG-Clouds_2006.pdf',' Progress 9/1/2006 - 12/31/2006','2007-02-05 09:56:49','2007-02-05 09:56:49','',NULL,NULL),(9,'2006 AWG Biomass Burning Progress','GOES-R-AWG-Fires_2006.pdf','Progress 9/1/2006 - 12/31/2006','2007-02-05 09:57:42','2007-02-05 09:57:42','',NULL,NULL),(10,'2006 AWG Ozone Progress','GOES-R-AWG-Ozone_2006.pdf','Progress 9/1/2006 - 12/31/2006','2007-02-05 09:58:02','2007-02-05 09:58:02','',NULL,NULL),(11,'2006 AWG Proxy Data Progress','GOES-R-AWG-Proxy_2006.pdf','Progress 9/1/2006 - 12/31/2006','2007-02-05 09:58:26','2007-02-05 09:58:26','',NULL,NULL),(12,'2006 AWG Sounding Progress','GOES-R-AWG-Soundings_2006.pdf','Progress 9/1/2006 - 12/31/2006','2007-02-05 09:58:45','2007-02-05 09:58:45','',NULL,NULL),(13,'2006 AWG Validation Progress','GOES-R-AWG-Soundings_validation_2006.pdf','Progress 9/1/2006 - 12/31/2006','2007-02-05 09:59:10','2007-02-05 09:59:10','',NULL,NULL),(14,'2006 AWG Winds Progress','GOES-R-AWG-Winds_2006.pdf','Progress 9/1/2006 - 12/31/2006','2007-02-05 09:59:29','2007-02-05 09:59:29','',NULL,NULL),(15,'20070202 Meeting Agenda/Action Items','20070202_agenda_actionitems.pdf','20070202 Meeting Agenda/Action Items','2007-02-05 10:16:10','2007-02-05 10:16:10','',NULL,NULL),(16,'20070202 Meeting Minutes','GOESR_AWG-2Feb-2007-Minutes.pdf','Meeting Minutes','2007-02-06 14:59:09','2007-02-06 14:59:09','',NULL,NULL),(17,'Algorithm Working Group Code Standards','DocumentationStandards.zip','Code Standards Zip File','2007-02-08 13:24:07','2007-02-08 13:24:07','',NULL,NULL),(18,'Walter Wolf AIT Presentation 20070111','AIT_Preparation_for_Internal_Deliveries_011107.ppt','Powerpoint','2007-02-08 13:27:17','2007-02-08 13:27:17','',NULL,NULL),(19,'Sounding AWG Summary Slides','AWG_sounding_tasks_FY07_Li.ppt','PPT format','2007-02-28 13:39:51','2007-02-28 13:39:51','',NULL,NULL),(20,'Clouds AWG Summary Slides','cimss_awg_cat_slides_v0.ppt','PPT format','2007-02-28 13:41:51','2007-02-28 13:41:51','',NULL,NULL),(21,'Winds AWG Summary Slides','AWG_AMV_ADR.ppt','PPT format','2007-02-28 13:43:05','2007-02-28 13:43:05','',NULL,NULL),(22,'Biomass Burning AWG Summary Slides','AWG_fire_Summary_Goals.ppt','PPT format','2007-02-28 13:44:15','2007-02-28 13:44:15','',NULL,NULL),(23,'20070329 Meeting Agenda/Action Items','20070329_agenda_actionitems.pdf','20070329 Meeting Agenda/Action Items','2007-04-03 10:13:18','2007-04-03 10:13:18','',NULL,NULL),(24,'20070329 Meeting Minutes','GOESR_AWG-29Mar-2007-Minutes.pdf','20070329 Meeting Minutes','2007-04-03 10:14:01','2007-04-03 10:14:01','',NULL,NULL),(25,'March 2007 Winds Progress','AWG_monthly_winds_Mar2007.pdf','Monthly Progress Report','2007-04-04 08:43:48','2007-04-04 08:43:48','',NULL,NULL),(26,'GOES-R AWG Delivery Schedule','GOES-R_AWG_Deliveries_Schedule.ppt','Schedule','2007-04-06 17:01:49','2007-04-06 17:01:49','',NULL,NULL),(27,'GOES-R_AWG_20070430 Minutes','GOESR_AWG-30Apr2007-minutes.pdf','Internal Meeting Minutes','2007-06-26 12:39:20','2007-06-26 12:39:20','',NULL,NULL),(28,'GOES-R_AWG_20070531 Minutes','GOESR_AWG-31May-2007-Minutes.pdf','Internal Meeting Minutes','2007-06-26 12:39:58','2007-06-26 12:39:58','',NULL,NULL),(29,'GOESR_AWG_20070627 Meeting Minutes','GOESR_AWG-27June-2007-Minutes.pdf','Internal Meeting Minutes','2007-09-06 10:30:46','2007-09-06 10:31:26','',NULL,NULL),(30,'ATBD Example','ATBDcontents_GOESR_AWG_v3.2.pdf','ATBD Example','2007-09-06 10:46:46','2007-09-06 10:46:46','',NULL,NULL),(31,'AIT System Framework','AIT_Framework_072507.pdf','AIT Framework','2007-09-06 10:47:23','2007-09-06 10:47:23','',NULL,NULL),(32,'GOESR_AWG_20070802_Minutes','GOESR_AWG-2Aug-2007-Minutes.pdf','Meeting minutes','2007-09-06 10:51:02','2007-09-06 10:51:02','',NULL,NULL),(33,'Algorithm Acceptance Procedure','Algorithm_Acceptance_Procedure_v0.2.pdf','Algorithm Acceptance Procedure','2007-09-06 10:57:54','2007-09-06 10:57:54','',NULL,NULL),(34,'SSEC/CIMSS GOES-R AWG AIT Deliverables Timeline','ait_milestone_timeline.ppt','PPT timeline of deliverables','2007-10-25 14:06:57','2007-10-25 14:06:57','',NULL,NULL),(35,'SSEC/CIMSS GOES-R Delivery Schedule','ait_deliverables.xls','SSEC/CIMSS GOES-R Delivery Schedule','2007-10-25 14:17:49','2007-10-25 14:17:49','',NULL,NULL),(36,'Geocat manual','geocat_manual_v0_5.pdf','version 0.5','2008-02-29 16:05:51','2008-02-29 16:05:51','',NULL,NULL),(37,'AIT Basic Coding Standards','Basic_Coding_Standards.doc','draft - AIT coding standards for V2 (80%) delivery','2008-05-19 11:24:35','2008-05-19 11:24:35','',NULL,NULL),(38,'AIT Variable Naming Guidelines','Variable_Naming_Guidelines.doc','draft - AIT Variable Naming Guidelines, including a table of common abbreviations','2008-05-19 11:26:39','2008-05-19 11:28:38','',NULL,NULL);
/*!40000 ALTER TABLE `awg_uploadplus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `awg_users`
--

DROP TABLE IF EXISTS `awg_users`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `awg_users` (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `user_login` varchar(60) NOT NULL default '',
  `user_pass` varchar(64) NOT NULL default '',
  `user_firstname` varchar(50) NOT NULL default '',
  `user_lastname` varchar(50) NOT NULL default '',
  `user_nickname` varchar(50) NOT NULL default '',
  `user_nicename` varchar(50) NOT NULL default '',
  `user_icq` int(10) unsigned NOT NULL default '0',
  `user_email` varchar(100) NOT NULL default '',
  `user_url` varchar(100) NOT NULL default '',
  `user_ip` varchar(15) NOT NULL default '',
  `user_domain` varchar(200) NOT NULL default '',
  `user_browser` varchar(200) NOT NULL default '',
  `user_registered` datetime NOT NULL default '0000-00-00 00:00:00',
  `user_level` int(2) unsigned NOT NULL default '0',
  `user_aim` varchar(50) NOT NULL default '',
  `user_msn` varchar(100) NOT NULL default '',
  `user_yim` varchar(50) NOT NULL default '',
  `user_idmode` varchar(20) NOT NULL default '',
  `user_activation_key` varchar(60) NOT NULL default '',
  `user_status` int(11) NOT NULL default '0',
  `user_description` longtext NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `user_login` (`user_login`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `awg_users`
--

LOCK TABLES `awg_users` WRITE;
/*!40000 ALTER TABLE `awg_users` DISABLE KEYS */;
INSERT INTO `awg_users` VALUES (1,'admin','c3fc84c3041358507aebd5076d59d549','','','Administrator','administrator',0,'billb@ssec.wisc.edu','http://','','','','2006-07-17 08:44:03',10,'','','','nickname','',0,''),(2,'waynef','509c6cc7546b79a1b15e743afeb6fdeb','Wayne','Feltz','waynef','waynef',0,'waynef@ssec.wisc.edu','http://','','','','2006-07-17 18:29:18',5,'','','','nickname','',0,''),(3,'tomg','696ceb77034963a34dc82f5ab18bf16d','Tom','Greenwald','tomg','tomg',0,'tom.greenwald@ssec.wisc.edu','http://','','','','2007-02-07 19:38:56',5,'','','','nickname','',0,''),(4,'matg','2e77f671a2ca15a392dd9297532a9be7','Mat','Gunshor','matg','matg',0,'mat.gunshor@ssec.wisc.edu','http://','','','','2007-02-07 19:39:41',5,'','','','nickname','',0,''),(5,'stevew','6efbe20e1cbc03776b161e50fdf69857','Steve','Wanzong','stevew','stevew',0,'stevew@ssec.wisc.edu','http://','','','','2007-02-28 21:58:50',5,'','','','nickname','',0,''),(6,'graemem','9d735b43b8cae08bc3217daff4bfdea4','Graeme','Martin','graemem','graemem',0,'graeme.martin@ssec.wisc.edu','http://','','','','2008-02-29 21:58:26',5,'','','','nickname','',0,''),(7,'joleenf','22f08dd722d4871a11a8780c2b121a14','Joleen','Feltz','joleenf','joleenf',0,'joleen.feltz@ssec.wisc.edu','http://','','','','2010-04-01 15:04:16',9,'','','','nickname','',0,'');
/*!40000 ALTER TABLE `awg_users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_categories`
--

DROP TABLE IF EXISTS `wp_categories`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `wp_categories` (
  `cat_ID` bigint(20) NOT NULL auto_increment,
  `cat_name` varchar(55) NOT NULL default '',
  `category_nicename` varchar(200) NOT NULL default '',
  `category_description` longtext NOT NULL,
  `category_parent` int(4) NOT NULL default '0',
  PRIMARY KEY  (`cat_ID`),
  KEY `category_nicename` (`category_nicename`)
) ENGINE=MyISAM AUTO_INCREMENT=25 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `wp_categories`
--

LOCK TABLES `wp_categories` WRITE;
/*!40000 ALTER TABLE `wp_categories` DISABLE KEYS */;
INSERT INTO `wp_categories` VALUES (1,'Uncategorized','uncategorized','',0),(2,'Monthly Progress Reports','monthly-progress-reports','Monthly Progress Reports',24),(3,'Statements of Work','statements-of-work','Quarterly Statements of Work of each AD staff',24),(4,'Group Quarterly Reports','group-quarterly-reports','Quarterly Group Leaders Progress Reports',24),(5,'Meeting Notes','meeting-notes','Monthly Group Meeting Notes',24),(6,'Cloud Model','cloud-model','',4),(10,'Forward Model','forward-model','',4),(8,'Announcements','announcements','',0),(9,'AD Quarterly Reports','ad-quarterly-reports','',24),(11,'NWP Model','nwp-model','',4),(12,'Surface Emissivity Model','surface-emissivity-model','',4),(13,'Aerosol/Dust Model','aerosoldust-model','',4),(14,'Simulation Dataset','simulation-dataset','',4),(15,'Wind','wind','',4),(16,'Sounding','sounding','',4),(17,'Tropical Cyclone','tropical-cyclone','',4),(18,'Biomass Burning','biomass-burning','',4),(19,'Cloud Retrieval','cloud-retrieval','',4),(20,'Aerosol/Dust Retrieval','aerosoldust-retrieval','',4),(21,'ATBD','atbd','',24),(22,'Presentation','presentation','For the deposit of all GOES-R3 Algorithm Development related presentation materials.',24),(23,'Publication/Documentation','publicationdocumentation','For the deposite of all GOES-R3 AD related publications and documentations',24),(24,'Algorith Development','algorith-development','',0);
/*!40000 ALTER TABLE `wp_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_comments`
--

DROP TABLE IF EXISTS `wp_comments`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL auto_increment,
  `comment_post_ID` int(11) NOT NULL default '0',
  `comment_author` tinytext NOT NULL,
  `comment_author_email` varchar(100) NOT NULL default '',
  `comment_author_url` varchar(200) NOT NULL default '',
  `comment_author_IP` varchar(100) NOT NULL default '',
  `comment_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL default '0000-00-00 00:00:00',
  `comment_content` text NOT NULL,
  `comment_karma` int(11) NOT NULL default '0',
  `comment_approved` enum('0','1','spam') NOT NULL default '1',
  `comment_agent` varchar(255) NOT NULL default '',
  `comment_type` varchar(20) NOT NULL default '',
  `comment_parent` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`comment_ID`),
  KEY `comment_approved` (`comment_approved`),
  KEY `comment_post_ID` (`comment_post_ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `wp_comments`
--

LOCK TABLES `wp_comments` WRITE;
/*!40000 ALTER TABLE `wp_comments` DISABLE KEYS */;
/*!40000 ALTER TABLE `wp_comments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_linkcategories`
--

DROP TABLE IF EXISTS `wp_linkcategories`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `wp_linkcategories` (
  `cat_id` bigint(20) NOT NULL auto_increment,
  `cat_name` tinytext NOT NULL,
  `auto_toggle` enum('Y','N') NOT NULL default 'N',
  `show_images` enum('Y','N') NOT NULL default 'Y',
  `show_description` enum('Y','N') NOT NULL default 'N',
  `show_rating` enum('Y','N') NOT NULL default 'Y',
  `show_updated` enum('Y','N') NOT NULL default 'Y',
  `sort_order` varchar(64) NOT NULL default 'rand',
  `sort_desc` enum('Y','N') NOT NULL default 'N',
  `text_before_link` varchar(128) NOT NULL default '<li>',
  `text_after_link` varchar(128) NOT NULL default '<br />',
  `text_after_all` varchar(128) NOT NULL default '</li>',
  `list_limit` int(11) NOT NULL default '-1',
  PRIMARY KEY  (`cat_id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `wp_linkcategories`
--

LOCK TABLES `wp_linkcategories` WRITE;
/*!40000 ALTER TABLE `wp_linkcategories` DISABLE KEYS */;
INSERT INTO `wp_linkcategories` VALUES (1,'Blogroll','N','Y','N','Y','Y','rand','N','<li>','<br />','</li>',-1),(2,'Other Resources','N','N','N','N','N','rating','N','<li>','<br />','</li>',-1),(4,'Mailing Lists','N','N','N','N','N','name','N','<li>','<br />','</li>',-1);
/*!40000 ALTER TABLE `wp_linkcategories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_links`
--

DROP TABLE IF EXISTS `wp_links`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `wp_links` (
  `link_id` bigint(20) NOT NULL auto_increment,
  `link_url` varchar(255) NOT NULL default '',
  `link_name` varchar(255) NOT NULL default '',
  `link_image` varchar(255) NOT NULL default '',
  `link_target` varchar(25) NOT NULL default '',
  `link_category` int(11) NOT NULL default '0',
  `link_description` varchar(255) NOT NULL default '',
  `link_visible` enum('Y','N') NOT NULL default 'Y',
  `link_owner` int(11) NOT NULL default '1',
  `link_rating` int(11) NOT NULL default '0',
  `link_updated` datetime NOT NULL default '0000-00-00 00:00:00',
  `link_rel` varchar(255) NOT NULL default '',
  `link_notes` mediumtext NOT NULL,
  `link_rss` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`link_id`),
  KEY `link_category` (`link_category`),
  KEY `link_visible` (`link_visible`)
) ENGINE=MyISAM AUTO_INCREMENT=15 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `wp_links`
--

LOCK TABLES `wp_links` WRITE;
/*!40000 ALTER TABLE `wp_links` DISABLE KEYS */;
INSERT INTO `wp_links` VALUES (14,'https://mailserv.ssec.wisc.edu/Lists/goesr_riskreduction_leads/List.html?Language=','Risk Reduction Leads','','',4,'mailing list archive','Y',1,0,'0000-00-00 00:00:00','','',''),(9,'http://www.ssec.wisc.edu/','SSEC','','',2,'','Y',2,2,'0000-00-00 00:00:00','','',''),(10,'http://cimss.ssec.wisc.edu/','CIMSS','','',2,'','Y',2,1,'0000-00-00 00:00:00','','',''),(11,'http://cimss.ssec.wisc.edu/goes/abi/','HES/ABI GOES-R Instrument Studies','','',2,'','Y',2,3,'0000-00-00 00:00:00','','',''),(12,'https://mailserv.ssec.wisc.edu/Lists/goesr3-AD/List.html?Language=','Algorithm Development','','',4,'mailing list archive','Y',1,0,'0000-00-00 00:00:00','','',''),(13,'https://mailserv.ssec.wisc.edu/Lists/goesr_riskreduction/List.html?Language=','Risk Reduction','','',4,'mailing list archive','Y',1,0,'0000-00-00 00:00:00','','','');
/*!40000 ALTER TABLE `wp_links` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_options`
--

DROP TABLE IF EXISTS `wp_options`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `wp_options` (
  `option_id` bigint(20) NOT NULL auto_increment,
  `blog_id` int(11) NOT NULL default '0',
  `option_name` varchar(64) NOT NULL default '',
  `option_can_override` enum('Y','N') NOT NULL default 'Y',
  `option_type` int(11) NOT NULL default '1',
  `option_value` longtext NOT NULL,
  `option_width` int(11) NOT NULL default '20',
  `option_height` int(11) NOT NULL default '8',
  `option_description` tinytext NOT NULL,
  `option_admin_level` int(11) NOT NULL default '1',
  `autoload` enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (`option_id`,`blog_id`,`option_name`),
  KEY `option_name` (`option_name`)
) ENGINE=MyISAM AUTO_INCREMENT=73 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `wp_options`
--

LOCK TABLES `wp_options` WRITE;
/*!40000 ALTER TABLE `wp_options` DISABLE KEYS */;
INSERT INTO `wp_options` VALUES (1,0,'siteurl','Y',1,'http://cimss.ssec.wisc.edu/goes_r/rr',20,8,'WordPress web address',1,'yes'),(2,0,'blogname','Y',1,'GOES R Risk Reduction',20,8,'Blog title',1,'yes'),(3,0,'blogdescription','Y',1,'GOES-R Risk Reduction Intranet',20,8,'Short tagline',1,'yes'),(4,0,'new_users_can_blog','Y',1,'0',20,8,'',1,'yes'),(5,0,'users_can_register','Y',1,'',20,8,'',1,'yes'),(6,0,'admin_email','Y',1,'bill.bellon@ssec.wisc.edu',20,8,'',1,'yes'),(7,0,'start_of_week','Y',1,'1',20,8,'',1,'yes'),(8,0,'use_balanceTags','Y',1,'1',20,8,'',1,'yes'),(9,0,'use_smilies','Y',1,'1',20,8,'',1,'yes'),(10,0,'require_name_email','Y',1,'1',20,8,'',1,'yes'),(11,0,'comments_notify','Y',1,'1',20,8,'',1,'yes'),(12,0,'posts_per_rss','Y',1,'10',20,8,'',1,'yes'),(13,0,'rss_excerpt_length','Y',1,'50',20,8,'',1,'yes'),(14,0,'rss_use_excerpt','Y',1,'0',20,8,'',1,'yes'),(15,0,'use_fileupload','Y',1,'',20,8,'',1,'yes'),(16,0,'fileupload_realpath','Y',1,'/var/apache/cimss/htdocs/goes_r/internal/alg_dev/wp-content',20,8,'',1,'yes'),(17,0,'fileupload_url','Y',1,'/goes_r/internal/alg_dev/wp-content',20,8,'',1,'yes'),(18,0,'fileupload_allowedtypes','Y',1,'jpg jpeg gif png doc xls txt ppt pdf',20,8,'',1,'yes'),(19,0,'fileupload_maxk','Y',1,'300',20,8,'',1,'yes'),(20,0,'fileupload_minlevel','Y',1,'5',20,8,'',1,'yes'),(21,0,'mailserver_url','Y',1,'mail.example.com',20,8,'',1,'yes'),(22,0,'mailserver_login','Y',1,'login@example.com',20,8,'',1,'yes'),(23,0,'mailserver_pass','Y',1,'password',20,8,'',1,'yes'),(24,0,'mailserver_port','Y',1,'110',20,8,'',1,'yes'),(25,0,'default_category','Y',1,'1',20,8,'',1,'yes'),(26,0,'default_comment_status','Y',1,'closed',20,8,'',1,'yes'),(27,0,'default_ping_status','Y',1,'closed',20,8,'',1,'yes'),(28,0,'default_pingback_flag','Y',1,'',20,8,'',1,'yes'),(29,0,'default_post_edit_rows','Y',1,'9',20,8,'',1,'yes'),(30,0,'posts_per_page','Y',1,'10',20,8,'',1,'yes'),(31,0,'what_to_show','Y',1,'posts',20,8,'',1,'yes'),(32,0,'date_format','Y',1,'F j, Y',20,8,'',1,'yes'),(33,0,'time_format','Y',1,'g:i a',20,8,'',1,'yes'),(34,0,'links_updated_date_format','Y',1,'F j, Y g:i a',20,8,'',1,'yes'),(35,0,'links_recently_updated_prepend','Y',1,'<em>',20,8,'',1,'yes'),(36,0,'links_recently_updated_append','Y',1,'</em>',20,8,'',1,'yes'),(37,0,'links_recently_updated_time','Y',1,'120',20,8,'',1,'yes'),(38,0,'comment_moderation','Y',1,'1',20,8,'',1,'yes'),(39,0,'moderation_notify','Y',1,'1',20,8,'',1,'yes'),(40,0,'permalink_structure','Y',1,'/%year%/%monthnum%/%day%/%postname%/',20,8,'',1,'yes'),(41,0,'gzipcompression','Y',1,'0',20,8,'',1,'yes'),(42,0,'hack_file','Y',1,'',20,8,'',1,'yes'),(43,0,'blog_charset','Y',1,'UTF-8',20,8,'',1,'yes'),(44,0,'moderation_keys','Y',1,'',20,8,'',1,'no'),(45,0,'active_plugins','Y',1,'a:5:{i:0;s:0:\"\";i:1;s:33:\"restrictAccess/restrictAccess.php\";i:2;s:17:\"show_overview.php\";i:3;s:25:\"uploadplus/uploadplus.php\";i:4;s:15:\"wrapexcerpt.php\";}',20,8,'',1,'yes'),(46,0,'home','Y',1,'http://cimss.ssec.wisc.edu/goes_r/rr',20,8,'',1,'yes'),(47,0,'category_base','Y',1,'',20,8,'',1,'yes'),(48,0,'ping_sites','Y',1,'',20,8,'',1,'yes'),(49,0,'advanced_edit','Y',1,'1',20,8,'',1,'yes'),(50,0,'comment_max_links','Y',1,'2',20,8,'',1,'yes'),(51,0,'default_email_category','Y',1,'1',20,8,'Posts by email go to this category',1,'yes'),(52,0,'recently_edited','Y',1,'a:2:{i:0;s:9:\"index.php\";i:2;b:0;}',20,8,'',1,'no'),(53,0,'use_linksupdate','Y',1,'',20,8,'',1,'yes'),(54,0,'template','Y',1,'goes_r',20,8,'',1,'yes'),(55,0,'stylesheet','Y',1,'goes_r',20,8,'',1,'yes'),(56,0,'comment_whitelist','Y',1,'1',20,8,'',1,'yes'),(57,0,'page_uris','Y',1,'a:9:{s:21:\"alg_dev/task-priority\";s:13:\"task-priority\";s:8:\"overview\";s:8:\"overview\";s:10:\"user-notes\";s:10:\"user-notes\";s:9:\"file-list\";s:9:\"file-list\";s:7:\"alg_dev\";s:7:\"alg_dev\";s:26:\"goes-r-risk-reduction-plan\";s:26:\"goes-r-risk-reduction-plan\";s:22:\"proposed-2007-activies\";s:22:\"proposed-2007-activies\";s:26:\"major-accomplishments-2006\";s:26:\"major-accomplishments-2006\";s:32:\"goes-r-risk-reduction-activities\";s:32:\"goes-r-risk-reduction-activities\";}',20,8,'',1,'yes'),(58,0,'blacklist_keys','Y',1,'',20,8,'',1,'no'),(59,0,'comment_registration','Y',1,'1',20,8,'',1,'yes'),(60,0,'open_proxy_check','Y',1,'1',20,8,'',1,'yes'),(61,0,'rss_language','Y',1,'en',20,8,'',1,'yes'),(62,0,'html_type','Y',1,'text/html',20,8,'',1,'yes'),(63,0,'use_trackback','Y',1,'0',20,8,'',1,'yes'),(64,0,'gmt_offset','Y',1,'-5',20,8,'',1,'yes'),(65,0,'rss_e7e6a539c0ab014a584494af2ba42a75','Y',1,'O:9:\"magpierss\":17:{s:6:\"parser\";i:0;s:12:\"current_item\";a:0:{}s:5:\"items\";a:1:{i:0;a:3:{s:5:\"title\";s:16:\"No results found\";s:11:\"description\";s:76:\"No results were found for http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev\";s:7:\"summary\";s:76:\"No results were found for http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev\";}}s:7:\"channel\";a:10:{s:9:\"generator\";s:15:\"Technorati v1.0\";s:9:\"webmaster\";s:43:\"support@technorati.com (Technorati Support)\";s:4:\"docs\";s:37:\"http://blogs.law.harvard.edu/tech/rss\";s:3:\"ttl\";s:2:\"60\";s:4:\"tapi\";a:3:{s:6:\"result\";s:5:\"\n    \";s:10:\"result_url\";s:50:\"http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev\";s:19:\"result_rankingstart\";s:1:\"0\";}s:6:\"result\";s:16:\"\n    \n    \n    \n\";s:5:\"title\";s:23:\"Technorati Search for: \";s:4:\"link\";s:50:\"http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev\";s:7:\"pubdate\";s:29:\"Thu, 01 Jan 1970 00:00:00 GMT\";s:7:\"tagline\";N;}s:9:\"textinput\";a:4:{s:5:\"title\";s:17:\"Search Technorati\";s:11:\"description\";s:43:\"Search millions of blogs for the latest on:\";s:4:\"name\";s:1:\"s\";s:4:\"link\";s:36:\"http://www.technorati.com/search.php\";}s:5:\"image\";a:3:{s:3:\"url\";s:50:\"http://static.technorati.com/pix/logos/logo_sm.gif\";s:5:\"title\";s:15:\"Technorati logo\";s:4:\"link\";s:25:\"http://www.technorati.com\";}s:9:\"feed_type\";s:3:\"RSS\";s:12:\"feed_version\";s:3:\"2.0\";s:5:\"stack\";a:0:{}s:9:\"inchannel\";b:0;s:6:\"initem\";b:0;s:9:\"incontent\";b:0;s:11:\"intextinput\";b:0;s:7:\"inimage\";b:0;s:13:\"current_field\";s:0:\"\";s:17:\"current_namespace\";b:0;s:19:\"_CONTENT_CONSTRUCTS\";a:6:{i:0;s:7:\"content\";i:1;s:7:\"summary\";i:2;s:4:\"info\";i:3;s:5:\"title\";i:4;s:7:\"tagline\";i:5;s:9:\"copyright\";}}',20,8,'',1,'no'),(66,0,'rss_e7e6a539c0ab014a584494af2ba42a75_ts','Y',1,'1149620927',20,8,'',1,'no'),(67,0,'rss_0ff4b43bd116a9d8720d689c80e7dfd4','Y',1,'O:9:\"magpierss\":19:{s:6:\"parser\";i:0;s:12:\"current_item\";a:0:{}s:5:\"items\";a:5:{i:0;a:12:{s:5:\"title\";s:32:\"Don?t Panic! WordPress Is Secure\";s:4:\"link\";s:61:\"http://wordpress.org/development/2005/11/wordpress-is-secure/\";s:8:\"comments\";s:70:\"http://wordpress.org/development/2005/11/wordpress-is-secure/#comments\";s:7:\"pubdate\";s:31:\"Tue, 08 Nov 2005 17:02:27 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:6:\"Dougal\";}s:8:\"category\";s:19:\"DevelopmentSecurity\";s:4:\"guid\";s:61:\"http://wordpress.org/development/2005/11/wordpress-is-secure/\";s:11:\"description\";s:353:\"There is news of a worm which uses a vulnerability in the PHPXMLRPC libraries to spread a computer virus. Some articles are pointing to out-of-date information claiming that WordPress 1.5 is vulnerable. That is incorrect. WordPress 1.5 or higher is safe. Since the release of version 1.5, WordPress has used a completely different XML-RPC library, [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:1332:\"<p>There is <a href=\"http://www.theregister.co.uk/2005/11/07/linux_worm/\" title=\"Linux Worm\">news</a> of a worm which uses a vulnerability in the PHPXMLRPC libraries to spread a computer virus. Some articles are pointing to out-of-date information claiming that WordPress 1.5 is vulnerable. That is incorrect. <strong>WordPress 1.5 or higher is safe</strong>. Since the release of version 1.5, WordPress has used a completely different XML-RPC library, called IXR.</p>\n<p>Older WP versions (1.2.x and earlier) are vulnerable, however. If for some reason you are still running a pre-1.5 version of WordPress, you should upgrade immediately to the latest version, <a href=\"/development/2005/08/one-five-two/\" title=\"The Strayhorn Release\">WordPress 1.5.2 &#8220;Strayhorn&#8221;</a>. If upgrading poses a problem for some reason, and if you don&#8217;t need pingbacks or blog client API functionality, simply delete the class-xmlrpc.php and class-xmlrpcs.php files from your installation&#8217;s wp-includes directory (but you really should upgrade).</p>\n<p>Also if you ever come across something you feel might be a security problem in WordPress, please send a note to <a href=\"http://wordpress.org/about/contact/\">the special address we&#8217;ve set up for security purposes</a> and we will address it as quickly as possible.  </p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:66:\"http://wordpress.org/development/2005/11/wordpress-is-secure/feed/\";}s:7:\"summary\";s:353:\"There is news of a worm which uses a vulnerability in the PHPXMLRPC libraries to spread a computer virus. Some articles are pointing to out-of-date information claiming that WordPress 1.5 is vulnerable. That is incorrect. WordPress 1.5 or higher is safe. Since the release of version 1.5, WordPress has used a completely different XML-RPC library, [...]\";s:12:\"atom_content\";s:1332:\"<p>There is <a href=\"http://www.theregister.co.uk/2005/11/07/linux_worm/\" title=\"Linux Worm\">news</a> of a worm which uses a vulnerability in the PHPXMLRPC libraries to spread a computer virus. Some articles are pointing to out-of-date information claiming that WordPress 1.5 is vulnerable. That is incorrect. <strong>WordPress 1.5 or higher is safe</strong>. Since the release of version 1.5, WordPress has used a completely different XML-RPC library, called IXR.</p>\n<p>Older WP versions (1.2.x and earlier) are vulnerable, however. If for some reason you are still running a pre-1.5 version of WordPress, you should upgrade immediately to the latest version, <a href=\"/development/2005/08/one-five-two/\" title=\"The Strayhorn Release\">WordPress 1.5.2 &#8220;Strayhorn&#8221;</a>. If upgrading poses a problem for some reason, and if you don&#8217;t need pingbacks or blog client API functionality, simply delete the class-xmlrpc.php and class-xmlrpcs.php files from your installation&#8217;s wp-includes directory (but you really should upgrade).</p>\n<p>Also if you ever come across something you feel might be a security problem in WordPress, please send a note to <a href=\"http://wordpress.org/about/contact/\">the special address we&#8217;ve set up for security purposes</a> and we will address it as quickly as possible.  </p>\n\";}i:1;a:12:{s:5:\"title\";s:8:\"Bug Hunt\";s:4:\"link\";s:50:\"http://wordpress.org/development/2005/11/bug-hunt/\";s:8:\"comments\";s:59:\"http://wordpress.org/development/2005/11/bug-hunt/#comments\";s:7:\"pubdate\";s:31:\"Thu, 03 Nov 2005 16:28:04 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:17:\"DevelopmentEvents\";s:4:\"guid\";s:50:\"http://wordpress.org/development/2005/11/bug-hunt/\";s:11:\"description\";s:342:\"You are invited to the WordPress Bug Hunt on Saturday, November 5th, 2005!\nWhether youâ€™re a die-hard WordPress hacker or just looking to gain some familiarity with WordPress internals, we need your help! Join us in #wordpress-bugs on irc.freenode.net as we triage and eliminate as many bugs as possible.  Work with us to confirm bugs, [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:1038:\"<p>You are invited to the WordPress Bug Hunt on <strong>Saturday, November 5th, 2005</strong>!</p>\n<p>Whether youâ€™re a die-hard WordPress hacker or just looking to gain some familiarity with WordPress internals, we need your help! Join us in #wordpress-bugs on irc.freenode.net as we triage and eliminate as many <a href=\"http://trac.wordpress.org/report/12\">bugs</a> as possible.  Work with us to confirm bugs, submit and test patches, and generally geek out.</p>\n<p>All you need to bring is a text editor, and an installation of <a href=\"/download/svn/\">WordPress 1.6-ALPHA</a>! Weâ€™ll provide the snacks, and manage the schedule.   </p>\n<p>Weâ€™ll start as soon as you arrive, so please be prompt!</p>\n<p>See <a href=\"http://codex.wordpress.org/WordPress_Bug_Hunts\">WordPress Bug Hunts</a> on the Codex for additional information. This looks to be a recurring effort, so if you canâ€™t attend this one, stay tuned for future Bug Hunts! We&#8217;ll also be working on Sunday, though the main thrust of the event is Saturday.    </p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:55:\"http://wordpress.org/development/2005/11/bug-hunt/feed/\";}s:7:\"summary\";s:342:\"You are invited to the WordPress Bug Hunt on Saturday, November 5th, 2005!\nWhether youâ€™re a die-hard WordPress hacker or just looking to gain some familiarity with WordPress internals, we need your help! Join us in #wordpress-bugs on irc.freenode.net as we triage and eliminate as many bugs as possible.  Work with us to confirm bugs, [...]\";s:12:\"atom_content\";s:1038:\"<p>You are invited to the WordPress Bug Hunt on <strong>Saturday, November 5th, 2005</strong>!</p>\n<p>Whether youâ€™re a die-hard WordPress hacker or just looking to gain some familiarity with WordPress internals, we need your help! Join us in #wordpress-bugs on irc.freenode.net as we triage and eliminate as many <a href=\"http://trac.wordpress.org/report/12\">bugs</a> as possible.  Work with us to confirm bugs, submit and test patches, and generally geek out.</p>\n<p>All you need to bring is a text editor, and an installation of <a href=\"/download/svn/\">WordPress 1.6-ALPHA</a>! Weâ€™ll provide the snacks, and manage the schedule.   </p>\n<p>Weâ€™ll start as soon as you arrive, so please be prompt!</p>\n<p>See <a href=\"http://codex.wordpress.org/WordPress_Bug_Hunts\">WordPress Bug Hunts</a> on the Codex for additional information. This looks to be a recurring effort, so if you canâ€™t attend this one, stay tuned for future Bug Hunts! We&#8217;ll also be working on Sunday, though the main thrust of the event is Saturday.    </p>\n\";}i:2;a:12:{s:5:\"title\";s:34:\"The Blogging Enterprise Conference\";s:4:\"link\";s:61:\"http://wordpress.org/development/2005/11/blogging-enterprise/\";s:8:\"comments\";s:70:\"http://wordpress.org/development/2005/11/blogging-enterprise/#comments\";s:7:\"pubdate\";s:31:\"Tue, 01 Nov 2005 05:19:16 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:17:\"DevelopmentEvents\";s:4:\"guid\";s:61:\"http://wordpress.org/development/2005/11/blogging-enterprise/\";s:11:\"description\";s:338:\"If any of you are in or near Austin, TX this Wednesday you should definitely check out the one-day Blogging Enterprise conference on November 2nd at the University of Texas. It looks like it&#8217;s going to be a great program, and I&#8217;ll be speaking on &#8220;Sorting Out RSS Software, Tools, and Technology&#8221; at 11:15 AM. [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:789:\"<p>If any of you are in or near Austin, TX this Wednesday you should definitely check out the one-day <a href=\"http://www.thebloggingenterprise.com/\">Blogging Enterprise conference</a> on November 2nd at the University of Texas. It looks like it&#8217;s going to be a great program, and I&#8217;ll be speaking on &#8220;Sorting Out RSS Software, Tools, and Technology&#8221; at 11:15 AM. Of course the best reason to go is <a href=\"http://www.thebloggingenterprise.com/\">they use WordPress to power their entire site</a>. I&#8217;m looking forward to the conference and spending some time in Texas again.</p>\n<p>Update: <a href=\"http://redcouch.typepad.com/weblog/2005/11/its_about_unsuc.html\">Shel Isreal blogged the panel</a> and also has been blogging the rest of the conference.Â </p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:66:\"http://wordpress.org/development/2005/11/blogging-enterprise/feed/\";}s:7:\"summary\";s:338:\"If any of you are in or near Austin, TX this Wednesday you should definitely check out the one-day Blogging Enterprise conference on November 2nd at the University of Texas. It looks like it&#8217;s going to be a great program, and I&#8217;ll be speaking on &#8220;Sorting Out RSS Software, Tools, and Technology&#8221; at 11:15 AM. [...]\";s:12:\"atom_content\";s:789:\"<p>If any of you are in or near Austin, TX this Wednesday you should definitely check out the one-day <a href=\"http://www.thebloggingenterprise.com/\">Blogging Enterprise conference</a> on November 2nd at the University of Texas. It looks like it&#8217;s going to be a great program, and I&#8217;ll be speaking on &#8220;Sorting Out RSS Software, Tools, and Technology&#8221; at 11:15 AM. Of course the best reason to go is <a href=\"http://www.thebloggingenterprise.com/\">they use WordPress to power their entire site</a>. I&#8217;m looking forward to the conference and spending some time in Texas again.</p>\n<p>Update: <a href=\"http://redcouch.typepad.com/weblog/2005/11/its_about_unsuc.html\">Shel Isreal blogged the panel</a> and also has been blogging the rest of the conference.Â </p>\n\";}i:3;a:12:{s:5:\"title\";s:12:\"Webzine 2005\";s:4:\"link\";s:54:\"http://wordpress.org/development/2005/09/webzine-2005/\";s:8:\"comments\";s:63:\"http://wordpress.org/development/2005/09/webzine-2005/#comments\";s:7:\"pubdate\";s:31:\"Fri, 23 Sep 2005 20:13:57 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:6:\"Events\";s:4:\"guid\";s:54:\"http://wordpress.org/development/2005/09/webzine-2005/\";s:11:\"description\";s:309:\"Myself and a few other WordPress folks will be spending the weekend at Webzine 2005 here in San Francisco. It has shaped up to be a really amazing conference that embraces the indy roots of what we do and I&#8217;ve been looking forward to it for a while now. Best of all, it&#8217;s affordable! Tickets [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:592:\"<p>Myself and a few other WordPress folks will be spending the weekend at <a href=\"http://webzine2005.com/\">Webzine 2005</a> here in San Francisco. It has shaped up to be a really amazing conference that embraces the indy roots of what we do and I&#8217;ve been looking forward to it for a while now. Best of all, it&#8217;s affordable! Tickets are only $22 for both days. If you&#8217;re a WP user and attending be sure to say hi during the conference. I&#8217;ll be participating in two panels, &#8220;Making Media with Open Source&#8221; Tools and &#8220;Blog Wares Dance Off.&#8221;\n</p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:59:\"http://wordpress.org/development/2005/09/webzine-2005/feed/\";}s:7:\"summary\";s:309:\"Myself and a few other WordPress folks will be spending the weekend at Webzine 2005 here in San Francisco. It has shaped up to be a really amazing conference that embraces the indy roots of what we do and I&#8217;ve been looking forward to it for a while now. Best of all, it&#8217;s affordable! Tickets [...]\";s:12:\"atom_content\";s:592:\"<p>Myself and a few other WordPress folks will be spending the weekend at <a href=\"http://webzine2005.com/\">Webzine 2005</a> here in San Francisco. It has shaped up to be a really amazing conference that embraces the indy roots of what we do and I&#8217;ve been looking forward to it for a while now. Best of all, it&#8217;s affordable! Tickets are only $22 for both days. If you&#8217;re a WP user and attending be sure to say hi during the conference. I&#8217;ll be participating in two panels, &#8220;Making Media with Open Source&#8221; Tools and &#8220;Blog Wares Dance Off.&#8221;\n</p>\n\";}i:4;a:12:{s:5:\"title\";s:15:\"WordPress 1.5.2\";s:4:\"link\";s:54:\"http://wordpress.org/development/2005/08/one-five-two/\";s:8:\"comments\";s:63:\"http://wordpress.org/development/2005/08/one-five-two/#comments\";s:7:\"pubdate\";s:31:\"Sun, 14 Aug 2005 23:17:29 +0000\";s:2:\"dc\";a:1:{s:7:\"creator\";s:4:\"Matt\";}s:8:\"category\";s:19:\"DevelopmentReleases\";s:4:\"guid\";s:54:\"http://wordpress.org/development/2005/08/one-five-two/\";s:11:\"description\";s:345:\"We&#8217;re happy to announce that a new version of WordPress is now available for download. This set of improvements and security fixes is in line with our commitment to maintaining an extremely stable 1.5 series. In addition to fixing a number of bugs and adding requested enhancements for plugin authors, this release also addresses all [...]\";s:7:\"content\";a:1:{s:7:\"encoded\";s:940:\"<p>We&#8217;re happy to announce that a <a href=\"../../download/\">new version of WordPress is now available for download</a>. This set of improvements and security fixes is in line with our commitment to maintaining an extremely stable 1.5 series. In addition to <a href=\"http://trac.wordpress.org/milestone/1.5.2\">fixing a number of bugs</a> and adding requested enhancements for plugin authors, this release also addresses all of the security issues that have been circulating the past few days. This is a very straight-forward upgrade, you just need to upload the new files over the old, but as always <a href=\"http://codex.wordpress.org/Upgrading_WordPress\">the Codex is the best resource on upgrading</a>.</p>\n<p>P.S. If you upgraded late Sunday night double-check that you have the <a href=\"http://trac.wordpress.org/file/branches/1.5/wp-settings.php?rev=2783&#038;format=txt\">latest version of wp-settings.php</a> on your blog. </p>\n\";}s:3:\"wfw\";a:1:{s:10:\"commentrss\";s:59:\"http://wordpress.org/development/2005/08/one-five-two/feed/\";}s:7:\"summary\";s:345:\"We&#8217;re happy to announce that a new version of WordPress is now available for download. This set of improvements and security fixes is in line with our commitment to maintaining an extremely stable 1.5 series. In addition to fixing a number of bugs and adding requested enhancements for plugin authors, this release also addresses all [...]\";s:12:\"atom_content\";s:940:\"<p>We&#8217;re happy to announce that a <a href=\"../../download/\">new version of WordPress is now available for download</a>. This set of improvements and security fixes is in line with our commitment to maintaining an extremely stable 1.5 series. In addition to <a href=\"http://trac.wordpress.org/milestone/1.5.2\">fixing a number of bugs</a> and adding requested enhancements for plugin authors, this release also addresses all of the security issues that have been circulating the past few days. This is a very straight-forward upgrade, you just need to upload the new files over the old, but as always <a href=\"http://codex.wordpress.org/Upgrading_WordPress\">the Codex is the best resource on upgrading</a>.</p>\n<p>P.S. If you upgraded late Sunday night double-check that you have the <a href=\"http://trac.wordpress.org/file/branches/1.5/wp-settings.php?rev=2783&#038;format=txt\">latest version of wp-settings.php</a> on your blog. </p>\n\";}}s:7:\"channel\";a:7:{s:5:\"title\";s:26:\"WordPress Development Blog\";s:4:\"link\";s:32:\"http://wordpress.org/development\";s:11:\"description\";s:33:\"WordPress development and updates\";s:7:\"pubdate\";s:31:\"Tue, 08 Nov 2005 17:02:27 +0000\";s:9:\"generator\";s:31:\"http://wordpress.org/?v=2.0-RC1\";s:8:\"language\";s:2:\"en\";s:7:\"tagline\";s:33:\"WordPress development and updates\";}s:9:\"textinput\";a:0:{}s:5:\"image\";a:0:{}s:9:\"feed_type\";s:3:\"RSS\";s:12:\"feed_version\";s:3:\"2.0\";s:5:\"stack\";a:0:{}s:9:\"inchannel\";b:0;s:6:\"initem\";b:0;s:9:\"incontent\";b:0;s:11:\"intextinput\";b:0;s:7:\"inimage\";b:0;s:13:\"current_field\";s:0:\"\";s:17:\"current_namespace\";b:0;s:19:\"_CONTENT_CONSTRUCTS\";a:6:{i:0;s:7:\"content\";i:1;s:7:\"summary\";i:2;s:4:\"info\";i:3;s:5:\"title\";i:4;s:7:\"tagline\";i:5;s:9:\"copyright\";}s:13:\"last_modified\";s:31:\"Tue, 08 Nov 2005 17:02:27 GMT\r\n\";s:4:\"etag\";s:36:\"\"e2aadd85359c3946aaa77ab5fb4d9adb\"\r\n\";}',20,8,'',1,'no'),(68,0,'rss_0ff4b43bd116a9d8720d689c80e7dfd4_ts','Y',1,'1134751671',20,8,'',1,'no'),(69,0,'rss_867bd5c64f85878d03a060509cd2f92c','Y',1,'O:9:\"magpierss\":19:{s:6:\"parser\";i:0;s:12:\"current_item\";a:0:{}s:5:\"items\";a:60:{i:0;a:6:{s:5:\"title\";s:67:\"Donncha: Interview with me and Matt: Blogging, WordPress, Business.\";s:4:\"guid\";s:93:\"http://blogs.linux.ie/xeer/2005/12/16/interview-with-me-and-matt-blogging-wordpress-business/\";s:4:\"link\";s:93:\"http://blogs.linux.ie/xeer/2005/12/16/interview-with-me-and-matt-blogging-wordpress-business/\";s:11:\"description\";s:451:\"<p>Tom Raftery has published his <a href=\"http://blogs.linux.ie/xeer/go.php?http://www.podleaders.com/matt-mullenweg-podcast/\">interview</a> with me and <a href=\"http://blogs.linux.ie/xeer/go.php?http://photomat.net/\">Matt Mullenweg</a>. He talked to us last Monday on various subjects related to WordPress, commercialisation, plus blogging in Ireland, business blogging and others. You can download and listen to the interview on the above site.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 16 Dec 2005 14:36:39 +0000\";s:7:\"summary\";s:451:\"<p>Tom Raftery has published his <a href=\"http://blogs.linux.ie/xeer/go.php?http://www.podleaders.com/matt-mullenweg-podcast/\">interview</a> with me and <a href=\"http://blogs.linux.ie/xeer/go.php?http://photomat.net/\">Matt Mullenweg</a>. He talked to us last Monday on various subjects related to WordPress, commercialisation, plus blogging in Ireland, business blogging and others. You can download and listen to the interview on the above site.\n</p>\";}i:1;a:6:{s:5:\"title\";s:35:\"Weblog Tools Collection: RSS Reader\";s:4:\"guid\";s:64:\"http://weblogtoolscollection.com/archives/2005/12/16/rss-reader/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=524\";s:11:\"description\";s:198:\"<p><a href=\"http://www.djspyhunter.com/teapot/uploaded_images/rsstroom_reader_restroom-761230.jpg\">RSS Reader</a>: Just click the link, personal news delivery at its finest!! Thanks Threadwatch.</p>\";s:7:\"pubdate\";s:31:\"Fri, 16 Dec 2005 12:16:09 +0000\";s:7:\"summary\";s:198:\"<p><a href=\"http://www.djspyhunter.com/teapot/uploaded_images/rsstroom_reader_restroom-761230.jpg\">RSS Reader</a>: Just click the link, personal news delivery at its finest!! Thanks Threadwatch.</p>\";}i:2;a:6:{s:5:\"title\";s:22:\"Matt: XFNâ€™s Birthday\";s:4:\"guid\";s:46:\"http://photomatt.net/2005/12/16/xfns-birthday/\";s:4:\"link\";s:46:\"http://photomatt.net/2005/12/16/xfns-birthday/\";s:11:\"description\";s:88:\"<p><a href=\"http://tantek.com/log/2005/12.html#d15t2245\">Happy Birthday to XFN!</a>\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 16 Dec 2005 11:37:00 +0000\";s:7:\"summary\";s:88:\"<p><a href=\"http://tantek.com/log/2005/12.html#d15t2245\">Happy Birthday to XFN!</a>\n</p>\";}i:3;a:6:{s:5:\"title\";s:17:\"Matt: Back Online\";s:4:\"guid\";s:46:\"http://photomatt.net/2005/12/15/back-online-2/\";s:4:\"link\";s:46:\"http://photomatt.net/2005/12/15/back-online-2/\";s:11:\"description\";s:454:\"<p>Sorry to folks that have had trouble getting to the site or sending me email the past few days, the server that hosts photomatt.net and mullenweg.com has been down more often than up, and emails are coming in days late. They replaced the RAM which seems to have been the source of the problem. Now I just need to find someplace in NY with universal chargers so I can get my cells working again and I will be back connected to the civilized world.\n</p>\";s:7:\"pubdate\";s:31:\"Thu, 15 Dec 2005 18:39:30 +0000\";s:7:\"summary\";s:454:\"<p>Sorry to folks that have had trouble getting to the site or sending me email the past few days, the server that hosts photomatt.net and mullenweg.com has been down more often than up, and emails are coming in days late. They replaced the RAM which seems to have been the source of the problem. Now I just need to find someplace in NY with universal chargers so I can get my cells working again and I will be back connected to the civilized world.\n</p>\";}i:4;a:6:{s:5:\"title\";s:33:\"Mike Little: Kraig Garland R.I.P.\";s:4:\"guid\";s:66:\"http://zed1.com/journalized/archives/2005/12/15/kraig-garland-rip/\";s:4:\"link\";s:66:\"http://zed1.com/journalized/archives/2005/12/15/kraig-garland-rip/\";s:11:\"description\";s:298:\"<p>Kraig Garland tragically passed away 8th December 2005 aged just 29 years. Today is his funeral. It is a sad day for all his friends and family. </p>\n	<p>There is an <a href=\"http://kraig-garland.zed1.net/book-of-condolence.html\">online Book of Condolence</a> set up for family and friends.\n</p>\";s:7:\"pubdate\";s:31:\"Thu, 15 Dec 2005 11:35:29 +0000\";s:7:\"summary\";s:298:\"<p>Kraig Garland tragically passed away 8th December 2005 aged just 29 years. Today is his funeral. It is a sad day for all his friends and family. </p>\n	<p>There is an <a href=\"http://kraig-garland.zed1.net/book-of-condolence.html\">online Book of Condolence</a> set up for family and friends.\n</p>\";}i:5;a:6:{s:5:\"title\";s:54:\"Weblog Tools Collection: Variables in your CSS via PHP\";s:4:\"guid\";s:83:\"http://weblogtoolscollection.com/archives/2005/12/14/variables-in-your-css-via-php/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=523\";s:11:\"description\";s:528:\"<p><a href=\"http://www.chrisjdavis.org/2005/10/16/php-in-css/\">Variables in your CSS via PHP</a>: Good writeup/tutorial on using PHP to control the way your page looks. I love the way Chris writes, but this article is even more poignant as it also talks very candidly about OOP in php (which is sorely lacking in larger percentage of all PHP code)</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/oop\" rel=\"tag\">oop</a> <a href=\"http://www.technorati.com/tag/php\" rel=\"tag\">php</a></span>\";s:7:\"pubdate\";s:31:\"Wed, 14 Dec 2005 10:59:36 +0000\";s:7:\"summary\";s:528:\"<p><a href=\"http://www.chrisjdavis.org/2005/10/16/php-in-css/\">Variables in your CSS via PHP</a>: Good writeup/tutorial on using PHP to control the way your page looks. I love the way Chris writes, but this article is even more poignant as it also talks very candidly about OOP in php (which is sorely lacking in larger percentage of all PHP code)</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/oop\" rel=\"tag\">oop</a> <a href=\"http://www.technorati.com/tag/php\" rel=\"tag\">php</a></span>\";}i:6;a:6:{s:5:\"title\";s:70:\"Weblog Tools Collection: StructuredBlogging.org is officially launched\";s:4:\"guid\";s:98:\"http://weblogtoolscollection.com/archives/2005/12/14/structuredbloggingorg-is-officially-launched/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=522\";s:11:\"description\";s:616:\"<p><a href=\"http://blog.softtechvc.com/2005/12/syndicate_confe.html\">StructuredBlogging.org is officially launched</a> <em>&#8230;announce the launch of StructuredBlogging.org, a non-profit initiative supporting the development and deployment of micro-formats in blog posts. </em> Wordpress plugin available. <a href=\"http://structuredblogging.org/\">StructuredBlogging.org</a>\n</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/structured+blogging\" rel=\"tag\">structured blogging</a> <a href=\"http://www.technorati.com/tag/wordpress+plugin\" rel=\"tag\">wordpress plugin</a></span>\";s:7:\"pubdate\";s:31:\"Wed, 14 Dec 2005 10:46:23 +0000\";s:7:\"summary\";s:616:\"<p><a href=\"http://blog.softtechvc.com/2005/12/syndicate_confe.html\">StructuredBlogging.org is officially launched</a> <em>&#8230;announce the launch of StructuredBlogging.org, a non-profit initiative supporting the development and deployment of micro-formats in blog posts. </em> Wordpress plugin available. <a href=\"http://structuredblogging.org/\">StructuredBlogging.org</a>\n</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/structured+blogging\" rel=\"tag\">structured blogging</a> <a href=\"http://www.technorati.com/tag/wordpress+plugin\" rel=\"tag\">wordpress plugin</a></span>\";}i:7;a:6:{s:5:\"title\";s:62:\"Weblog Tools Collection: FeedBurner introduces interactive RSS\";s:4:\"guid\";s:91:\"http://weblogtoolscollection.com/archives/2005/12/13/feedburner-introduces-interactive-rss/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=521\";s:11:\"description\";s:921:\"<p><a href=\"http://www.feedburner.com/fb/a/pressreleases;jsessionid=19F75CE660DF30FE240771EEC62E1045.app3?release=flare_121305.jsp\">FeedBurner introduces interactive RSS</a> with a good writeup (and via) <a href=\"http://www.readwriteweb.com/\">here</a>. I cannot help but stop and think how this will jive with the fact that feeds will have to change along with presently published content, thus forcing readers to view old content (with slightly modified matter) as new content. For example, if the number of comments on a post change, that might not be enough for many people to have to download that content again. If that is not the case, then is the content truly dynamic/interactive beside being simple links?</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/Feedburner\" rel=\"tag\">Feedburner</a> <a href=\"http://www.technorati.com/tag/feedflare\" rel=\"tag\">feedflare</a></span>\";s:7:\"pubdate\";s:31:\"Tue, 13 Dec 2005 15:30:39 +0000\";s:7:\"summary\";s:921:\"<p><a href=\"http://www.feedburner.com/fb/a/pressreleases;jsessionid=19F75CE660DF30FE240771EEC62E1045.app3?release=flare_121305.jsp\">FeedBurner introduces interactive RSS</a> with a good writeup (and via) <a href=\"http://www.readwriteweb.com/\">here</a>. I cannot help but stop and think how this will jive with the fact that feeds will have to change along with presently published content, thus forcing readers to view old content (with slightly modified matter) as new content. For example, if the number of comments on a post change, that might not be enough for many people to have to download that content again. If that is not the case, then is the content truly dynamic/interactive beside being simple links?</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/Feedburner\" rel=\"tag\">Feedburner</a> <a href=\"http://www.technorati.com/tag/feedflare\" rel=\"tag\">feedflare</a></span>\";}i:8;a:6:{s:5:\"title\";s:62:\"Owen Winkler: Philly WordPress Meetup - THIS SATURDAY, Dec. 17\";s:4:\"guid\";s:85:\"http://asymptomatic.net/2005/12/13/2155/philly-wordpress-meetup-this-saturday-dec-17/\";s:4:\"link\";s:85:\"http://asymptomatic.net/2005/12/13/2155/philly-wordpress-meetup-this-saturday-dec-17/\";s:11:\"description\";s:3081:\"<p>&#8220;What&#8217;s this?&#8221; you ask.  &#8220;This meetup is a week early!&#8221;</p>\n<p>That&#8217;s right!  The dates have changed to avoid these blasted holidays.  It seems like every week we have a meetup there is some holiday like Christmas or Memorial Day or something.  So the monthly <a href=\"http://wordpress.meetup.com/84/\">Philadelphia WordPress meetups</a> are now the <strong>third Saturday</strong> of the month.</p>\n<p>Meetup time is 2pm.  Immediately following the WordPress meetup at 3pm (at least, last I looked) is the <a href=\"http://blog.meetup.com/309/\">Philadelphia Weblogger Meetup</a>.  It&#8217;s mostly Blogspot users, but they&#8217;re a fun group of prolific Philly bloggers.  It&#8217;s nice to see how the others live.<br />\n<a id=\"more-2155\"></a><br />\nI want to see about moving the meetup to a cleaner venue.  I like Fergie&#8217;s but it seems that some of the group isn&#8217;t down with the dark and smoky Irish bar scene.  That&#8217;s fine, but I&#8217;ll need to find someplace new.</p>\n<p>Jim suggested <a href=\"http://wordcafelive.com\">World Cafe Live</a>, and I&#8217;m going to drop by over there after the meetup to check out their space.  I wonder how much that&#8217;s going to cost me.  Hmm.</p>\n<p>In the future, assuming the group continues to show up, I would like to get some special guests.  Maybe I could get them to Skype into the Meetup and answer some questions or tell us about what they&#8217;re working on.  If you are interested in participating as a speaker, please let me know.</p>\n<p>If that pans out, I would like to produce a monthly podcast from the meetup.  It would be a summary of topics covered, and everyone could get some mic time, including the special guest.  I&#8217;m not sure how the format would work, but I think this would be of interest not only for luring more folks into our own den of geekines, but also for getting more people involved worldwide.</p>\n<p>Our group caters to a low-techie audience.  I&#8217;ve answered a bunch of new user questions, and I&#8217;m happy to do it.  Getting down with the people who actually use WordPress and make it popular gives me insight into how things can be made better for its audience.  And sometimes I just like to help.</p>\n<p>Many of our unscripted topics are of interest to computer users in general.  We don&#8217;t talk about WordPress and blogs through the whole meetup.  So don&#8217;t let that scare you away.  If you&#8217;re thinking of coming down for a walkthrough of the software, that&#8217;s not what this is really about.  We can tell you what we like about it, how we&#8217;ve accomplished things with it, what we use it for, and what we write about.  We can show you some new things, talk about new features, and give you a glimpse at the future.  But really, we just like to get together and hang out.</p>\n<p>Please join us this weekend for our December meetup at 2pm.  Meetups usually last for about 2 hours, sometimes longer.  Fergie&#8217;s often has live Irish music at 4pm, which isn&#8217;t half bad.  Come and enjoy!\n</p>\";s:7:\"pubdate\";s:31:\"Tue, 13 Dec 2005 15:18:06 +0000\";s:7:\"summary\";s:3081:\"<p>&#8220;What&#8217;s this?&#8221; you ask.  &#8220;This meetup is a week early!&#8221;</p>\n<p>That&#8217;s right!  The dates have changed to avoid these blasted holidays.  It seems like every week we have a meetup there is some holiday like Christmas or Memorial Day or something.  So the monthly <a href=\"http://wordpress.meetup.com/84/\">Philadelphia WordPress meetups</a> are now the <strong>third Saturday</strong> of the month.</p>\n<p>Meetup time is 2pm.  Immediately following the WordPress meetup at 3pm (at least, last I looked) is the <a href=\"http://blog.meetup.com/309/\">Philadelphia Weblogger Meetup</a>.  It&#8217;s mostly Blogspot users, but they&#8217;re a fun group of prolific Philly bloggers.  It&#8217;s nice to see how the others live.<br />\n<a id=\"more-2155\"></a><br />\nI want to see about moving the meetup to a cleaner venue.  I like Fergie&#8217;s but it seems that some of the group isn&#8217;t down with the dark and smoky Irish bar scene.  That&#8217;s fine, but I&#8217;ll need to find someplace new.</p>\n<p>Jim suggested <a href=\"http://wordcafelive.com\">World Cafe Live</a>, and I&#8217;m going to drop by over there after the meetup to check out their space.  I wonder how much that&#8217;s going to cost me.  Hmm.</p>\n<p>In the future, assuming the group continues to show up, I would like to get some special guests.  Maybe I could get them to Skype into the Meetup and answer some questions or tell us about what they&#8217;re working on.  If you are interested in participating as a speaker, please let me know.</p>\n<p>If that pans out, I would like to produce a monthly podcast from the meetup.  It would be a summary of topics covered, and everyone could get some mic time, including the special guest.  I&#8217;m not sure how the format would work, but I think this would be of interest not only for luring more folks into our own den of geekines, but also for getting more people involved worldwide.</p>\n<p>Our group caters to a low-techie audience.  I&#8217;ve answered a bunch of new user questions, and I&#8217;m happy to do it.  Getting down with the people who actually use WordPress and make it popular gives me insight into how things can be made better for its audience.  And sometimes I just like to help.</p>\n<p>Many of our unscripted topics are of interest to computer users in general.  We don&#8217;t talk about WordPress and blogs through the whole meetup.  So don&#8217;t let that scare you away.  If you&#8217;re thinking of coming down for a walkthrough of the software, that&#8217;s not what this is really about.  We can tell you what we like about it, how we&#8217;ve accomplished things with it, what we use it for, and what we write about.  We can show you some new things, talk about new features, and give you a glimpse at the future.  But really, we just like to get together and hang out.</p>\n<p>Please join us this weekend for our December meetup at 2pm.  Meetups usually last for about 2 hours, sometimes longer.  Fergie&#8217;s often has live Irish music at 4pm, which isn&#8217;t half bad.  Come and enjoy!\n</p>\";}i:9;a:6:{s:5:\"title\";s:24:\"Donncha: Matt in Blarney\";s:4:\"guid\";s:54:\"http://blogs.linux.ie/xeer/2005/12/13/matt-in-blarney/\";s:4:\"link\";s:54:\"http://blogs.linux.ie/xeer/2005/12/13/matt-in-blarney/\";s:11:\"description\";s:1472:\"<p>Matt has <a href=\"http://blogs.linux.ie/xeer/go.php?http://photomatt.net/2005/12/12/no-guinness/\">been in Cork</a> for the past few days and we&#8217;re catching up on WordPress stuff. After mentioning a local beverage, the discussion on his blog has centered around which is better, Guinness or Murphys! I don&#8217;t drink either so I&#8217;ll let that up to others!<br />\nHe&#8217;s going home soon, but expect a podcast interview by <a href=\"http://blogs.linux.ie/xeer/go.php?http://tomrafteryit.net/views\">Tom Raftery</a> before the end of the week, and I&#8217;ll post a picture later today!<br />\nHere <a href=\"http://blogs.linux.ie/xeer/go.php?http://inphotos.org/2005/12/13/matt-and-donncha/\">it is</a>! A great <a href=\"http://blogs.linux.ie/xeer/go.php?http://inphotos.org/2005/12/13/matt-and-donncha/\">photo</a> taken by Jacinta outside Blarney Woollen Mills.<br />\n<b>Later</b> .. Matt is on his travels again and he&#8217;ll reach the US later today.  He was a pleasure to have visit as he&#8217;s so easy going! The local B&#038;B he stayed in, River Walk, is run by husband and wife, Eddie and Grace and they put on an early morning breakfast to prepare him for the day!<br />\nApart from the B&#038;B, Eddie runs a <a href=\"http://blogs.linux.ie/xeer/go.php?http://www.bikecraft.ie/\">Bikecraft.ie</a> where he runs <a href=\"http://blogs.linux.ie/xeer/go.php?http://bikecraft.ie/www/Bikecraft/Training%20Modules.htm\">motorcycle training</a> courses!\n</p>\";s:7:\"pubdate\";s:31:\"Tue, 13 Dec 2005 09:48:36 +0000\";s:7:\"summary\";s:1472:\"<p>Matt has <a href=\"http://blogs.linux.ie/xeer/go.php?http://photomatt.net/2005/12/12/no-guinness/\">been in Cork</a> for the past few days and we&#8217;re catching up on WordPress stuff. After mentioning a local beverage, the discussion on his blog has centered around which is better, Guinness or Murphys! I don&#8217;t drink either so I&#8217;ll let that up to others!<br />\nHe&#8217;s going home soon, but expect a podcast interview by <a href=\"http://blogs.linux.ie/xeer/go.php?http://tomrafteryit.net/views\">Tom Raftery</a> before the end of the week, and I&#8217;ll post a picture later today!<br />\nHere <a href=\"http://blogs.linux.ie/xeer/go.php?http://inphotos.org/2005/12/13/matt-and-donncha/\">it is</a>! A great <a href=\"http://blogs.linux.ie/xeer/go.php?http://inphotos.org/2005/12/13/matt-and-donncha/\">photo</a> taken by Jacinta outside Blarney Woollen Mills.<br />\n<b>Later</b> .. Matt is on his travels again and he&#8217;ll reach the US later today.  He was a pleasure to have visit as he&#8217;s so easy going! The local B&#038;B he stayed in, River Walk, is run by husband and wife, Eddie and Grace and they put on an early morning breakfast to prepare him for the day!<br />\nApart from the B&#038;B, Eddie runs a <a href=\"http://blogs.linux.ie/xeer/go.php?http://www.bikecraft.ie/\">Bikecraft.ie</a> where he runs <a href=\"http://blogs.linux.ie/xeer/go.php?http://bikecraft.ie/www/Bikecraft/Training%20Modules.htm\">motorcycle training</a> courses!\n</p>\";}i:10;a:6:{s:5:\"title\";s:73:\"Weblog Tools Collection: Closed, Open Source Share Compatibility Problems\";s:4:\"guid\";s:101:\"http://weblogtoolscollection.com/archives/2005/12/13/closed-open-source-share-compatibility-problems/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=520\";s:11:\"description\";s:832:\"<p><a href=\"http://www.eweek.com/article2/0,1895,1900450,00.asp\">Closed, Open Source Share Compatibility Problems</a>: Interesting take on the compatibility problems brought onto Wordpress by the latest versions of Mysql running in &#8220;strict&#8221; mode as default. Especially poignant here because I see well greased programmers moving to the postgresql model because of a shift of ideologies of the mysql group. I should look into the added benefits that the strict model provides to the system.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/database\" rel=\"tag\">database</a> <a href=\"http://www.technorati.com/tag/mysql\" rel=\"tag\">mysql</a> <a href=\"http://www.technorati.com/tag/schema\" rel=\"tag\">schema</a> <a href=\"http://www.technorati.com/tag/strict\" rel=\"tag\">strict</a></span>\";s:7:\"pubdate\";s:31:\"Tue, 13 Dec 2005 09:27:31 +0000\";s:7:\"summary\";s:832:\"<p><a href=\"http://www.eweek.com/article2/0,1895,1900450,00.asp\">Closed, Open Source Share Compatibility Problems</a>: Interesting take on the compatibility problems brought onto Wordpress by the latest versions of Mysql running in &#8220;strict&#8221; mode as default. Especially poignant here because I see well greased programmers moving to the postgresql model because of a shift of ideologies of the mysql group. I should look into the added benefits that the strict model provides to the system.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/database\" rel=\"tag\">database</a> <a href=\"http://www.technorati.com/tag/mysql\" rel=\"tag\">mysql</a> <a href=\"http://www.technorati.com/tag/schema\" rel=\"tag\">schema</a> <a href=\"http://www.technorati.com/tag/strict\" rel=\"tag\">strict</a></span>\";}i:11;a:6:{s:5:\"title\";s:46:\"Weblog Tools Collection: WP Theme: The Cabinet\";s:4:\"guid\";s:74:\"http://weblogtoolscollection.com/archives/2005/12/12/wp-theme-the-cabinet/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=519\";s:11:\"description\";s:504:\"<p>Two column, black and neon (green?) nuveau theme for Wordpress from <a href=\"http://www.evokinteractive.com/\">EVOK Interactive</a> Download <a href=\"http://weblogtoolscollection.com/b2-img/the_cabinet.zip\">here</a>.\n</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/EVOK\" rel=\"tag\">EVOK</a> <a href=\"http://www.technorati.com/tag/the+cabinet\" rel=\"tag\">the cabinet</a> <a href=\"http://www.technorati.com/tag/wordpress+theme\" rel=\"tag\">wordpress theme</a></span>\";s:7:\"pubdate\";s:31:\"Mon, 12 Dec 2005 19:06:02 +0000\";s:7:\"summary\";s:504:\"<p>Two column, black and neon (green?) nuveau theme for Wordpress from <a href=\"http://www.evokinteractive.com/\">EVOK Interactive</a> Download <a href=\"http://weblogtoolscollection.com/b2-img/the_cabinet.zip\">here</a>.\n</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/EVOK\" rel=\"tag\">EVOK</a> <a href=\"http://www.technorati.com/tag/the+cabinet\" rel=\"tag\">the cabinet</a> <a href=\"http://www.technorati.com/tag/wordpress+theme\" rel=\"tag\">wordpress theme</a></span>\";}i:12;a:6:{s:5:\"title\";s:61:\"Weblog Tools Collection: Embedding WordPress into OS Commerce\";s:4:\"guid\";s:90:\"http://weblogtoolscollection.com/archives/2005/12/12/embedding-wordpress-into-os-commerce/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=516\";s:11:\"description\";s:360:\"<p><a href=\"http://www.michaelwender.com/page/blog/archives/44/embedding-wordpress-into-os-commerce\">Embedding WordPress into OS Commerce</a></p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/OS+Commerce\" rel=\"tag\">OS Commerce</a> <a href=\"http://www.technorati.com/tag/wordpress+hack\" rel=\"tag\">wordpress hack</a></span>\";s:7:\"pubdate\";s:31:\"Mon, 12 Dec 2005 16:00:35 +0000\";s:7:\"summary\";s:360:\"<p><a href=\"http://www.michaelwender.com/page/blog/archives/44/embedding-wordpress-into-os-commerce\">Embedding WordPress into OS Commerce</a></p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/OS+Commerce\" rel=\"tag\">OS Commerce</a> <a href=\"http://www.technorati.com/tag/wordpress+hack\" rel=\"tag\">wordpress hack</a></span>\";}i:13;a:6:{s:5:\"title\";s:39:\"Weblog Tools Collection: WP Theme: Kiwi\";s:4:\"guid\";s:67:\"http://weblogtoolscollection.com/archives/2005/12/12/wp-theme-kiwi/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=517\";s:11:\"description\";s:415:\"<p><a href=\"http://no.oneslistening.com/kiwi\">WP Theme: Kiwi</a> I missed this one. Comprehensive, well formatted and designed theme for Wordpress that seems to have received quite a bit of attention already.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/kiwi\" rel=\"tag\">kiwi</a> <a href=\"http://www.technorati.com/tag/wordpress+theme\" rel=\"tag\">wordpress theme</a></span>\";s:7:\"pubdate\";s:31:\"Mon, 12 Dec 2005 16:00:35 +0000\";s:7:\"summary\";s:415:\"<p><a href=\"http://no.oneslistening.com/kiwi\">WP Theme: Kiwi</a> I missed this one. Comprehensive, well formatted and designed theme for Wordpress that seems to have received quite a bit of attention already.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/kiwi\" rel=\"tag\">kiwi</a> <a href=\"http://www.technorati.com/tag/wordpress+theme\" rel=\"tag\">wordpress theme</a></span>\";}i:14;a:6:{s:5:\"title\";s:59:\"Weblog Tools Collection: Yahoo! to offer WordPress as well?\";s:4:\"guid\";s:86:\"http://weblogtoolscollection.com/archives/2005/12/12/yahoo-to-offer-wordpress-as-well/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=518\";s:11:\"description\";s:127:\"<p><a href=\"http://www.blogherald.com/2005/12/12/yahoo-to-offer-wordpress-as-well/\">Yahoo! to offer WordPress as well?</a> </p>\";s:7:\"pubdate\";s:31:\"Mon, 12 Dec 2005 16:00:35 +0000\";s:7:\"summary\";s:127:\"<p><a href=\"http://www.blogherald.com/2005/12/12/yahoo-to-offer-wordpress-as-well/\">Yahoo! to offer WordPress as well?</a> </p>\";}i:15;a:6:{s:5:\"title\";s:17:\"Matt: No Guinness\";s:4:\"guid\";s:44:\"http://photomatt.net/2005/12/12/no-guinness/\";s:4:\"link\";s:44:\"http://photomatt.net/2005/12/12/no-guinness/\";s:11:\"description\";s:345:\"<p>Been in Ireland since Saturday, and it couldn&#8217;t be better. What a lovely country with lovely people. One thing I&#8217;ve noticed, at least here in the &#8220;real capital&#8221; Cork, that &#8220;Guinness is for tourists.&#8221; Everyone here drinks Murphy&#8217;s. Anyway, back to work with Donncha on some WordPress.com goodies.\n</p>\";s:7:\"pubdate\";s:31:\"Mon, 12 Dec 2005 10:43:27 +0000\";s:7:\"summary\";s:345:\"<p>Been in Ireland since Saturday, and it couldn&#8217;t be better. What a lovely country with lovely people. One thing I&#8217;ve noticed, at least here in the &#8220;real capital&#8221; Cork, that &#8220;Guinness is for tourists.&#8221; Everyone here drinks Murphy&#8217;s. Anyway, back to work with Donncha on some WordPress.com goodies.\n</p>\";}i:16;a:6:{s:5:\"title\";s:63:\"Weblog Tools Collection: Yahoo offers Movable Type for bloggers\";s:4:\"guid\";s:92:\"http://weblogtoolscollection.com/archives/2005/12/12/yahoo-offers-movable-type-for-bloggers/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=515\";s:11:\"description\";s:295:\"<p><a href=\"http://today.reuters.com/news/newsArticle.aspx?type=internetNews&#038;storyID=2005-12-12T051918Z_01_FOR219060_RTRUKOC_0_US-MEDIA-YAHOO-BLOGS.xml\">Yahoo offers Movable Type for bloggers</a> <em>&#8230; Yahoo will be the preferred supplier of Movable Type for small businesses</em></p>\";s:7:\"pubdate\";s:31:\"Mon, 12 Dec 2005 09:12:55 +0000\";s:7:\"summary\";s:295:\"<p><a href=\"http://today.reuters.com/news/newsArticle.aspx?type=internetNews&#038;storyID=2005-12-12T051918Z_01_FOR219060_RTRUKOC_0_US-MEDIA-YAHOO-BLOGS.xml\">Yahoo offers Movable Type for bloggers</a> <em>&#8230; Yahoo will be the preferred supplier of Movable Type for small businesses</em></p>\";}i:17;a:6:{s:5:\"title\";s:34:\"Weblog Tools Collection: Daily Div\";s:4:\"guid\";s:63:\"http://weblogtoolscollection.com/archives/2005/12/11/daily-div/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=514\";s:11:\"description\";s:105:\"<p><img src=\"http://weblogtoolscollection.com/b2-img/Funky_Winkerbean.gif\" alt=\"Funky Winkerbean\" />\n</p>\";s:7:\"pubdate\";s:31:\"Sun, 11 Dec 2005 11:35:38 +0000\";s:7:\"summary\";s:105:\"<p><img src=\"http://weblogtoolscollection.com/b2-img/Funky_Winkerbean.gif\" alt=\"Funky Winkerbean\" />\n</p>\";}i:18;a:6:{s:5:\"title\";s:54:\"Weblog Tools Collection: Why Bloggers Donâ€™t Need SEO\";s:4:\"guid\";s:80:\"http://weblogtoolscollection.com/archives/2005/12/09/why-bloggers-dont-need-seo/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=513\";s:11:\"description\";s:620:\"<p><a href=\"http://performancing.com/node/375\">Why Bloggers Don&#8217;t Need SEO</a><em>If you write a great blog, and make an effort to network your niche and gain those all important regular deep links to your posts from other bloggers, you&#8217;ll rank, your archives will be monetized, particularly if you pay attention to such things as Time Sensitive Adsense, and your blog will be in Better Health.</em> Well said, Nick!\n</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/blog+seo\" rel=\"tag\">blog seo</a> <a href=\"http://www.technorati.com/tag/seo\" rel=\"tag\">seo</a></span>\";s:7:\"pubdate\";s:31:\"Fri, 09 Dec 2005 22:00:09 +0000\";s:7:\"summary\";s:620:\"<p><a href=\"http://performancing.com/node/375\">Why Bloggers Don&#8217;t Need SEO</a><em>If you write a great blog, and make an effort to network your niche and gain those all important regular deep links to your posts from other bloggers, you&#8217;ll rank, your archives will be monetized, particularly if you pay attention to such things as Time Sensitive Adsense, and your blog will be in Better Health.</em> Well said, Nick!\n</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/blog+seo\" rel=\"tag\">blog seo</a> <a href=\"http://www.technorati.com/tag/seo\" rel=\"tag\">seo</a></span>\";}i:19;a:6:{s:5:\"title\";s:26:\"Matt: London Meetup Update\";s:4:\"guid\";s:53:\"http://photomatt.net/2005/12/09/london-meetup-update/\";s:4:\"link\";s:53:\"http://photomatt.net/2005/12/09/london-meetup-update/\";s:11:\"description\";s:213:\"<p>I&#8217;m here with Khaled and Podz at the <a href=\"http://www.revolution-bars.co.uk/bars.php?bar_id=149\">Revolution Bar in Soho</a>. We&#8217;ll be hanging out here into the night so come by if you fancy.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 09 Dec 2005 17:06:06 +0000\";s:7:\"summary\";s:213:\"<p>I&#8217;m here with Khaled and Podz at the <a href=\"http://www.revolution-bars.co.uk/bars.php?bar_id=149\">Revolution Bar in Soho</a>. We&#8217;ll be hanging out here into the night so come by if you fancy.\n</p>\";}i:20;a:6:{s:5:\"title\";s:46:\"Weblog Tools Collection: del.icio.us: y.ah.oo!\";s:4:\"guid\";s:69:\"http://weblogtoolscollection.com/archives/2005/12/09/delicious-yahoo/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=512\";s:11:\"description\";s:406:\"<p><a href=\"http://blog.del.icio.us/blog/2005/12/yahoo.html\">del.icio.us: y.ah.oo!</a> Congratulations Joshua on the recent acquisition. Yahoo does seem to be picking up companies that are simply amazing.\n</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/del.icio.us\" rel=\"tag\">del.icio.us</a> <a href=\"http://www.technorati.com/tag/yahoo\" rel=\"tag\">yahoo</a></span>\";s:7:\"pubdate\";s:31:\"Fri, 09 Dec 2005 16:54:37 +0000\";s:7:\"summary\";s:406:\"<p><a href=\"http://blog.del.icio.us/blog/2005/12/yahoo.html\">del.icio.us: y.ah.oo!</a> Congratulations Joshua on the recent acquisition. Yahoo does seem to be picking up companies that are simply amazing.\n</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/del.icio.us\" rel=\"tag\">del.icio.us</a> <a href=\"http://www.technorati.com/tag/yahoo\" rel=\"tag\">yahoo</a></span>\";}i:21;a:6:{s:5:\"title\";s:21:\"Matt: The Googleverse\";s:4:\"guid\";s:48:\"http://photomatt.net/2005/12/09/the-googleverse/\";s:4:\"link\";s:48:\"http://photomatt.net/2005/12/09/the-googleverse/\";s:11:\"description\";s:497:\"<p>I&#8217;ve been particpating in an <a href=\"http://forums.prospero.com/kr-svgoogle05/\">online discussion called The Googleverse</a> with <a href=\"http://www.siliconvalley.com/mld/siliconvalley/13233755.htm\">some amazing people</a> the past few days. The conversation has been good (and has been <a href=\"http://xooglers.blogspot.com/2005/12/like-i-said.html\">showing up in</a> some of my <a href=\"http://blogs.siliconvalley.com/gmsv/\">fav blogs</a>) so I&#8217;d recommend checking it out.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 09 Dec 2005 07:56:24 +0000\";s:7:\"summary\";s:497:\"<p>I&#8217;ve been particpating in an <a href=\"http://forums.prospero.com/kr-svgoogle05/\">online discussion called The Googleverse</a> with <a href=\"http://www.siliconvalley.com/mld/siliconvalley/13233755.htm\">some amazing people</a> the past few days. The conversation has been good (and has been <a href=\"http://xooglers.blogspot.com/2005/12/like-i-said.html\">showing up in</a> some of my <a href=\"http://blogs.siliconvalley.com/gmsv/\">fav blogs</a>) so I&#8217;d recommend checking it out.\n</p>\";}i:22;a:6:{s:5:\"title\";s:19:\"Matt: London Meetup\";s:4:\"guid\";s:46:\"http://photomatt.net/2005/12/09/london-meetup/\";s:4:\"link\";s:46:\"http://photomatt.net/2005/12/09/london-meetup/\";s:11:\"description\";s:381:\"<p>There is a <a href=\"http://www.tamba2.org.uk/T2/archives/2005/12/04/wp-london-next-friday/\">WordPress meetup in London</a> today that I&#8217;ll be at. I imagine the topics will cover everything from WordPress 2.0 to the Codex and support. I&#8217;m <strong>really</strong> looking forward to meeting some of the people that have been a part of the community for years now.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 09 Dec 2005 06:58:55 +0000\";s:7:\"summary\";s:381:\"<p>There is a <a href=\"http://www.tamba2.org.uk/T2/archives/2005/12/04/wp-london-next-friday/\">WordPress meetup in London</a> today that I&#8217;ll be at. I imagine the topics will cover everything from WordPress 2.0 to the Codex and support. I&#8217;m <strong>really</strong> looking forward to meeting some of the people that have been a part of the community for years now.\n</p>\";}i:23;a:6:{s:5:\"title\";s:27:\"Matt: NY Times on WordPress\";s:4:\"guid\";s:54:\"http://photomatt.net/2005/12/08/ny-times-on-wordpress/\";s:4:\"link\";s:54:\"http://photomatt.net/2005/12/08/ny-times-on-wordpress/\";s:11:\"description\";s:313:\"<p><a href=\"http://eightface.com/\">Dave Kellam</a> just wrote in about <a href=\"http://carpetbagger.nytimes.com/\">The Carpetbagger</a>, a new WordPress-powered blog from the New York Times. It&#8217;s currently linked to from the front page of nytimes.com. This is the last one I blog for a while, I promise!\n</p>\";s:7:\"pubdate\";s:31:\"Thu, 08 Dec 2005 19:04:52 +0000\";s:7:\"summary\";s:313:\"<p><a href=\"http://eightface.com/\">Dave Kellam</a> just wrote in about <a href=\"http://carpetbagger.nytimes.com/\">The Carpetbagger</a>, a new WordPress-powered blog from the New York Times. It&#8217;s currently linked to from the front page of nytimes.com. This is the last one I blog for a while, I promise!\n</p>\";}i:24;a:6:{s:5:\"title\";s:21:\"Matt: London Troubles\";s:4:\"guid\";s:48:\"http://photomatt.net/2005/12/08/london-troubles/\";s:4:\"link\";s:48:\"http://photomatt.net/2005/12/08/london-troubles/\";s:11:\"description\";s:565:\"<p>Geez, I should have stayed in Paris! When I arrived at my hotel in SoHo London last night around midnight I found out they had no record of my reservation from Orbitz and no rooms available. What makes this worse is my reservation for 4 nights had already been charged. Every hotel in town was booked solid for the night. Several hours later I found myself in a hotel waaaay out by Heathrow and now instead of exploring London I&#8217;m trying to clear things up, find a place to stay in town tonight, and catch up with work I was planning to do last night.\n</p>\";s:7:\"pubdate\";s:31:\"Thu, 08 Dec 2005 13:34:24 +0000\";s:7:\"summary\";s:565:\"<p>Geez, I should have stayed in Paris! When I arrived at my hotel in SoHo London last night around midnight I found out they had no record of my reservation from Orbitz and no rooms available. What makes this worse is my reservation for 4 nights had already been charged. Every hotel in town was booked solid for the night. Several hours later I found myself in a hotel waaaay out by Heathrow and now instead of exploring London I&#8217;m trying to clear things up, find a place to stay in town tonight, and catch up with work I was planning to do last night.\n</p>\";}i:25;a:6:{s:5:\"title\";s:24:\"Matt: Consumating Bought\";s:4:\"guid\";s:51:\"http://photomatt.net/2005/12/08/consumating-bought/\";s:4:\"link\";s:51:\"http://photomatt.net/2005/12/08/consumating-bought/\";s:11:\"description\";s:583:\"<p><a href=\"http://consumating.com/about/news/entries/2\">Consumating was bought</a>, something I chatted with Ben Brown a while back about and thought was interesting. (Apparently <a href=\"http://texasvc.weblogswork.com/?p=415\">Alex Muse saw us</a> and also has some thoughts on the deal.) Mike Tatum (the guy who got me to work at CNET) <a href=\"http://37signals.com/svn/archives2/consummating_consumatingcom.php\">writes about the acquisition here</a>, and the comments are interesting as well. I think CNET will be judged a lot based on how this goes over the next year or so.\n</p>\";s:7:\"pubdate\";s:31:\"Thu, 08 Dec 2005 13:26:23 +0000\";s:7:\"summary\";s:583:\"<p><a href=\"http://consumating.com/about/news/entries/2\">Consumating was bought</a>, something I chatted with Ben Brown a while back about and thought was interesting. (Apparently <a href=\"http://texasvc.weblogswork.com/?p=415\">Alex Muse saw us</a> and also has some thoughts on the deal.) Mike Tatum (the guy who got me to work at CNET) <a href=\"http://37signals.com/svn/archives2/consummating_consumatingcom.php\">writes about the acquisition here</a>, and the comments are interesting as well. I think CNET will be judged a lot based on how this goes over the next year or so.\n</p>\";}i:26;a:6:{s:5:\"title\";s:40:\"Mike Little: WordPress Meet-up In London\";s:4:\"guid\";s:76:\"http://zed1.com/journalized/archives/2005/12/08/wordpress-meet-up-in-london/\";s:4:\"link\";s:76:\"http://zed1.com/journalized/archives/2005/12/08/wordpress-meet-up-in-london/\";s:11:\"description\";s:1077:\"<p>I&#8217;m looking forward to the WordPress meet-up in London tomorrow. Matt Mullenweg will be visiting the UK (for the first time?) on Friday. I&#8217;m quite excited to be meeting Matt and Podz amongst others.</p>\n	<p>There has been a <a href=\"http://www.tamba2.org.uk/T2/archives/2005/12/04/wp-london-next-friday/\">conversation over at Podz&#8217; blog</a> about arrangements and timings.</p>\n	<p>The arrangements so far are a bit sketchy but the most concrete seems to be a meeting in Starbucks, <a href=\"http://www.streetsensation.co.uk/covent/la2_sout.htm\">Long Acre</a> in <a href=\"http://www.tfl.gov.uk/tfl/pdfdocs/colourmap.gif\">Covent Garden</a>. Though Matt is not yet confirmed to be at that one. </p>\n	<p>Here is <a href=\"http://starbucks.co.uk/en-GB/_Our+Stores/_Store+Locator/StoreLocatorMap.htm?StoreKey=33239\">Starbucks&#8217; own map of the store</a> complete with confirmation of wireless internet access!</p>\n	<p>The likelihood is that there will be another get-together in the evening. I&#8217;ll be in London from just after noon till late evening. </p>\";s:7:\"pubdate\";s:31:\"Thu, 08 Dec 2005 12:05:56 +0000\";s:7:\"summary\";s:1077:\"<p>I&#8217;m looking forward to the WordPress meet-up in London tomorrow. Matt Mullenweg will be visiting the UK (for the first time?) on Friday. I&#8217;m quite excited to be meeting Matt and Podz amongst others.</p>\n	<p>There has been a <a href=\"http://www.tamba2.org.uk/T2/archives/2005/12/04/wp-london-next-friday/\">conversation over at Podz&#8217; blog</a> about arrangements and timings.</p>\n	<p>The arrangements so far are a bit sketchy but the most concrete seems to be a meeting in Starbucks, <a href=\"http://www.streetsensation.co.uk/covent/la2_sout.htm\">Long Acre</a> in <a href=\"http://www.tfl.gov.uk/tfl/pdfdocs/colourmap.gif\">Covent Garden</a>. Though Matt is not yet confirmed to be at that one. </p>\n	<p>Here is <a href=\"http://starbucks.co.uk/en-GB/_Our+Stores/_Store+Locator/StoreLocatorMap.htm?StoreKey=33239\">Starbucks&#8217; own map of the store</a> complete with confirmation of wireless internet access!</p>\n	<p>The likelihood is that there will be another get-together in the evening. I&#8217;ll be in London from just after noon till late evening. </p>\";}i:27;a:6:{s:5:\"title\";s:48:\"Weblog Tools Collection: WP Themes: Nigiri Sushi\";s:4:\"guid\";s:76:\"http://weblogtoolscollection.com/archives/2005/12/08/wp-themes-nigiri-sushi/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=511\";s:11:\"description\";s:462:\"<p><a href=\"http://ericsetiawan.com/2005/12/08/wp-themes-nigiri-sushi/\">WP Themes: Nigiri Sushi</a> Nicely done, minimalistic, ever so slightly colorful photoblog theme for Wordpress. <a href=\"http://budigitalized.com/\">Demo Here</a>. Via Email.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/photoblog\" rel=\"tag\">photoblog</a> <a href=\"http://www.technorati.com/tag/wordpress+theme\" rel=\"tag\">wordpress theme</a></span>\";s:7:\"pubdate\";s:31:\"Thu, 08 Dec 2005 12:02:51 +0000\";s:7:\"summary\";s:462:\"<p><a href=\"http://ericsetiawan.com/2005/12/08/wp-themes-nigiri-sushi/\">WP Themes: Nigiri Sushi</a> Nicely done, minimalistic, ever so slightly colorful photoblog theme for Wordpress. <a href=\"http://budigitalized.com/\">Demo Here</a>. Via Email.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/photoblog\" rel=\"tag\">photoblog</a> <a href=\"http://www.technorati.com/tag/wordpress+theme\" rel=\"tag\">wordpress theme</a></span>\";}i:28;a:6:{s:5:\"title\";s:56:\"Weblog Tools Collection: Wordpress Theme Toolkit Upgrade\";s:4:\"guid\";s:85:\"http://weblogtoolscollection.com/archives/2005/12/08/wordpress-theme-toolkit-upgrade/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=510\";s:11:\"description\";s:710:\"<p>A new version of the <a href=\"http://frenchfragfactory.net/ozh/my-projects/wordpress-theme-toolkit-admin-menu/\">Wordpress Theme Toolkit</a> hits the road, compatible with the upcoming Wordpress 2.0 (and downwards compatible with existing installations). Theme authors and users are advised to <a href=\"http://frenchfragfactory.net/ozh/archives/2005/12/08/wordpress-theme-toolkit-upgrade/\">upgrade</a>.\n</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/wordpress\" rel=\"tag\">wordpress</a> <a href=\"http://www.technorati.com/tag/wordpress+plugin\" rel=\"tag\">wordpress plugin</a> <a href=\"http://www.technorati.com/tag/wordpress+theme\" rel=\"tag\">wordpress theme</a></span>\";s:7:\"pubdate\";s:31:\"Thu, 08 Dec 2005 04:39:32 +0000\";s:7:\"summary\";s:710:\"<p>A new version of the <a href=\"http://frenchfragfactory.net/ozh/my-projects/wordpress-theme-toolkit-admin-menu/\">Wordpress Theme Toolkit</a> hits the road, compatible with the upcoming Wordpress 2.0 (and downwards compatible with existing installations). Theme authors and users are advised to <a href=\"http://frenchfragfactory.net/ozh/archives/2005/12/08/wordpress-theme-toolkit-upgrade/\">upgrade</a>.\n</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/wordpress\" rel=\"tag\">wordpress</a> <a href=\"http://www.technorati.com/tag/wordpress+plugin\" rel=\"tag\">wordpress plugin</a> <a href=\"http://www.technorati.com/tag/wordpress+theme\" rel=\"tag\">wordpress theme</a></span>\";}i:29;a:6:{s:5:\"title\";s:44:\"Weblog Tools Collection: Tech Blogs Critique\";s:4:\"guid\";s:73:\"http://weblogtoolscollection.com/archives/2005/12/07/tech-blogs-critique/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=508\";s:11:\"description\";s:703:\"<p><a href=\"http://online.wsj.com/public/article/SB113391812858915737-PdGY3flRpneCpyQcsjOc_Ng4Doc_20061206.html?mod=rss_free\">Tech Blogs Critique</a>: I am not sure how to name/tag this article from the Wall Street Journal and I also cannot place whether he is praising or denouncing the new fangled tech blogs and blog aggregating mechanisms but he does echo some of my own thoughts. <em>If you&#8217;re clever enough, you can make a career out of complaining about never being mentioned by the blog-aggregation sites.</em> A <a href=\"http://www.google.com/search?hl=en&#038;q=%22LEE+GOMES%22&#038;btnG=Google+Search\">Google Search on the author Lee Gomes</a> yields some very interesting results.\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 17:00:13 +0000\";s:7:\"summary\";s:703:\"<p><a href=\"http://online.wsj.com/public/article/SB113391812858915737-PdGY3flRpneCpyQcsjOc_Ng4Doc_20061206.html?mod=rss_free\">Tech Blogs Critique</a>: I am not sure how to name/tag this article from the Wall Street Journal and I also cannot place whether he is praising or denouncing the new fangled tech blogs and blog aggregating mechanisms but he does echo some of my own thoughts. <em>If you&#8217;re clever enough, you can make a career out of complaining about never being mentioned by the blog-aggregation sites.</em> A <a href=\"http://www.google.com/search?hl=en&#038;q=%22LEE+GOMES%22&#038;btnG=Google+Search\">Google Search on the author Lee Gomes</a> yields some very interesting results.\n</p>\";}i:30;a:6:{s:5:\"title\";s:54:\"Weblog Tools Collection: eBay Developer Challenge 2006\";s:4:\"guid\";s:83:\"http://weblogtoolscollection.com/archives/2005/12/07/ebay-developer-challenge-2006/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=509\";s:11:\"description\";s:541:\"<p><a href=\"http://www.oreillynet.com/pub/a/network/2005/12/05/ebay-developer-challenge-2006.html\">eBay Developer Challenge 2006</a>: Write cool, innovative code for eBay Web Services (and promote eBay in the process) and win $5000 plus other goodies. Pretty cool mashup examples provided. These are good times for enterprising and enthusiastic newcomers to jump into the fray headfirst.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/ebay+developer+challenge\" rel=\"tag\">ebay developer challenge</a>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 12:13:45 +0000\";s:7:\"summary\";s:541:\"<p><a href=\"http://www.oreillynet.com/pub/a/network/2005/12/05/ebay-developer-challenge-2006.html\">eBay Developer Challenge 2006</a>: Write cool, innovative code for eBay Web Services (and promote eBay in the process) and win $5000 plus other goodies. Pretty cool mashup examples provided. These are good times for enterprising and enthusiastic newcomers to jump into the fray headfirst.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/ebay+developer+challenge\" rel=\"tag\">ebay developer challenge</a>\";}i:31;a:6:{s:5:\"title\";s:38:\"Matt: About.com switching to WordPress\";s:4:\"guid\";s:48:\"http://photomatt.net/2005/12/07/about-switching/\";s:4:\"link\";s:48:\"http://photomatt.net/2005/12/07/about-switching/\";s:11:\"description\";s:1780:\"<p>Sheila Coggins just <a href=\"http://weblogs.about.com/od/bestofblogsdirectory/a/MattMullenweg.htm\">published an interview with me on About.com Weblogs</a>, which came out fairly well and talks a little bit about new efforts like WordPress.com.</p>\n<p>The timing for the interview couldn&#8217;t be better. As people watching closely may have already started to notice, About.com has begun switching their sites over to WordPress from Movable Type. They&#8217;ve been doing it quietly and one-by-one for at least month now, you can see WP in action on <a href=\"http://weblogs.about.com\">Weblogs</a>, <a href=\"http://babyparenting.about.com/\">Baby Parenting</a>, <a href=\"http://entrepreneurs.about.com/\">entrepreneur</a>, <a href=\"http://uspolitics.about.com/\">US politics</a>, and many more. They&#8217;ve integrated it so tightly with their system most of the usual signs of a WP blog aren&#8217;t there, but the dead giveaway is the comments. In fact none of their older blogs seem to have comments enabled, just the upgraded WP ones.</p>\n<p>About.com isn&#8217;t very &#8220;2.0&#8243; hip but they are still get some of the highest traffic on the web, easily within the top 50 sites in the world. From what I understand they haven&#8217;t made any changes to the core code, all of their customizations have been through plugins. They&#8217;re also looking at bringing a WP &#8220;powered by&#8221; link to the pages. (Which, <a href=\"http://photomatt.net/2005/12/03/yahoo-on-wordpress/\">as noted in the previous entry</a>, is completely optional.) I&#8217;m very glad About has found a platform that will grow with them. <img src=\"http://photomatt.net/blog/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" /> </p>\n<p>The good news keeps coming in.\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 11:19:02 +0000\";s:7:\"summary\";s:1780:\"<p>Sheila Coggins just <a href=\"http://weblogs.about.com/od/bestofblogsdirectory/a/MattMullenweg.htm\">published an interview with me on About.com Weblogs</a>, which came out fairly well and talks a little bit about new efforts like WordPress.com.</p>\n<p>The timing for the interview couldn&#8217;t be better. As people watching closely may have already started to notice, About.com has begun switching their sites over to WordPress from Movable Type. They&#8217;ve been doing it quietly and one-by-one for at least month now, you can see WP in action on <a href=\"http://weblogs.about.com\">Weblogs</a>, <a href=\"http://babyparenting.about.com/\">Baby Parenting</a>, <a href=\"http://entrepreneurs.about.com/\">entrepreneur</a>, <a href=\"http://uspolitics.about.com/\">US politics</a>, and many more. They&#8217;ve integrated it so tightly with their system most of the usual signs of a WP blog aren&#8217;t there, but the dead giveaway is the comments. In fact none of their older blogs seem to have comments enabled, just the upgraded WP ones.</p>\n<p>About.com isn&#8217;t very &#8220;2.0&#8243; hip but they are still get some of the highest traffic on the web, easily within the top 50 sites in the world. From what I understand they haven&#8217;t made any changes to the core code, all of their customizations have been through plugins. They&#8217;re also looking at bringing a WP &#8220;powered by&#8221; link to the pages. (Which, <a href=\"http://photomatt.net/2005/12/03/yahoo-on-wordpress/\">as noted in the previous entry</a>, is completely optional.) I&#8217;m very glad About has found a platform that will grow with them. <img src=\"http://photomatt.net/blog/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" /> </p>\n<p>The good news keeps coming in.\n</p>\";}i:32;a:6:{s:5:\"title\";s:36:\"Owen Winkler: How to Patch WordPress\";s:4:\"guid\";s:63:\"http://asymptomatic.net/2005/12/03/2142/how-to-patch-wordpress/\";s:4:\"link\";s:63:\"http://asymptomatic.net/2005/12/03/2142/how-to-patch-wordpress/\";s:11:\"description\";s:5703:\"<p>With the looming release of WordPress 2.0, there are a bunch of folks that are submitting bug fixes that say things like, &#8220;I would submit this to <a href=\"http://trac.wordpress.org\">Trac</a>, but I don&#8217;t know how.&#8221;  </p>\n<p>I think even more people are suggesting that writing to the mailing list with their bugs to &#8220;confirm&#8221; them is better than submitting them directly to Trac.  I suppose if you&#8217;re not sure something is a bug, it might be worthwhile to ask someone else (I would ask on IRC at #wordpress on irc.freenode.net) but it really is better to have a formal record of an issue, even if it turns out that what you&#8217;re experiencing is expected behavior.  If you really fear that it&#8217;s something to do specifically with your installation, check on IRC or maybe try a fresh install.</p>\n<p>Nevertheless, it might be useful to folks to learn how I do it.  I&#8217;m not saying my method is <em>correct</em>, just that it seems to get the job done with few complaints from the devs who commit my patches.  It&#8217;s also a good method to use on Windows.  (Sorry, someone else can document command-line Subversion use - not that I don&#8217;t know it, I&#8217;m just lazy.)  Here we go&#8230;<br />\n<a id=\"more-2142\"></a></p>\n<p>Here&#8217;s what you need to do to get an environment that is ripe for making source modifications:</p>\n<ol>\n<li><strong>Get a WordPress.org Support Forum Login</strong> - You need a <a href=\"http://wordpress.org/support/register.php\">support forum login</a> to gain access to Trac.  <a href=\"http://trac.wordpress.org\">Trac</a> is the software WordPress uses for bug tracking, and it shares its login database with the support forum.</li>\n<li><strong>Download and Install Tortoise SVN</strong> - <a href=\"http://tortoisesvn.tigris.org/\">Tortoise</a> is the best Subversion client for Windows.  It will let you get the latest source from the code repository without messing with funky nightly versions.</li>\n<li><strong>Install XAMPP</strong> - If you&#8217;re not already running Apache locally, you&#8217;re going to need it.  You can test under Microsoft&#8217;s IIS (and this is probably not a bad idea considering there are fewer people testing that environment) but if you&#8217;re not running Windows XP Pro (not Home), you may find this difficult.  <a href=\"http://www.apachefriends.org/en/xampp.html\">XAMPP</a> is Apache, MySQL, PHP and some other thing you don&#8217;t need for WordPress all rolled into one bundle.</li>\n<li><strong>Checkout a Copy of WordPress</strong> - Find the directory that XAMPP is using for its DocumentRoot and right-click on it (or create a &#8220;wordpress&#8221; directory there and right-click on that).  Select <em>SVN Checkout&#8230;</em>.  In the dialog, use http://svn.automattic.com/wordpress/trunk as the repository URL.  Click OK to download the latest WordPress source.</li>\n<li><strong>Make a Database</strong> - Use phpMyAdmin to create a new database for WordPress.  Navigate to http://localhost/phpmyadmin to see the interface.</li>\n<li><strong>Run the WordPress Install</strong> - I trust you already know how to do this.  If not, then perhaps patching is a bit advanced, no?</li>\n</ol>\n<p>Ok, now WordPress is running.  You should be able to do anything that you normally do with WordPress.</p>\n<p>At this point, you can modify code freely.  If you make a change you don&#8217;t like, you can always switch back to the original code.  Right-click on the file, choose <em> Tortoise SVN > Revert</em> and the file will be restored to the last checkout version.</p>\n<p>You should be able to see where you&#8217;ve made changes to the source by looking at the icon for the folder/file.  The ones that are changed will likely be red.</p>\n<p>Here&#8217;s what you need to do to make a patch:</p>\n<ol>\n<li><strong>Update your source</strong> - This step is pretty important, otherwise you might end up patching bugs back into source that&#8217;s already fixed.  Subversion has integrated merge features.  All you need to do is right-click on the wordpress root folder and select <em>SVN Update</em>.  If any of the files you edited come up as conflicted (in red in the list), you will need to merge them by hand in the tool provided when you double-click on the list item.</li>\n<li><strong>Create a patch</strong> - This is easy.  Right-click on the wordpress root folder and select <em>Tortoise SVN - Create Patch</em>.  A dialog appears to allow you to select the files you want to include in the patch.  Check the files you want to include, then save the patch file.  If I&#8217;m patching one file, I&#8217;ll usually use the full name of the file followed by &#8220;.diff&#8221;, for example, &#8220;admin-functions.php.diff&#8221;.</li>\n<li><strong>Find a Trac Ticket</strong> - To submit a patch, you need a ticket.  Be sure to search for an existing ticket for your issue before creating a new ticket.  If one doesn&#8217;t exist, create one and explain the problem as clearly as possible.  When you have a ticket, click <em>Attach File</em> and attach your patch file.</li>\n</ol>\n<p>That&#8217;s pretty much it, even though I&#8217;m sure I&#8217;ve left some trivial things out.</p>\n<p>The essential bit to recognize is that there really isn&#8217;t a good excuse for a developer to know enough to make code changes but not enough to use source control.  If you don&#8217;t know source control, consider that learning this simple task is a great way to pad your resume.  One way to scientifically demonstate that you can work well with teams is to show a proficiency with source code conrol tools.  Hopefully this short description will help you on your way.</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 04:30:27 +0000\";s:7:\"summary\";s:5703:\"<p>With the looming release of WordPress 2.0, there are a bunch of folks that are submitting bug fixes that say things like, &#8220;I would submit this to <a href=\"http://trac.wordpress.org\">Trac</a>, but I don&#8217;t know how.&#8221;  </p>\n<p>I think even more people are suggesting that writing to the mailing list with their bugs to &#8220;confirm&#8221; them is better than submitting them directly to Trac.  I suppose if you&#8217;re not sure something is a bug, it might be worthwhile to ask someone else (I would ask on IRC at #wordpress on irc.freenode.net) but it really is better to have a formal record of an issue, even if it turns out that what you&#8217;re experiencing is expected behavior.  If you really fear that it&#8217;s something to do specifically with your installation, check on IRC or maybe try a fresh install.</p>\n<p>Nevertheless, it might be useful to folks to learn how I do it.  I&#8217;m not saying my method is <em>correct</em>, just that it seems to get the job done with few complaints from the devs who commit my patches.  It&#8217;s also a good method to use on Windows.  (Sorry, someone else can document command-line Subversion use - not that I don&#8217;t know it, I&#8217;m just lazy.)  Here we go&#8230;<br />\n<a id=\"more-2142\"></a></p>\n<p>Here&#8217;s what you need to do to get an environment that is ripe for making source modifications:</p>\n<ol>\n<li><strong>Get a WordPress.org Support Forum Login</strong> - You need a <a href=\"http://wordpress.org/support/register.php\">support forum login</a> to gain access to Trac.  <a href=\"http://trac.wordpress.org\">Trac</a> is the software WordPress uses for bug tracking, and it shares its login database with the support forum.</li>\n<li><strong>Download and Install Tortoise SVN</strong> - <a href=\"http://tortoisesvn.tigris.org/\">Tortoise</a> is the best Subversion client for Windows.  It will let you get the latest source from the code repository without messing with funky nightly versions.</li>\n<li><strong>Install XAMPP</strong> - If you&#8217;re not already running Apache locally, you&#8217;re going to need it.  You can test under Microsoft&#8217;s IIS (and this is probably not a bad idea considering there are fewer people testing that environment) but if you&#8217;re not running Windows XP Pro (not Home), you may find this difficult.  <a href=\"http://www.apachefriends.org/en/xampp.html\">XAMPP</a> is Apache, MySQL, PHP and some other thing you don&#8217;t need for WordPress all rolled into one bundle.</li>\n<li><strong>Checkout a Copy of WordPress</strong> - Find the directory that XAMPP is using for its DocumentRoot and right-click on it (or create a &#8220;wordpress&#8221; directory there and right-click on that).  Select <em>SVN Checkout&#8230;</em>.  In the dialog, use http://svn.automattic.com/wordpress/trunk as the repository URL.  Click OK to download the latest WordPress source.</li>\n<li><strong>Make a Database</strong> - Use phpMyAdmin to create a new database for WordPress.  Navigate to http://localhost/phpmyadmin to see the interface.</li>\n<li><strong>Run the WordPress Install</strong> - I trust you already know how to do this.  If not, then perhaps patching is a bit advanced, no?</li>\n</ol>\n<p>Ok, now WordPress is running.  You should be able to do anything that you normally do with WordPress.</p>\n<p>At this point, you can modify code freely.  If you make a change you don&#8217;t like, you can always switch back to the original code.  Right-click on the file, choose <em> Tortoise SVN > Revert</em> and the file will be restored to the last checkout version.</p>\n<p>You should be able to see where you&#8217;ve made changes to the source by looking at the icon for the folder/file.  The ones that are changed will likely be red.</p>\n<p>Here&#8217;s what you need to do to make a patch:</p>\n<ol>\n<li><strong>Update your source</strong> - This step is pretty important, otherwise you might end up patching bugs back into source that&#8217;s already fixed.  Subversion has integrated merge features.  All you need to do is right-click on the wordpress root folder and select <em>SVN Update</em>.  If any of the files you edited come up as conflicted (in red in the list), you will need to merge them by hand in the tool provided when you double-click on the list item.</li>\n<li><strong>Create a patch</strong> - This is easy.  Right-click on the wordpress root folder and select <em>Tortoise SVN - Create Patch</em>.  A dialog appears to allow you to select the files you want to include in the patch.  Check the files you want to include, then save the patch file.  If I&#8217;m patching one file, I&#8217;ll usually use the full name of the file followed by &#8220;.diff&#8221;, for example, &#8220;admin-functions.php.diff&#8221;.</li>\n<li><strong>Find a Trac Ticket</strong> - To submit a patch, you need a ticket.  Be sure to search for an existing ticket for your issue before creating a new ticket.  If one doesn&#8217;t exist, create one and explain the problem as clearly as possible.  When you have a ticket, click <em>Attach File</em> and attach your patch file.</li>\n</ol>\n<p>That&#8217;s pretty much it, even though I&#8217;m sure I&#8217;ve left some trivial things out.</p>\n<p>The essential bit to recognize is that there really isn&#8217;t a good excuse for a developer to know enough to make code changes but not enough to use source control.  If you don&#8217;t know source control, consider that learning this simple task is a great way to pad your resume.  One way to scientifically demonstate that you can work well with teams is to show a proficiency with source code conrol tools.  Hopefully this short description will help you on your way.</p>\";}i:33;a:6:{s:5:\"title\";s:44:\"Owen Winkler: Whatâ€™s New in WordPress 2.0?\";s:4:\"guid\";s:66:\"http://asymptomatic.net/2005/11/29/2135/whats-new-in-wordpress-20/\";s:4:\"link\";s:66:\"http://asymptomatic.net/2005/11/29/2135/whats-new-in-wordpress-20/\";s:11:\"description\";s:7847:\"<p>WordPress 2.0 isn&#8217;t out yet, but every day that I spend on the #wordpress IRC channel, I see this question go by at least once:</p>\n<blockquote><p>What is new in WordPress 2.0 from 1.5?</p></blockquote>\n<p>Wouldn&#8217;t <em>you</em> like to know?</p>\n<p>One important note before we begin:  Many of the changes in WordPress from 1.5 to 2.0 are under the hood.  They are things that you&#8217;re not going to notice unless you are developer.  There are some features that casual users will notice that are significant, but (in my opinion) most of the real change has happened where most people won&#8217;t see.</p>\n<p>As a result, there is a fundamental thing to understand here.  What often looks like catering to plugin developers is actually of benefit to common users, because with the enhanced capabilities of the underlying engine it becomes possible to make better extensions faster than we could before.  The underlying engine has been made to work <em>better</em>.  There have been times while doing contract work on 1.5.x installations where two days of work were necessary to accomplish something that I could have done in 1.6 (now 2.0) in about 10 minutes.  Seriously.</p>\n<p>There has been a lot of talk in the WP scene about feature bloat, and it&#8217;s my own opinion that certain aspects of 2.0 are wildly overrated for what they do, but from an underlying technology standpoint, WordPress 2.0 is incredibly superior to the 1.5 codebase.</p>\n<p>So if you don&#8217;t want to upgrade because you don&#8217;t think that 2.0 offers you anything, just wait a couple months until the really fun plugins start appearing.</p>\n<p>Enough said on that.  On with the new features list, which is by no means comprehensive:<br />\n<a id=\"more-2135\"></a></p>\n<ul>\n<li><strong>More Abstracted Data Layer</strong> - The core WordPress code has been refactored to abstract direct calls to the database when adding posts, comments, and other data.  This will lead to improvements in database access (perhaps even supporting other database engines in the future) and plugin development, including&#8230;</li>\n<li><strong>New Import System</strong> - The new import system leverages the abstraction done at the data layer, so that import routines can call simple functions to convert posts from other blogging tools instead of a huge complicated series of queries.  Importers are also available directly from the admin, so no special process need be taken to employ them.  (Thanks, <a href=\"http://lair.fierydragon.org\">tinster</a>.)</li>\n<li><strong>Admin Redesign</strong> - It&#8217;s not so significant as the Tiger Admin plugin, but there are a few more gadgets in the admin, especially on the Write page.  You can now drag sections of the page to reorganize them, and click the plus/minus to expand/contract the sections.</li>\n<li><strong>The Rich Editor</strong> - WordPress has a new post editor built in that lets you see what you&#8217;re going to get without having to decipher tags.  You can also resize the editing area on the fly by dragging it, which is pretty cool.  Not everyone who has tried it likes the WYSIWYG editor, so there is an option to disable it on a per-user basis.</li>\n<li><strong>Image/File Uploading</strong> - Just under the Rich Editor in the Write panel, there is a new control that allows you to upload and insert images into your posts.  WordPress keeps track of these images and can even automatically provide dedicated pages to receive comments for them.</li>\n<li><strong>Improved Post Preview</strong> - Instead of displaying the post as plain text below the editor, the post is now displayed in an embedded frame, using all of the layout and CSS that is normally applied to your site.  In effect, the post looks <em>exactly</em> like it will when you publish it, giving you ample opportunity to review the post&#8217;s layout.</li>\n<li><strong>User Metadata</strong> - To support user-based options, the user data now sports a much more flexible structure.  People who use WordPress as a CMS can now use code to add custom data of any kind to any user profile.</li>\n<li><strong>User Roles and Capabilities</strong> - The &#8220;user level&#8221; concept of security has now been replaced with Roles.  WordPress associates a Role to each user. Roles have Capabilities such as &#8220;edit posts&#8221; and &#8220;activate plugins&#8221; that allow certain actions.  There is no more concept of hierarchical users, but plugin authors can now create whole new Capabilities to apply proper permission management.</li>\n<li><strong>Presentation Page Changes</strong> - WordPress 1.5 lets you switch themes, and 2.0 shows you what they look like before you do it.  If a theme includes a screenshot, you&#8217;ll see it in the Presentation admin panel to help you choose the theme for your site.</li>\n<li><strong>Ajax Category Addition</strong> - There&#8217;s a bunch of ajax in WordPress 2.0 and this is probably the most requested use of it.  This feature lets you add new categories directly from the post-writing page.</li>\n<li><strong>Ajax List Management</strong> - There are a few places in the admin that show lists of things and let you delete, like categories, posts, comments.  Now, instead of reloading, the row turns red and then fades out.</li>\n<li><strong>Moved Javascript/Images</strong> - Version 2.0 uses a lot more javascript than prior versions.  Some utilities, like <a href=\"http://www.axentric.com/posts/default/7\">FAT</a> (Fade Anything Technique) and <a href=\"http://twilightuniverse.com/2005/05/sack-of-ajax/\">SACK</a> (Simple Ajax Code Kit), can be used by other tools and plugins, so it&#8217;s good to put them someplace where developers know they will reside, and outside of the admin directory, which might have weird permissions.</li>\n<li><strong>Theme Admin Pages</strong> - The guys who worked on <a href=\"http://binarybonsai.com/wordpress/k2/\">K2</a> went to some lengths to hack a custom configuration page for their theme into the WordPress admin.  Now that capability is easily available by including a functions.php file with the theme.  You can see this at work in the new header generator for the Default theme.</li>\n<li><strong>Ping Delay Removed</strong> - Rather than pinging trackbacks and pingbacks when the post is saved (this causes the delay you see when posting to WP1.5), the pings are attempted via a different method that allows the admin interface to respond more quickly.</li>\n<li><strong>Persistent Cache</strong> - There are certain types of queries that WordPress makes to the database repeatedly.  To speed things up, the results of these queries are cached to disk.  This caching is still compatible with other caching plugins, like WP-Cache, and could be just enough of a boost for larger sites to avoid optimizing everything.</li>\n<li><strong>Database Versioning</strong> - Now when updates are made to the database schema, your admin panel will tell you to run the upgrade routines.  This is handy because it keeps your database fresh enough to support the code that runs on it.</li>\n<li><strong>New Built-In Plugins</strong> - WordPress 2.0 is now packed with the Akismet plugin for comment spam prevention, and the WP-DB-Backup plugin for manual or automated database backups.</li>\n</ul>\n<p>Those are the major features added since 1.5.2 was released on August 20th.  In addition to these major items (did I forget anything, anyone?) a few hundred bug fixes have been applied.  I did not count them to know the specific number, but there were a lot.  If you have a favorite bug that you wanted squashed, you should head over to <a href=\"http://trac.wordpress.org\">the bug database</a> and search for it.  If you don&#8217;t find your bug, <em>add it</em>.  (Use your WordPress support forum login for the bug database - It&#8217;s easy!)\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 04:30:27 +0000\";s:7:\"summary\";s:7847:\"<p>WordPress 2.0 isn&#8217;t out yet, but every day that I spend on the #wordpress IRC channel, I see this question go by at least once:</p>\n<blockquote><p>What is new in WordPress 2.0 from 1.5?</p></blockquote>\n<p>Wouldn&#8217;t <em>you</em> like to know?</p>\n<p>One important note before we begin:  Many of the changes in WordPress from 1.5 to 2.0 are under the hood.  They are things that you&#8217;re not going to notice unless you are developer.  There are some features that casual users will notice that are significant, but (in my opinion) most of the real change has happened where most people won&#8217;t see.</p>\n<p>As a result, there is a fundamental thing to understand here.  What often looks like catering to plugin developers is actually of benefit to common users, because with the enhanced capabilities of the underlying engine it becomes possible to make better extensions faster than we could before.  The underlying engine has been made to work <em>better</em>.  There have been times while doing contract work on 1.5.x installations where two days of work were necessary to accomplish something that I could have done in 1.6 (now 2.0) in about 10 minutes.  Seriously.</p>\n<p>There has been a lot of talk in the WP scene about feature bloat, and it&#8217;s my own opinion that certain aspects of 2.0 are wildly overrated for what they do, but from an underlying technology standpoint, WordPress 2.0 is incredibly superior to the 1.5 codebase.</p>\n<p>So if you don&#8217;t want to upgrade because you don&#8217;t think that 2.0 offers you anything, just wait a couple months until the really fun plugins start appearing.</p>\n<p>Enough said on that.  On with the new features list, which is by no means comprehensive:<br />\n<a id=\"more-2135\"></a></p>\n<ul>\n<li><strong>More Abstracted Data Layer</strong> - The core WordPress code has been refactored to abstract direct calls to the database when adding posts, comments, and other data.  This will lead to improvements in database access (perhaps even supporting other database engines in the future) and plugin development, including&#8230;</li>\n<li><strong>New Import System</strong> - The new import system leverages the abstraction done at the data layer, so that import routines can call simple functions to convert posts from other blogging tools instead of a huge complicated series of queries.  Importers are also available directly from the admin, so no special process need be taken to employ them.  (Thanks, <a href=\"http://lair.fierydragon.org\">tinster</a>.)</li>\n<li><strong>Admin Redesign</strong> - It&#8217;s not so significant as the Tiger Admin plugin, but there are a few more gadgets in the admin, especially on the Write page.  You can now drag sections of the page to reorganize them, and click the plus/minus to expand/contract the sections.</li>\n<li><strong>The Rich Editor</strong> - WordPress has a new post editor built in that lets you see what you&#8217;re going to get without having to decipher tags.  You can also resize the editing area on the fly by dragging it, which is pretty cool.  Not everyone who has tried it likes the WYSIWYG editor, so there is an option to disable it on a per-user basis.</li>\n<li><strong>Image/File Uploading</strong> - Just under the Rich Editor in the Write panel, there is a new control that allows you to upload and insert images into your posts.  WordPress keeps track of these images and can even automatically provide dedicated pages to receive comments for them.</li>\n<li><strong>Improved Post Preview</strong> - Instead of displaying the post as plain text below the editor, the post is now displayed in an embedded frame, using all of the layout and CSS that is normally applied to your site.  In effect, the post looks <em>exactly</em> like it will when you publish it, giving you ample opportunity to review the post&#8217;s layout.</li>\n<li><strong>User Metadata</strong> - To support user-based options, the user data now sports a much more flexible structure.  People who use WordPress as a CMS can now use code to add custom data of any kind to any user profile.</li>\n<li><strong>User Roles and Capabilities</strong> - The &#8220;user level&#8221; concept of security has now been replaced with Roles.  WordPress associates a Role to each user. Roles have Capabilities such as &#8220;edit posts&#8221; and &#8220;activate plugins&#8221; that allow certain actions.  There is no more concept of hierarchical users, but plugin authors can now create whole new Capabilities to apply proper permission management.</li>\n<li><strong>Presentation Page Changes</strong> - WordPress 1.5 lets you switch themes, and 2.0 shows you what they look like before you do it.  If a theme includes a screenshot, you&#8217;ll see it in the Presentation admin panel to help you choose the theme for your site.</li>\n<li><strong>Ajax Category Addition</strong> - There&#8217;s a bunch of ajax in WordPress 2.0 and this is probably the most requested use of it.  This feature lets you add new categories directly from the post-writing page.</li>\n<li><strong>Ajax List Management</strong> - There are a few places in the admin that show lists of things and let you delete, like categories, posts, comments.  Now, instead of reloading, the row turns red and then fades out.</li>\n<li><strong>Moved Javascript/Images</strong> - Version 2.0 uses a lot more javascript than prior versions.  Some utilities, like <a href=\"http://www.axentric.com/posts/default/7\">FAT</a> (Fade Anything Technique) and <a href=\"http://twilightuniverse.com/2005/05/sack-of-ajax/\">SACK</a> (Simple Ajax Code Kit), can be used by other tools and plugins, so it&#8217;s good to put them someplace where developers know they will reside, and outside of the admin directory, which might have weird permissions.</li>\n<li><strong>Theme Admin Pages</strong> - The guys who worked on <a href=\"http://binarybonsai.com/wordpress/k2/\">K2</a> went to some lengths to hack a custom configuration page for their theme into the WordPress admin.  Now that capability is easily available by including a functions.php file with the theme.  You can see this at work in the new header generator for the Default theme.</li>\n<li><strong>Ping Delay Removed</strong> - Rather than pinging trackbacks and pingbacks when the post is saved (this causes the delay you see when posting to WP1.5), the pings are attempted via a different method that allows the admin interface to respond more quickly.</li>\n<li><strong>Persistent Cache</strong> - There are certain types of queries that WordPress makes to the database repeatedly.  To speed things up, the results of these queries are cached to disk.  This caching is still compatible with other caching plugins, like WP-Cache, and could be just enough of a boost for larger sites to avoid optimizing everything.</li>\n<li><strong>Database Versioning</strong> - Now when updates are made to the database schema, your admin panel will tell you to run the upgrade routines.  This is handy because it keeps your database fresh enough to support the code that runs on it.</li>\n<li><strong>New Built-In Plugins</strong> - WordPress 2.0 is now packed with the Akismet plugin for comment spam prevention, and the WP-DB-Backup plugin for manual or automated database backups.</li>\n</ul>\n<p>Those are the major features added since 1.5.2 was released on August 20th.  In addition to these major items (did I forget anything, anyone?) a few hundred bug fixes have been applied.  I did not count them to know the specific number, but there were a lot.  If you have a favorite bug that you wanted squashed, you should head over to <a href=\"http://trac.wordpress.org\">the bug database</a> and search for it.  If you don&#8217;t find your bug, <em>add it</em>.  (Use your WordPress support forum login for the bug database - It&#8217;s easy!)\n</p>\";}i:34;a:6:{s:5:\"title\";s:30:\"Owen Winkler: Adhesive Updated\";s:4:\"guid\";s:57:\"http://asymptomatic.net/2005/11/21/2113/adhesive-updated/\";s:4:\"link\";s:57:\"http://asymptomatic.net/2005/11/21/2113/adhesive-updated/\";s:11:\"description\";s:1523:\"<p><a href=\"http://redalt.com/wiki/Adhesive\"><img src=\"http://asymptomatic.net/wp/wp-content/uploads/2005/11/thumb-adhesive.gif\" alt=\"Adhesive Sticky Setting\" /></a> I have updated Adhesive for WordPress 2.0 and released <a href=\"http://redalt.com/wiki/Adhesive\">a preliminary archive of the plugin</a>.  There is a glitch in WordPress that prevents code in the footer of the post edit page from executing.  I have submitted <a href=\"http://trac.wordpress.org/ticket/1932\">a support ticket</a> with a patch for this issue.  As soon as that patch is applied, things should work swimmingly.</p>\n<p><a href=\"http://www.flickr.com/photos/asy/65557742/\"><img src=\"http://static.flickr.com/27/65557742_77d140826d_t.jpg\" alt=\"Adhesive Config Demo\" /></a>What&#8217;s new in Adhesive?  Not much, really.  The new version does make use of something new I&#8217;m trying out for configuration.  Instead of using up a whole menu slot for a config page with only three options, I&#8217;ve made a kind of Ajax popup thing.  You kind of need to <a href=\"http://www.flickr.com/photos/asy/65557742/\">see it</a> to understand what I&#8217;m talking about.<br />\n<a id=\"more-2113\"></a><br />\nThis plugin is just the first plugin of a slew of updates that I&#8217;m planning for the next couple of weeks.  I know that Adhesive is a popular plugin, so I hope that people who are trying out the <a href=\"http://wordpress.org/support/forum/12\">WordPress 2.0 Beta</a> will also give Adhesive a shot and let me know what issues they encounter.</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 04:30:27 +0000\";s:7:\"summary\";s:1523:\"<p><a href=\"http://redalt.com/wiki/Adhesive\"><img src=\"http://asymptomatic.net/wp/wp-content/uploads/2005/11/thumb-adhesive.gif\" alt=\"Adhesive Sticky Setting\" /></a> I have updated Adhesive for WordPress 2.0 and released <a href=\"http://redalt.com/wiki/Adhesive\">a preliminary archive of the plugin</a>.  There is a glitch in WordPress that prevents code in the footer of the post edit page from executing.  I have submitted <a href=\"http://trac.wordpress.org/ticket/1932\">a support ticket</a> with a patch for this issue.  As soon as that patch is applied, things should work swimmingly.</p>\n<p><a href=\"http://www.flickr.com/photos/asy/65557742/\"><img src=\"http://static.flickr.com/27/65557742_77d140826d_t.jpg\" alt=\"Adhesive Config Demo\" /></a>What&#8217;s new in Adhesive?  Not much, really.  The new version does make use of something new I&#8217;m trying out for configuration.  Instead of using up a whole menu slot for a config page with only three options, I&#8217;ve made a kind of Ajax popup thing.  You kind of need to <a href=\"http://www.flickr.com/photos/asy/65557742/\">see it</a> to understand what I&#8217;m talking about.<br />\n<a id=\"more-2113\"></a><br />\nThis plugin is just the first plugin of a slew of updates that I&#8217;m planning for the next couple of weeks.  I know that Adhesive is a popular plugin, so I hope that people who are trying out the <a href=\"http://wordpress.org/support/forum/12\">WordPress 2.0 Beta</a> will also give Adhesive a shot and let me know what issues they encounter.</p>\";}i:35;a:6:{s:5:\"title\";s:39:\"Owen Winkler: Anybody Else Notice This?\";s:4:\"guid\";s:65:\"http://asymptomatic.net/2005/11/18/2107/anybody-else-notice-this/\";s:4:\"link\";s:65:\"http://asymptomatic.net/2005/11/18/2107/anybody-else-notice-this/\";s:11:\"description\";s:930:\"<p><a href=\"http://svn.automattic.com/wordpress/trunk/wp-includes/version.php\">Beta1</a>?</p>\n<p>As far as I know, the only other place you can find this out is via the <a href=\"http://wordpress.org/support/topic/49790\">support forums</a> and the <a href=\"http://comox.textdrive.com/pipermail/wp-testers/2005-November/000726.html\">wp-testers mailing list</a>.  And since there&#8217;s a link to the downoad on the forum post, I&#8217;m assuming it&#8217;s a public beta.<br />\n<a id=\"more-2107\"></a><br />\nIf you&#8217;re brave, roll it out.  If you&#8217;re not brave, <em>you might want to wait for a second beta</em>.</p>\n<p>If you&#8217;re looking for a list of changes since 1.5.x, you&#8217;re going to have to wait a little while for the compilation.  There are a <em>lot</em>.  Most of the stuff is internal, stuff that you&#8217;re not going to notice - and that stuff that goes unnoticed is why the system is great.\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 04:30:27 +0000\";s:7:\"summary\";s:930:\"<p><a href=\"http://svn.automattic.com/wordpress/trunk/wp-includes/version.php\">Beta1</a>?</p>\n<p>As far as I know, the only other place you can find this out is via the <a href=\"http://wordpress.org/support/topic/49790\">support forums</a> and the <a href=\"http://comox.textdrive.com/pipermail/wp-testers/2005-November/000726.html\">wp-testers mailing list</a>.  And since there&#8217;s a link to the downoad on the forum post, I&#8217;m assuming it&#8217;s a public beta.<br />\n<a id=\"more-2107\"></a><br />\nIf you&#8217;re brave, roll it out.  If you&#8217;re not brave, <em>you might want to wait for a second beta</em>.</p>\n<p>If you&#8217;re looking for a list of changes since 1.5.x, you&#8217;re going to have to wait a little while for the compilation.  There are a <em>lot</em>.  Most of the stuff is internal, stuff that you&#8217;re not going to notice - and that stuff that goes unnoticed is why the system is great.\n</p>\";}i:36;a:6:{s:5:\"title\";s:40:\"Owen Winkler: Skippy and Ryan in Hershey\";s:4:\"guid\";s:67:\"http://asymptomatic.net/2005/11/18/2106/skippy-and-ryan-in-hershey/\";s:4:\"link\";s:67:\"http://asymptomatic.net/2005/11/18/2106/skippy-and-ryan-in-hershey/\";s:11:\"description\";s:2773:\"<p><img src=\"http://static.flickr.com/31/64464633_cfb0e32396_m.jpg\" alt=\"Skippy and Ryan at Your Place\" />I&#8217;ve been complacent in my posting this week.  Too much to do between Riley&#8217;s birthday and work and not sleeping properly.  I totally forgot to mention that I met with <a href=\"http://skippy.net/\">Skippy</a> and <a href=\"http://ryanduff.net/\">Ryan</a> this past Saturday.</p>\n<p>I met <a href=\"http://www.skippy.net/blog/2005/11/12/hershey-pa/\">Skippy</a> and <a href=\"http://ryanduff.net/archives/2005/11/13/lunch-with-some-pals/\">Ryan</a> both through WordPress, primarily by talking with them via IRC, and they&#8217;re both into WordPress and blogging enough that they beat me to the web to talk about our meeting.<br />\n<a id=\"more-2106\"></a><br />\n&#8220;Your Place&#8221; was a strangely named place to get together.  I was very confused when Ryan first mentioned it.  Also weird was that after my hour+ drive out there, the bardenter had me use the ladies&#8217; room.  It smelled of flowers and had no discolored puddles on the floor.  Odd indeed.</p>\n<p>The company was quite cool.  We discussed some WordPress things, of course, along with some other web technology stuff.  We exchanged job descriptions, the typical first-meeting stuff.  And there was beer, which is always good.</p>\n<p>I learned that <a href=\"http://ryanduff.net/archives/2005/11/18/wedding-bells/\">Ryan&#8217;s getting married tomorrow</a>, so stop by his site and wish him well.  Yeah, I&#8217;ll drive an hour to meet with a guy and not even realize before I get there that he&#8217;s getting married in a week.  I feel like a sap!</p>\n<p>Skippy game me a cool Skippy.net bumpersticker.  I haven&#8217;t decided what to do with it yet.  Maybe stick it to my computer case.  Surely I won&#8217;t be applying <a href=\"http://www.cafepress.com/skippy_net\">Skippy&#8217;s mug</a> to my bumper.</p>\n<p>Anyhow, I had a good retreat to chocolate country, and it was great to finally meet in person with these two guys I talk to all the time.</p>\n<p>This might be the last WordPress meetup for me this year, since the <a href=\"http://wordpress.meetup.com/84/\">Philly meetup</a> folks have the next meetup on Thanskgiving weekend, and I&#8217;ll be out of town.  And December&#8217;s meetup is on Christmas eve, when I doubt I will find a blogger to hang with.  So January&#8217;s meetup should offer my return to real-life appearances, if that means anything to you.  I&#8217;m looking forward to catching up with <a href=\"http://somethingunpredictable.com/\">masquerade</a> from #wordpress IRC at that one.  I&#8217;ll have to remind him to show.</p>\n<p>Someone needs to print #wordpress trading cards so we can collect them.  I think Skippy&#8217;s ahead in the race so far.\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 04:30:27 +0000\";s:7:\"summary\";s:2773:\"<p><img src=\"http://static.flickr.com/31/64464633_cfb0e32396_m.jpg\" alt=\"Skippy and Ryan at Your Place\" />I&#8217;ve been complacent in my posting this week.  Too much to do between Riley&#8217;s birthday and work and not sleeping properly.  I totally forgot to mention that I met with <a href=\"http://skippy.net/\">Skippy</a> and <a href=\"http://ryanduff.net/\">Ryan</a> this past Saturday.</p>\n<p>I met <a href=\"http://www.skippy.net/blog/2005/11/12/hershey-pa/\">Skippy</a> and <a href=\"http://ryanduff.net/archives/2005/11/13/lunch-with-some-pals/\">Ryan</a> both through WordPress, primarily by talking with them via IRC, and they&#8217;re both into WordPress and blogging enough that they beat me to the web to talk about our meeting.<br />\n<a id=\"more-2106\"></a><br />\n&#8220;Your Place&#8221; was a strangely named place to get together.  I was very confused when Ryan first mentioned it.  Also weird was that after my hour+ drive out there, the bardenter had me use the ladies&#8217; room.  It smelled of flowers and had no discolored puddles on the floor.  Odd indeed.</p>\n<p>The company was quite cool.  We discussed some WordPress things, of course, along with some other web technology stuff.  We exchanged job descriptions, the typical first-meeting stuff.  And there was beer, which is always good.</p>\n<p>I learned that <a href=\"http://ryanduff.net/archives/2005/11/18/wedding-bells/\">Ryan&#8217;s getting married tomorrow</a>, so stop by his site and wish him well.  Yeah, I&#8217;ll drive an hour to meet with a guy and not even realize before I get there that he&#8217;s getting married in a week.  I feel like a sap!</p>\n<p>Skippy game me a cool Skippy.net bumpersticker.  I haven&#8217;t decided what to do with it yet.  Maybe stick it to my computer case.  Surely I won&#8217;t be applying <a href=\"http://www.cafepress.com/skippy_net\">Skippy&#8217;s mug</a> to my bumper.</p>\n<p>Anyhow, I had a good retreat to chocolate country, and it was great to finally meet in person with these two guys I talk to all the time.</p>\n<p>This might be the last WordPress meetup for me this year, since the <a href=\"http://wordpress.meetup.com/84/\">Philly meetup</a> folks have the next meetup on Thanskgiving weekend, and I&#8217;ll be out of town.  And December&#8217;s meetup is on Christmas eve, when I doubt I will find a blogger to hang with.  So January&#8217;s meetup should offer my return to real-life appearances, if that means anything to you.  I&#8217;m looking forward to catching up with <a href=\"http://somethingunpredictable.com/\">masquerade</a> from #wordpress IRC at that one.  I&#8217;ll have to remind him to show.</p>\n<p>Someone needs to print #wordpress trading cards so we can collect them.  I think Skippy&#8217;s ahead in the race so far.\n</p>\";}i:37;a:6:{s:5:\"title\";s:34:\"Owen Winkler: New Stuff at Red Alt\";s:4:\"guid\";s:61:\"http://asymptomatic.net/2005/11/10/2098/new-stuff-at-red-alt/\";s:4:\"link\";s:61:\"http://asymptomatic.net/2005/11/10/2098/new-stuff-at-red-alt/\";s:11:\"description\";s:3627:\"<p>I don&#8217;t know why I didn&#8217;t think of this sooner.</p>\n<p>I downloaded a copy of <a href=\"http://bbPress.org\">bbPress</a> to put on <a href=\"http://redalt.com\">Red Alt</a> to keep track of <a href=\"http://redalt.com/support\">support issues</a>.  Hey, it&#8217;s not a ticket-based system, it&#8217;s better &#8212; It allows the community to pool their knowledge for support.  Hopefully that means I won&#8217;t have to do it all myself.</p>\n<p>I&#8217;m making some other changes over at RedAlt, too.  I&#8217;m slowly building a new download section so that things are easier to find.  While I&#8217;m doing it, I&#8217;m writing up that missing documentation for the plugins that are laying around over there.  Most of them didn&#8217;t really need documentation when they started, so I never wrote any, and then as they got more complicated they needed documentation that I never thought to write.</p>\n<p>Plus many of those plugins need WordPress 1.6 treatment.  Some of them are already ready, just not sitting out there for download yet because they&#8217;re waiting for the organizational changes to come through.  I&#8217;m thinking about how I&#8217;m going to organize everything so that you download the correct version for your copy of WordPress.<br />\n<a id=\"more-2098\"></a><br />\nI built a new forum for each plugin (although I think I might be missing one or two, now that I think about it).  I&#8217;m quite pleased with the way I have been able to integrate the bbPress layout into the new site.  How much tweaking I did to the bbPress templates - well, that&#8217;s another question.  Some of the stuff I need to look at a little more closely because although I like the ajax features, I&#8217;m not fond of their layout.  Specifically the topic informaton that appears near the top of each topic.  I&#8217;m anxious to change the way it looks, but I don&#8217;t want to break the way ajax is working there.</p>\n<p>Something else I was considering is a plugin to synchronize the Red Alt forum user list with my WordPress user list here at Asymptomatic.  If they were the same site, I think it would be easy.  If they were on the same server it would be more possible.  But neither of these are true.  So it looks like there might be a need for a WordPress plugin that accepts requests from remote servers for user authentication.  (Someone&#8217;s going to say &#8220;LDAP&#8221; and I&#8217;m going to say &#8220;Stick a sock in it&#8221;, but I&#8217;m just a curmudgeon.)  I&#8217;ll need to think about alternatives to that.</p>\n<p>While I&#8217;m on the topic of plugins, someone needs to write a plugin that reorganizes the category list in the post-writing screen so that the most-used categories appear topmost in the list.  This alphabetical business is for the birds.  And while they&#8217;re at it, it might differentiate the most used category as posted from the bookmarklet, and use that as the default there.  It&#8217;s a minor annoyance, since I only ever use the bookmarklet to post in one category (what you might call &#8220;asides&#8221;, the &#8220;linklog&#8221;) and I always have to scroll down to the &#8220;L&#8221;s and check that one when I just want to quick link to something.  Maybe I should just change the bookmarklet functionality altogether.</p>\n<p>Now I&#8217;m kind of day-dreaming aloud.  <img src=\"http://asymptomatic.net/wp/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" /> </p>\n<p>Anyway, check out the new forum thing and let me know what you think.  And, of course, post support issues over there where we can all get at them.\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 04:30:27 +0000\";s:7:\"summary\";s:3627:\"<p>I don&#8217;t know why I didn&#8217;t think of this sooner.</p>\n<p>I downloaded a copy of <a href=\"http://bbPress.org\">bbPress</a> to put on <a href=\"http://redalt.com\">Red Alt</a> to keep track of <a href=\"http://redalt.com/support\">support issues</a>.  Hey, it&#8217;s not a ticket-based system, it&#8217;s better &#8212; It allows the community to pool their knowledge for support.  Hopefully that means I won&#8217;t have to do it all myself.</p>\n<p>I&#8217;m making some other changes over at RedAlt, too.  I&#8217;m slowly building a new download section so that things are easier to find.  While I&#8217;m doing it, I&#8217;m writing up that missing documentation for the plugins that are laying around over there.  Most of them didn&#8217;t really need documentation when they started, so I never wrote any, and then as they got more complicated they needed documentation that I never thought to write.</p>\n<p>Plus many of those plugins need WordPress 1.6 treatment.  Some of them are already ready, just not sitting out there for download yet because they&#8217;re waiting for the organizational changes to come through.  I&#8217;m thinking about how I&#8217;m going to organize everything so that you download the correct version for your copy of WordPress.<br />\n<a id=\"more-2098\"></a><br />\nI built a new forum for each plugin (although I think I might be missing one or two, now that I think about it).  I&#8217;m quite pleased with the way I have been able to integrate the bbPress layout into the new site.  How much tweaking I did to the bbPress templates - well, that&#8217;s another question.  Some of the stuff I need to look at a little more closely because although I like the ajax features, I&#8217;m not fond of their layout.  Specifically the topic informaton that appears near the top of each topic.  I&#8217;m anxious to change the way it looks, but I don&#8217;t want to break the way ajax is working there.</p>\n<p>Something else I was considering is a plugin to synchronize the Red Alt forum user list with my WordPress user list here at Asymptomatic.  If they were the same site, I think it would be easy.  If they were on the same server it would be more possible.  But neither of these are true.  So it looks like there might be a need for a WordPress plugin that accepts requests from remote servers for user authentication.  (Someone&#8217;s going to say &#8220;LDAP&#8221; and I&#8217;m going to say &#8220;Stick a sock in it&#8221;, but I&#8217;m just a curmudgeon.)  I&#8217;ll need to think about alternatives to that.</p>\n<p>While I&#8217;m on the topic of plugins, someone needs to write a plugin that reorganizes the category list in the post-writing screen so that the most-used categories appear topmost in the list.  This alphabetical business is for the birds.  And while they&#8217;re at it, it might differentiate the most used category as posted from the bookmarklet, and use that as the default there.  It&#8217;s a minor annoyance, since I only ever use the bookmarklet to post in one category (what you might call &#8220;asides&#8221;, the &#8220;linklog&#8221;) and I always have to scroll down to the &#8220;L&#8221;s and check that one when I just want to quick link to something.  Maybe I should just change the bookmarklet functionality altogether.</p>\n<p>Now I&#8217;m kind of day-dreaming aloud.  <img src=\"http://asymptomatic.net/wp/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" /> </p>\n<p>Anyway, check out the new forum thing and let me know what you think.  And, of course, post support issues over there where we can all get at them.\n</p>\";}i:38;a:6:{s:5:\"title\";s:48:\"Owen Winkler: How to use Flickr on WordPress.com\";s:4:\"guid\";s:74:\"http://asymptomatic.net/2005/11/03/2083/how-to-use-flickr-on-wordpresscom/\";s:4:\"link\";s:74:\"http://asymptomatic.net/2005/11/03/2083/how-to-use-flickr-on-wordpresscom/\";s:11:\"description\";s:1407:\"<p>I wrote this post over at <a href=\"http://owen.wordpress.com\">my WordPress.com blog</a>, but I figured I would post it here because people actually <em>read</em> this one.</p>\n<p>You might have noticed the new tab in the media box at WordPress.com labeled &#8220;Browse Flickr&#8221;.  I am partially responsible for that functionality.  <a href=\"http://andy.wordpress.com/2005/11/02/wordpress-likes-flickr/\" title=\"Andy\'s WordPress/Flickr post\">Andy Skelton</a> coded the bulk of the media browser, and I added the Flickr tab by copying a lot of his code and mixing in the Flickr API.<br />\n<a id=\"more-2083\"></a><br />\nRather than bore you with written details of how it works, I&#8217;ll just direct you to the animations I made for using the media browser on both Internet Explorer and Firefox. Check them out, there are instructions in the photo descriptions for each!</p>\n<p>On Firefox: <a title=\"Flickr on WordPress.com using Firefox\" href=\"http://flickr.com/photos/94632485@N00/59368625/\"><img width=\"100\" height=\"74\" alt=\"Flickr on WordPress.com using Firefox\" src=\"http://static.flickr.com/31/59368625_77fd572f8e_t.jpg\" /></a></p>\n<p>On Internet Explorer: <a title=\"Flickr on WordPress.com using IE\" href=\"http://flickr.com/photos/94632485@N00/59375719/\"><img width=\"100\" height=\"78\" alt=\"Flickr on WordPress.com using IE\" src=\"http://static.flickr.com/30/59375719_5f04f668f9_t.jpg\" /></a>\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 04:30:27 +0000\";s:7:\"summary\";s:1407:\"<p>I wrote this post over at <a href=\"http://owen.wordpress.com\">my WordPress.com blog</a>, but I figured I would post it here because people actually <em>read</em> this one.</p>\n<p>You might have noticed the new tab in the media box at WordPress.com labeled &#8220;Browse Flickr&#8221;.  I am partially responsible for that functionality.  <a href=\"http://andy.wordpress.com/2005/11/02/wordpress-likes-flickr/\" title=\"Andy\'s WordPress/Flickr post\">Andy Skelton</a> coded the bulk of the media browser, and I added the Flickr tab by copying a lot of his code and mixing in the Flickr API.<br />\n<a id=\"more-2083\"></a><br />\nRather than bore you with written details of how it works, I&#8217;ll just direct you to the animations I made for using the media browser on both Internet Explorer and Firefox. Check them out, there are instructions in the photo descriptions for each!</p>\n<p>On Firefox: <a title=\"Flickr on WordPress.com using Firefox\" href=\"http://flickr.com/photos/94632485@N00/59368625/\"><img width=\"100\" height=\"74\" alt=\"Flickr on WordPress.com using Firefox\" src=\"http://static.flickr.com/31/59368625_77fd572f8e_t.jpg\" /></a></p>\n<p>On Internet Explorer: <a title=\"Flickr on WordPress.com using IE\" href=\"http://flickr.com/photos/94632485@N00/59375719/\"><img width=\"100\" height=\"78\" alt=\"Flickr on WordPress.com using IE\" src=\"http://static.flickr.com/30/59375719_5f04f668f9_t.jpg\" /></a>\n</p>\";}i:39;a:6:{s:5:\"title\";s:48:\"Owen Winkler: WordPress Bug Hunt - This Saturday\";s:4:\"guid\";s:73:\"http://asymptomatic.net/2005/11/01/2077/wordpress-bug-hunt-this-saturday/\";s:4:\"link\";s:73:\"http://asymptomatic.net/2005/11/01/2077/wordpress-bug-hunt-this-saturday/\";s:11:\"description\";s:1720:\"<p>For anyone interested in helping bring WordPress 1.6 into the world, <a title=\"Skippy\'s Bug Hunt Alert\" href=\"http://www.skippy.net/blog/2005/11/01/wordpress-bug-hunt-2005-11-05/\">now is your chance</a>.</p>\n<p>This weekend we&#8217;re having a bug hunt. There are many roles to play even if you&#8217;re not an experienced coder. We need folks to verify reported issues and test patches, and the more people are available, I imagine the better the effort will be. </p>\n<p><a title=\"Skippy\'s site\" href=\"http://skippy.net\">Skippy</a> recommends that you have a WordPress blog to test from. This is preferrably going to be something you&#8217;re not insistant on keeping alive, but rather a local WordPress install that you can mangle and rebuild, since we&#8217;ll be working with the 1.6 alpha. I&#8217;m told that 1.5.2 bugs are going to be considered, too, if they haven&#8217;t already been fixed.<br />\n<a id=\"more-2077\"></a><br />\nI&#8217;m going to guess that there will be more info available as the date rolls around, and you&#8217;ll be able to get it at the dedicated WordPress Bug-B-Que IRC channel, <tt><a href=\"irc://irc.freenode.com/wordpress-bugs\">#wordpress-bugs</a></tt> on <tt>irc.freenode.com</tt>.  Arm yourself with the knowledge that is <em>already</em> available over at the <a title=\"WordPress bug database\" href=\"http://trac.wordpress.org\">WordPress bug database</a>.  You can use your WordPress.org support forum login to login to the bug database.</p>\n<p>If you do stop by, and you&#8217;re a newbie, you&#8217;ll recognize me as <tt>ringmaster</tt> on IRC.  There should be plenty of WP-coding talent there, so be sure to take advantage if some bug in WordPress has been nagging you.\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 04:30:27 +0000\";s:7:\"summary\";s:1720:\"<p>For anyone interested in helping bring WordPress 1.6 into the world, <a title=\"Skippy\'s Bug Hunt Alert\" href=\"http://www.skippy.net/blog/2005/11/01/wordpress-bug-hunt-2005-11-05/\">now is your chance</a>.</p>\n<p>This weekend we&#8217;re having a bug hunt. There are many roles to play even if you&#8217;re not an experienced coder. We need folks to verify reported issues and test patches, and the more people are available, I imagine the better the effort will be. </p>\n<p><a title=\"Skippy\'s site\" href=\"http://skippy.net\">Skippy</a> recommends that you have a WordPress blog to test from. This is preferrably going to be something you&#8217;re not insistant on keeping alive, but rather a local WordPress install that you can mangle and rebuild, since we&#8217;ll be working with the 1.6 alpha. I&#8217;m told that 1.5.2 bugs are going to be considered, too, if they haven&#8217;t already been fixed.<br />\n<a id=\"more-2077\"></a><br />\nI&#8217;m going to guess that there will be more info available as the date rolls around, and you&#8217;ll be able to get it at the dedicated WordPress Bug-B-Que IRC channel, <tt><a href=\"irc://irc.freenode.com/wordpress-bugs\">#wordpress-bugs</a></tt> on <tt>irc.freenode.com</tt>.  Arm yourself with the knowledge that is <em>already</em> available over at the <a title=\"WordPress bug database\" href=\"http://trac.wordpress.org\">WordPress bug database</a>.  You can use your WordPress.org support forum login to login to the bug database.</p>\n<p>If you do stop by, and you&#8217;re a newbie, you&#8217;ll recognize me as <tt>ringmaster</tt> on IRC.  There should be plenty of WP-coding talent there, so be sure to take advantage if some bug in WordPress has been nagging you.\n</p>\";}i:40;a:6:{s:5:\"title\";s:46:\"Owen Winkler: Spam Karma 2 Akismet Plugin BETA\";s:4:\"guid\";s:73:\"http://asymptomatic.net/2005/10/31/2074/spam-karma-2-akismet-plugin-beta/\";s:4:\"link\";s:73:\"http://asymptomatic.net/2005/10/31/2074/spam-karma-2-akismet-plugin-beta/\";s:11:\"description\";s:1224:\"<p>Here&#8217;s a <a href=\"http://www.sebbi.de/archives/2005/10/31/spam-karma-2-akismet-plugin-beta/\">Spam Karma 2 Plugin</a> that takes advantage of the <a href=\"http://akismet.com\">Akismet</a> comment spam service.<br />\n<a id=\"more-2074\"></a><br />\nIt still uses the API key (it must in order to access the service) so you will still need a WordPress.com account to use it.  </p>\n<p>It uses the karma level of a comment to determine whether that comment should be forwarded on to Akismet for analysis.  I wonder what kind of impact this will have on the service&#8217;s ability to track spam generally, since really spammy comments would be preemptively blocked and would not be forwarded to comprise Akismet&#8217;s database of spam.  Likewise, valid comments would also not comprise Akismet&#8217;s not-spam database.</p>\n<p>I wonder if people who need to select a plugin would choose Spam Karma with Akismet over just Akismet.  There is an advantage to not having to set all sorts of options to get working spam prevention on your blog.</p>\n<p>I think this new &#8220;plugin plugin&#8221; will serve well the folks who have had SK2 installed all along, but want the added benefit of the spam-preventing hive mind.\n</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 04:30:27 +0000\";s:7:\"summary\";s:1224:\"<p>Here&#8217;s a <a href=\"http://www.sebbi.de/archives/2005/10/31/spam-karma-2-akismet-plugin-beta/\">Spam Karma 2 Plugin</a> that takes advantage of the <a href=\"http://akismet.com\">Akismet</a> comment spam service.<br />\n<a id=\"more-2074\"></a><br />\nIt still uses the API key (it must in order to access the service) so you will still need a WordPress.com account to use it.  </p>\n<p>It uses the karma level of a comment to determine whether that comment should be forwarded on to Akismet for analysis.  I wonder what kind of impact this will have on the service&#8217;s ability to track spam generally, since really spammy comments would be preemptively blocked and would not be forwarded to comprise Akismet&#8217;s database of spam.  Likewise, valid comments would also not comprise Akismet&#8217;s not-spam database.</p>\n<p>I wonder if people who need to select a plugin would choose Spam Karma with Akismet over just Akismet.  There is an advantage to not having to set all sorts of options to get working spam prevention on your blog.</p>\n<p>I think this new &#8220;plugin plugin&#8221; will serve well the folks who have had SK2 installed all along, but want the added benefit of the spam-preventing hive mind.\n</p>\";}i:41;a:6:{s:5:\"title\";s:45:\"Owen Winkler: WordPress Upgrade Documentation\";s:4:\"guid\";s:72:\"http://asymptomatic.net/2005/10/26/2069/wordpress-upgrade-documentation/\";s:4:\"link\";s:72:\"http://asymptomatic.net/2005/10/26/2069/wordpress-upgrade-documentation/\";s:11:\"description\";s:3755:\"<p><a href=\"http://www.flickr.com/photos/asy/56294371/\"><img src=\"http://static.flickr.com/26/56294371_4d558c7d25_m.jpg\" alt=\"Upgrade Mockup\" /></a>There has been some discussion on the wp-hackers and wp-docs about what a potential Upgrade documentation for WordPress 1.6 should look like.</p>\n<p>I&#8217;m not a proponent of &#8220;simple is better&#8221; in documentation.  At least, in terms of the WordPress upgrade, there is very little to do on the WordPress end to upgrade your system to the new version.  Essentially, you push a button.  But there are some steps you need to take before you get to that point to make sure everything runs smoothly, and that&#8217;s where adequate documentation comes into play.</p>\n<p>I was thinking about what &#8220;Web 2.0&#8243; documentation looks like.  We&#8217;re trying to play off WordPress as a state-of-the-art content management system.  So why not have state-of-the-art documentation?  The <a href=\"http://codex.wordpress.org\">Codex</a> is a good resource for WordPress, but there are users of WordPress that never need to know how to customize their software.  These users will only want to know how to upgrade their installations, and the documentation should hold their hand through the process.  So I assembled this silly mockup of what I imagined Web 2.0 documenation looked like.<br />\n<a id=\"more-2069\"></a><br />\nImportant bits to point out:</p>\n<p>This is a step-by-step process that walks you thorugh the upgrade and <em>that&#8217;s all</em>.  There is no other navigation on the page to confuse you as to what&#8217;s going on.  When you complete a step (or select a path through the steps) you simply move on to the next page/step.</p>\n<p>The first page of this documentation is linked-to from the download page on WordPress.org.  So when you download the new version, you have a direct link to the installation documentation.  Even better, there should also be a link on the installation page.  If you already have the files on the server, then it may already be too late to perform a few of the steps, but at least you can follow along.</p>\n<p>There are the links to the <a href=\"http://wordpress.org/support/\">support forum</a> and the Codex at the bottom of every step, so if you&#8217;re really lost or this information is too basic, you have somewhere to go.</p>\n<p>There are illustrations of every step on the right side of the display.  Even if they are just for show or a logo, I think it looks nice.  In the case of this mockup, there could actually be pictures of different versions of WordPress.  Clicking on one might do the same thing as clicking on one of the links.</p>\n<p>Something that&#8217;s missing form this is a link that says, &#8220;How do I find my version?&#8221;  The installation steps should all think of questions that a user might ask while they are on that step.  But the answers should all lead back to the main path, eventually ending in an upgraded blog.</p>\n<p>The very end of the path should provide links to &#8220;next steps&#8221;.  Inform them that they&#8217;re about to be dumped into a larger resource (Codex) and provide links with suggestions based on what most users like to do after they&#8217;ve finished installing.  For example, there might be a link to a Codex page that helps them find and install a new theme.  There might be a link to another page that tells them what is new or different in the installed version, and where to find and how to use those features.</p>\n<p>This is just a suggestion of mine, and doesn&#8217;t constitute the actual documentation.  I figured I put enough time in the artistic aspect of it that I might as well write a bit about it and put it in front of people to get some response.  Any thoughts?</p>\";s:7:\"pubdate\";s:31:\"Wed, 07 Dec 2005 04:30:27 +0000\";s:7:\"summary\";s:3755:\"<p><a href=\"http://www.flickr.com/photos/asy/56294371/\"><img src=\"http://static.flickr.com/26/56294371_4d558c7d25_m.jpg\" alt=\"Upgrade Mockup\" /></a>There has been some discussion on the wp-hackers and wp-docs about what a potential Upgrade documentation for WordPress 1.6 should look like.</p>\n<p>I&#8217;m not a proponent of &#8220;simple is better&#8221; in documentation.  At least, in terms of the WordPress upgrade, there is very little to do on the WordPress end to upgrade your system to the new version.  Essentially, you push a button.  But there are some steps you need to take before you get to that point to make sure everything runs smoothly, and that&#8217;s where adequate documentation comes into play.</p>\n<p>I was thinking about what &#8220;Web 2.0&#8243; documentation looks like.  We&#8217;re trying to play off WordPress as a state-of-the-art content management system.  So why not have state-of-the-art documentation?  The <a href=\"http://codex.wordpress.org\">Codex</a> is a good resource for WordPress, but there are users of WordPress that never need to know how to customize their software.  These users will only want to know how to upgrade their installations, and the documentation should hold their hand through the process.  So I assembled this silly mockup of what I imagined Web 2.0 documenation looked like.<br />\n<a id=\"more-2069\"></a><br />\nImportant bits to point out:</p>\n<p>This is a step-by-step process that walks you thorugh the upgrade and <em>that&#8217;s all</em>.  There is no other navigation on the page to confuse you as to what&#8217;s going on.  When you complete a step (or select a path through the steps) you simply move on to the next page/step.</p>\n<p>The first page of this documentation is linked-to from the download page on WordPress.org.  So when you download the new version, you have a direct link to the installation documentation.  Even better, there should also be a link on the installation page.  If you already have the files on the server, then it may already be too late to perform a few of the steps, but at least you can follow along.</p>\n<p>There are the links to the <a href=\"http://wordpress.org/support/\">support forum</a> and the Codex at the bottom of every step, so if you&#8217;re really lost or this information is too basic, you have somewhere to go.</p>\n<p>There are illustrations of every step on the right side of the display.  Even if they are just for show or a logo, I think it looks nice.  In the case of this mockup, there could actually be pictures of different versions of WordPress.  Clicking on one might do the same thing as clicking on one of the links.</p>\n<p>Something that&#8217;s missing form this is a link that says, &#8220;How do I find my version?&#8221;  The installation steps should all think of questions that a user might ask while they are on that step.  But the answers should all lead back to the main path, eventually ending in an upgraded blog.</p>\n<p>The very end of the path should provide links to &#8220;next steps&#8221;.  Inform them that they&#8217;re about to be dumped into a larger resource (Codex) and provide links with suggestions based on what most users like to do after they&#8217;ve finished installing.  For example, there might be a link to a Codex page that helps them find and install a new theme.  There might be a link to another page that tells them what is new or different in the installed version, and where to find and how to use those features.</p>\n<p>This is just a suggestion of mine, and doesn&#8217;t constitute the actual documentation.  I figured I put enough time in the artistic aspect of it that I might as well write a bit about it and put it in front of people to get some response.  Any thoughts?</p>\";}i:42;a:6:{s:5:\"title\";s:35:\"Dougal Campbell: Poisoning the well\";s:4:\"guid\";s:60:\"http://dougal.gunters.org/blog/2005/12/06/poisoning-the-well\";s:4:\"link\";s:60:\"http://dougal.gunters.org/blog/2005/12/06/poisoning-the-well\";s:11:\"description\";s:3075:\"<p>\nOverall, the volume of spam attempts on my server have been down lately. Oh, I still get a steady stream, I delete over 100 comment spams (caught by my filters) each day. But I\'ve seen fewer of the massive, server-squashing spam runs that hammer my web service with too many simultaneous connections, blocking out legitimate users.\n</p>\n<p>\nOn the other hand, I\'m seeing a lot more attempts by spammers to <a href=\"http://en.wikipedia.org/wiki/Poisoning_the_well\">poison the well</a>. What I mean by that is that they are submitting bogus comments, full of non-spammy (but more-or-less random) content, and links to legitimate web sites. For example:\n</p>\n<blockquote><p><strong>Name:</strong> <a href=\"http://www.osnews.com/\" rel=\"external nofollow\">Adam Baumann</a></p>\n\n	<p>Hi. Just letting you know that I enjoyed your site. when Soldier Double Game Lose: <a href=\"http://www.newscorp.com/\" rel=\"nofollow\">http://www.newscorp.com/</a> , to Bet Opponents you should be very Faithful <a href=\"http://ranchero.com/netnewswire/\" rel=\"nofollow\">Big Gnome becomes Industrious Plane in final</a> , Superb Opponents becomes Superb Soldier in final <a href=\"http://gaim.sourceforge.net/\" rel=\"nofollow\">Faithful is feature of White Circle</a>\n</p>\n</blockquote>\n<p>\nThe comment is obviously gibberish, right? And the links are all to perfectly normal -- in fact, popular -- sites. You might wonder why a spammer would bother posting it. The idea is to poison the well of any sites which use <a href=\"http://www.paulgraham.com/spam.html\">Bayesian techniques</a> to classify content as spam or not. By tricking sites into classifying \"good\" content as \"spam\", they (theoretically) can reduce the effectiveness of the spam filters.\n</p>\n<p>\nWith enough poisoning, your spam filter may start getting <a href=\"http://en.wikipedia.org/wiki/False_positive#False_positives_and_spam\">false-positives</a>, which are legitimate messages that have incorrectly been tagged as spam. And if you get enough false-positives, you\'ll lose faith in your spam filter and disable it. At least, that\'s what the spammers are trying to accomplish.\n</p>\n<p>\nWill their plan work? I guess that depends on your particular spam filters. I\'m betting that systems like <a href=\"http://akismet.com/\">Akismet</a>, which collect data from a wide variety of sources, will probably be able to defend against Bayes poisoning. How? Well, there\'s this thing called an IP address. Even though the spammers submit their garbage via an army of anonymous proxy servers and <a href=\"http://en.wikipedia.org/wiki/Zombie_computers\">zombie machines</a>, they still only have access to a finite number of hosts, a limited number of IP addresses. It won\'t take long for those IPs to be statistically classified as sources of spam. An IP like <code>221.3.235.96</code> will be flagged as a spam indicator far sooner than the words \"Industrious\" and \"Soldier\".\n</p>\n<p>\nSo once again I say, <a href=\"http://dougal.gunters.org/blog/2005/09/16/dear-spammers\">thank you, spammers</a>. We\'re learning more about you every day.\n</p>\";s:7:\"pubdate\";s:31:\"Tue, 06 Dec 2005 17:07:47 +0000\";s:7:\"summary\";s:3075:\"<p>\nOverall, the volume of spam attempts on my server have been down lately. Oh, I still get a steady stream, I delete over 100 comment spams (caught by my filters) each day. But I\'ve seen fewer of the massive, server-squashing spam runs that hammer my web service with too many simultaneous connections, blocking out legitimate users.\n</p>\n<p>\nOn the other hand, I\'m seeing a lot more attempts by spammers to <a href=\"http://en.wikipedia.org/wiki/Poisoning_the_well\">poison the well</a>. What I mean by that is that they are submitting bogus comments, full of non-spammy (but more-or-less random) content, and links to legitimate web sites. For example:\n</p>\n<blockquote><p><strong>Name:</strong> <a href=\"http://www.osnews.com/\" rel=\"external nofollow\">Adam Baumann</a></p>\n\n	<p>Hi. Just letting you know that I enjoyed your site. when Soldier Double Game Lose: <a href=\"http://www.newscorp.com/\" rel=\"nofollow\">http://www.newscorp.com/</a> , to Bet Opponents you should be very Faithful <a href=\"http://ranchero.com/netnewswire/\" rel=\"nofollow\">Big Gnome becomes Industrious Plane in final</a> , Superb Opponents becomes Superb Soldier in final <a href=\"http://gaim.sourceforge.net/\" rel=\"nofollow\">Faithful is feature of White Circle</a>\n</p>\n</blockquote>\n<p>\nThe comment is obviously gibberish, right? And the links are all to perfectly normal -- in fact, popular -- sites. You might wonder why a spammer would bother posting it. The idea is to poison the well of any sites which use <a href=\"http://www.paulgraham.com/spam.html\">Bayesian techniques</a> to classify content as spam or not. By tricking sites into classifying \"good\" content as \"spam\", they (theoretically) can reduce the effectiveness of the spam filters.\n</p>\n<p>\nWith enough poisoning, your spam filter may start getting <a href=\"http://en.wikipedia.org/wiki/False_positive#False_positives_and_spam\">false-positives</a>, which are legitimate messages that have incorrectly been tagged as spam. And if you get enough false-positives, you\'ll lose faith in your spam filter and disable it. At least, that\'s what the spammers are trying to accomplish.\n</p>\n<p>\nWill their plan work? I guess that depends on your particular spam filters. I\'m betting that systems like <a href=\"http://akismet.com/\">Akismet</a>, which collect data from a wide variety of sources, will probably be able to defend against Bayes poisoning. How? Well, there\'s this thing called an IP address. Even though the spammers submit their garbage via an army of anonymous proxy servers and <a href=\"http://en.wikipedia.org/wiki/Zombie_computers\">zombie machines</a>, they still only have access to a finite number of hosts, a limited number of IP addresses. It won\'t take long for those IPs to be statistically classified as sources of spam. An IP like <code>221.3.235.96</code> will be flagged as a spam indicator far sooner than the words \"Industrious\" and \"Soldier\".\n</p>\n<p>\nSo once again I say, <a href=\"http://dougal.gunters.org/blog/2005/09/16/dear-spammers\">thank you, spammers</a>. We\'re learning more about you every day.\n</p>\";}i:43;a:6:{s:5:\"title\";s:44:\"Weblog Tools Collection: WP Plugin: SmileTAG\";s:4:\"guid\";s:72:\"http://weblogtoolscollection.com/archives/2005/12/06/wp-plugin-smiletag/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=507\";s:11:\"description\";s:342:\"<p><a href=\"http://www.smiletag.com/\">WP Plugin: SmileTAG</a> AJAX and PHP based &#8220;SHoutbox&#8221; plugin for Wordpress.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/smiletag\" rel=\"tag\">smiletag</a> <a href=\"http://www.technorati.com/tag/wordpress+plugin\" rel=\"tag\">wordpress plugin</a></span>\";s:7:\"pubdate\";s:31:\"Tue, 06 Dec 2005 10:25:36 +0000\";s:7:\"summary\";s:342:\"<p><a href=\"http://www.smiletag.com/\">WP Plugin: SmileTAG</a> AJAX and PHP based &#8220;SHoutbox&#8221; plugin for Wordpress.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/smiletag\" rel=\"tag\">smiletag</a> <a href=\"http://www.technorati.com/tag/wordpress+plugin\" rel=\"tag\">wordpress plugin</a></span>\";}i:44;a:6:{s:5:\"title\";s:40:\"Dougal Campbell: The State of FeedLounge\";s:4:\"guid\";s:65:\"http://dougal.gunters.org/blog/2005/12/05/the-state-of-feedlounge\";s:4:\"link\";s:65:\"http://dougal.gunters.org/blog/2005/12/05/the-state-of-feedlounge\";s:11:\"description\";s:1368:\"<p>\n<a href=\"http://alexking.org/blog/\">Alex</a> has posted a moderately detailed article explaining <a href=\"http://feedlounge.com/blog/2005/12/05/state-of-feedlounge/\">The State of FeedLounge</a>. For any newcomers who don\'t know what <a href=\"http://feedlounge.com/\">FeedLounge</a> is, it\'s a web based feed aggregator, not unlike BlogLines. But FeedLounge is a next-generation web service that looks and acts more like a desktop application than a web site.\n</p>\n<p>\nI\'m one of the lucky <a href=\"http://dougal.gunters.org/blog/2005/06/10/feedlounge\">alpha testers</a> who have had access for the last six months. I committed to using FeedLounge as my only feed reader, dumping SharpReader and the <acronym title=\"Rich Site Summary\"><span class=\"caps\">RSS</span></acronym> capabilities of Thunderbird. I\'ve watched FeedLounge go through some rough spots, and it always came back better than before. Alex and <a href=\"http://dotnot.org/blog/\">Scott</a> have done an outstanding job with everything from the great AJAXian user interface to the invisible backend. When the time comes, if the price is right, I\'m going to be a paying customer.\n</p>\n<p>\nBut you don\'t care about all that, do you? What good is it to read about a service that you don\'t have access to? All you care about is knowing that FeedLounge will be open for public beta on January 16, 2006. \n</p>\";s:7:\"pubdate\";s:31:\"Mon, 05 Dec 2005 16:25:42 +0000\";s:7:\"summary\";s:1368:\"<p>\n<a href=\"http://alexking.org/blog/\">Alex</a> has posted a moderately detailed article explaining <a href=\"http://feedlounge.com/blog/2005/12/05/state-of-feedlounge/\">The State of FeedLounge</a>. For any newcomers who don\'t know what <a href=\"http://feedlounge.com/\">FeedLounge</a> is, it\'s a web based feed aggregator, not unlike BlogLines. But FeedLounge is a next-generation web service that looks and acts more like a desktop application than a web site.\n</p>\n<p>\nI\'m one of the lucky <a href=\"http://dougal.gunters.org/blog/2005/06/10/feedlounge\">alpha testers</a> who have had access for the last six months. I committed to using FeedLounge as my only feed reader, dumping SharpReader and the <acronym title=\"Rich Site Summary\"><span class=\"caps\">RSS</span></acronym> capabilities of Thunderbird. I\'ve watched FeedLounge go through some rough spots, and it always came back better than before. Alex and <a href=\"http://dotnot.org/blog/\">Scott</a> have done an outstanding job with everything from the great AJAXian user interface to the invisible backend. When the time comes, if the price is right, I\'m going to be a paying customer.\n</p>\n<p>\nBut you don\'t care about all that, do you? What good is it to read about a service that you don\'t have access to? All you care about is knowing that FeedLounge will be open for public beta on January 16, 2006. \n</p>\";}i:45;a:6:{s:5:\"title\";s:18:\"Matt: German Focus\";s:4:\"guid\";s:45:\"http://photomatt.net/2005/12/05/german-focus/\";s:4:\"link\";s:45:\"http://photomatt.net/2005/12/05/german-focus/\";s:11:\"description\";s:633:\"<p>So the next trip to Europe I&#8217;ll have to catch the Netherlands and Germany, I&#8217;ve met some fantastic WordPress users (and future users) from both. There is someone on stage from a German media organization talking about how they&#8217;ve begun emphasizing blogs much more in their publication, <a href=\"http://focus.msn.de/\">Focus</a>. After browsing a bit I noticed that <a href=\"http://blog.focus.msn.de/\">blogs.focus.msn.de</a> (yes that&#8217;s MSN) is all WordPress blogs &#8212; cool! What&#8217;s interesting about being Open Source is that the software turns up places you would never suspect or know about.\n</p>\";s:7:\"pubdate\";s:31:\"Mon, 05 Dec 2005 13:52:07 +0000\";s:7:\"summary\";s:633:\"<p>So the next trip to Europe I&#8217;ll have to catch the Netherlands and Germany, I&#8217;ve met some fantastic WordPress users (and future users) from both. There is someone on stage from a German media organization talking about how they&#8217;ve begun emphasizing blogs much more in their publication, <a href=\"http://focus.msn.de/\">Focus</a>. After browsing a bit I noticed that <a href=\"http://blog.focus.msn.de/\">blogs.focus.msn.de</a> (yes that&#8217;s MSN) is all WordPress blogs &#8212; cool! What&#8217;s interesting about being Open Source is that the software turns up places you would never suspect or know about.\n</p>\";}i:46;a:6:{s:5:\"title\";s:44:\"Weblog Tools Collection: WP Theme: Exquisite\";s:4:\"guid\";s:72:\"http://weblogtoolscollection.com/archives/2005/12/04/wp-theme-exquisite/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=506\";s:11:\"description\";s:287:\"<p><a href=\"http://www.kaushalsheth.com/exquisite-wordpress-theme/\">WP Theme: Exquisite</a> Two column, elegant, tabbed theme for Wordpress. Via Email.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/wordpress+theme\" rel=\"tag\">wordpress theme</a>\";s:7:\"pubdate\";s:31:\"Sun, 04 Dec 2005 11:15:38 +0000\";s:7:\"summary\";s:287:\"<p><a href=\"http://www.kaushalsheth.com/exquisite-wordpress-theme/\">WP Theme: Exquisite</a> Two column, elegant, tabbed theme for Wordpress. Via Email.</p>\n<span class=\"technoratitags\">Technorati Tags: <a href=\"http://www.technorati.com/tag/wordpress+theme\" rel=\"tag\">wordpress theme</a>\";}i:47;a:6:{s:5:\"title\";s:21:\"Matt: Akismet in Java\";s:4:\"guid\";s:48:\"http://photomatt.net/2005/12/04/akismet-in-java/\";s:4:\"link\";s:48:\"http://photomatt.net/2005/12/04/akismet-in-java/\";s:11:\"description\";s:259:\"<p><a href=\"http://www.blojsom.com/blog/java/2005/12/02/Akismet-Java-API-1-0-Available.html\">Akismet Java API</a>, by David Czarnecki (the author of the excellent <a href=\"http://wiki.blojsom.com/wiki/display/blojsom/About+blojsom\">Blojsom</a>). So cool!\n</p>\";s:7:\"pubdate\";s:31:\"Sun, 04 Dec 2005 08:29:54 +0000\";s:7:\"summary\";s:259:\"<p><a href=\"http://www.blojsom.com/blog/java/2005/12/02/Akismet-Java-API-1-0-Available.html\">Akismet Java API</a>, by David Czarnecki (the author of the excellent <a href=\"http://wiki.blojsom.com/wiki/display/blojsom/About+blojsom\">Blojsom</a>). So cool!\n</p>\";}i:48;a:6:{s:5:\"title\";s:24:\"Matt: Yahoo on WordPress\";s:4:\"guid\";s:51:\"http://photomatt.net/2005/12/03/yahoo-on-wordpress/\";s:4:\"link\";s:51:\"http://photomatt.net/2005/12/03/yahoo-on-wordpress/\";s:11:\"description\";s:828:\"<p><a href=\"http://www.shallwesingasongforyou.co.uk/\">Stephen Steele</a> (is that a real name?) just wrote in that <a href=\"http://updates.mail.yahoo.com/blog/\">the new Yahoo Mail updates blog is on WordPress</a>. As far as I know this is the first official Yahoo blog on WP I&#8217;ve seen. What makes it really interesting is it&#8217;s the first time I&#8217;ve seen third-party software (like WordPress) on the yahoo.com domain. You&#8217;ll notice every time they&#8217;ve done blogs before it&#8217;s been on a different domain like yahoo.net or ysearchblog.com, I imagine because of the incredibly strict security requirements anything with access to Yahoo.com cookies must meet. This is very exciting news. <img src=\"http://photomatt.net/blog/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" />\n</p>\";s:7:\"pubdate\";s:31:\"Sat, 03 Dec 2005 14:55:53 +0000\";s:7:\"summary\";s:828:\"<p><a href=\"http://www.shallwesingasongforyou.co.uk/\">Stephen Steele</a> (is that a real name?) just wrote in that <a href=\"http://updates.mail.yahoo.com/blog/\">the new Yahoo Mail updates blog is on WordPress</a>. As far as I know this is the first official Yahoo blog on WP I&#8217;ve seen. What makes it really interesting is it&#8217;s the first time I&#8217;ve seen third-party software (like WordPress) on the yahoo.com domain. You&#8217;ll notice every time they&#8217;ve done blogs before it&#8217;s been on a different domain like yahoo.net or ysearchblog.com, I imagine because of the incredibly strict security requirements anything with access to Yahoo.com cookies must meet. This is very exciting news. <img src=\"http://photomatt.net/blog/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" />\n</p>\";}i:49;a:6:{s:5:\"title\";s:12:\"Matt: Landed\";s:4:\"guid\";s:39:\"http://photomatt.net/2005/12/03/landed/\";s:4:\"link\";s:39:\"http://photomatt.net/2005/12/03/landed/\";s:11:\"description\";s:463:\"<p>Paris has the most confusing airport, although I suppose any airport is confusing if you don&#8217;t speak the language. <a href=\"http://photomatt.net/2005/12/02/french-phrases/#comment-34113\">Franck was right</a>. I ended up chickening out and taking a taxi, and I&#8217;m not checked in and settled. First order of business: find an adapter for these weird plugs. The weather seems to have cleared up so I&#8217;m going to venture out and explore a bit.\n</p>\";s:7:\"pubdate\";s:31:\"Sat, 03 Dec 2005 12:47:27 +0000\";s:7:\"summary\";s:463:\"<p>Paris has the most confusing airport, although I suppose any airport is confusing if you don&#8217;t speak the language. <a href=\"http://photomatt.net/2005/12/02/french-phrases/#comment-34113\">Franck was right</a>. I ended up chickening out and taking a taxi, and I&#8217;m not checked in and settled. First order of business: find an adapter for these weird plugs. The weather seems to have cleared up so I&#8217;m going to venture out and explore a bit.\n</p>\";}i:50;a:6:{s:5:\"title\";s:20:\"Matt: French Phrases\";s:4:\"guid\";s:47:\"http://photomatt.net/2005/12/02/french-phrases/\";s:4:\"link\";s:47:\"http://photomatt.net/2005/12/02/french-phrases/\";s:11:\"description\";s:492:\"<p>After reading about <a href=\"http://anarkystic.com/blog/2005/12/01/i-have-no-chance-will-make-my-time/\">Andy&#8217;s adventures</a> I decided I better Google up a French phrasebook for study on the flight. <a href=\"http://yoyo.cc.monash.edu.au/~mongoose/french/phrases.html\">The first hit</a> looks like it would get me in to a little more trouble than I&#8217;m looking for. <img src=\"http://photomatt.net/blog/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" />\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 02 Dec 2005 23:48:15 +0000\";s:7:\"summary\";s:492:\"<p>After reading about <a href=\"http://anarkystic.com/blog/2005/12/01/i-have-no-chance-will-make-my-time/\">Andy&#8217;s adventures</a> I decided I better Google up a French phrasebook for study on the flight. <a href=\"http://yoyo.cc.monash.edu.au/~mongoose/french/phrases.html\">The first hit</a> looks like it would get me in to a little more trouble than I&#8217;m looking for. <img src=\"http://photomatt.net/blog/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" />\n</p>\";}i:51;a:6:{s:5:\"title\";s:42:\"Mike Little: UPA North Meeting, Manchester\";s:4:\"guid\";s:77:\"http://zed1.com/journalized/archives/2005/12/02/upa-north-meeting-manchester/\";s:4:\"link\";s:77:\"http://zed1.com/journalized/archives/2005/12/02/upa-north-meeting-manchester/\";s:11:\"description\";s:2393:\"<p>I will be going to the next UK Usability Professionals Association (UPA) North meeting at Cafe Muse at the Manchester Museum on Thursday 8th December. This time we are very privileged to have Prof. Alistair Sutcliffe from University of Manchester to present the main event.</p>\n	<blockquote><p><strong>The Main Event - Alistair Sutcliffe on &#8216;Designing Attractive Web Sites&#8217;</strong></p>\n	<p>&#8220;This talk will present recent research that attempts to unpack the current debate about user engagement and aesthetics in web site design&#8230; The end point, I hope, will be to foster discussion of concepts of engagement and aesthetics in web design and when such concepts are really important in delivering effectiveness and commercial success.&#8221; </p></blockquote>\n	<p>If you are interested in usability, aesthetics and e-commerce and how it all fits together, you really SHOULD NOT MISS THIS!</p>\n	<blockquote><p><strong>The B Feature - Steve Potts on Website Accessibility Evaluation Techniques</strong></p>\n	<p>Steve Potts will give a brief tour of the techniques and pragmatic perspective applied when evaluating websites for accessibility.<br />\n&#8220;In this presentation we&#8217;ll investigate how to address website accessibility evaluations from a technical perspective, highlighting the difficulties imposed by the wide range of collective technologies accessing the web, and the criteria by which we measure the objectives of an evaluation.&#8221;</p></blockquote>\n	<p>Steve is a good friend of mine and someone I admire and respect. Steve&#8217;s presentation is another reason you should not miss this event.</p>\n	<p>As ever, the meeting will provide an opportunity to network, chat, have a drink and meet new people.</p>\n	<p><strong>Venue and Date Details</strong></p>\n	<ul>\n<li>Venue: Cafe Muse, Manchester Museum, Oxford Road, Manchester,M13 7QQ Map at <a href=\"http://tinyurl.com/byj4u\">http://tinyurl.com/byj4u</a></li>\n	<li>Date: Thursday 8th December 2005</li>\n	<li>Start Time: 6.30pm for 7.00pm</li>\n	<li>End Time: Around 9.00pm and then drinks at Cafe Muse and Kro Bar.</li>\n	<li>Cost: Free</li>\n	</ul>\n	<p>You do <strong>not</strong> need to be a member of the UPA to attend this meeting. </p>\n	<p>RSVP: It helps us if we know how many people are coming, so <strong>please email to book using northern.usability [AT] gmail [DOT] com</strong>.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 02 Dec 2005 23:43:46 +0000\";s:7:\"summary\";s:2393:\"<p>I will be going to the next UK Usability Professionals Association (UPA) North meeting at Cafe Muse at the Manchester Museum on Thursday 8th December. This time we are very privileged to have Prof. Alistair Sutcliffe from University of Manchester to present the main event.</p>\n	<blockquote><p><strong>The Main Event - Alistair Sutcliffe on &#8216;Designing Attractive Web Sites&#8217;</strong></p>\n	<p>&#8220;This talk will present recent research that attempts to unpack the current debate about user engagement and aesthetics in web site design&#8230; The end point, I hope, will be to foster discussion of concepts of engagement and aesthetics in web design and when such concepts are really important in delivering effectiveness and commercial success.&#8221; </p></blockquote>\n	<p>If you are interested in usability, aesthetics and e-commerce and how it all fits together, you really SHOULD NOT MISS THIS!</p>\n	<blockquote><p><strong>The B Feature - Steve Potts on Website Accessibility Evaluation Techniques</strong></p>\n	<p>Steve Potts will give a brief tour of the techniques and pragmatic perspective applied when evaluating websites for accessibility.<br />\n&#8220;In this presentation we&#8217;ll investigate how to address website accessibility evaluations from a technical perspective, highlighting the difficulties imposed by the wide range of collective technologies accessing the web, and the criteria by which we measure the objectives of an evaluation.&#8221;</p></blockquote>\n	<p>Steve is a good friend of mine and someone I admire and respect. Steve&#8217;s presentation is another reason you should not miss this event.</p>\n	<p>As ever, the meeting will provide an opportunity to network, chat, have a drink and meet new people.</p>\n	<p><strong>Venue and Date Details</strong></p>\n	<ul>\n<li>Venue: Cafe Muse, Manchester Museum, Oxford Road, Manchester,M13 7QQ Map at <a href=\"http://tinyurl.com/byj4u\">http://tinyurl.com/byj4u</a></li>\n	<li>Date: Thursday 8th December 2005</li>\n	<li>Start Time: 6.30pm for 7.00pm</li>\n	<li>End Time: Around 9.00pm and then drinks at Cafe Muse and Kro Bar.</li>\n	<li>Cost: Free</li>\n	</ul>\n	<p>You do <strong>not</strong> need to be a member of the UPA to attend this meeting. </p>\n	<p>RSVP: It helps us if we know how many people are coming, so <strong>please email to book using northern.usability [AT] gmail [DOT] com</strong>.\n</p>\";}i:52;a:6:{s:5:\"title\";s:14:\"Matt: En Route\";s:4:\"guid\";s:41:\"http://photomatt.net/2005/12/02/en-route/\";s:4:\"link\";s:41:\"http://photomatt.net/2005/12/02/en-route/\";s:11:\"description\";s:633:\"<p>About to board the plane to Paris for the <a href=\"http://lesblogs.typepad.com/\">Les Blogs conference</a>, where I will be representing open source and WP from the audience side. I&#8217;m looking forward to exploring Paris and meeting some French WordPress users. I&#8217;m surprised that <a href=\"http://www.dotclear.net/\">Dot Clear</a> isn&#8217;t represented at the conference, as it seems to be one of the more significant blogging tools over there. There is no WP meetup planned but I&#8217;m there through Wednesday so if you&#8217;re interested in something <a href=\"http://photomatt.net/contact/\">drop me a note</a>.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 02 Dec 2005 23:12:50 +0000\";s:7:\"summary\";s:633:\"<p>About to board the plane to Paris for the <a href=\"http://lesblogs.typepad.com/\">Les Blogs conference</a>, where I will be representing open source and WP from the audience side. I&#8217;m looking forward to exploring Paris and meeting some French WordPress users. I&#8217;m surprised that <a href=\"http://www.dotclear.net/\">Dot Clear</a> isn&#8217;t represented at the conference, as it seems to be one of the more significant blogging tools over there. There is no WP meetup planned but I&#8217;m there through Wednesday so if you&#8217;re interested in something <a href=\"http://photomatt.net/contact/\">drop me a note</a>.\n</p>\";}i:53;a:6:{s:5:\"title\";s:89:\"Weblog Tools Collection: Chitika publishers see drastically reduced earnings after audits\";s:4:\"guid\";s:118:\"http://weblogtoolscollection.com/archives/2005/12/02/chitika-publishers-see-drastically-reduced-earnings-after-audits/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=504\";s:11:\"description\";s:912:\"<p><a href=\"http://www.jensense.com/archives/2005/12/chitika_publish.html\">Chitika publishers see drastically reduced earnings after audits</a>: I got in after the hump, maybe well after the hump (the hump being the huge rush of people trying out Chitika for their adserving needs). I personally made little to no money right from the beginning and frankly should have known that this would be the outcome. Chitika had piss poor results for my blog with their text ads and their eMiniMalls returns have now fallen to those levels. Long live Chitika, Chitika is dead. There is enough money to be had in this business that if you create a little buzz in the industry, you can rope in enough people to start making you some money. I should really resurrect that open source text link ad app (to be able to sell ads independantly and dynamically on your blog, accept payments via PayPal) I was putting together.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 02 Dec 2005 14:00:23 +0000\";s:7:\"summary\";s:912:\"<p><a href=\"http://www.jensense.com/archives/2005/12/chitika_publish.html\">Chitika publishers see drastically reduced earnings after audits</a>: I got in after the hump, maybe well after the hump (the hump being the huge rush of people trying out Chitika for their adserving needs). I personally made little to no money right from the beginning and frankly should have known that this would be the outcome. Chitika had piss poor results for my blog with their text ads and their eMiniMalls returns have now fallen to those levels. Long live Chitika, Chitika is dead. There is enough money to be had in this business that if you create a little buzz in the industry, you can rope in enough people to start making you some money. I should really resurrect that open source text link ad app (to be able to sell ads independantly and dynamically on your blog, accept payments via PayPal) I was putting together.\n</p>\";}i:54;a:6:{s:5:\"title\";s:25:\"Matt: Akismet Development\";s:4:\"guid\";s:52:\"http://photomatt.net/2005/12/02/akismet-development/\";s:4:\"link\";s:52:\"http://photomatt.net/2005/12/02/akismet-development/\";s:11:\"description\";s:442:\"<p><a href=\"http://akismet.com/blog/2005/12/python-and-api/\">Akismet now has API documentation and not one but two Python implementations</a>. The WordPress plugin has also <a href=\"http://akismet.com/blog/2005/11/thanksgiving-plugin-update/\">been updated</a> to respond to the most common feedback and a few minor bugfixes. Akismet has caught 465,769 spams since it started (81% of all comments) and is protecting over 35k unique blogs.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 02 Dec 2005 09:44:06 +0000\";s:7:\"summary\";s:442:\"<p><a href=\"http://akismet.com/blog/2005/12/python-and-api/\">Akismet now has API documentation and not one but two Python implementations</a>. The WordPress plugin has also <a href=\"http://akismet.com/blog/2005/11/thanksgiving-plugin-update/\">been updated</a> to respond to the most common feedback and a few minor bugfixes. Akismet has caught 465,769 spams since it started (81% of all comments) and is protecting over 35k unique blogs.\n</p>\";}i:55;a:6:{s:5:\"title\";s:77:\"Weblog Tools Collection: Jason has trouble with Firefox 1.5 and Wordpress 1.5\";s:4:\"guid\";s:104:\"http://weblogtoolscollection.com/archives/2005/12/02/jason-has-trouble-with-firefox-15-and-wordpress-15/\";s:4:\"link\";s:60:\"http://feeds.feedburner.com/weblogtoolscollection/UXMP?m=505\";s:11:\"description\";s:298:\"<p><a href=\"http://www.powerpage.org/archives/2005/12/firefox_15_no_w.html\">Jason has trouble with Firefox 1.5 and Wordpress 1.5</a> I cannot seem to recreate the problem Jason, I cannot recreate your report of the bug. Do you have any extensions (or are you using Wordpress 2 beta/alpha etc)?\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 02 Dec 2005 09:26:06 +0000\";s:7:\"summary\";s:298:\"<p><a href=\"http://www.powerpage.org/archives/2005/12/firefox_15_no_w.html\">Jason has trouble with Firefox 1.5 and Wordpress 1.5</a> I cannot seem to recreate the problem Jason, I cannot recreate your report of the bug. Do you have any extensions (or are you using Wordpress 2 beta/alpha etc)?\n</p>\";}i:56;a:6:{s:5:\"title\";s:28:\"Matt: Roles and Capabilities\";s:4:\"guid\";s:55:\"http://photomatt.net/2005/12/02/roles-and-capabilities/\";s:4:\"link\";s:55:\"http://photomatt.net/2005/12/02/roles-and-capabilities/\";s:11:\"description\";s:202:\"<p><a href=\"http://boren.nu/archives/2005/12/01/whats-new-in-20-roles-and-capabilities/\">Whatâ€™s New in 2.0: Roles and Capabilities</a>. I&#8217;m using the new bookmarklet to post this, it rocks.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 02 Dec 2005 08:58:58 +0000\";s:7:\"summary\";s:202:\"<p><a href=\"http://boren.nu/archives/2005/12/01/whats-new-in-20-roles-and-capabilities/\">Whatâ€™s New in 2.0: Roles and Capabilities</a>. I&#8217;m using the new bookmarklet to post this, it rocks.\n</p>\";}i:57;a:6:{s:5:\"title\";s:17:\"Matt: Sister Moon\";s:4:\"guid\";s:44:\"http://photomatt.net/2005/12/01/sister-moon/\";s:4:\"link\";s:44:\"http://photomatt.net/2005/12/01/sister-moon/\";s:11:\"description\";s:212:\"<p><a href=\"http://photomatt.net/dropbox/2005/12/06%20Sister%20Moon.mp3\">My mistress&#8217; eyes are nothing like the sun, my hunger for her explains everything I&#8217;ve done</a>. Herbie Hancock and Sting.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 02 Dec 2005 05:37:29 +0000\";s:7:\"summary\";s:212:\"<p><a href=\"http://photomatt.net/dropbox/2005/12/06%20Sister%20Moon.mp3\">My mistress&#8217; eyes are nothing like the sun, my hunger for her explains everything I&#8217;ve done</a>. Herbie Hancock and Sting.\n</p>\";}i:58;a:6:{s:5:\"title\";s:50:\"Ryan Boren: WP Commit Digest for Oct. 15 - Nov. 15\";s:4:\"guid\";s:71:\"http://boren.nu/archives/1999/11/30/wp-commit-digest-for-oct-15-nov-15/\";s:4:\"link\";s:71:\"http://boren.nu/archives/2005/11/14/wp-commit-digest-for-oct-15-nov-15/\";s:11:\"description\";s:2619:\"<p>The past month has seen almost <a href=\"http://trac.wordpress.org/timeline?from=11%2F15%2F05&#038;daysback=31&#038;changeset=on\">150 commits</a>.  The <a href=\"http://boren.nu/archives/2005/11/06/bug-hunt/\">bug hunt</a> is responsible for many of those.  Almost 100 bugs were squashed during the hunt.  Amidst the bug fixing we managed to add some new features and refine some existing ones.</p>\n<p>The WYSIWYG editor received lots of polishing.  It is <a href=\"http://andy.wordpress.com/2005/11/08/wordpress-wysiwyg-gets-more-accessible/\">much more accessible</a> thanks to <a href=\"http://andy.wordpress.com/\">Andy&#8217;s</a> work.  Andy also did lots of work on the image uploader.  Images and other uploaded objects now can have their own <a href=\"http://andy.wordpress.com/2005/11/02/wordpress-likes-flickr/\">permalinks and comments</a>.  Andy and <a href=\"http://asymptomatic.net/\">Owen</a>  also created a <a href=\"http://asymptomatic.net/2005/11/03/2083/how-to-use-flickr-on-wordpresscom/\"> Flickr </a><a href=\"http://andy.wordpress.com/2005/11/07/wordpress-likes-flickr-kinda/\">plugin</a> that provides nice integration with your Flickr photos.</p>\n<p>I worked behind the scenes on <a href=\"http://ryan.wordpress.com/2005/11/01/database-versioning/\">database versioning</a> and a <a href=\"http://ryan.wordpress.com/2005/11/14/persistent-object-cache/\">persistent object cache</a>.  Users don&#8217;t really care about these since they&#8217;re not visible, but the changes should result in a faster, leaner, and more vigorous WordPress. Honest.</p>\n<p>To wrap this up, here are a few development headlines from the last month.</p>\n<ul>\n<li><a href=\"http://ryan.wordpress.com/2005/11/14/persistent-object-cache/\">Persistent Object Cache</a></li>\n<li><a href=\"http://ryan.wordpress.com/2005/11/01/wp-mail-love/\">wp-mail Love</a></li>\n<li><a href=\"http://ryan.wordpress.com/2005/11/01/resolving-subcategory-uris/\">Resolving Subcategory URIs</a></li>\n<li><a href=\"http://ryan.wordpress.com/2005/11/01/bookmarklet-love/\">Bookmarklet Love</a></li>\n<li><a href=\"http://ryan.wordpress.com/2005/11/01/database-versioning/\">Database Versioning</a></li>\n<li><a href=\"http://andy.wordpress.com/2005/11/08/wordpress-wysiwyg-gets-more-accessible/\">WordPress WYSIWYG gets more accessible&#8221;</a></li>\n<li><a href=\"http://andy.wordpress.com/2005/11/07/wordpress-likes-flickr-kinda/\">Wordpress Likes Flickr, kinda</a></li>\n<li><a href=\"http://andy.wordpress.com/2005/11/02/wordpress-likes-flickr/\">WordPress Likes Flickr</a></li>\n<li><a href=\"http://matt.wordpress.com/2005/11/08/rsd-support/\">RSD Support</a></li>\n</ul>\";s:7:\"pubdate\";s:31:\"Fri, 02 Dec 2005 00:30:36 +0000\";s:7:\"summary\";s:2619:\"<p>The past month has seen almost <a href=\"http://trac.wordpress.org/timeline?from=11%2F15%2F05&#038;daysback=31&#038;changeset=on\">150 commits</a>.  The <a href=\"http://boren.nu/archives/2005/11/06/bug-hunt/\">bug hunt</a> is responsible for many of those.  Almost 100 bugs were squashed during the hunt.  Amidst the bug fixing we managed to add some new features and refine some existing ones.</p>\n<p>The WYSIWYG editor received lots of polishing.  It is <a href=\"http://andy.wordpress.com/2005/11/08/wordpress-wysiwyg-gets-more-accessible/\">much more accessible</a> thanks to <a href=\"http://andy.wordpress.com/\">Andy&#8217;s</a> work.  Andy also did lots of work on the image uploader.  Images and other uploaded objects now can have their own <a href=\"http://andy.wordpress.com/2005/11/02/wordpress-likes-flickr/\">permalinks and comments</a>.  Andy and <a href=\"http://asymptomatic.net/\">Owen</a>  also created a <a href=\"http://asymptomatic.net/2005/11/03/2083/how-to-use-flickr-on-wordpresscom/\"> Flickr </a><a href=\"http://andy.wordpress.com/2005/11/07/wordpress-likes-flickr-kinda/\">plugin</a> that provides nice integration with your Flickr photos.</p>\n<p>I worked behind the scenes on <a href=\"http://ryan.wordpress.com/2005/11/01/database-versioning/\">database versioning</a> and a <a href=\"http://ryan.wordpress.com/2005/11/14/persistent-object-cache/\">persistent object cache</a>.  Users don&#8217;t really care about these since they&#8217;re not visible, but the changes should result in a faster, leaner, and more vigorous WordPress. Honest.</p>\n<p>To wrap this up, here are a few development headlines from the last month.</p>\n<ul>\n<li><a href=\"http://ryan.wordpress.com/2005/11/14/persistent-object-cache/\">Persistent Object Cache</a></li>\n<li><a href=\"http://ryan.wordpress.com/2005/11/01/wp-mail-love/\">wp-mail Love</a></li>\n<li><a href=\"http://ryan.wordpress.com/2005/11/01/resolving-subcategory-uris/\">Resolving Subcategory URIs</a></li>\n<li><a href=\"http://ryan.wordpress.com/2005/11/01/bookmarklet-love/\">Bookmarklet Love</a></li>\n<li><a href=\"http://ryan.wordpress.com/2005/11/01/database-versioning/\">Database Versioning</a></li>\n<li><a href=\"http://andy.wordpress.com/2005/11/08/wordpress-wysiwyg-gets-more-accessible/\">WordPress WYSIWYG gets more accessible&#8221;</a></li>\n<li><a href=\"http://andy.wordpress.com/2005/11/07/wordpress-likes-flickr-kinda/\">Wordpress Likes Flickr, kinda</a></li>\n<li><a href=\"http://andy.wordpress.com/2005/11/02/wordpress-likes-flickr/\">WordPress Likes Flickr</a></li>\n<li><a href=\"http://matt.wordpress.com/2005/11/08/rsd-support/\">RSD Support</a></li>\n</ul>\";}i:59;a:6:{s:5:\"title\";s:28:\"Ryan Boren: The Gory Details\";s:4:\"guid\";s:23:\"http://boren.nu/?p=1407\";s:4:\"link\";s:53:\"http://boren.nu/archives/2005/09/17/the-gory-details/\";s:11:\"description\";s:624:\"<p>For those who want the low-low-down on WordPress development, I&#8217;ll be blogging about the gory day-to-day details over at my <a href=\"http://ryan.wordpress.com/\">wordpress.com</a> site.  I&#8217;ll stick punch lists, running commentary on commits, and development head-scratching over there while continuing with the higher level WP Commit Digests here at boren.nu.  I also intend to outline some areas of the code that need to be cleaned up or reviewed so that those interested in helping with some of the smaller development chores can take on some tasks that will help them get their feet wet in the WP core.\n</p>\";s:7:\"pubdate\";s:31:\"Fri, 02 Dec 2005 00:30:36 +0000\";s:7:\"summary\";s:624:\"<p>For those who want the low-low-down on WordPress development, I&#8217;ll be blogging about the gory day-to-day details over at my <a href=\"http://ryan.wordpress.com/\">wordpress.com</a> site.  I&#8217;ll stick punch lists, running commentary on commits, and development head-scratching over there while continuing with the higher level WP Commit Digests here at boren.nu.  I also intend to outline some areas of the code that need to be cleaned up or reviewed so that those interested in helping with some of the smaller development chores can take on some tasks that will help them get their feet wet in the WP core.\n</p>\";}}s:7:\"channel\";a:5:{s:5:\"title\";s:16:\"WordPress Planet\";s:4:\"link\";s:28:\"http://planet.wordpress.org/\";s:8:\"language\";s:2:\"en\";s:11:\"description\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"tagline\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";}s:9:\"textinput\";a:0:{}s:5:\"image\";a:0:{}s:9:\"feed_type\";s:3:\"RSS\";s:12:\"feed_version\";s:3:\"2.0\";s:5:\"stack\";a:0:{}s:9:\"inchannel\";b:0;s:6:\"initem\";b:0;s:9:\"incontent\";b:0;s:11:\"intextinput\";b:0;s:7:\"inimage\";b:0;s:13:\"current_field\";s:0:\"\";s:17:\"current_namespace\";b:0;s:19:\"_CONTENT_CONSTRUCTS\";a:6:{i:0;s:7:\"content\";i:1;s:7:\"summary\";i:2;s:4:\"info\";i:3;s:5:\"title\";i:4;s:7:\"tagline\";i:5;s:9:\"copyright\";}s:13:\"last_modified\";s:31:\"Fri, 16 Dec 2005 16:30:56 GMT\r\n\";s:4:\"etag\";s:34:\"\"4a01c5-173bc-43a2ebc0;432f77d7\"\r\n\";}',20,8,'',1,'no'),(70,0,'rss_867bd5c64f85878d03a060509cd2f92c_ts','Y',1,'1134751672',20,8,'',1,'no'),(71,0,'rss_17986f152f11df379684c3ebdfeebe29','Y',1,'O:9:\"MagpieRSS\":19:{s:6:\"parser\";i:0;s:12:\"current_item\";a:0:{}s:5:\"items\";a:10:{i:0;a:9:{s:5:\"title\";s:37:\"Taylor Mays\' Agent Hates Pete Carroll\";s:6:\"author\";s:12:\"doctorgeeves\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/IOe4rzdUM_4/\";s:4:\"guid\";s:83:\"http://technorati.com/sports/football/article/taylor-mays-agent-hates-pete-carroll/\";s:11:\"description\";s:205:\"Taylor Mays has been compared to Troy Polamalu, which could help his draft stock - if his agent can shut his mouth.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/IOe4rzdUM_4\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Thu, 01 Apr 2010 04:45:20 +0000\";s:8:\"category\";s:47:\"Footballncaa-footballpete-carrollTaylor Maysusc\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:83:\"http://technorati.com/sports/football/article/taylor-mays-agent-hates-pete-carroll/\";}s:7:\"summary\";s:205:\"Taylor Mays has been compared to Troy Polamalu, which could help his draft stock - if his agent can shut his mouth.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/IOe4rzdUM_4\" height=\"1\" width=\"1\"/>\";}i:1;a:9:{s:5:\"title\";s:39:\"Lavin, Kowalczyk Head Coaching Carousel\";s:6:\"author\";s:12:\"doctorgeeves\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/KLU5f4kAYBE/\";s:4:\"guid\";s:76:\"http://technorati.com/sports/article/lavin-kowalczyk-head-coaching-carousel/\";s:11:\"description\";s:195:\"Two NCAA basketball coaching hires stand above the rest as interesting stories to track come next season.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/KLU5f4kAYBE\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Thu, 01 Apr 2010 04:22:30 +0000\";s:8:\"category\";s:60:\"Sportsncaa-basketballSt. JohnsSteve LavinTed KowalczykToledo\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:76:\"http://technorati.com/sports/article/lavin-kowalczyk-head-coaching-carousel/\";}s:7:\"summary\";s:195:\"Two NCAA basketball coaching hires stand above the rest as interesting stories to track come next season.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/KLU5f4kAYBE\" height=\"1\" width=\"1\"/>\";}i:2;a:9:{s:5:\"title\";s:43:\"E-book Titles Nearly Settled For iPad Debut\";s:6:\"author\";s:9:\"bastetmax\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/Ib27vGWUYts/\";s:4:\"guid\";s:74:\"http://technorati.com/technology/article/e-book-titles-nearly-settled-for/\";s:11:\"description\";s:188:\"E-book prices have been in flux for weeks as Amazon\'s Kindle and Apple\'s iPad fight for supremacy.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/Ib27vGWUYts\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Thu, 01 Apr 2010 03:08:27 +0000\";s:8:\"category\";s:99:\"Technologyamazonapplebestsellerscontroversye-booksGutenberg Project.iPadkindlePartnershippublishers\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:74:\"http://technorati.com/technology/article/e-book-titles-nearly-settled-for/\";}s:7:\"summary\";s:188:\"E-book prices have been in flux for weeks as Amazon\'s Kindle and Apple\'s iPad fight for supremacy.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/Ib27vGWUYts\" height=\"1\" width=\"1\"/>\";}i:3;a:9:{s:5:\"title\";s:42:\"Challenged Travelers Break Travel Barriers\";s:6:\"author\";s:9:\"kaleeltvp\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/Nyc-BJvvLR4/\";s:4:\"guid\";s:90:\"http://technorati.com/lifestyle/travel/article/challenged-travelers-break-travel-barriers/\";s:11:\"description\";s:205:\"Challenged or handicapped travelers are kayaking, mountain climbing and breaking down all kinds of travel barriers.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/Nyc-BJvvLR4\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Thu, 01 Apr 2010 02:58:43 +0000\";s:8:\"category\";s:62:\"Traveldisabled travelersHandicappedphysically-challengedtravel\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:90:\"http://technorati.com/lifestyle/travel/article/challenged-travelers-break-travel-barriers/\";}s:7:\"summary\";s:205:\"Challenged or handicapped travelers are kayaking, mountain climbing and breaking down all kinds of travel barriers.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/Nyc-BJvvLR4\" height=\"1\" width=\"1\"/>\";}i:4;a:9:{s:5:\"title\";s:42:\"Bullying Leads To Another Teenager Suicide\";s:6:\"author\";s:6:\"amohit\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/8IncVaZ1ITI/\";s:4:\"guid\";s:90:\"http://technorati.com/lifestyle/family/article/bullying-leads-to-another-teenager-suicide/\";s:11:\"description\";s:213:\"Why did Phoebe Prince, the new kid in school, hang herself? Was it because of bullies, or the lack of action on her school?<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/8IncVaZ1ITI\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Thu, 01 Apr 2010 01:07:43 +0000\";s:8:\"category\";s:27:\"FamilybullyingPhoebe Prince\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:90:\"http://technorati.com/lifestyle/family/article/bullying-leads-to-another-teenager-suicide/\";}s:7:\"summary\";s:213:\"Why did Phoebe Prince, the new kid in school, hang herself? Was it because of bullies, or the lack of action on her school?<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/8IncVaZ1ITI\" height=\"1\" width=\"1\"/>\";}i:5;a:9:{s:5:\"title\";s:44:\"Group Calls for Ronald McDonald\'s Retirement\";s:6:\"author\";s:9:\"sageone73\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/fzaX2QrWeTU/\";s:4:\"guid\";s:91:\"http://technorati.com/lifestyle/family/article/group-calls-for-ronald-mcdonalds-retirement/\";s:11:\"description\";s:204:\"Ronald McDonald is targeted by consumer group to retire due to bad influence over children and their eating habits<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/fzaX2QrWeTU\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Wed, 31 Mar 2010 23:39:49 +0000\";s:8:\"category\";s:70:\"Familyeds-pickfast-foodmcdonaldsronald mcdonaldsan-francisco-chronicle\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:91:\"http://technorati.com/lifestyle/family/article/group-calls-for-ronald-mcdonalds-retirement/\";}s:7:\"summary\";s:204:\"Ronald McDonald is targeted by consumer group to retire due to bad influence over children and their eating habits<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/fzaX2QrWeTU\" height=\"1\" width=\"1\"/>\";}i:6;a:9:{s:5:\"title\";s:22:\"NY Electric with Autos\";s:6:\"author\";s:9:\"sageone73\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/KYxBuR1mw9Y/\";s:4:\"guid\";s:69:\"http://technorati.com/lifestyle/autos/article/ny-electric-with-autos/\";s:11:\"description\";s:213:\"Manufacturers are putting a lot of energy behind EV models in the next couple of years and the NY auto show is electrifying<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/KYxBuR1mw9Y\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Wed, 31 Mar 2010 23:13:14 +0000\";s:8:\"category\";s:89:\"Autoschevychrystlereco-friendly vehicleseds-pickelectric-carsfordmercedesmitsubishinissan\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:69:\"http://technorati.com/lifestyle/autos/article/ny-electric-with-autos/\";}s:7:\"summary\";s:213:\"Manufacturers are putting a lot of energy behind EV models in the next couple of years and the NY auto show is electrifying<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/KYxBuR1mw9Y\" height=\"1\" width=\"1\"/>\";}i:7;a:9:{s:5:\"title\";s:33:\"The Importance of Listening in PR\";s:6:\"author\";s:9:\"sageone73\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/qtbxSz9po3M/\";s:4:\"guid\";s:85:\"http://technorati.com/business/advertising/article/the-importance-of-listening-in-pr/\";s:11:\"description\";s:190:\"Listening is a big part of success in business and should be the basis of any communications program<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/qtbxSz9po3M\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Wed, 31 Mar 2010 22:55:35 +0000\";s:8:\"category\";s:64:\"Advertisingeds-pickfacebooklisteningpublic-relationssocial media\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:85:\"http://technorati.com/business/advertising/article/the-importance-of-listening-in-pr/\";}s:7:\"summary\";s:190:\"Listening is a big part of success in business and should be the basis of any communications program<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/qtbxSz9po3M\" height=\"1\" width=\"1\"/>\";}i:8;a:9:{s:5:\"title\";s:53:\"New Study: Online Shopping and Walk-in Payment Trends\";s:6:\"author\";s:9:\"sageone73\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/eGjR9VJURt4/\";s:4:\"guid\";s:74:\"http://technorati.com/business/article/new-study-online-shopping-and-walk/\";s:11:\"description\";s:225:\"New study shows that ordering online and paying in-store is a popular trend with those that are making a fairly luxurious annual income<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/eGjR9VJURt4\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Wed, 31 Mar 2010 22:29:59 +0000\";s:8:\"category\";s:66:\"Businessconsumer-spendinge-retailerseBillmeeds-pickonline shopping\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:74:\"http://technorati.com/business/article/new-study-online-shopping-and-walk/\";}s:7:\"summary\";s:225:\"New study shows that ordering online and paying in-store is a popular trend with those that are making a fairly luxurious annual income<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/eGjR9VJURt4\" height=\"1\" width=\"1\"/>\";}i:9;a:9:{s:5:\"title\";s:59:\"Rocket Scientists Brought In To Investigate Runaway Toyotas\";s:6:\"author\";s:11:\"ecolsen2003\";s:4:\"link\";s:59:\"http://feeds09.technorati.com/~r/trarticles/~3/S-VOIbc_eTw/\";s:4:\"guid\";s:94:\"http://technorati.com/technology/embedded/article/rocket-scientists-brought-in-to-investigate/\";s:11:\"description\";s:158:\"DOT summons the big boys from NASA and National Academy of Sciences.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/S-VOIbc_eTw\" height=\"1\" width=\"1\"/>\";s:7:\"pubdate\";s:31:\"Wed, 31 Mar 2010 19:22:47 +0000\";s:8:\"category\";s:105:\"EmbeddedDOTelectronic systemsembeddednasaNational Academy of Sciencessudden unintended accelerationtoyota\";s:10:\"feedburner\";a:1:{s:8:\"origlink\";s:94:\"http://technorati.com/technology/embedded/article/rocket-scientists-brought-in-to-investigate/\";}s:7:\"summary\";s:158:\"DOT summons the big boys from NASA and National Academy of Sciences.<img src=\"http://feeds.feedburner.com/~r/trarticles/~4/S-VOIbc_eTw\" height=\"1\" width=\"1\"/>\";}}s:7:\"channel\";a:9:{s:5:\"title\";s:26:\"All articles at Technorati\";s:4:\"link\";s:22:\"http://technorati.com/\";s:11:\"description\";s:29:\"Bloggers write for Technorati\";s:7:\"pubdate\";s:31:\"Thu, 01 Apr 2010 04:45:20 +0000\";s:9:\"copyright\";s:29:\"Copyright 2010 by the authors\";s:9:\"generator\";s:6:\"Scrive\";s:8:\"language\";s:5:\"en-us\";s:4:\"docs\";s:37:\"http://blogs.law.harvard.edu/tech/rss\";s:7:\"tagline\";s:29:\"Bloggers write for Technorati\";}s:9:\"textinput\";a:0:{}s:5:\"image\";a:0:{}s:9:\"feed_type\";s:3:\"RSS\";s:12:\"feed_version\";s:3:\"2.0\";s:5:\"stack\";a:0:{}s:9:\"inchannel\";b:0;s:6:\"initem\";b:0;s:9:\"incontent\";b:0;s:11:\"intextinput\";b:0;s:7:\"inimage\";b:0;s:13:\"current_field\";s:0:\"\";s:17:\"current_namespace\";b:0;s:19:\"_CONTENT_CONSTRUCTS\";a:6:{i:0;s:7:\"content\";i:1;s:7:\"summary\";i:2;s:4:\"info\";i:3;s:5:\"title\";i:4;s:7:\"tagline\";i:5;s:9:\"copyright\";}s:4:\"etag\";s:29:\"PcKIWcMJ2J9QFqjQ4aVba01xph8\r\n\";s:13:\"last_modified\";s:31:\"Thu, 01 Apr 2010 07:15:36 GMT\r\n\";}',20,8,'',1,'no'),(72,0,'rss_17986f152f11df379684c3ebdfeebe29_ts','Y',1,'1270134290',20,8,'',1,'no');
/*!40000 ALTER TABLE `wp_options` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_post2cat`
--

DROP TABLE IF EXISTS `wp_post2cat`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `wp_post2cat` (
  `rel_id` bigint(20) NOT NULL auto_increment,
  `post_id` bigint(20) NOT NULL default '0',
  `category_id` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`rel_id`),
  KEY `post_id` (`post_id`,`category_id`)
) ENGINE=MyISAM AUTO_INCREMENT=209 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `wp_post2cat`
--

LOCK TABLES `wp_post2cat` WRITE;
/*!40000 ALTER TABLE `wp_post2cat` DISABLE KEYS */;
INSERT INTO `wp_post2cat` VALUES (25,19,9),(41,32,22),(43,34,8),(22,16,3),(29,22,8),(27,21,8),(45,36,2),(24,18,1),(44,35,5),(21,15,5),(20,14,5),(46,37,2),(31,23,8),(32,24,8),(36,28,1),(35,27,8),(37,29,5),(39,31,1),(47,38,2),(48,39,2),(50,41,2),(51,42,2),(54,45,1),(57,48,2),(60,50,2),(63,53,2),(71,59,2),(72,60,5),(66,55,2),(68,56,5),(69,57,5),(70,58,2),(81,65,21),(75,63,1),(76,64,8),(84,71,16),(79,67,8),(83,70,15),(90,76,10),(88,74,12),(89,75,8),(91,77,8),(92,78,2),(93,78,1),(94,79,2),(98,83,2),(96,81,2),(97,82,1),(99,84,2),(101,85,2),(102,85,1),(103,86,2),(104,87,2),(105,87,1),(106,88,2),(107,89,9),(108,90,9),(109,91,5),(110,92,9),(111,93,21),(112,94,21),(113,95,9),(114,96,3),(115,97,3),(116,98,3),(117,99,3),(118,100,10),(119,101,9),(120,102,3),(121,103,8),(122,104,3),(123,105,2),(124,106,8),(125,107,2),(128,109,2),(129,110,2),(130,111,2),(134,114,2),(132,112,2),(133,113,2),(136,115,2),(137,116,3),(138,117,5),(139,118,2),(140,118,1),(141,119,3),(142,119,1),(143,120,8),(144,121,2),(145,122,5),(146,123,2),(147,124,2),(148,125,5),(149,126,2),(150,127,2),(151,128,2),(152,129,5),(153,130,2),(156,131,9),(157,132,4),(158,132,10),(159,133,2),(163,136,2),(161,134,2),(162,135,2),(164,137,9),(165,138,9),(166,139,2),(167,140,21),(168,141,5),(169,142,2),(170,143,2),(171,144,1),(175,148,2),(176,149,11),(177,150,2),(178,151,4),(179,151,10),(180,152,9),(181,153,9),(182,154,9),(183,155,9),(184,156,5),(185,157,23),(186,158,23),(187,159,23),(188,160,23),(189,161,23),(190,162,23),(191,163,23),(192,164,23),(193,165,2),(194,166,1),(196,168,1),(197,169,1),(198,170,1),(201,171,2),(202,172,2),(203,173,2),(204,174,2),(205,175,2),(206,176,11),(207,177,2),(208,178,8);
/*!40000 ALTER TABLE `wp_post2cat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_postmeta`
--

DROP TABLE IF EXISTS `wp_postmeta`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) NOT NULL auto_increment,
  `post_id` bigint(20) NOT NULL default '0',
  `meta_key` varchar(255) default NULL,
  `meta_value` text,
  PRIMARY KEY  (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=18 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `wp_postmeta`
--

LOCK TABLES `wp_postmeta` WRITE;
/*!40000 ALTER TABLE `wp_postmeta` DISABLE KEYS */;
INSERT INTO `wp_postmeta` VALUES (6,31,'_wp_page_template','default'),(4,18,'_wp_page_template','default'),(8,45,'_wp_page_template','default'),(9,63,'_wp_page_template','default'),(10,144,'_wp_page_template','default'),(13,166,'_wp_page_template','default'),(15,168,'_wp_page_template','default'),(16,169,'_wp_page_template','default'),(17,170,'_wp_page_template','default');
/*!40000 ALTER TABLE `wp_postmeta` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_posts`
--

DROP TABLE IF EXISTS `wp_posts`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `post_author` int(4) NOT NULL default '0',
  `post_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL default '0000-00-00 00:00:00',
  `post_content` longtext NOT NULL,
  `post_title` text NOT NULL,
  `post_category` int(4) NOT NULL default '0',
  `post_excerpt` text NOT NULL,
  `post_status` enum('publish','draft','private','static','object') NOT NULL default 'publish',
  `comment_status` enum('open','closed','registered_only') NOT NULL default 'open',
  `ping_status` enum('open','closed') NOT NULL default 'open',
  `post_password` varchar(20) NOT NULL default '',
  `post_name` varchar(200) NOT NULL default '',
  `to_ping` text NOT NULL,
  `pinged` text NOT NULL,
  `post_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL default '0000-00-00 00:00:00',
  `post_content_filtered` text NOT NULL,
  `post_parent` int(11) NOT NULL default '0',
  `guid` varchar(255) NOT NULL default '',
  `menu_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `post_name` (`post_name`),
  KEY `post_status` (`post_status`)
) ENGINE=MyISAM AUTO_INCREMENT=179 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `wp_posts`
--

LOCK TABLES `wp_posts` WRITE;
/*!40000 ALTER TABLE `wp_posts` DISABLE KEYS */;
INSERT INTO `wp_posts` VALUES (22,3,'2005-10-21 12:51:02','2005-10-21 17:51:02','For every GOES-R3 AD group leader:\r\nPlease post your quarterly report 2 weeks after the end of the quarter in \"Group Quarterly Reports\" under your group category, such as cloud model or wind ....','Quarterly Report Deadline',0,'','publish','open','closed','','quarterly-report','','','2005-10-21 16:07:27','2005-10-21 21:07:27','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/21/quarterly-report/',0),(23,3,'2005-10-21 13:18:32','2005-10-21 18:18:32','14 Nov., 2005 - Deadline for Draft of Refined ATBDs\' Outline\r\n30 Dec., 2005 - 2005 Version of ATBDs\r\n\r\n2005 ATBDs include Sounding, Wind, and Clouds ATBD','ATBD Deadline',0,'','publish','open','closed','','atbd-deadline','','','2005-10-21 13:18:32','2005-10-21 18:18:32','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/21/atbd-deadline/',0),(19,3,'2005-10-20 15:02:07','2005-10-20 20:02:07','<a href=\'/goes_r/rr/wp-content/GOES_R_2005_Q3AlogDev.doc\' title=\'Q3 2005 AD Progress Report\'>Q3 2005 AD Progress Report</a>','2005 Q3 AD Progress Report',0,'','publish','open','closed','','q3-2005-ad-progress-report','','','2006-06-07 14:12:34','2006-06-07 19:12:34','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=19',0),(34,3,'2005-10-27 14:56:44','2005-10-27 19:56:44','When: <strong>9:30 am 7 Nov. (Monday)</strong>\r\nWhere: Room 351\r\nWho: People who is interested in Cloud Modeling','Cloud Group Meeting',0,'','publish','open','closed','','cloud-group-meeting','','','2005-10-27 14:56:44','2005-10-27 19:56:44','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/27/cloud-group-meeting/',0),(35,3,'2005-10-27 15:01:50','2005-10-27 20:01:50','Subject: Minutes of GOES-R sub-group meeting on cloudy-sky forward modeling\r\n\r\nDate: 24 October 2005\r\n\r\nPreparer: TomG\r\n\r\n\r\nDaveTo and LeslieM summarized where they are in terms of gas absorption modeling and the impact of its uncertainties on computing clear sky brightness temperatures. Several improvements have been made to PLOD since 2002. The version of PLOD based on the latest coefficients is performing very well, with RMS errors of less than about 0.2 K across most of the spectrum. The difficult problem of accounting for the reflectance of high spectral resolution downwelling sky radiation at the surface for computing brightness temperatures was also discussed. Much progress has been made but more work is needed, especially related to the convolution problem.\r\n\r\nTomG discussed the latest news on the CRTM. PaulvD concurred with our idea of using the CRTM as a framework for comparing various RT models. A beta version of the code will be available soon.  \r\n\r\nSteveA would like to provide his own model in the â€œbake-offâ€ between various fast RT models. \r\n\r\n\r\nAction items:\r\n\r\nÂ·	Continue modifying 2-layer model code (TomG)','Cloud Group Meeting Minutes - 24 Oct. 2005',0,'','publish','open','closed','','cloud-group-meeting-minutes-24-oct-2005','','','2005-10-27 15:01:50','2005-10-27 20:01:50','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/27/cloud-group-meeting-minutes-24-oct-2005/',0),(16,18,'2005-10-20 14:18:17','2005-10-20 19:18:17','Statement of Work:\r\nIn charge of producing the state-of-the-art NWP model atmosphere suitable for simulating GOES-R sensor suites measurements, such as HES, ABI, and others.\r\nSpecifically, the generation of high temporal and spatial cloud resolved large scale thermal dynamic fields which can be interfaced with GIFTS, AIRS, CrIS, IASI, HES, ABI, VIIRS fast forward models to simulate top of atmosphere radiances under both clear and cloudy conditions.\r\nNear term deliverables:\r\n1.	24-hour GIFTS like data set in semi-full disk (8-km resolution), CONUS (continental US, 4km?), and regional (1km?) at temporal resolution of 1 hour, half hour, and few minutes..\r\n2.	Continue to improve WRF model capability in cloud parameterization schemes and data assimilation.\r\n3.	Support other sister projects such as GOES-R AWG and MURI as needed.\r\n','SOW - Jason Otkin (Q4 2005/50%)',0,'','publish','open','closed','','sow-jason-otkin-q4-200550','','','2005-11-09 12:35:28','2005-11-09 17:35:28','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=16',0),(21,3,'2005-10-21 12:46:19','2005-10-21 17:46:19','For every person who is working on GOES-R3 AD projects (#5111-8):\r\n\r\nPlease post your monthly progress report in \"Progress Reports\" categories at the same time of your SSEC time sheet is due.','Monthly Progress Report Deadline',0,'','publish','open','closed','','monthly-progress-report-deadline','','','2005-10-21 16:07:43','2005-10-21 21:07:43','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/21/monthly-progress-report-deadline/',0),(15,3,'2005-10-20 14:11:51','2005-10-20 19:11:51','Subject: Minutes of 3rd GOES-R3 meeting (Algorithm Development)\r\n\r\nDate: Oct 10, 2005\r\n\r\nPreparer: ChrisV\r\n\r\nA)	Update of outstanding tasks and action items from 1st and 2nd meeting minutes.  \r\n\r\nSubject: Tasks of 1st GOES-R3 Joint (algorithm & data processing) Internal meeting. Statements in red are items with deadlines or in need of immediate attention.\r\n\r\nDate: 4 May 2005\r\n\r\n1)	Create a 24-hour simulation dataset based on the GIFTS sensor in order to evaluate needs of data processing, storage, and management of the high rate data streams anticipated from the GOES-R sensor suite.\r\n2)	In this FY, we need to update existing ATBDs, and create first drafts of others as we proposed. We should also use these revised ATBDs to guide our algorithm development and system implementation.\r\n3)	Set up GOES-R web site â€“ Steve will ask Leanne for help\r\n\r\n\r\nSubject: Tasks of 2nd GOES-R3 algorithm development meeting\r\n\r\nDate: 12 Sept 2005\r\n\r\n1)	Dealing with surface effects. BobK and SuzanneS indicated progress was being made, and more will be made in the coming weeks. \r\n2)	Dealing with clouds, retrieval algorithm, and forward model. Input provided by JunL and Allen:\r\n1)	Develop a fast and accurate Jacobian model. Jacobian is needed along with the fast radiative transfer model.\r\n2)	Continue assessment of emissivity impact on sounding \r\n3)	Continue to examine the angle effect on MODIS/AIRS cloud-clearing. \r\n4)	Study the synergy of IR and MW data (AMSU and AIRS)\r\n5)	In regard to cloud property modeling, cloud radiation, and clear+cloudy RT, a specific model should be chosen soon. The \"bake-off\" of models that was suggested is needed.  This should be done in an efficient and objective way.\r\n3)	SteveA stressed the need to get the ATBDs written/updated and submitted, and make sure the quarterly reports are submitted to TomA on time. The group leads asked for additional guidelines on what makes a â€œgoodâ€ ATBD. A suggestion was made to have an independent reader (Leanne?) review the ATBD documents to assess the quality.  A goal is to have the Version1.0 ATBDs drafted by the end of this calender year.\r\n4)	Allen introduced a new GOES-R3 management and progress reporting direction, focusing on closer communication, group meetings, and monthly/quarterly reports. Allen will send out (or put on the new GOES-R web page) his priority list for tasks, expected accomplishment dates, etc. The first monthly progress reports (All) will be due at the end of October. The next GOES-R Quarterly Report (Group Leads) is due in October (July/Aug/Sept reporting period).\r\n5)	The FY06 GOES-R3 proposal needs to be finalized in October. PIâ€™s are getting guidance and budget updates from TomA and SteveA.\r\n\r\n\r\nB)	Minutes from the 3rd GOES-R3 Algorithm Development Meeting\r\n\r\n1)	The meeting opened with a summary from Allen on where we are at, and a review of the last meetingâ€™s minutes. See above for outstanding or ongoing tasks and expected deliverables.\r\n2)	The next segment of the meeting hosted briefings from everyone. Highlights:\r\n\r\nA)	Good progress in dealing with surface effects. Eva reported the surface reflection components are now being included in the r/t modeling. In the next 3 months the baseline emissivity by ecosystem will be improved by \r\nadding more inflection points, and the global gridded emissivity will be expanded by applying multiple years of MODIS (MOD11) observed land surface emissivities. \r\nB)	A â€œbake offâ€ of prospective models will be one topic of a special Cloud subgroup meeting that will convene soon. TomG will take the lead on organizing this.\r\nC)	SteveA will provide feedback and guidance to the primary ATBD drafters for input to the versions due Nov. 15.\r\nD)	Kudos to ErikO and JasonO for providing outstanding monthly reports for September!\r\nE)	JasonO: The WRF model was used to generate a simulated atmospheric profile dataset for a case study referred to as the â€œFULLDISKâ€ simulation.  This simulation contains a 1580 x 1830 grid point domain with 8-km horizontal grid spacing that nearly covers the entire geographical region to be observed by GOES-R.  The domain extends from the southern tip of South America northward into southern Canada with an east-west distance of ~110Âº degrees longitude.  An hourly dataset was generated for a 6-hour period during this simulation.  It is anticipated that this will be lengthened to 24-hours in the next month or two.\r\nF)	ErikO: GIFTS fast model improvements include: Debugged the 2-layer cloud model for 64-bit processors, added emissivity tables for land cases, and added 2-angle quadrature of downwelling clear sky radiances.\r\nG)	RE: Cloud Model Comparisons, Tom Greenwald, Leslie Moy, Dave Turner, Chris O\'Dell: 1. We have chosen a test Profile from the WRF model runs. (In the end we hope to use about 20 profiles.) 2. We have calculated its corresponding TOA radiances using Lblrtm/Disort to use as our \"truth\" 3.We are in the process of comparing the \"truths\" to Fast Cloud Model (SOI, Yang\'s 2layerCld model).\r\nH)	Dave Turner is working with Chris O\'Dell to implement SOI into LBLDIS as an option.  This will facilitate intercomparisons with LBLDIS and SOI. He also plans to work with Tiziano to implement his scattering RT code into LBLDIS as a third option in the coming weeks.\r\nI)	TizianoM: Completed adaptation of the ADGB\'s codes sequence (main \'hartcode\' and \'rtx\') to the SSEC computer system. Codes have been recompiled and in part rewritten. Usage of LblRtm and LblDisort: Comparisons between these two codes in clear sky; comparison in clear and cloudy conditions between LbLdis and rtx.\"\r\nJ)	XuanjiW is working on the validation of 2 layer hyperspectral cloud fast forward model (LY2G) with various atmospheric conditions and cloud system based on the comparisons with accurate RT model, LBLDIS.\r\nK)	HongZ: The code for running global AIRS cloud clearing is set, and one day of global AIRS cloud clearing has been successfully tested.  The cloud clearing performance analysis and global statistics of characterization has been working.\r\nL)	Jinlong Li checked how much water vapor information we can get from above opaque clouds if we know the exact cloud top height, and ran the AIRS model experiments with several raised surface pressure as cloud top. Based on the calculated changes of water vapor weighting functions, it was found that the water vapor information above the clouds is very limited in thick cloudy skies, even if you know the cloud-top information. The higher the clouds are, the less water information the IR radiance will provide. Therefore, it appears we can only retrieve soundings over thin cloudy skies. \r\nM)	From Jeff Key: â€œSorry I missed the meeting.  It was a federal holiday so I was at home. I\'d like to make a suggestion: Don\'t hesitate to involve the NOAA people at CIMSS in your algorithm development efforts, if and where appropriate.  After all, we\'re free, and I would think that having one or more NOAA people on a NOAA-sponsored project would look good to those providing the funding.  But most importantly, at least a couple people in our group have significant expertise.  We don\'t all have something to contribute, but some do.  Don\'t think of us any differently than CIMSS scientists!â€   Allen, Steve and Tom fully agreed.\r\n\r\n3) The next GOES-R3 algorithm development monthly meeting is scheduled for 14 Nov.\r\n','Meeting Minutes for Oct. 2005',0,'','publish','open','closed','','meeting-minutes-for-oct-2005','','','2006-06-07 14:13:06','2006-06-07 19:13:06','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/20/meeting-minutes-for-oct-2005/',0),(18,3,'2005-10-20 14:39:32','2005-10-20 19:39:32','<ul>\r\n	<li><strong><em>Sounding, Clouds, Wind ATBD</em></strong>\r\nDue Date â€“ Dec. 2005 (1st Draft 15th of November)</li>\r\n\r\n	<li><strong><em>Eco-based land surface emissivity modeling</em></strong>\r\nVersion ? â€“ Distributed 15 Sep.</li>\r\n	<li> <strong><em>Documented Cloud Fast Forward Model for simulation and retrieval</em></strong>\r\nDue Date â€“ ASAP (few weeks before the release of 24-hour simulated data)</li>\r\n\r\n	<li><strong><em>24-hour simulated hyperspectral dataset</em></strong>\r\nDue Date â€“ ASAP (no later than the end of 2005)</li>\r\n\r\n	<li><strong><em>Validation and documentation of Cloudy Forward Model</em></strong>\r\nDue Date â€“ ASAP (no later than the end of November)</li>\r\n\r\n	<li><strong><em>Fortran Version of Clear Forward Model Jacobian/Tangent linear/Adjoint</em></strong>\r\nDue Date â€“ Mid-October</li>\r\n\r\n	<li><em><strong>GOES-R monthly report</strong></em>\r\nLast Day of the month (For each person working on GOES-R3 tasks)</li>\r\n \r\n	<li><strong><em>GOES-R Quarterly report</em></strong> \r\n2 weeks after the end of each quarter (for each group leaders)</li>\r\n</ul>\r\n\r\n\r\n','Task Priority ',0,'','static','open','closed','','task-priority','','','2006-06-06 15:27:47','2006-06-06 20:27:47','',144,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/task-priority/',0),(14,3,'2005-09-20 14:07:47','2005-09-20 19:07:47','Subject: Minutes of 2nd GOES-R3 meeting (Algorithm Development)\r\n\r\nDate: Sept 12, 2005\r\n\r\nPreparer: ChrisV\r\n\r\nA)  Update of Task list and action items from 1st meeting minutes. Green means completed. Orange means being completed. Red means still outstanding.\r\n\r\nSubject: Minutes of 1st UW/FSU GOES-R3 Joint (algorithm & data processing) Internal meeting\r\n\r\nDate: 4 May 2005\r\n\r\n1)	Action item: Does version6 of the GOES-R plan Paul M. presented adequately reflect our CIMSS tasks? Cross check with our latest proposal. \r\n2)	Need CIMSS milestones out to FY12 (Paul Mâ€™s request) \r\n3)	Create a 24-hour simulation dataset based on the GIFTS sensor in order to evaluate needs of data processing, storage, and management of the high rate data streams anticipated from the GOES-R sensor suite.\r\n4)	In this FY, we need to update existing ATBDs, and create first drafts of others as we proposed. We should also use these revised ATBDs to guide our algorithm development and system implementation.\r\n5)	Set up GOES-R web site â€“ Steve will ask Leanne for help\r\n6)	Create a FTP site for Prof. Zou to access our GOES-R3 related information she canâ€™t get into our internal web site.\r\n \r\nB) Minutes of 2nd meeting, including tasks/action items.\r\n\r\n1)	Paul Menzel opened the meeting by offering his perspectives on the newly formed Algorithm Working Group (AWG). The AWG sits under the GOES Program Manager and will help develop and implement prototype algorithms designed under the GOES-R3 research.\r\n2)	The next segment of the meeting hosted briefings on selected topics:\r\nA.	Dealing with surface effects. BobK and SuzanneS indicated progress was being made, and more will be made in the coming weeks. AllenH emphasized the importance of this work on downstream components such as the retrieval algorithm.\r\nB.	Dealing with clouds, retrieval algorithm, and forward model. Input provided by JunL and Allen:\r\n1)	Fast and accurate Jacobian calculation revisited.  Since the AIRS SARTA model does not provide Jacobian model, we have to use the approximation form (see Li et al. 2000 â€“ JAM for details) in algorithm development with AIRS data.  We find that the approximation algorithm has the similar Jacobian peak of the accurate but slow method (e.g., through numerical perturbation), however, the magnitude of approximation form is quite different from the accurate one.  This might have significant impact on physical retrieval results.  Jacobian is needed along with the fast radiative transfer model.\r\n2)	Emissivity impact on sounding retrieval tested.  We find that using 15 emissivities in training data is not enough.  High spectral resolution emissivity is needed in training for regression.  The emissivity impact on water vapor retrieval is significant, especially over desert region.\r\n3)	Angle effect on MODIS/AIRS cloud-clearing quantified.  In MODIS/AIRS cloud-clearing algorithm (Li et al. 2005), a pair of adjacent AIRS footprint is needed for cloud-cleared radiance spectrum.  Angle effect needs to be considered if the pair of footprints cross track.  We find that in limb side in clear sky, the brightness temperature difference between adjacent footprints can be as large as 0.5 K due to the angle effect.  This angle effect should be removed before perform the cloud-clearing.\r\n4)	Synergy of IR and MW data studied.  AMSU and AIRS data from Aqua are used for this study.  Results from one granule AIRS over ocean show that soundings from the combination of IR clear radiances and AMSU radiances are better than that from either AIRS clear radiances alone or AMSU radiances alone.  We also tested soundings from the synergy of AIRS cloud-cleared (using MODIS data, see Li et al. 2005 â€“ IEEE TGARS for details) radiances and AMSU radiances, soundings are improved with help of AMSU data over that from AIRS cloud-cleared radiances alone.\r\n                  5)  From Dave Tobin: Regarding overall structure and management, there are multiple, and somewhat parallel, efforts relating to cloud property modeling, cloud radiation, and clear+cloudy RT. Researching different approaches is a good idea, but since the model forms the foundation and framework of alot of follow-on work  (retrievals, simulations, etc.), the sooner a specific model is picked, the better. For example, the development of a PLOD + cloudy RT algorithm, including Jacobians and adjoint, has been supported under MURI, is engrained in many CIMSS projects, and is also now part of GOES-R.  e.g. Jun\'s  retrievals and the GIFTS simulations use such a model.  Note that this model is not part of the CRTM, currently.  It was suggested at the meeting that we should go the SOI model.  OSS is another option. The \"bake-off\" of models that was suggested is needed.  This should be done in an efficient and objective way.\r\n\r\nC.	NWP model simulations. JasonO recently completed a massive WRF model simulation for Bob K. in support of the GOES-R3 project.  The simulation contained a single domain consisting of 1580 x 1830 grid points with 8-km horizontal grid spacing.  The simulation covered a geographical area extending from the southern tip of South America northward to southern Canada and from 130 W to 20 W longitude.  This simulation utilized about 60% of the memory on the Altix so we should be able to perform an even larger simulation.  ErikO is currently generating (or should be in the next couple weeks) TOA radiances for this simulation. Contact ErikO if you would like the cvs location of the latest 2 layer fast model that works on both the 32-bit intel and 64-bit altix platforms. Erik is currently adding the emissivity tables from Eva and Suzanne for the land pixels. Latest model will be used to produce TOA radiances.  Model instrument data for 6 hour and 24 hour datasets are produced using these radiances. Steve A. noted that we need to check TOA radiances before moving too far along in the process.\r\n\r\n3)	TomA provided a brief progress report on the FY2005 funding (it is finally here!) and research accomplishments. SteveA followed this up with his take on 2006 milestones and tasks. Steve stressed the need to make progress now, get the ATBDs written/updated and submitted, and make sure the quarterly reports are submitted to TomA on time. The group leads asked for additional guidelines on what makes a â€œgoodâ€ ATBD. A suggestion was made to have an independent reader (Leanne?) review the ATBD documents to assess the quality.  A goal is to have the Version1.0 ATBDs drafted by the end of this calender year.\r\n4)	Allen introduced a new GOES-R3 management and progress reporting direction, focusing on closer communication, group meetings, and monthly/quarterly reports. It is important that everyone involved in charging labor to GOES-R funding participate in this progress reporting, and also in identifying the key tasks with milestones, and any show-stoppers. Everyone is asked to provide AllenH with a 3-month outlook of their expected activities and estimated labor time by 1 October at the latest. Allen will then send out (or put on the new GOES-R web page) his priority list for tasks, expected accomplishment dates, etc. The first monthly progress reports (All) will be due at the end of October. The next GOES-R Quarterly Report (Group Leads) is due in October (July/Aug/Sept reporting period).\r\n5)	The FY06 GOES-R3 proposal needs to be finalized in October. PIâ€™s are waiting on guidance from PaulM and TomA.\r\n6)	The next GOES-R3 Algorithm Development monthly meeting will be held in 10 Oct. Sub-groups are encouraged to meet sooner.\r\n','Meeting Minutes for Sep. 2005',0,'','publish','open','closed','','meeting-minutes-for-sep-2005','','','2006-06-07 14:13:18','2006-06-07 19:13:18','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/20/meeting-minutes-for-sep-2005/',0),(24,3,'2005-10-21 13:26:27','2005-10-21 18:26:27','Who: All AD staff\r\nWhere: Room 351\r\nWhen: 1 pm 14 Nov. (Monday)\r\n','November 2005 Monthly Meeting',0,'','publish','open','closed','','november-2005-monthly-meeting-2','','','2005-10-21 13:28:31','2005-10-21 18:28:31','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/21/november-2005-monthly-meeting-2/',0),(28,3,'2005-10-21 14:13:46','2005-10-21 19:13:46','Subject: Minutes of GOES-R sub-group meeting on cloudy-sky forward modeling\r\n\r\nDate: 17 October 2005\r\n\r\nPreparer: TomG\r\n\r\n\r\nTo start off the meeting, TomG provided overview of fast forward modeling effort and described the role of the SOI model and other fast models.\r\n\r\nBobK suggested we use the CRTM framework as a testbed for our comparison study of different fast models with the ultimate goal of having model code written as modules so they can be easily inserted into and removed from the CRTM. Consequently when the JCSDA makes changes to the CRTM we will be easily prepared to make the same changes.\r\n\r\nSteveA recommended TomG contact Paul Van Delst regarding CRTM\r\n\r\nSteveA recommended a first step in the comparison study: Let fast models use LBL gas optical depths as input so only the multiple scattering errors can be evaluated. Also suggested we test a simplified version of the 2-layer model. It would also be good to review the magnitude of the clear sky errors, so a request was made to DaveTo to show these results at the next meeting.\r\n\r\nAnother model suggested for the comparison study was RTTOVS\r\n\r\nBobK also mentioned we should use in situ measured cloud profiles for selected case studies in the comparison study. AllanH stressed it was important to utilize both WRF simulations and in situ measured profiles.\r\n\r\n<strong>A<em>ction items:\r\n\r\nÂ·	Contact Paul Van Delst (TomG)\r\nÂ·	Obtain copy of 1-layer model (TomG)\r\nÂ·	Prepare summary of fast model clear sky errors to show at next meeting (DaveTo/Moy)\r\nÂ·	Begin work on simplifying 2-layer/1-layer model code (TomG)</em></strong>','Cloud Group ',0,'','draft','open','closed','','','','','2005-10-21 14:13:46','2005-10-21 19:13:46','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=28',0),(27,3,'2005-10-21 14:09:37','2005-10-21 19:09:37','When: 9:30 am 24 Oct. (Monday)\r\nWhere: Room 351\r\nWho: People who is interested in cloud modeling','Cloud Group Meeting',0,'','publish','open','closed','','cloud-group-meeting-2','','','2005-10-21 14:09:37','2005-10-21 19:09:37','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/21/cloud-group-meeting-2/',0),(29,3,'2005-10-21 14:14:49','2005-10-21 19:14:49','Subject: Minutes of GOES-R sub-group meeting on cloudy-sky forward modeling\r\n\r\nDate: 17 October 2005\r\n\r\nPreparer: TomG\r\n\r\n\r\nTo start off the meeting, TomG provided overview of fast forward modeling effort and described the role of the SOI model and other fast models.\r\n\r\nBobK suggested we use the CRTM framework as a testbed for our comparison study of different fast models with the ultimate goal of having model code written as modules so they can be easily inserted into and removed from the CRTM. Consequently when the JCSDA makes changes to the CRTM we will be easily prepared to make the same changes.\r\n\r\nSteveA recommended TomG contact Paul Van Delst regarding CRTM\r\n\r\nSteveA recommended a first step in the comparison study: Let fast models use LBL gas optical depths as input so only the multiple scattering errors can be evaluated. Also suggested we test a simplified version of the 2-layer model. It would also be good to review the magnitude of the clear sky errors, so a request was made to DaveTo to show these results at the next meeting.\r\n\r\nAnother model suggested for the comparison study was RTTOVS\r\n\r\nBobK also mentioned we should use in situ measured cloud profiles for selected case studies in the comparison study. AllanH stressed it was important to utilize both WRF simulations and in situ measured profiles.\r\n\r\n<strong>A<em>ction items:\r\n\r\nÂ·	Contact Paul Van Delst (TomG)\r\nÂ·	Obtain copy of 1-layer model (TomG)\r\nÂ·	Prepare summary of fast model clear sky errors to show at next meeting (DaveTo/Moy)\r\nÂ·	Begin work on simplifying 2-layer/1-layer model code (TomG)</em></strong>','Cloud Group Meeting Minutes - 17 Oct. 2005',0,'','publish','open','closed','','cloud-group-meeting-17-oct-2005','','','2005-10-21 14:15:41','2005-10-21 19:15:41','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/21/cloud-group-meeting-17-oct-2005/',0),(31,3,'2005-10-21 14:32:04','2005-10-21 19:32:04','<h3>GOES-R Risk Reduction Project Objective</h3>\r\n<p style=\"margin: 0px; padding:  0px;\"><a href=\"/goes_r/rr/wp-content/overview-diagram_large.jpg\"><img src=\"/goes_r/rr/wp-content/overview-diagram_small.jpg\" align=\"right\" style=\"margin: 0px; margin-left: 4px; float: right; border: none;\" border=\"0\" /></a>In preparation for NOAA/NESDIS GOES-R mission, CIMSS is researching software, tools and knowledge using available observations and simulations to ensure optimal use of these future measurements.  These activities will establish a stable set of products and retrieval approaches that can readily be applied to HES and ABI related studies. The CIMSS GOES-R Risk Reduction activities fall into five broad areas: </p>\r\n<ul>\r\n	<li><a href=\"/goes_r/rr/overview/#ad\">Algorithm Development</a></li>\r\n	<li><a href=\"/goes_r/rr/overview/#processing\">Data Processing and Archive System</a></li>\r\n	<li><a href=\"/goes_r/rr/overview/#assimiliation\">Preparing for Data Assimilation</a></li>\r\n	<li><a href=\"/goes_r/rr/overview/#nowcasting\">Nowcasting Research</a></li>\r\n	<li><a href=\"/goes_r/rr/overview/#epo\">Education and Public Outreach</a></li>\r\n</ul>\r\n\r\n<!-- OVERVIEW_END -->\r\n\r\n<h3><a name=\"ad\"></a>GOES-R3 Algorithm Development (AD) Element</h3>\r\nAD element of CIMSS GOES-R3 efforts are further classified into the following tasks:\r\n<ul>\r\n	<li>Radiances</li>\r\n	<li>Atmospheric Sounding</li>\r\n	<li>Winds</li>\r\n	<li>Clouds</li>\r\n	<li>Land Surface</li>\r\n	<li>Atmospheric Composition</li>\r\n	<li>Aerosols</li>\r\n	<li>Tropical Cyclone Research and Application</li>\r\n	<li>Biomass Burning and Aerosols</li>\r\n</ul>\r\n\r\n<h4>Algorithm Development (AD) Personnel and Management</h4>\r\n<p>GOES-R3 AD element is managed by program managers Chris Velden & Allen Huang. Many scientists and software engineers are working together in a seamless way to effectively communicate and coordinate tasks required to achieve its goal. Figure above shows the task structure of CIMSS GOES-R3 AD element.</p>\r\n<p>Within GOES-R3 AD team ten technical groups are formed to take on the tasks required to conduct the end-to-end algorithm development, processing demonstration and verification. Algorithm Theoretical Based Document (ATBD) for sounding, clouds, wind, and aerosol/dust are also the significant efforts of AD team. These groups lead by group leaders to provide direction and coordination to their respected members. Group leaders will also provide quarterly progress reports. These groups are</p>\r\n\r\n<strong>Forward Model</strong> â€“ Tom Greenwald & Dave Tobin (Group Leaders)\r\n<ul>\r\n	<li>PLOD with Cloud Parameterization â€“ Xuanji W.\r\n        <ul>\r\n	<li>Model Development â€“ Xuanji W., Tiziano M., Tom G.</li>\r\n	<li>Model Operator (Tangent Linear; Jocobian; Adjoint) â€“ Leslie M. & Tom G.</li>\r\n	<li>Model Documentation & Interface â€“ Xuanji W., Leslie M.</li></ul></li>\r\n\r\n	<li>Successive Order of Iteration (SOI) â€“ Tom. G.\r\n          <ul>\r\n	    <li>Model Development â€“ Tom G. & Tiziano M.</li>\r\n  	    <li>Model Documentation & Interface â€“ Tom G.</li></ul></li>\r\n	\r\n       <li>Model Performance Assessment/Validation/ â€“ Dave Tobin; Dave Turner; Tom G.; T.M.; X. W.\r\n         <ul>\r\n	    <li>Accuracy, Speed, Documentationâ€¦</li>\r\n    	    <li>Clear</li>\r\n  	    <li>Clear & Cloudy</li>\r\n	    <li>Other external Models (SARTA, RT-IASI, PCRTM, KCARTA, â€¦)</li></ul></li>\r\n</ul>\r\n\r\n\r\n<strong>Dataset/Simulation</strong>\r\n<ul>\r\n<li>WRF/NWP Modeling â€“ Jason O.</li>\r\n<li>WRF Modeling Documentation & Interface â€“ Jason O.</li>\r\n<li>Top of Atmosphere Radiances â€“ Erik O., Leslie M.,  & Xuanji W.</li>\r\n<li>Simulation Documentation & Interface â€“ Erik O., Leslie M.,  & Xuanji W.</li>\r\n	<li>Simulation Database Management â€“ Erik O.</li>\r\n</ul>\r\n\r\n<strong>Sounding  - Jun Li (Group Leader)</strong>\r\n<ul>\r\n<li>Measurements Noise Characterization (1) â€“ Allen H.</li>\r\n<li>Cloud Detection (2) â€“ Allen H.; Jun L. & Bill S.</li>\r\n<li>Cloud Clearing (3) â€“ Hong Z. & Jun L.</li>\r\n<li>Clear Regression Retrieval Implementation/Testing (4) â€“ Elisabeth W.</li>\r\n<li>Clear physical Retrieval Implementation/Testing (5) â€“ Xuebao W. & Elisabeth W.</li>\r\n<li>Cloud-cleared Regression Retrieval Implementation/Testing (6) â€“ E.W. & Jun L.</li>\r\n<li>Cloud-cleared Physical Retrieval Implementation/Testing (7) â€“ Xuebao W. & E. W.</li>\r\n<li>Cloudy Regression Retrieval Implementation/Testing (8) â€“ Bill S. & Jun L.</li>\r\n<li>ATBD â€“ Overall (Bill S. & Allen H.)\r\n<ul>\r\n<li>1 to 3 â€“ Allen H.</li>\r\n<li>4 to 7 â€“ Jun L. & Elisabeth W.</li>\r\n<li>8 â€“ Bill S. & Jun L.</li></ul>\r\nSupporting Scientists â€“Jinlong L.; Pradeep Thapliyal</li>\r\n</ul>\r\n\r\n<strong>Cloud Retrieval </strong>\r\n<ul>\r\n	<li>Cloud Property Retrieval â€“ Jun L., Andy H., Steve A.</li>\r\n	<li>Cloudy Training Database â€“ Susanne S.; Eva B., Bill S.</li>\r\n	<li>ATBD â€“ Steve A., Jun L, Andy H.</li>\r\n</ul>\r\n\r\n\r\n\r\n<strong>Aerosol/Dust Retrieval </strong>\r\n<ul>\r\n	<li>Aerosol/dust Property Retrieval â€“ Steve A.; Jun L.<br />\r\nATBD â€“ Steve A.; Jun L.</li>\r\n</ul>\r\n\r\n\r\n\r\n<strong>Wind â€“ Chris V. (Group Leader)</strong>\r\n<ul>\r\n	<li>Algorithm Refinement (1) â€“ Dave S.</li>\r\n	<li>Algorithm Implementation and Testing (2) â€“ Dave S. & Steve W.</li>\r\n	<li>Radiance Wind Demonstration (3) â€“ Dave S. & Steve W.</li>\r\n	<li>Retrieval Wind Demonstration (4) â€“ Dave S. & Steve W.</li>\r\n	<li>ATBD â€“ Overall (Chris V.)\r\n<ul>\r\n	<li>1 â€“ D.S.</li>\r\n	<li>2 â€“ D.S. & S.W.</li>\r\n	<li>3-4 â€“ C.V., & D.</li>\r\n</ul></li>\r\n</ul>\r\n<h3><a name=\"processing\"></a>Data Processing and Archive System</h3>\r\n<p>Content needed!</p> \r\n\r\n<h3><a name=\"assimilation\"></a>Preparing for Data Assimilation</h3>\r\n<p>Content needed!</p>\r\n\r\n<h3><a name=\"nowcasting\"></a>Nowcasting Research</h3>\r\n<p>Content needed!</p>\r\n\r\n<h3><a name=\"epo\"></a>Education and Public Outreach</h3>\r\n<p>Content needed!</p>','Overview',0,'','static','open','closed','','overview','','','2007-01-05 16:47:11','2007-01-05 21:47:11','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/goes-r3-project-objective/',0),(32,3,'2005-10-24 09:06:13','2005-10-24 14:06:13','<a href=\'/goes_r/rr/wp-content/GOESRcloudmodeling.ppt\' title=\'GOES-R Fast Forward Model\'>GOES-R Fast Forward Model</a>','GOES-R Fast Forward Model',0,'','publish','open','closed','','goes-r-fast-forward-model','','','2006-06-07 14:12:25','2006-06-07 19:12:25','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/24/goes-r-fast-forward-model/',0),(36,10,'2005-09-30 10:06:17','2005-09-30 15:06:17','GOES-R Project Monthly Report for September 2005\r\n\r\nTom Greenwald\r\n\r\n\r\nI coded the tangent linear for the radiative transfer part of the 2-layer fast model. It has yet to be tested. Since it was decided that a comparison study needed to be done first between the 2-layer model and the SOI model, my attention shifted to finding suitable cloudy cases simulated by WRF to use as test profiles. We (Leslie Moy, Erik Olson and I) examined several GIFTS cube files and identified a few good cases. I wrote a program to extract the profile information from the netcdf file. \r\nAlso, Dave Turner and I discussed the possibility of integrating the SOI model into LBLDIS. \r\n','Tom Greenwald Sep/05 Monthly Report',0,'','publish','open','closed','','tom-greenwald-sep05-monthly-report','','','2005-11-09 15:55:38','2005-11-09 20:55:38','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/28/tom-greenwald-sep05-monthly-report/',0),(37,18,'2005-09-30 10:09:24','2005-09-30 15:09:24','Used the WRF model to generate a simulated atmospheric profile dataset for a case study referred to as the â€œFULLDISKâ€ simulation.  This simulation contains a 1580 x 1830 grid point domain with 8-km horizontal grid spacing that nearly covers the entire geographical region to be observed by GOES-R.  The domain extends from the southern tip of South America northward into southern Canada with an east-west distance of ~110Âº degrees longitude.  An hourly dataset was generated for a 6-hour period during this simulation.  It is anticipated that this will be lengthened to 24-hours in the next month or two.\r\n\r\nAttended the WRF-NMM tutorial in Boulder, CO.  The WRF-NMM is the NCEP version of the WRF model.  Overall, it has some slight advantages compared to the WRF-ARW core (the NCAR version of WRF), but these advantages are outweighed at this time by the lack of sophisticated parameterization schemes.  More importantly for our future work, WRF-NMM currently does not contain a data assimilation module.  There was talk at the tutorial about releasing a data assimilation package sometime during the next year or two.\r\n\r\nBegan writing a journal article that documents the numerical modeling work that I perform in support of forward model and retrieval algorithm development.  Since this is a novel use of numerical models and in order to get the maximum exposure for our work, I plan to submit this to BAMS in the next month or so.\r\n','Jason Otkin Sep/05 Monthly Report',0,'','publish','open','closed','','jason-otkin-sep05-monthly-report','','','2005-11-09 15:55:18','2005-11-09 20:55:18','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/28/jason-otkin-sep05-monthly-report/',0),(38,7,'2005-09-30 10:10:28','2005-09-30 15:10:28','Two types of global gridded emissivity dataset were created for Fortran users. a wavelength version for users who work with broad band instruments like MODIS, and in this month the wave number version for the users of high spectral resolution instruments like AIRS. In this month the new wave number type of database (version 1) were also beta released to CIMSS and the NOAA/NESDIS Joint Center (JCDA) and were also placed among with the wavelength version on the permanent place on the Internet:\r\n\r\nhttp://thorpex-data.ssec.wisc.edu/UWSSEC/GLOBAL_EMIS/\r\nor can be direct accessed from barrage: /mnt/chasm/UWSSEC/GLOBAL_EMIS\r\n\r\nThe global gridded emissivity was applied to the SeeBor v3 training dataset and validated with the MODIS MOD07 total precipitable water product using the new gridded emissivity. Improvement was seen over the ecosystem based emissivity used formerly. \r\n\r\nWe got feedbacks regarding the emissivity dataset from Mike Pavolonis who are using this dataset for MODIS cloud mask and from Erik Olson due to the Fortran codes.\r\n','Eva Borbas Sep/05 Monthly Report',0,'','publish','open','closed','','eva-borbas-sep05-monthly-report','','','2005-11-09 15:54:24','2005-11-09 20:54:24','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/28/eva-borbas-sep05-monthly-report/',0),(39,17,'2005-09-30 10:12:57','2005-09-30 15:12:57','Main efforts during the month of September relate to adding various improvements to the GIFTS fast model. Updates on the improvements are:\r\n\r\n1) Debug 2 layer cloud model for 64-bit processors.\r\nThe two layer cloud model runs on the 64-bit altix, but it produces inconsistent results. It is likely due to the changes in the regression coefficients or improper variable declarations within the model.\r\n\r\n2) Add Suzanne and Evaâ€™s emissivity tables for land cases.\r\nThe first implementation of the new emissivity tables increased the processing time from about one second per profile to 122 seconds per profile. To reduce the processing time to something more reasonable, the structure of the fast model had to be rearranged. At the same time the ocean emissivity calculations were moved to the part of the model that\r\ndetermines ecosystem type. This eliminated processing gaps where the two separate landâ€“ sea masks were different.\r\n\r\n3) Add 2 angle quadrature of downwelling clear sky radiances.\r\nThe initial version of the downwelling radiance calculations still does not compile, but the process of debugging has started.\r\n\r\nI also worked with Leslie and Tom Greenwald to make sure that the code they start with is consistent with what other researchers are using.','Erik Olson Sep/05 Monthly Report',0,'','publish','open','closed','','erik-olson-sep05-monthly-report','','','2005-11-09 15:54:53','2005-11-09 20:54:53','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/28/erik-olson-sep05-monthly-report/',0),(41,16,'2005-09-30 13:09:00','2005-09-30 18:09:00','I ran the LBLRTM and LBLDIS models for the first cloudy case simulated by WRF that we have chosen.  I coded the generation of the input files (Lbldis parameter file) to make future runs semi-automated.  These runs will serve as â€œtruthâ€ for our cloud model validation studies.  Also, I am in the process of writing the tangent linear for the fast clear sky model.  And Iâ€™ve worked with Hal Woolf and Erik Olsen in debugging the fast clear sky model, and writing a test plan for both the clear and cloudy sky model.','Leslie Moy Sep/05 Monthly Report',0,'','publish','open','closed','','leslie-moy-sep05-monthly-report','','','2005-11-09 15:53:39','2005-11-09 20:53:39','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/28/leslie-moy-sep05-monthly-report/',0),(42,25,'2005-10-29 09:13:52','2005-10-29 14:13:52','My accomplishments for Oct05 are:\r\n\r\n  * Began the integration of SOI into the LBLDIS framework.  This will allow the two models to be evaluated relative to each other simply and with the exact same input.\r\n\r\n  * Investigated the use of different numerical transforms that can be applied to the layer optical depths before averaging them to the finite spectral intervals used by the scattering RT models (DISORT, SOI, etc).  The goal is to reduce the error associated with the product of convolutions (i.e., the polychromatic approximation).\r\n\r\nI will show results from the second bullet at the next meeting... ','Dave Turner Oct/05 Monthly Report',0,'','publish','open','closed','','dave-turner-oct05-monthly-report','','','2005-11-09 12:33:02','2005-11-09 17:33:02','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/10/29/dave-turner-oct05-monthly-report/',0),(45,1,'2005-11-07 16:36:00','2005-11-07 21:36:00','<div style=\"margin: 20px auto 20px auto; text-align: center; font-size: 85%;\"><a href=\"#overview\">Overview</a> | <a href=\"#add\">Adding a post</a> | <a href=\"#modify\">Modify a post</a> | <a href=\"#mailinglist\">Manage mailing list</a> | <a href=\"#misc\">Miscellaneous Notes</a></div>\r\n\r\n<h3 style=\"margin-top: 0px;\"><a name=\"overview\"></a>Brief Overview</h3>\r\nThis website is implented using a blog application called <a href=\"http://www.wordpress.org/\">WordPress\r\n</a>.  It is basically a set of web forms that allow users to submit content (\"<a href=\"http://codex.wordpress.org/Glossary#Post\">Posts</a>\" and \"<a href=\"http://codex.wordpress.org/Glossary#Page\">Pages</a>\") to the web server where it is stored in a database and is then displayed on the website.  Posts and pages are organized by \"<a href=\"http://codex.wordpress.org/Glossary#Category\">Categories</a>\".\r\n\r\nMore information\r\n<ul>\r\n	<li><a href=\"http://codex.wordpress.org/\">Online WordPress documentation</a></li>\r\n	<li><a href=\"http://codex.wordpress.org/Getting_Started_with_WordPress#WordPress_for_Beginners\">WordPress for Beginners</a></li>\r\n</ul>\r\n\r\n<h3><a name=\"add\"></a>Adding a post (quarterly reports, statements of work, ...)</h3>\r\n<ol>\r\n	<li>Either print these instructions or open them in a new window (or tab)</li>\r\n	<li>Login using the <strong>\"Login\"</strong> link on the front page.  Please note that the admin interface works best with gecko based browsers (Firefox, Netscape 7+, Mozilla).  <a href=\"#browsers\">More info on browser support</a>.</li>\r\n	<li>Click on the <strong>\"Write\"</strong> menu/link at the top of the resulting web page. </li>\r\n	<li>Select the <strong>\"Write Post\"</strong> sub-menu/link near the top if it isn\'t selected.</li>\r\n	<li>Fill in the title in the <strong>\"Title\"</strong> field - refer to the titles of other posts in the category you are submitting into to make your title consistent with the other posts.</li>\r\n	<li>Either type in or copy and paste in your content in the <strong>\"Post\"</strong> field.  You can instead just upload your content via the UploadPlus plugin (see <a href=\"/goes_r/rr/2005/12/19/file-upload-now-available/\">instructions</a>) and then attach a link to it in the <strong>\"Post\"</strong> field.</li>\r\n	<li>Using the <strong>\"Quicktag\"</strong> buttons at the top right of the <strong>\"Post\"</strong> field, add any formatting you want, as well as make any text links to web pages.  Use the link entitled <strong>\"Quicktags\"</strong> for more information.</li>\r\n	<li>To the right of the <strong>\"Post\"</strong> field is the <strong>\"Categories\"</strong> field - unselect the default <strong>\"Uncategorized\"</strong> and select the categories your post is being submitted to.</li>\r\n        <li>If you are posting a Progress Report for an ealier month, you can set the date to that earlier date by clicking on the <strong>\"Advanced Editing\"</strong> button and then changing the date in the <strong>\"Edit time\"</strong> field (make sure that the <strong>\"Edit timestamp\"</strong> checkbox is checked). </li>\r\n	<li>Either <strong>\"Save as a Draft\"</strong> and re-edit and <strong>\"Publish\"</strong> it later OR <strong>\"Publish\"</strong> it now using the buttons below the <strong>\"Post\"</strong> field.</li>\r\n	<li>Click on the <strong>\"View site\"</strong> link at the very top to view the website, where you can then navigate to your post and view it.</li>\r\n</ol>\r\n	<strong><a href=\"http://codex.wordpress.org/Writing_Posts\">More information</a></strong>\r\n\r\n<h3><a name=\"modify\"></a>Modifying a post</h3>\r\n<ol>\r\n	<li>Login</li>\r\n	<li>Click on the <strong>\"Manage\"</strong> menu/link at the top of the resulting web page. </li>\r\n	<li>Select the <strong>\"Posts\"</strong> sub-menu/link near the top if it isn\'t selected. Do NOT edit anything else under the <strong>\"Manage\"</strong> menu unless you know what you are doing and if you already have cleared this with either Allen or me.</li>\r\n	<li>Find your post in the list and click on the <strong>\"Edit\"</strong> link for it.</li>\r\n	<li>This will open up the <strong>\"Write Post\"</strong> sub-menu for that post - follow the above relevant instructions on how to use this form.</li>\r\n</ol>\r\n\r\n<h3><a name=\"mailinglist\"></a>Manage mailing lists</h3>\r\n<p>To list, add or delete people on the goesr_AD mailing list, do the following:</p>\r\n<ol>\r\n<li>click on the \"GOES-R3 AD Mailing List\" link underneath Other Resources on the right.</li>\r\n<li>Click on the \"Enter\" link in the top right</li>\r\n<li>Login</li>\r\n<li>click on the \"Folders\" link</li>\r\n<li>click on the \"(List)\" link on the same line as the goesr_AD mailing list</li>\r\n<li>click on the \"Subscription\"  link - this will take you to a page where you can see all of the users on the mailing list and add/delete people to the list.</li></ol>\r\n\r\n<h3><a name=\"misc\"></a>Miscellaneous Notes</h3>\r\n<ul>\r\n<li>Please do <strong>NOT</strong> fill in or select any web form field dealing with either <strong>\"Trackback\"</strong> or <strong>\"Pings\"</strong> - these are features that we do NOT need and as soon as I can, I will be removing this functionality completely from this application.</li>\r\n<li><a name=\"browsers\"></a>Browser support: Gecko based browsers (Firefox, Netscape 7+, and Mozilla) work best with the admin interface for WordPress (this application).  Opera also appears to work pretty well, but I haven\'t completely tested it.  IE 6+ works, but not as well as gecko browsers.  Safari, unfortunately, appears to work the least well, in that the Quicktag formatting buttons do not show up.  It is recommended that you start out using a gecko based browser and after you have gotten comfortable with the admin interface, to try your primary browser of choice and see how well it works.  As browsers get better at supporting standards, this problem should lessen.</li>\r\n</ul>\r\n<div style=\"height: 500px;\"> </div>','User Notes',0,'','static','open','closed','','user-notes','','','2006-06-07 13:26:11','2006-06-07 18:26:11','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/user-notes/',0),(48,5,'2005-10-31 16:40:54','2005-10-31 21:40:54','Helped modify version 1 of the Algorithm Theoretical Basis Document Document (ATBD) entitled ABI Images Altitude-Resolved Water Vapor Wind Algorithms.\r\n\r\nWindco targeting for ATREC case is working.\r\n','Steve Wanzong Oct/05 Monthly Report',0,'','publish','open','closed','','steve-wanzong-oct05-monthly-report','','','2005-11-09 15:52:54','2005-11-09 20:52:54','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=48',0),(50,17,'2005-10-31 15:20:12','2005-10-31 20:20:12','October GOES-R3 Report  -  Erik Olson\r\n\r\nMain efforts during the month of October were the efforts to get the processing of the 24 hour dataset calculated.  \r\n\r\n1)	Finish the implemented improvements to the fast model.  \r\n\r\nThe addition of the emissivity database and downwelling approximation still had a few bugs to work out. This was mostly concerned with updating the input data paths and making sure the needed information is passed to the appropriate modules. The efforts from September to get the 64 bit version working never did reliable succeed.  The problems are most likely due to a poor job of variable declaration.\r\n\r\n2)	Processing of the 24 hour dataset.\r\n\r\nMuch of this effort was spent on developing scripts for generating jobs to run on the computing cluster. It was a trying month for the cluster. We dealt with a full home disk and multiple crashes of the new cluster head node and its queueing system. About 25% of the TOA radiances were computed using the new fast model (minus the 2nd water continuum term) with Leslieâ€™s regression coefficients from 2003.\r\n\r\n\r\nThe two things from the plan timeline created in early September that I didnâ€™t get to were:\r\n\r\na) Work with whomever is developing a more formal test plan for the simulated data.\r\nb) Document the WRF (with Jason) and cloudy forward model.\r\n\r\nPart b) is being attended to with the AMS extended abstract and Jasonâ€™s BAMS article.\r\n','Erik Olson Oct/05 Monthly Report',0,'','publish','open','closed','','erik-olson-oct05-monthly-report','','','2005-11-09 15:52:13','2005-11-09 20:52:13','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/11/09/erik-olson-oct05-monthly-report/',0),(53,10,'2005-10-31 11:40:55','2005-10-31 16:40:55','I extracted the 2-layer model code (i.e., the multiple scattering model) from the main program used to compute cloudy sky radiances for GIFTS wavelengths (ly2g.f). I reorganized and improved the code, making it much more flexible to use. The code was also converted to F90, conforming roughly to the standardized code that is part of the CRTM. The new code also compiles and runs under F95. The only minor remaining issues are that the new code produces results about 0.05 K too high compared to the previous code and that it runs slightly slower. The speed issue can be resolved by loading the R/T lookup tables into memory.\r\n\r\nI also acquired a beta version of the CRTM and successfully built the libraries and ran the test program.\r\n\r\n\r\n','Tom Greenwald Oct/05 Monthly Report',0,'','publish','open','closed','','tom-greenwald-oct05-monthly-report','','','2005-12-22 09:54:58','2005-12-22 14:54:58','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/11/11/tom-greenwald-oct05-monthly-report/',0),(59,10,'2005-11-30 15:42:34','2005-11-30 20:42:34','I converted the FPLOD code to F95. Rather than use the version that was part of the previous 2-layer model system (i.e., routine â€œgifts_tranâ€), I started with the FSU version and used the gifts_tran code for guidance. The new code is much cleaner and more flexible to use. I applied some of the same coding standards as for the 2-layer model code. In addition, all the coefficients are now loaded into memory; previously they were read from disk as needed. \r\n\r\nPerformed preliminary comparison of SOI vs. 2-layer model in clear sky. Overall, there is close correspondence except at center of 15 micron CO2 line. The differences are likely related to how the thermal source is integrated across the layer. This will be investigated next month.\r\n\r\nAlso, discovered a bug in the routine cloudsMM5, which is used to assign optical properties to cloud layers. Clouds occupying a single layer were misidentified as clear sky.\r\n\r\nI helped Leslie with FPLOD tangent linear code and started 1-layer model code conversion.\r\n\r\nBegan comparisons of SOI model and 2-layer model in cloudy conditions. There are some major differences in the results. I believe the cloud visible optical depth is being correctly converted to infrared optical depth. The cause may be that I am using the wrong cloud optical property database for the SOI model. Iâ€™m continuing to work on resolving the problem.\r\n\r\n\r\n\r\n\r\n','Tom Greenwald Nov 2005 Monthly Report',0,'','publish','open','closed','','tom-greenwald-nov-2005-monthly-report','','','2005-12-22 09:53:59','2005-12-22 14:53:59','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/05/tom-greenwald-nov-2005-monthly-report/',0),(55,18,'2005-10-31 15:34:17','2005-10-31 20:34:17','Completed a new WRF model simulation of the FULDISK case study that contains finer temporal frequency than the previous FULLDISK simulation.  The model-simulated atmospheric profile dataset for this case study is currently being generated for a 24-hour period with 40-min temporal resolution.  This \"40-min\" dataset should be available for all interested users by 5 November.\r\n\r\nConstructed a webpage for the FULLDISK case study that contains a brief description of the WRF model simulation, a list of the available datasets, and gif images of various simulated atmospheric fields.  The webpage address is: http://www.ssec.wisc.edu/~jasono/muri/fulldisk/index.html .\r\n\r\nContinued to write the NWP paper documenting the numerical modeling work that I perform in support of forward model and retrieval algorithm development.  Although I am currently waiting for feedback from several co-authors, it is anticipated that this paper will be submitted to BAMS by the end of November or the first part of December.\r\n\r\nAttended the AMS Mesoscale Conference.  I gave a poster presentation that compared the cloud structures produced by the various cloud microphysical schemes currently implemented in the WRF model.','Jason Otkin Oct 2005 Monthly Report',0,'','publish','open','closed','','55','','','2005-12-21 15:49:20','2005-12-21 20:49:20','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/11/14/55/',0),(56,10,'2005-11-23 12:03:46','2005-11-23 17:03:46','Subject: Minutes of GOES-R sub-group meeting on cloudy-sky forward modeling\r\n\r\nDate: 7 November 2005\r\n\r\nPreparer: TomG\r\n\r\nDaveT has been working on ways to speed up radiative transfer (RT) calculations by reducing the spectral resolution of LBL gas optical depths before performing the RT calculations; i.e., the convolution problem. He showed results of brightness temperature errors for various convolution methods and spectral averaging intervals. The smallest errors were achieved when the optical depths were averaged assuming a power law with a base value of about 100. The optimal base value may depend on the atmospheric conditions.\r\n\r\nTomG gave the status of the 2-layer and 1-layer model code conversion to F90. The 2-layer model code has been converted to F90 (i.e., the RT code, not the gas absorption model). The code has been restructured and is more flexible. It also compiles under F95. The only minor problems are the code has a discrepancy of about 0.05 K with the previous code and it runs slightly slower, mainly due to more frequent I/O regarding the R/T lookup tables. Further improvements and extensions to the code were proposed. The 1-layer model code conversion has just begun. The beta version of the CRTM was also discussed. He successfully built the CRTM libraries and executed the test program. \r\n\r\nRegarding ways in which to integrate our science code into the CRTM, BobK recommended we take advantage of programming expertise already available at CIMSS and suggested a meeting with RayG to discuss how this might be done.\r\n\r\nBobK suggested observational datasets that might be useful for validation purposes. For example, the in situ measurements and extensive remote sensing data available at the DOE ARM sites. The Southern Great Plains site was suggested as a possible location. We also, apparently, have access to aircraft measurements of cloud microphysical properties. It was also brought up as to what types of clouds to consider in a validation effort. A variety of clouds is good but efforts should be focused on plane-parallel-like clouds, in order to mitigate 3D effects in the comparisons.\r\n\r\n\r\nAction items:\r\n\r\nÂ·	Tiziano will discuss his doubling-adding model at the next meeting\r\nÂ·	Continue modifying 2-layer model code and convert FSU PLOD code to F90 (TomG)\r\nÂ·	Set up meeting with RayG and BobK \r\n','Cloud Group Meeting Minutes 7 Nov 2005',0,'','publish','open','closed','','cloud-group-meeting-minutes-7-nov-2005','','','2005-11-23 12:04:56','2005-11-23 17:04:56','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/11/23/cloud-group-meeting-minutes-7-nov-2005/',0),(57,10,'2005-11-23 12:06:51','2005-11-23 17:06:51','Subject: Minutes of GOES-R sub-group meeting on cloudy-sky forward modeling\r\n\r\nDate: 21 November 2005\r\n\r\nPreparer: TomG\r\n\r\n\r\nTomG gave the status of the 2-layer/1-layer model and FPLOD code conversion. Two bugs were discovered and fixed in the 2-layer model code. FPLOD has been successfully converted to F95. The FPLOD coefficients are now loaded into memory. Before, the coefficients were read from disk when needed. LeslieM has written the Tangent Linear for the new FPLOD code and it is being tested. A preliminary clear sky comparison between the SOI model and the 2-layer model are within about 0.1 K except near very strong absorption lines, where the differences can reach 1 K. These differences reflect the different ways in which the source function is interpolated vertically across strongly absorbing layers in the two models. Progress has been made on the cloudy sky comparisons, though additional work is needed.\r\n\r\nTiziano summarized his radiative transfer modeling system. Its main purpose is to serve as a reference model for radiance calculations from the microwave to visible, but it also will be useful in retrievals and in developing cloud parameterizations. The absorption line information is based principally on HITRAN/GEISHA. The radiative transfer model used is a vector (polarimetric) doubling-adding model developed by Evans and Stephens. Cloud scattering properties are derived from Mie calculations for spheres (homogeneous and coated) and Ping Yangâ€™s properties for various ice crystal habits. \r\n\r\nBobK stressed the need for a reference model.\r\n\r\nChia will work with us to transition our science code to the CRTM framework.\r\n\r\nAction items:\r\n\r\nÂ·	Continue working on cloudy sky comparisons between 2-layer and SOI model (TomG)\r\nÂ·	Work with Tiziano and DaveT on model comparisons (TomG) \r\nÂ·	Meet with Chia (TomG)\r\n\r\n','Cloud Group Meeting Minutes - 21 Nov 2005',0,'','publish','open','closed','','cloud-group-meeting-minutes-21-nov-2005','','','2005-11-28 10:14:05','2005-11-28 15:14:05','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/11/23/cloud-group-meeting-minutes-21-nov-2005/',0),(58,18,'2005-11-30 12:12:16','2005-11-30 17:12:16','Finished writing the second draft of the NWP paper.  Although I am currently waiting for feedback from several co-authors, it is anticipated that this paper will be submitted to BAMS by the second week of December.\r\n\r\nVersion 2.1 of the WRF model (NMM core) was released this month.  This is the version of WRF developed by NCEP.  Initial attempts to compile and test the NMM core have failed due to problems with the ifort compiler.  This problem should be fixed in the next few days and at that time I will begin testing the NMM core.\r\n\r\nIn an effort to improve how cloud processes are modeled during our WRF simulations, I am exploring additional microphysics options outside of the standard WRF modeling framework.  Axel Seifert has recently implemented a double-moment microphysics scheme in WRF that explicitly calculates the mixing ratios and number concentrations for 5 microphysical species.  He has been kind enough to provide his code to me.  His code has only been tested for a couple specific atmospheric conditions so there is not guarantee that it\'ll work for our simulations.  If it is reasonably stable, it promises to be a major improvement over the single-moment schemes currently implemented in WRF.','Jason Otkin Nov 2005 Monthly Report',0,'','publish','open','closed','','jason-otkin-nov-2005-monthly-report','','','2005-12-21 15:54:13','2005-12-21 20:54:13','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=58',0),(60,10,'2005-12-06 09:18:19','2005-12-06 14:18:19','Subject: Minutes of GOES-R sub-group meeting on cloudy-sky forward modeling\r\n\r\nDate: 5 December 2005\r\n\r\nPreparer: TomG\r\n\r\nTomG summarized the status of the 2-layer model and the comparison study. The source function integration method for SOI was incorporated into the 2-layer model and now the differences between these models in clear sky are less than 0.0001 K. Based on one cloudy sky case it appears that an 8-stream SOI model might be needed to bring the errors down to under 0.1 K in the forward calculations of brightness temperature. Though the cloud sky comparisons have improved, however, problems still remain. The developer of the 2-layer model, Jianguo Niu, has been contacted for assistance.\r\n\r\nLeslieM completed the tangent linear model for the new FPLOD code and some results were shown. While certain aspects of the results came into question, we believe the tangent linear model is working properly. This is based on comparisons made to perturbations in the forward nonlinear model.\r\n\r\n\r\nAction items:\r\n\r\nÂ·	Continue working on cloudy sky comparisons between 2-layer and SOI model (TomG)\r\nÂ·	Begin building adjoint for FPLOD (LeslieM)\r\n','Cloud Group Meeting Minutes - Dec 5 2005',0,'','publish','open','closed','','cloud-group-meeting-minutes-dec-5-2005','','','2005-12-06 09:18:19','2005-12-06 14:18:19','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/06/cloud-group-meeting-minutes-dec-5-2005/',0),(65,3,'2005-12-19 12:44:40','2005-12-19 17:44:40','<a href=\'/goes_r/rr/wp-content/HESRetrievalStrategyFlowChart.ppt\' title=\'Sounding Rtv. Strategy Flow Chart - Draft\'>Sounding Rtv. Strategy Flow Chart - Draft</a>','Sounding Rtv. Strategy - Flow Chart Draft',0,'Sounding Rtv. Strategy - Flow Chart Draft','publish','open','closed','','sounding-rtv-strategy-flow-chart-draft','','','2006-06-07 14:12:18','2006-06-07 19:12:18','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/19/sounding-rtv-strategy-flow-chart-draft/',0),(63,1,'2005-12-19 12:11:49','2005-12-19 17:11:49','<h3>Files</h3>\r\n<!--UPLOADPLUS ACTION=\"filelist\" NUM=\"all\"-->','File List',0,'','static','open','closed','','file-list','','','2005-12-19 12:11:49','2005-12-19 17:11:49','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/file-list/',0),(64,1,'2005-12-19 12:30:55','2005-12-19 17:30:55','I have written a plugin that gives users of this blog the ability to upload files and manage them. \r\n<h3>To use this feature:</h3>\r\n<ol><li>login,</li> \r\n<li>then click on the <strong>Manage menu</strong>,</li>\r\n<li>and then the <strong>UploadPlus submenu</strong>.</li></ol> This plugin is a BETA version - please use and if you run into any problems or find that there is a particular feature or change that you would really like, please let me know.  \r\n\r\n<h3>Notes:</h3>\r\n\r\n<ul>\r\n<li>To link to one of the files that have been uploaded, use the \"Attach a File\" drop down menu in the \"Write Post\" or \"Write Page\" form/page</li>\r\n<li>links will only show up as text in Excerpts (as denoted by being wrapped in a light gray box)  due to the way the WordPress software works - you have to click on the \"More\" link or the title to view the \"permalink\" page for a particular post where all of the links and HTML work and where you will get the entire content for that post</li>\r\n<li> when you click on \"Checkout & edit\", you will get a page that has a link for you to download the file to your computer where you can make changes to the file.  At the same time, the file is marked as \"checked out\" in the database and while it is checked out, nobody except you can edit or delete it.  When the file is checked out, the \"Checkout & edit\" link should change to a \"checkin\" link that allows you to upload the modified file from your computer and check it back in.</li>\r\n<li>when you click on \"Edit Properties\", you will get a page that allows you change the ... you guessed it, the properties of the file and at the same time, the file is checked out until you either submit your edits of the file properties or you check it back in with out editing it.</li>\r\n<li>There is <strong>NO </strong> access control involved in this yet - anyone who has an account for this blog can edit or delete files that you upload.  I plan on adding this in the future at some point.</li>\r\n<li>There is also no version history (keeping older versions of files) and files that are deleted are <strong>DELETED FOR GOOD</strong>.  Again, these are features I will add as time and interest in them dictate.  I also plan on adding the ability to group files into folders/subfolders at some point as well.</li>\r\n<li>This plugin is only usable inside the building for now or for people who use a VPN (talk to TC about this).  At some point, after this has developed more, I may open this up.</li>\r\n</ul>\r\n\r\nAnyway, I hope you find this useful and please let me know if you have any questions.\r\n\r\nBill','File Upload - Now Available',0,'','publish','open','closed','','file-upload-now-available','','','2005-12-20 12:26:13','2005-12-20 17:26:13','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=64',0),(67,3,'2005-12-19 12:53:19','2005-12-19 17:53:19','Regular GOES-R3 Monthly meeting will be\r\n1 pm room 351\r\nMonday 19 Dec., 2005\r\n','Dec 2005 Monthly meeting',0,'','publish','open','closed','','dec-2005-monthly-meeting-2','','','2005-12-19 12:53:19','2005-12-19 17:53:19','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/19/dec-2005-monthly-meeting-2/',0),(71,3,'2005-12-19 13:13:22','2005-12-19 18:13:22','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=6\">Sounding Progress</a>','Sounding Progress - Dec. 2005',0,'','publish','open','closed','','sounding-progress-dec-2005','','','2006-06-07 14:12:02','2006-06-07 19:12:02','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/19/sounding-progress-dec-2005/',0),(70,3,'2005-12-19 13:06:04','2005-12-19 18:06:04','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=5\">Wind Progress</a>','Wind Progress - Dec 2005',0,'','publish','open','closed','','wind-progress-dec-2005-2','','','2006-06-07 14:12:09','2006-06-07 19:12:09','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/19/wind-progress-dec-2005-2/',0),(75,3,'2005-12-19 13:45:46','2005-12-19 18:45:46','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=9\">19 Dec 2005 Meeting Agenda</a>','19 Dec. Meeting Agenda',0,'','publish','open','closed','','19-dec-meeting-agenda','','','2006-06-07 14:11:46','2006-06-07 19:11:46','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/19/19-dec-meeting-agenda/',0),(76,3,'2005-12-19 16:16:53','2005-12-19 21:16:53','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=10\">Forward Model Status</a>','Status of Forward Model Development',0,'','publish','open','closed','','status-of-forward-model-development','','','2006-06-07 14:11:38','2006-06-07 19:11:38','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/19/status-of-forward-model-development/',0),(74,3,'2005-12-19 13:29:50','2005-12-19 18:29:50','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=7\">IR Surface Emis Modeling</a>','IR Surface Emissivity Modeling Progress as of Dec 2005',0,'','publish','open','closed','','ir-surface-emissivity-modeling-progress-as-of-dec-2005','','','2006-06-07 14:11:54','2006-06-07 19:11:54','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/19/ir-surface-emissivity-modeling-progress-as-of-dec-2005/',0),(77,3,'2005-12-19 16:19:25','2005-12-19 21:19:25','1-2:30 pm Monday 23 January 2006\r\nRoom 351','January 2006 AD Monthly Meeting',0,'','publish','open','closed','','january-2006-ad-monthly-meeting','','','2005-12-19 16:19:25','2005-12-19 21:19:25','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/19/january-2006-ad-monthly-meeting/',0),(78,16,'2005-12-20 10:36:25','2005-12-20 15:36:25','I have complete the Fortran95 version of the tangent linear model.  I am in the testing phase of the adjoint model.','December Monthly Report - Leslie Moy',0,'','publish','open','closed','','december-monthly-report-leslie-moy','','','2005-12-20 10:36:25','2005-12-20 15:36:25','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/20/december-monthly-report-leslie-moy/',0),(79,15,'2005-10-20 15:17:18','2005-10-20 20:17:18','Comparison of clear sky radiances obtained with LBLRTM and LBLDIS. \r\nSame exercise with HARTCODE and RTX (equivalent codes used in the Physics dept. of the University of Bologna). RTX input file has been adapted to work using the optical depths produced by LBLRTM.\r\nInvestigations of discrepancies found in the most absorbing regions when codes of the same â€˜familyâ€™ (ie LBLRTM and LBLDIS) are compared. Minor differences due to layering and source functions. Main effects are due to inaccuracies in the interpolation of LBLRTM high spectral resolution optical depths to typical spectral resolution used in multiple scattering computations (0.05-0.01 cm-1).\r\nBrightness temperature differences are maintained less than 0.05 K when the original resolution is maintained.\r\nIt will be necessary to develop new algorithms for the exploitation of LBLRTM optical depths in DISORT and in the interface with RTX, when coarse resolution is used.\r\n','October monthly report - Tiziano Maestri',0,'','publish','open','closed','','october-monthly-report','','','2005-12-21 15:10:40','2005-12-21 20:10:40','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/20/october-monthly-report/',0),(81,15,'2005-11-20 15:53:38','2005-11-20 20:53:38','The cloud scattering module in RTX has been modified to the SSEC computing environment.\r\nFirst comparisons between LBLDIS and RTX in cloudy sky conditions.\r\nSingle scattering optical properties of single particles, computed by Ping Yang, are adapted to be exploited in RTX. \r\nThe new routines read the Ping Yang database and output the optical properties of size distributions that can be a mixture of different shapes.\r\nMethodology is complete in the infrared range. Minor modifications need to be applied to exploit the solar part of the database. \r\n','November monthly report - Tiziano Maestri',0,'','publish','open','closed','','november-monthly-report-tiziano-maestri-2','','','2005-12-21 15:09:44','2005-12-21 20:09:44','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/20/november-monthly-report-tiziano-maestri-2/',0),(83,10,'2005-12-22 10:26:35','2005-12-22 15:26:35','I finished writing the driver code that reads WRF simulated profiles from a GIFTS cube data file (actually an ncdump text file from the original netcdf) and then computes spectral brightness temperatures using a multi-stream version of the SOI model, the original fast version of the SOI model, and the 2-layer model. Error statistics are also generated. I also uncovered a bug in the SOI model, whereby the model had used upwelling/downwelling source function values left over from previous calls to subroutine. Consequently, the forward calculations were contaminated. This went unnoticed since the model is used primarily at microwave wavelengths where the source functions values tend to be much smaller than in the IR.\r\n\r\nI contacted Niu (the creator of the 2-layer model) concerning my difficulty with matching the single scattering properties going into the SOI model with the same properties that were used in generating the 2-layer model reflection/transmission tables. He agreed to help me but I have not received much feedback from him. We then requested Ping Yang to generate R/T tables for us using Bryanâ€™s latest bulk scattering property models from 100 to 3250 cm-1. The decision to use these mixed habit models is based on the fact that we donâ€™t have a priori knowledge about the particle habits within the clouds. Ping also agreed to generate tables in the microwave.\r\n \r\nThe routine I used to interpolate scattering properties apparently had a few bugs, which have now been fixed. In addition, the scattering tables are now loaded into memory. The R/T tables for the 2-layer model are loaded into memory as well.  \r\n','Tom Greenwald Dec 2005 Monthly Report',0,'','publish','open','closed','','tom-greenwald-dec-2005-progress-rpt','','','2005-12-22 10:28:38','2005-12-22 15:28:38','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=83',0),(82,1,'2005-12-21 14:32:10','2005-12-21 19:32:10','','',0,'','draft','open','closed','','','','','2005-12-21 14:32:10','2005-12-21 19:32:10','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=82',0),(84,5,'2005-12-29 09:57:02','2005-12-29 14:57:02','The WRF true water vapor from December 5, 2003 was used to construct a loop of images for water vapor feature tracking using windco.  Hourly images were constructed (12z, 13z, and 14z were used).  Clouds were masked out of the water vapor images.  Winds were run at the following pressure levels:  343mb, 374mb, 407mb, 441mb, 477mb, 515mb, 555mb, 596mb, 639mb, 683mb, 729mb, 777mb, 827mb, 878mb, and 931mb.  You can look at the plots of raw winds with the attached power point file in the winds section of the GOES-R site.\r\n\r\nThe data has been staged for the retrieved water vapor wind sets.  A similar power point slide should be ready for the January meeting.','Steve Wanzong Dec 2005 Monthly Report',0,'Various wind sets were run on the true model water vapor from the ATReC case of 2003 day 339.  Loop times were 12z, 13z, and 14z.','publish','open','closed','','steve-wanzong-dec-2005-monthly-report','','','2006-01-03 13:28:58','2006-01-03 18:28:58','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/29/steve-wanzong-dec-2005-monthly-report/',0),(85,27,'2005-12-30 18:31:11','2005-12-30 23:31:11','Working on the three model comparisons, LBLRTM, LBLDIS, and LY2G. Now got all these models work for a specific given atmospheric profiles, and obtained preliminary results of all three models. But run into difficulties with model comparison issue related to the spectral convolution. I have asked James Davies for help on this issue since he did it partly before, and will look into the convolution algorithms for the better outcome. ','December monthly report- Xuanji Wang',0,'','publish','open','closed','','december-monthly-report-xuanji-wang','','','2005-12-30 18:31:11','2005-12-30 23:31:11','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/30/december-monthly-report-xuanji-wang/',0),(86,18,'2005-12-28 11:00:29','2005-12-28 16:00:29','The NCEP version of the WRF model (known as the NMM core) was released last month.  All compilation issues associated with this version appear to be addressed now as I am able to successfully compile the WRF-NMM SI (standard initialization) and the WRF-NMM model itself.  I plan to evaluate the performance of this model when some free time is available on serenity next month.\r\n\r\nI continued testing the Seifert and Beheng double-moment microphysics scheme in the ARW core of the WRF model.  Although substantial differences exist between the Seifert scheme and the single-moment schemes we have used in the past, preliminary results are encouraging.  The default Seifert scheme is very sensitive to the graupel and rain fall speeds, however, and proved to be unstable for the test case I performed.  Stable results were achieved by modifying the WRF model so that the graupel and rain fall speeds are calculated using a much shorter time step than that used for the other terms.  Overall, the Seifert scheme uses about 30-40% more memory than the WSM6 scheme and takes about 2 to 2.5 times as long to run for the same simulation.\r\n\r\nIn an effort to better evaluate the WRF model output, I am currently modifying the WRF_TO_GRADS utility so that it calculates the composite reflectivity using sound theoretical principles and the assumptions explicit to a given microphysics scheme.  The existing code simply uses an empirical formula independent of microphysics scheme, which can result in large errors.  Axel Seifert has provided me with his code, which I am now adapting to the WRF_TO_GRADS utility.','December monthly report - Jason Otkin',0,'','publish','open','closed','','december-monthly-report-jason-otkin','','','2006-01-03 12:02:40','2006-01-03 17:02:40','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=86',0),(87,9,'2005-12-30 12:33:25','2005-12-30 17:33:25','Submitted cloud case study paper to JTECH (Turner, Minnis co-authors) showing results from simultaneous ground-, aircraft-, and satellite-based measurements of cirrus.\r\n\r\nBegan analysis of MPACE and EAQUATE cloud cases (17 Oct 2004 and 6 Sep 2004, respectively). Presented preliminary results at AGU NPOESS session.\r\n\r\nCreated list of good cirrus cases which can be used for GOES R3 model comparison study:\r\n24 Nov 2002 and 8 Dec 2000 at ARM SGP; 17 Oct 2004 at ARM NSA; 6 Dec 2004 during EAQUATE-Italy campaign; and 5 Dec 2003 during ATOST field campaign.  Each of these cases (aside from the ATOST case) has been previously analyzed to some extent by myself.  Results are available upon request for comparison with model studies.\r\n\r\nCurrent tasks:  \r\n -work closely with Tiziano and Dan Zhou (LaRC) on 6 Dec 2004 EAQUATE case which has been noted as a possible publication case study;\r\n -begin analysis of 5 Dec 2003 ATOST case for comparison with Zhou/Smith retrieval results\r\n -revise submitted paper per reviewers recommendations','December Progress Report',0,'','publish','open','closed','','december-progress-report','','','2005-12-30 12:33:25','2005-12-30 17:33:25','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/30/december-progress-report/',0),(88,7,'2005-12-31 12:48:07','2005-12-31 17:48:07','This month the focus of the work was on beginning work toward the creation of a high spectral resolution emissivity database from the laboratory spectra and MODIS MOD11 data by using Principal Component Analyses. 322 laboratory measurements were selected and interpolated into 413 wavenumbers with resolution 5 cm-1. 26 principal components were chosen for the 0.999 explained variance. 5000 simulated spectra were calculated randomly. The best-fit simulated spectra were chosen globally for each MOD11 emissivity spectra by using the least squares method. The laboratory measurements were convolved with the MODIS SRF before hand. For physical consistency checks the laboratory measurement was chosen that is most similar to the selected simulated spectra (best fit by least squares) and results were analyzed by IGBP ecosystem. A meeting was called to discuss the preliminary results. ','2005 December Monthly Report - Eva Borbas and Suzanne Seemann',0,'','publish','open','closed','','2005-december-monthly-report-eva-borbas-and-suzanne-seemann','','','2006-01-23 17:27:37','2006-01-23 22:27:37','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/13/2005-december-monthly-report-eva-borbas-and-suzanne-seemann/',0),(89,3,'2006-01-19 17:31:02','2006-01-19 22:31:02','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=11\">Q4-2005-FMReport</a>','2005 Q4 report - Cloudy Forawrd Model',0,'','publish','open','closed','','2005-4q-report-fm','','','2006-06-07 14:11:31','2006-06-07 19:11:31','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/19/2005-4q-report-fm/',0),(90,3,'2006-01-19 17:31:40','2006-01-19 22:31:40','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=12\">Surface Emissivity Modeling report</a>','2005 Q4 report - Surface Emissivity',0,'','publish','open','closed','','2005-4q-report-se','','','2006-06-07 14:11:15','2006-06-07 19:11:15','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/19/2005-4q-report-se/',0),(91,3,'2006-01-19 18:15:54','2006-01-19 23:15:54','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=13\">Internal Meeting Minutes</a>','Internal Meeting Minutes - Dec19-2005',0,'','publish','open','closed','','internal-meeting-minutes-dec19-2005','','','2006-06-07 14:11:22','2006-06-07 19:11:22','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/19/internal-meeting-minutes-dec19-2005/',0),(92,3,'2006-01-20 16:10:53','2006-01-20 21:10:53','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=14\">Wind 2005 Q4 Report</a>','2005 Q4 report - Wind',0,'','publish','open','closed','','wind-2005-q4-report','','','2006-06-07 14:10:34','2006-06-07 19:10:34','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/20/wind-2005-q4-report/',0),(93,3,'2006-01-20 17:12:35','2006-01-20 22:12:35','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=15\">Sounding ATBD - Table of Contents</a>','Initial Draft of Table of Contents for Sounding ATBD',0,'','publish','open','closed','','initial-draft-of-table-of-contents-for-sounding-atbd','','','2006-06-07 14:10:10','2006-06-07 19:10:10','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/20/initial-draft-of-table-of-contents-for-sounding-atbd/',0),(94,3,'2006-01-20 17:15:57','2006-01-20 22:15:57','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=16\">Initial Draft of PPT Version of Sounding ATBD</a>','Initial Draft of PPT Version of HES Sounding ATBD',0,'','publish','open','closed','','initial-draft-of-ppt-version-of-hes-sounding-atbd','','','2006-06-07 14:10:00','2006-06-07 19:10:00','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/20/initial-draft-of-ppt-version-of-hes-sounding-atbd/',0),(95,3,'2006-01-20 17:22:03','2006-01-20 22:22:03','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=17\">2005 Q4 Report - Sounding</a>','2005 Q4 Report - Sounding',0,'','publish','open','closed','','2005-q4-report-sounding','','','2006-06-07 14:09:52','2006-06-07 19:09:52','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/20/2005-q4-report-sounding/',0),(96,3,'2006-01-20 17:56:10','2006-01-20 22:56:10','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=18\">2005 Q1 SOW - Wind Group</a>','2006 Q1 SOW - Wind Group',0,'','publish','open','closed','','2006-q1-sow-wind-group','','','2006-06-07 14:09:44','2006-06-07 19:09:44','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/20/2006-q1-sow-wind-group/',0),(97,3,'2006-01-20 17:57:04','2006-01-20 22:57:04','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=22\">2006 Q1 SOW - TomG</a>','2006 Q1 SOW - TomG',0,'','publish','open','closed','','2006-q1-sow-tomg','','','2006-06-07 14:09:37','2006-06-07 19:09:37','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/20/2006-q1-sow-tomg/',0),(98,3,'2006-01-20 17:57:38','2006-01-20 22:57:38','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=20\">2006 Q1 SOW - SteveA</a>','2006 Q1 SOW - SteveA',0,'','publish','open','closed','','2006-q1-sow-stevea','','','2006-06-07 14:09:30','2006-06-07 19:09:30','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/20/2006-q1-sow-stevea/',0),(99,3,'2006-01-20 17:58:09','2006-01-20 22:58:09','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=19\">2006 Q1 SOW - LeslieM</a>','2006 Q1 SOW - LeslieM',0,'','publish','open','closed','','2006-q1-sow-lesliem','','','2006-06-07 14:09:22','2006-06-07 19:09:22','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/20/2006-q1-sow-lesliem/',0),(100,3,'2006-01-23 11:03:50','2006-01-23 16:03:50','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=23\">Suumary of Cloudy FM</a>','Summary of Progress of Cloudy FM',0,'','publish','open','closed','','summary-of-progress-of-cloudy-fm','','','2006-06-07 14:09:15','2006-06-07 19:09:15','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/23/summary-of-progress-of-cloudy-fm/',0),(101,3,'2006-01-23 11:12:04','2006-01-23 16:12:04','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=24\">2005 Q4 Report - NWP</a>','2005 Q4 Report - NWP',0,'','publish','open','closed','','q4-2005-report-nwp','','','2006-06-07 14:09:08','2006-06-07 19:09:08','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/23/q4-2005-report-nwp/',0),(102,3,'2006-01-23 11:43:13','2006-01-23 16:43:13','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=25\">2006 Q1 SOW -  JasonO</a>','206 Q1 SOW - JasonO',0,'','publish','open','closed','','206-q1-sow-jasono','','','2006-06-07 14:08:59','2006-06-07 19:08:59','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/23/206-q1-sow-jasono/',0),(103,3,'2006-01-23 13:06:26','2006-01-23 18:06:26','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=26\">Quarterly Report Template</a>\r\n\r\nPls use this template to write your Quarterly report!','Quarterly Report Template',0,'','publish','open','closed','','quarterly-report-template','','','2006-06-07 14:08:50','2006-06-07 19:08:50','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/23/quarterly-report-template/',0),(104,17,'2006-01-23 13:52:41','2006-01-23 18:52:41','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=27\">2006 Q1 SOW - ErikO</a>','2006 Q1 SOW - ErikO',0,'','publish','open','closed','','2006-q1-sow-eriko','','','2006-06-07 14:08:35','2006-06-07 19:08:35','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/23/2006-q1-sow-eriko/',0),(105,17,'2005-12-31 13:59:17','2005-12-31 18:59:17','<strong>December GOES-R3 Report  -  Erik Olson</strong>\r\n\r\nMain efforts during the month of December are once again related to processing of the 24 hour dataset. \r\n\r\n1)	Processing of 24 hour dataset.  \r\n\r\nThe processing effort has been severely affected by the various instabilities of the refurbished cluster. The main plagues were random crashes of serenity, which was being used for both processing and file serving. The master node of the refurbished cluster was also experiencing random crashes. The master node crashes have been solved and a work around for the serenity problems is in place. The partial files and errors left over from the 3 dozen or so crashes have been an enormous effort to clean up.\r\n\r\n2)	Test Plan\r\n\r\nI have not heard who has been identified to develop and implement the synthetic data test plan, but I am happy to help them get started.\r\n\r\n','December Monthly Report - ErikO',0,'','publish','open','closed','','december-monthly-report-eriko','','','2006-01-23 17:26:55','2006-01-23 22:26:55','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/23/december-monthly-report-eriko/',0),(106,3,'2006-01-23 15:37:33','2006-01-23 20:37:33','1-2:30 pm Monday 20 February 2006\r\nRoom 351.\r\n','February 2006 AD Group Leader Meeting',0,'','publish','open','closed','','february-2006-ad-group-leader-meeting','','','2006-01-23 15:37:33','2006-01-23 20:37:33','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/23/february-2006-ad-group-leader-meeting/',0),(107,15,'2006-01-27 11:18:08','2006-01-27 16:18:08','Monthly report: December 2005\r\n\r\nTiziano Maestri\r\n\r\nData analysis and simulations of clear sky NAST-I interferometric measurements collected on the 8th of September 2004 during the EAQUATE experiment, in southern Italy. \r\n \r\nI have currently fully analyzed 3 overpasses (on a total # of 4) of the ER flight carrier over the Difa Lidar site. Water vapor profile has been derived from the Raman lidar measurements. The 4th overpass is affected by a lack of radiosondeâ€™s data between 6 and 9 km of altitude. I need further work and time before having the 4th profile. \r\n\r\nBoth LbLRTM and RTX codes have been used in the analysis showing maximum spectral differences of 0.5 cm-1 in the water vapor band. This is explainable with the different version of HITRAN database used and the different assumptions in the interpolation of monochromatic optical depth procedures performed by the two codes.\r\n\r\n\r\nSurface emissivty was derived from SSEC gridded dataset (Eva Borbas and Suzanne Seemann), using a baseline fit method on MOD11 measurements (MODIS surface emissivity retrieval algorithm). Differences with respect to when using a unit surface emissivity are sensible and their effects when retrieving optical properties of semitransparent clouds need to be evaluated.\r\n\r\n\r\nData and simulations show a very good agreement in the water vapor band for the third overpass where the lidar measurement was less affected by solar radiation noise. Plots of the percentage differences between simulations and data in that band show residuals that are less than 2% for the fists 2 cases and mostly inside 1% for the 3rd overpass.\r\n\r\nA sensitivity analysis has been performed on the water vapor profile for that specific case. Results indicate that the discrepancies between simulations and data can be explained by an increase of 10-15% in the water vapor number density for every layer of the profile. \r\n','December Monthly report- Tiziano Maestri',0,'','draft','open','closed','','','','','2006-01-27 11:18:08','2006-01-27 16:18:08','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=107',0),(109,15,'2005-12-31 11:32:07','2005-12-31 16:32:07','Monthly report: December 2005\r\n\r\nTiziano Maestri\r\n\r\nData analysis and simulations of clear sky NAST-I interferometric measurements collected on the 8th of September 2004 during the EAQUATE experiment, in southern Italy. \r\n \r\nI have currently fully analyzed 3 overpasses (on a total # of 4) of the ER flight carrier over the Difa Lidar site. Water vapor profile has been derived from the Raman lidar measurements. The 4th overpass is affected by a lack of radiosondeâ€™s data between 6 and 9 km of altitude. I need further work and time before having the 4th profile. \r\n\r\nBoth LbLRTM and RTX codes have been used in the analysis showing maximum spectral differences of 0.5 cm-1 in the water vapor band. This is explainable with the different version of HITRAN database used and the different assumptions in the interpolation of monochromatic optical depth procedures performed by the two codes.\r\n\r\n\r\nSurface emissivty was derived from SSEC gridded dataset (Eva Borbas and Suzanne Seemann), using a baseline fit method on MOD11 measurements (MODIS surface emissivity retrieval algorithm). Differences with respect to when using a unit surface emissivity are sensible and their effects when retrieving optical properties of semitransparent clouds need to be evaluated.\r\n\r\n\r\nData and simulations show a very good agreement in the water vapor band for the third overpass where the lidar measurement was less affected by solar radiation noise. Plots of the percentage differences between simulations and data in that band show residuals that are less than 2% for the fists 2 cases and mostly inside 1% for the 3rd overpass.\r\n\r\nA sensitivity analysis has been performed on the water vapor profile for that specific case. Results indicate that the discrepancies between simulations and data can be explained by an increase of 10-15% in the water vapor number density for every layer of the profile. \r\n','December Monthly report- Tiziano Maestri',0,'','publish','open','closed','','december-monthly-report-tiziano-maestri','','','2006-01-27 11:33:25','2006-01-27 16:33:25','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=109',0),(110,15,'2006-01-27 12:39:42','2006-01-27 17:39:42','Monthly report: January 2006\r\n\r\nTiziano Maestri\r\n\r\nTwo main tasks:\r\n\r\n1)	Analysis of about 5100 measured particles size distributions, courtesy by A. Heymsfield (FIRE-I, FIRE-II, SHEBA, ARM, TRMM). Distributions are fitted with a Gamma Type SD defined by an interception, a slope and a size. Looking for relations between the shape of the distribution and the temperature. No evident relation found. Idea is to extract a subset of 20-40 PSD representative of the variety of cases measured in nature.\r\n\r\n2)	 Working at a new fast code for retrieving cloud optical depths. The idea is to modify RTX and make the new code retrieve the spectral modulation of optical depth and then comparing the result to a pre-computed database of optical depths obtained for various PSD and habits.\r\n','January Monthly Report- Tiziano Maestri',0,'','publish','open','closed','','january-monthly-report-tiziano-maestri','','','2006-01-27 12:39:42','2006-01-27 17:39:42','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/27/january-monthly-report-tiziano-maestri/',0),(111,10,'2006-01-27 14:24:25','2006-01-27 19:24:25','Wrote the tangent linear for the 2-layer model (FIRTM2) and performed initial testing','January 06 monthly report - Tom G',0,'','publish','open','closed','','january-06-monthly-report-tom-g','','','2006-02-01 11:42:51','2006-02-01 16:42:51','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=111',0),(112,33,'2005-12-31 00:00:00','2005-12-31 05:00:00','I have developed a code for the sounding and total column ozone regression retrieval by combining the HES and ABI bands. A few experiments have been carried out to look at the effects of different spectral coverage of HES and synergy of HES and ABI on ozone profile and total column ozone retrieval. These results are also compared with current GOES retrieval.','December monthly report - Jinlong Li',0,'','publish','open','closed','','december-monthly-report','','','2006-01-31 12:58:11','2006-01-31 17:58:11','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2005/12/31/december-monthly-report/',0),(113,33,'2006-01-31 12:54:14','2006-01-31 17:54:14','Working with Xuebao on the algorithm development of sounding retrieval:\r\nBased on previous work, I have developed four different versions of codes in AIRS sounding retrieval, including with or without BT class, and with or without forecast in regression training. The retrieval results have been compared with best estimated ARM datasets. \r\n\r\nWorking with Jun and Xuebao on AIRS and ARM matchup data:\r\nBased on AIRS radiance and ARM sounder data, we have identified some bad profiles from above matchup dataset, which will be excluded from future retrieval comparison. I also wrote a simple code to transfer water vapor and ozone column density to mixing ratio for AIRS 100 layer support data and these data are further converted into 101 levels data for the purpose of comparison with retrieval results.\r\n','January monthly report - Jinlong Li',0,'','publish','open','closed','','january-monthly-report-jinlong-li','','','2006-01-31 12:54:14','2006-01-31 17:54:14','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/31/january-monthly-report-jinlong-li/',0),(114,18,'2006-01-31 13:50:10','2006-01-31 18:50:10','Used the WRF model (ARW core) to generate a simulated atmospheric profile dataset for a case study referred to as the â€œOCEAN-WINDSâ€ simulation.  This simulation contains a single 1070 x 1070 grid point domain with 2-km horizontal resolution that covers the eastern U.S. and a portion of the western Atlantic.  A simulated dataset with 30-minute temporal resolution and 4-km horizontal resolution (a coarsened version of the original model data) was generated for a 24-hour period during this simulation.  A webpage containing a brief description of the WRF model simulation and gif images of various atmospheric fields has been constructed for this case study.  The webpage address is:\r\n\r\nhttp://www.ssec.wisc.edu/~jasono/muri/oceanwinds/index.html .\r\n\r\nAn alternative post-processing utility that can be used to view WRF model output was released last fall.  A nice feature of this utility is the ability to convert model output from both the ARW and NMM cores of the WRF model into a format suitable to generate images with Grads.  The utility is able to generate all of the standard model-derived data fields produced operationally at NCEP.  The code is more cumbersome to use than existing utilities, however, due to several intermediate steps.\r\n\r\nPerformed several test simulations of a severe thunderstorm event using the NMM core of the WRF model.  The model simulations failed due to errors associated with the radiation parameterization schemes.  These errors appear to be specific to the SGI Altix.  I informed the WRF-NMM developers about this problem a couple weeks ago but have not heard back from them yet.  We will not be able to use the WRF-NMM model until this problem is fixed.\r\n\r\nI am attending two classes in the AOS department this spring that discuss numerical modeling and cloud physics.','January 2006 Monthly Report--Jason Otkin',0,'','publish','open','closed','','january-2006-monthly-report-jason-otkin','','','2006-02-01 13:55:34','2006-02-01 18:55:34','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/01/31/january-2006-monthly-report-jason-otkin/',0),(115,7,'2006-02-03 16:30:55','2006-02-03 21:30:55','This month we began work on a second method to build a high spectral resolution emissivity database.  This new approach also uses principle component analysis of the 332 laboratory spectra, but then uses the MOD11 emissivity data to compute the coefficients. Because there are only 6 MOD11 channels, we are restricted in this approach to using 6 principal components.  Our preliminary results show that 6 PCs are not enough to represent the spectral information of the laboratory spectra.  We will try to partition the laboratory measurements into physically relevant ecosystem categories.  This month, we also put together a poster presentation for the AMS annual meeting in Georgia and we both attended. ','2006 January monthly report by Suzanne W. Seemann and Eva Borbas',0,'','publish','open','closed','','2006-january-monthly-report-by-suzanne-w-seemann-and-eva-borbas','','','2006-02-03 16:30:55','2006-02-03 21:30:55','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/02/03/2006-january-monthly-report-by-suzanne-w-seemann-and-eva-borbas/',0),(116,7,'2006-02-03 16:41:21','2006-02-03 21:41:21','Our plan during this period is to finalize the emissivity Version A & B databases (baseline fit and PCA emis matching with MOD11), perform comparisons between the databases and with other independent measurements, and test the databases in the MODIS MOD07 and AIRS T, q profile retrieval algorithms.  We intend in this period to submit a paper detailing these first two versions, with emphasis on the effects of improved surface emissivity on synthetic retrievals of atmospheric T,q.   Eva works 30 % of her time on this project. Suzanne will be on  unpaid leave for two months in the first quarter. ','2006 Q1-Q2 SOW Suzanne W. Seemann and Eva Borbas ',0,'','publish','open','closed','','2006-q1-q2-sow-suzanne-w-seemann-and-eva-borbas','','','2006-02-03 16:41:21','2006-02-03 21:41:21','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/02/03/2006-q1-q2-sow-suzanne-w-seemann-and-eva-borbas/',0),(117,3,'2006-02-14 16:32:43','2006-02-14 21:32:43','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=28\">Meeting Minutes</a>','Internal Meeting Minutes - Jan. 23 2006',0,'','publish','open','closed','','internal-meeting-minutes-jan-23-2006','','','2006-06-07 14:08:25','2006-06-07 19:08:25','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/02/14/internal-meeting-minutes-jan-23-2006/',0),(118,16,'2006-02-20 15:56:47','2006-02-20 20:56:47','Complete the Forward, Tangent Linear, and Adjoint models in Fortran 95.  Code was checked against the Matlab version and against itself (it is internally consistent), and submitted to CVS in the directory /devel/Model/gfm_f90','Leslie Moy\'s January Progress Report',0,'','publish','open','closed','','leslie-moys-january-progress-report','','','2006-02-20 15:56:50','2006-02-20 20:56:50','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=118',0),(119,16,'2006-02-20 15:59:09','2006-02-20 20:59:09','JAN:  Will commit the clear sky Fortran adjoint model to CVS. (30%) \r\nFEB:  Continue improvements to clear sky code. (30%)\r\nMAR: Will assist in the validation of the cloudy sky model, and the transfer of code from research to production teams. (40%)\r\n','Leslie Moy SOW',0,'','publish','open','closed','','leslie-moy-sow','','','2006-02-20 15:59:09','2006-02-20 20:59:09','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/02/20/leslie-moy-sow/',0),(120,3,'2006-02-24 11:22:27','2006-02-24 16:22:27','The Fortan 95 version of the GIFTS RT model has been released. The code is available on cvs under the directory devel/Model/gfm_f90. Forward code is included for FPLOD and the 2-layer RT model (FIRTM2). Tangent linear and adjoint are also available for FPLOD.\r\n','Forward Model Release',0,'1st Internal 2-layer cloudy RT Model','publish','open','closed','','forward-model-release','','','2006-02-24 11:22:27','2006-02-24 16:22:27','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/02/24/forward-model-release/',0),(121,10,'2006-02-28 15:57:15','2006-02-28 20:57:15','Tested tangent linear 2-layer model. Persuaded Bryan Baum to compute ice particle phase functions across the spectrum from 100 to 3250 cm-1. Ping Yangâ€™s group subsequently used these new scattering properties to compute new R/T lookup tables. I have copied the new databases over to my system but have not yet looked at them. I also acquired code from Dave Turner to generate Lengendre polynomial expansion coefficients of the phase function, which are needed by the SOI model for the bake-off. \r\nOfficially released version 1 of the GIFTS cloud sky forward RT model that is written in F95. Made further updates to ly2g.f90 and provided test software and databases for Jun Li to test the forward model system.  \r\nHad a meeting (Feb 22) with Erik Olsen, Ray Garcia, Maciek, and Jason Otkin to discuss how to utilize the new version of cloudy RT model in the system for processing TOA GIFTS radiances from WRF simulations. The plan for me was to write a driver to import directly a netcdf GIFTS data cube and process it. This code will undergo timing tests in order to decide what resources will be needed to do the job. I wrote a new driver and have also made further changes to the model code. I optimized the interpolation of the RT lookup tables and modularized the 2-layer model code. During this process I uncovered a bug in the parseclouds routine.\r\nHeld another cloud subgroup meeting (Feb 27).\r\n','Feb \'06 Progress Rpt - Tom Greenwald',0,'','publish','open','closed','','feb-06-progress-rpt-tom-greenwald','','','2006-02-28 15:57:15','2006-02-28 20:57:15','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/02/28/feb-06-progress-rpt-tom-greenwald/',0),(122,10,'2006-02-28 14:04:46','2006-02-28 19:04:46','Subject: Minutes of GOES-R sub-group meeting on cloudy-sky forward modeling\r\n\r\nDate: 27 February 2006\r\n\r\nPreparer: TomG\r\n\r\nTiziano has been working with a large database of measured particle size distributions (over 5000) and he gave us a summary of some preliminary analyses. He fitted the measured distributions to the gamma distribution and found that overall this distribution characterizes well the measurements. The most common range of the dispersion (width of distribution) was from about 2 to â€“2. Negative values are usually associated with deep convection and hence large particles. The median mass diameters of the fitted distributions were also independent of ice water content. \r\n\r\nThere will be an upcoming meeting devoted to cloud detection. The motivation is to bring together CIMSS scientists involved in cloud detection work (satellite and ground-based) in order to gather validation datasets for satellite-based methods and to work together on submitting proposals to the latest NASA research announcement on EOS science team recompetition.   \r\n\r\nAction items:\r\n\r\nÂ·	Contact SteveA as to when to have the cloud detection meeting (TomG)\r\n','Cloud subgroup meeting - 27 Feb 2006',0,'','publish','open','closed','','cloud-subgroup-meeting-feb-27-2006','','','2006-03-01 14:06:12','2006-03-01 19:06:12','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/03/01/cloud-subgroup-meeting-feb-27-2006/',0),(123,18,'2006-02-28 17:42:44','2006-02-28 22:42:44','Used the WRF model (ARW core) to generate a simulated atmospheric profile dataset for a case study referred to as the â€œNP-CONVECTIONâ€ simulation.  This simulation contains a single 1070 x 1070 grid point domain with 2-km horizontal resolution that covers most of the central and eastern U.S.  A simulated dataset with 30-minute temporal resolution and 4-km horizontal resolution (a coarsened version of the original model data) was generated for a 24-hour period during this simulation.  A webpage containing a brief description of the WRF model simulation and gif images of various atmospheric fields has been constructed for this case study.  The webpage address is:\r\nhttp://www.ssec.wisc.edu/~jasono/muri/np_convection/index.html .\r\n\r\nModified the existing WRF-to-GIFTS utility to be able to output additional model-predicted and model-derived variables that can be used by the convective initiation and winds groups.  The new variables include the horizontal wind components (u and v), the vertical wind component (w), the cloud top temperature with respect to ice and liquid, the total model precipitation, and the composite reflectivity.  The composite reflectivity represents the maximum radar reflectivity within the model column and was calculated using the Rayleigh approximation.\r\n\r\nI began to explore two different data assimilation utilities that have been developed for the WRF model.  Both utilities are still early in their development and as such are not currently able to assimilate satellite radiances.  The first utility, which is known as WRF-VAR, is a 3-dimensional variational assimilation scheme developed by NCAR.  I am able to successfully compile this utility.  Attempts to use this utility, however, have failed due to numerous problems with the supplied scripts used to run it.  The second utility, known as WRF-DART, was developed as part of the Data Assimilation Research Testbed.  The utility uses an Ensemble Kalman filter approach to assimilate observations.  Due to the four dimensional nature of this utility, it is very expensive to use.\r\n\r\nI also continued to attend two classes in the AOS department dealing with numerical modeling and cloud physics.','February 2006 Monthly Report--Jason Otkin',0,'','publish','open','closed','','february-2006-monthly-report-jason-otkin','','','2006-02-28 17:42:44','2006-02-28 22:42:44','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/02/28/february-2006-monthly-report-jason-otkin/',0),(124,15,'2006-02-28 11:35:14','2006-02-28 16:35:14','Monthly report: February 2006\r\n\r\nTiziano Maestri\r\n\r\nThree main tasks:\r\n\r\n1)	Measured particles size distributions, PSDs, from 6 field experiments (FIRE-I, FIRE-II, SHEBA, ARM, TRMM, CRYSTAL) have been discretized in order to be used with the Ping Yang single particle and single scattering optical properties database. Sensitivity studies on TOA infrared radiances have been performed by changing the main cloud PSDsâ€™ parameters. Results shown that the particles, which in the SD mainly contribute to the total mass, are the same that drive the infrared optical properties. Nevertheless, when the effective dimension of the PSD is larger than a certain value (i.e., 100 microns), the optical depths produced by two different PSDs show very similar features along the infrared spectrum. In presence of these PSDs an infrared retrieval of microphysical properties seems to be extremely difficult. The far infrared (100-550 cm-1) appears to be helpful in this process.\r\n\r\n2)	Still working at a new fast code for retrieving cloud optical depths. \r\n\r\n3)	Working with Robert Holtz on sensitivity studies concerning inversion lines of water vapor and methane on convective clouds.\r\n','Tiziano Maestri\'s Monthly report',0,'','publish','open','closed','','tiziano-maestris-monthly-report','','','2006-03-08 11:36:27','2006-03-08 16:36:27','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/03/08/tiziano-maestris-monthly-report/',0),(125,3,'2006-03-08 14:11:08','2006-03-08 19:11:08','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=29\">Meeting Minutes</a>','Internal Group Leader Meeting Minutes - Feb. 20 2006',0,'','publish','open','closed','','internal-group-leader-meeting-minutes-feb-20-2006','','','2006-06-07 13:57:43','2006-06-07 18:57:43','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/03/08/internal-group-leader-meeting-minutes-feb-20-2006/',0),(126,7,'2006-03-08 17:45:10','2006-03-08 22:45:10','Eva Borbas (0 hour) Suzanne (12 hour).\r\n A poster was presented about the IR surface emissivty database at the AMS annual meeting  on February 1, 2006.  We had a lot of interest in the poster. On February 10, before Suzanne  began her leave of absence for the move to CA, we had a meeting to discuss our recent work on  the high spectral resolution IR emissivty database.\r\n\r\nTwo websites were created, one for the global clear sky training dataset(<a href=\"http://cimss.ssec.wisc.edu/training_data/\">http://cimss.ssec.wisc.edu/training_data/</a>)  and one for the IR surface emissivty (<a href=\"http://cimss.ssec.wisc.edu/iremis/\">http://cimss.ssec.wisc.edu/iremis/)</a>. Both pages are linked to  ITWG Radiative Transfer Working Group\'s page. We also continued working on the high spectral IR emissivity  database using PC analyses. ','February 2006 Monthly Report by Eva and Suzanne',0,'','publish','open','closed','','february-2006-monthly-report-by-eva-and-suzanne','','','2006-03-08 17:48:25','2006-03-08 22:48:25','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/03/08/february-2006-monthly-report-by-eva-and-suzanne/',0),(127,10,'2006-03-31 09:09:56','2006-03-31 14:09:56','* Held meeting to update our progress on code to simulate GIFTS TOA radiances (Mar 2)\r\n\r\n* Helped Jun Liâ€™s assistant (Chian-Yi Liu) in getting 2-layer code to work with Intel f90 compiler\r\n\r\n* Fixed additional bugs in getCloudsMM5 routine and interpolation routines. Tested single vs. double precision versions of the two-layer model code (discovered yet another problem with getCloudsMM5, related to arithmetic precision)\r\n\r\n* Gave 2-layer model test code to Ray Garcia for determining computing resources needed for processing GIFTS TOA radiances (successfully tested for pgf90 and g95 compilers). Code was executed in double precision.\r\n\r\n* Wrote sections 9.1, 9.2, and 10.2 of the ATBD\r\n\r\n* Held Mar 20 meeting of cloud subgroup. Topic of discussion was cloud detection.\r\n\r\n* Modified driver for 2-layer model code to write netcdf files\r\n\r\n','Mar 2006  Progress Report - Tom Greenwald',0,'','publish','open','closed','','mar-2006-progress-report-tom-greenwald','','','2006-04-03 09:10:47','2006-04-03 14:10:47','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/?p=127',0),(128,18,'2006-03-31 12:00:57','2006-03-31 17:00:57','Assisted Tom G. in developing a new infrastructure around the radiative transfer model that is capable of reading and writing profile data in netcdf format.  The code was also made more flexible than previous versions.\r\n\r\nAttended a conference/workshop in Boulder, CO on statistical methods used to parameterize sub-grid scale process in numerical models.\r\n\r\nWrote several abstracts and extended abstracts for presentations that will be given at the GOES-R Userâ€™s Conference in May and the WRF Userâ€™s Workshop in June.\r\n\r\nPerformed several new test simulations using the Seifert & Beheng double-moment microphysics scheme.  These tests showed that there is substantial sensitivity to how the graupel scheme is parameterized.  A new version of this scheme includes an additional microphysics species (hail) that may further improve the performance of the simulations.  I plan to test this new version this month.\r\n\r\nI also continued to attend a class in the AOS department dealing with numerical modeling.','March 2006 Progress Report - Jason Otkin',0,'','publish','open','closed','','march-2006-progress-report-jason-otkin','','','2006-03-31 12:00:57','2006-03-31 17:00:57','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/03/31/march-2006-progress-report-jason-otkin/',0),(129,10,'2006-03-31 11:28:58','2006-03-31 16:28:58','Preparer: TomG\r\n\r\nTopic of discussion was cloud detection, led by Steve Ackerman. CIMSS has a long history of developing methods for detecting clouds for many kinds of instruments, so one issue of discussion was whether to consolidate these methods. Another issue that came up was whether the topic of cloud detection should be a broad GOES-R activity.\r\n\r\nDave Tobin suggested having a conservative clear-sky product, which would ensure a cloud free FOV for profiling. He also recommended using a time continuity test.\r\n\r\nAllen Huang commented it would be good to know which hyperspectral channels are sensitive to clouds.\r\n\r\nBob Holz presented a new approach he has developed that uses only thermal hyperspectral measurements for detecting clouds. Itâ€™s based on differential absorption between on-line and off-line parts of the CO2 absorption band. Early results are encouraging, though there are problems. He has also built a testbed for testing and validating cloud detection algorithms, which is made up of an extensive collection of MODIS and AIRS matchup datasets over the ARM sites. It was also brought up that including AVHRR data in these matchups would also be good (Andy Heidinger and Mike Pavolonis will look into it).\r\n\r\nAllen Huang described a principal component analysis (PCA) approach he is using to detect clouds from AIRS-only measurements. A hyperspectral-only method is being developed because we wonâ€™t be able to rely on the ABI for subFOV cloud detection of HES measurements. Early results of the PCA method are disappointing, however, more work is needed. \r\n\r\nIt was agreed that a combination of cloud detection approaches would be best, involving the following tests:\r\n\r\n* Spectral tests (e.g., channel differences) â€“ advantage: applicable to many different instruments\r\n* Spatial tests (e.g., spatial coherence)\r\n* Temporal tests\r\n\r\nAnother important component will be to test the reliability of the detection methods using validation datasets, which will need to be collected.\r\n\r\n\r\nAction items:\r\n* Set up meeting in three weeks\r\n* Andy Heidinger â€“ AVHHR matchups with ARM sites?\r\n\r\n','Cloud sub-group meeting - 20 March 2006',0,'','publish','open','closed','','cloud-sub-group-meeting-20-march-2006','','','2006-03-31 11:28:58','2006-03-31 16:28:58','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/03/31/cloud-sub-group-meeting-20-march-2006/',0),(130,15,'2006-03-31 09:35:17','2006-03-31 14:35:17','Monthly report: March 2006\r\n\r\nTiziano Maestri\r\n\r\nA new fast code for retrieving cloud optical depths and cloud microphysical properties in the infrared part of the spectrum has been assembled. The code is based on a doubling and adding algorithm and has been interfaced with lblrtm which computes the clear sky optical depths. Retrieved cloud optical depths are compared with a pre-computed optical depths database and an estimation of effective diameter is then given. The optical depthsâ€™ database has been obtained using a set of measured particles size distribution (from 6 field experiments) and the Ping Yang single scattering and single particle optical properties\r\n','Tiziano Maestri - March Monthly Report',0,'','publish','open','closed','','tiziano-maestri-march-monthly-report','','','2006-03-31 09:35:17','2006-03-31 14:35:17','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/03/31/tiziano-maestri-march-monthly-report/',0),(131,18,'2006-04-18 16:21:32','2006-04-18 21:21:32','GOES-R3 Progress Report for January â€“ March 2006\r\n\r\nProject Title:  GOES-R3 NWP Model\r\nAuthor:  Jason Otkin\r\n\r\nUsed the WRF model (ARW core) to generate a simulated atmospheric profile dataset for a case study referred to as the â€œOCEAN-WINDSâ€ simulation.  This simulation contains a single 1070 x 1070 grid point domain with 2-km horizontal resolution that covers the eastern U.S. and a portion of the western Atlantic.  A simulated dataset with 30-minute temporal resolution and 4-km horizontal resolution (a coarsened version of the original model data) was generated for a 24-hour period during this simulation.  A webpage containing a brief description of the WRF model simulation and gif images of various atmospheric fields has been constructed for this case study.  The webpage address is:\r\nhttp://www.ssec.wisc.edu/~jasono/goes-r-awg/oceanwinds/index.html .\r\n\r\nSubmitted a journal article entitled â€œMesoscale numerical weather prediction models used in support of infrared hyperspectral measurements simulation and product algorithm developmentâ€ to the Journal of Atmospheric and Oceanic Technology.  The article describes how sophisticated mesoscale models, such as the MM5 and WRF, have been used to generate simulated atmospheric profile datasets with fine horizontal and vertical resolution.  Model results from two prior case study simulations were presented.  Representative examples illustrating the use of the simulated datasets, such as the generation of simulated TOA radiances, temperature and water vapor profiles, and atmospheric motion vectors were also included.  The case study results demonstrated that the MM5 and WRF models are able to realistically simulate mesoscale cloud, temperature, and water vapor structures present in the real atmosphere.  The realism of the simulated datasets indicates that TOA radiances derived from numerical model output can serve as an effective alternative for real radiances observed by infrared sensors.\r\n\r\nIn an effort to better parameterize cloud microphysical processes in the WRF model, a recently developed double-moment microphysics scheme has been evaluated for use in future model simulations.  This scheme, referred to as the Seifert and Beheng scheme, explicitly predicts the mixing ratios and total number concentrations for five microphysical species, including cloud water, rain water, cloud ice, snow, and rimed snow (graupel).  Although substantial differences exist between the Seifert and Beheng scheme and the single-moment schemes that we have used for prior simulations, preliminary results are encouraging.  A newer version of this scheme includes an additional microphysics species (hail) that may further improve the performance of the simulation.  Test simulations using this new version will be performed during the next few months.\r\n\r\nUsed the WRF model (ARW core) to generate a simulated atmospheric profile dataset for a case study referred to as the â€œNP-CONVECTIONâ€ simulation.  This simulation contains a single 1070 x 1070 grid point domain with 2-km horizontal resolution that covers most of the central and eastern U.S.  A simulated dataset with 30-minute temporal resolution and 4-km horizontal resolution (a coarsened version of the original model data) was generated for a 24-hour period during this simulation.  A webpage containing a brief description of the WRF model simulation and gif images of various atmospheric fields has been constructed for this case study.  The webpage address is:\r\nhttp://www.ssec.wisc.edu/~jasono/goes-r-awg/np_convection/index.html .\r\n\r\nI began to explore two different data assimilation utilities that have been developed for the WRF model.  Both utilities are still early in their development and as such are not currently able to assimilate satellite radiances.  The first utility, which is known as WRF-VAR, is a 3-dimensional variational assimilation scheme developed by NCAR.  I am able to successfully compile this utility.  Attempts to use this utility, however, have failed due to numerous problems associated with the supplied scripts used to run it.  The second utility, known as WRF-DART, was developed as part of the Data Assimilation Research Testbed.  The utility uses an Ensemble Kalman filter approach to assimilate observations.  Due to the four dimensional nature of this utility, it is very expensive to use.\r\n\r\nThe NCEP version of the WRF model (known as the NMM core) was released last November. Several test simulations using the NMM core were performed for a severe thunderstorm event.  The model simulations failed due to errors associated with the radiation parameterization schemes.  These errors appear to be specific to the SGI Altix.  I informed the WRF-NMM developers about this problem in January but have not heard back from them yet.  We will not be able to use the WRF-NMM model until this problem is fixed.','2006 Q1 Report - NWP',0,'','publish','open','closed','','2006-q1-report-nwp','','','2006-04-18 16:23:18','2006-04-18 21:23:18','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/04/18/2006-q1-report-nwp/',0),(132,10,'2006-03-31 08:33:47','2006-03-31 13:33:47','Â·	Ping Yang completed new reflection/transmission lookup databases for FIRTM2 that are based on Bryan Baumâ€™s bulk scattering models\r\nÂ·	Tom Greenwald wrote tangent linear for FIRTM2 and performed initial testing.\r\nÂ·	Leslie Moy completed forward, tangent linear and adjoint models for FPLOD (written in F95) and submitted them to our code repository.\r\nÂ·	Tom Greenwald made further significant improvements to FIRTM2 code \r\nÂ·	Version 1 of the complete GIFTS cloudy sky forward model (written in F95) was officially released\r\nÂ·	Provided forward model code to sounding group (Jun Li) for testing purposes and helped them get code to work\r\nÂ·	Submitted drafts of sections 9.1, 9.2 and 10.2 of the ATBD\r\nÂ·	Tom Greenwald wrote a driver for the GIFTS cloudy sky forward model that directly reads a WRF output netcdf file, computes a TOA radiance spectrum at each grid point in the model domain and then writes out the radiances to a netcdf file. This code was used by Ray Garcia to determine computing resources needed for processing TOA radiances and will eventually replace the F77 version of the code that is currently used.\r\n','2006 Q1 Report - Forward Modeling',0,'','publish','open','closed','','2006-q1-report-forward-modeling','','','2006-03-31 08:33:47','2006-03-31 13:33:47','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/03/31/2006-q1-report-forward-modeling/',0),(133,15,'2006-05-01 09:26:33','2006-05-01 14:26:33','Monthly report: April 2006\r\n\r\nTiziano Maestri\r\n\r\nThe first application of RT-RET (a new cloud properties retrieval code) to measured data has been performed. The field experiment considered is MPACE 2004, in the north of Alaska. In order to obtain consistent comparison among the infrared hyper-spectral sensors involved in the experiment the RT-RET code has been built up very flexible and capable to work with AIRS, S-HIS and AERI data. \r\nThe latter ground base sensor, AERI, has been particularly useful in the validation process since its FOVs were coincident with those of AHSRL lidar system.\r\nResults and a brief algorithm explanation have been shown during the 3rd Annual Advanced High Spectral Resolution Observation Workshop (26-28 April 2006, Madison). The general uncertainties related to those kind of retrievals have been also discussed.\r\nA copy of the oral talk can be downloaded from the web: \r\nhttp://www.ssec.wisc.edu/hsr/meetings/2006/workshop.html - presentations\r\n','April Monthly report- Tiziano Maestri',0,'','publish','open','closed','','april-monthly-report-tiziano-maestri','','','2006-05-01 09:26:33','2006-05-01 14:26:33','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/05/01/april-monthly-report-tiziano-maestri/',0),(134,7,'2006-05-04 16:50:48','2006-05-04 21:50:48','Work this month focused on 1)  developing the high spectral resolution emissivity database using principal component analysis (â€œversions B & Câ€), 2) writing a paper on the derivation of the moderate spectral resolution emissivity database (â€œversion Aâ€, baseline spectral fit to MOD11 points) and its application to AIRS and MODIS temperature and moisture retrievals.','2006 March Monthly Report - Borbas-Seemann ',0,'','publish','open','closed','','2006-march-monthly-report-borbas-seemann','','','2006-05-04 16:56:36','2006-05-04 21:56:36','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/05/04/2006-march-monthly-report-borbas-seemann/',0),(135,7,'2006-05-04 16:51:47','2006-05-04 21:51:47','We continued to work on developing the high spectral resolution emissivity database using principal component analysis (â€œversions B & Câ€) and on the paper of Version A. Eva Borbas gave a presentation with the title of â€œPCA and Surface Emissivitiesâ€ at the 3rd Annual Advanced High Spectral Resolution Infrared Observations Workshop, Madison, WI.  ','2006 April Monthly Report - Borbas-Seemann',0,'','publish','open','closed','','2006-april-monthly-reoprt-borbas-seemann','','','2006-05-04 16:52:42','2006-05-04 21:52:42','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/05/04/2006-april-monthly-reoprt-borbas-seemann/',0),(136,10,'2006-04-28 11:22:09','2006-04-28 16:22:09','* Made significant modifications to GIFTS forward code: added I/O error handling, added Leslieâ€™s â€œdfluxâ€ code, and incorporated the new ice reflection/transmission database based on the Baum scattering property models.\r\n\r\n* Continuing work on bake-off. Generated tables of Legendre expansion coefficients for the phase function needed by the SOI model. Wrote routine to interpolate tables and modified SOI model to accept the Legendre coefficients. Discovered a problem with the multi-stream version of the SOI model. Will need to investigate further. \r\n\r\n* Attended hyperspectral workshop\r\n\r\n* Worked on poster for GOES-R Users Conference\r\n\r\n','April 2006 Progress Rpt - Tom Greenwald',0,'','publish','open','closed','','april-2006-progress-rpt-tom-greenwald','','','2006-04-28 11:22:09','2006-04-28 16:22:09','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/04/28/april-2006-progress-rpt-tom-greenwald/',0),(137,3,'2006-05-08 13:27:24','2006-05-08 18:27:24','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=30\">Q1 2006 Report - Sounding</a>','Q1 2006 Report - Sounding',0,'GOES-R3 Sounding Quarterly Report\r\nAuthor: Jun Li','publish','open','closed','','q1-2006-report-sounding','','','2006-06-07 13:35:00','2006-06-07 18:35:00','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/05/08/q1-2006-report-sounding/',0),(138,3,'2006-05-08 13:35:40','2006-05-08 18:35:40','<a href=\"/rr/alg_dev/wp-content/files/file.php?up_id=31\">Q1 2006 Report - Surface Property</a>','Q1 2006 Report - Surface Property',0,'GOES-R3 Surface Property Quarterly report\r\nAuthor: Suzanne & Eva','publish','open','closed','','q1-2006-report-surface-property','','','2006-06-07 13:32:33','2006-06-07 18:32:33','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/05/08/q1-2006-report-surface-property/',0),(139,18,'2006-04-30 14:23:01','2006-04-30 19:23:01','Helped create a poster for the GOES-R Userâ€™s Conference that discusses the numerical modeling and forward modeling work that we have performed in support of GOES-R development.  I also provided numerical modeling support to several other people who will be giving presentations at this conference.\r\n\r\nWrote a flexible utility capable of generating clear-sky brightness temperatures and radiances for each of the GOES sounder and imager bands from simulated WRF-ARW data.  Water vapor and temperature profiles at each grid point, along with climatological ozone data and simulated skin temperatures, are passed through a clear-sky forward model provided by Hal Woolf.','April 2006 Monthly Report -- Jason Otkin',0,'','publish','open','closed','','april-2006-monthly-report-jason-otkin','','','2006-04-30 14:23:01','2006-04-30 19:23:01','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/04/30/april-2006-monthly-report-jason-otkin/',0),(140,3,'2006-05-30 16:59:12','2006-05-30 21:59:12','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=32\">HES Sounding ATBD</a>','HES Sounding ATBD - Working V1.0',0,'Internal Working Version 1.0','publish','open','closed','','hes-sounding-atbd-working-v10','','','2006-06-07 13:30:38','2006-06-07 18:30:38','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/05/30/hes-sounding-atbd-working-v10/',0),(141,3,'2006-05-30 17:07:36','2006-05-30 22:07:36','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=33\">AD Group Leader Meeting Minutes</a>','Group Leader Meeting Minutes - 18 April 2006',0,'','publish','open','closed','','group-leader-meeting-minutes-18-april-2006','','','2006-06-07 13:14:59','2006-06-07 18:14:59','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/05/30/group-leader-meeting-minutes-18-april-2006/',0),(142,18,'2006-05-31 10:29:09','2006-05-31 15:29:09','Attended the GOES-R Userâ€™s Conference in Broomfield, CO where I gave a poster presentation documenting the numerical modeling and forward modeling work that we have performed in support of GOES-R development.\r\n\r\nBegan revising the numerical modeling paper that I submitted to the Journal of Atmospheric and Oceanic Technology in February.  Overall, the reviewer comments concerning this paper were positive.\r\n\r\nContinued to improve my understanding of the Ensemble Kalman filter data assimilation method.  It is anticipated that this method will be used for our future data assimilation studies.','May 2006 Monthly Report -- Jason Otkin',0,'','publish','open','closed','','may-2006-monthly-report-jason-otkin','','','2006-05-31 10:29:09','2006-05-31 15:29:09','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/05/31/may-2006-monthly-report-jason-otkin/',0),(143,10,'2006-05-31 15:24:33','2006-05-31 20:24:33','* Attended GOES Usersâ€™ Conference held in Broomfield Colorado\r\n\r\n* Held second cloud detection meeting of the cloud subgroup\r\n\r\n* Reviewed Zhang et al. manuscript on a new fast IR radiative transfer model\r\n\r\n* Helped ErikO incorporate the land surface emissivity database into the F95 version of the GIFTS fast model code\r\n\r\n*  Got the F95 version of the GIFTS FM code running on zara with both the Gnu F95 and Intel F90 compilers. Discovered bug in one of routines that interpolates cloud reflectance and transmittance from the lookup table for the two-layer model\r\n','May 2006 Monthly Report - Tom Greenwald',0,'','publish','open','closed','','may-2006-monthly-report-tom-greenwald','','','2006-06-05 15:25:40','2006-06-05 20:25:40','',0,'http://cimss.ssec.wisc.edu/goes_r/internal/alg_dev/2006/06/05/may-2006-monthly-report-tom-greenwald/',0),(144,1,'2006-06-06 15:27:16','2006-06-06 20:27:16','<h2>Algorithm Development Information</h2>\r\n<ul>\r\n<li><a href=\"http://cimss.ssec.wisc.edu/goes_r/rr/task-priority/\">Task Priority</a></li>\r\n</ul>','Algorithm Development',0,'','static','open','closed','','alg_dev','','','2006-08-31 16:46:42','2006-08-31 21:46:42','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/alg_dev/',0),(148,18,'2006-06-29 17:05:33','2006-06-29 22:05:33','Finished making revisions to the journal article describing the numerical modeling infrastructure here at CIMSS.\r\n\r\nPrepared two poster presentations that I gave at the WRF Userâ€™s Workshop in Boulder.  Feedback was favorable for both posters with particular interest in the study I did comparing the behavior of several cloud microphysical schemes during a severe weather event.\r\n\r\nAttended the 2nd Annual Summer Community Meeting in Boulder.  The purpose of this meeting was to discuss the weaknesses of the numerical modeling community and how best to remedy them.  It was an interesting meeting to attend.\r\n\r\nPrepared a 45-minute presentation that I will give at the CIMSS colloquium in July.  This presentation documents the numerical modeling work that I have performed during the last year in support of various GOES-R research activities.','June 2006 Monthly Report -- Jason Otkin',0,'','publish','open','closed','','june-2006-monthly-report','','','2006-06-29 17:06:23','2006-06-29 22:06:23','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/06/29/june-2006-monthly-report/',0),(149,18,'2006-06-30 11:38:51','2006-06-30 16:38:51','GOES-R3 Progress Report for April â€“ June 2006\r\n\r\nProject Title:  GOES-R3 NWP Model\r\nAuthor:  Jason Otkin\r\n\r\n\r\nFinished the first set of revisions for the journal article entitled â€œMesoscale numerical weather prediction models used in support of infrared hyperspectral measurements simulation and product algorithm developmentâ€, which was initially submitted to the Journal of Atmospheric and Oceanic Technology in February.  Reviewer comments for this article were generally favorable.\r\n\r\nAttended the GOES-R Userâ€™s Conference in Broomfield, CO, where I gave a poster presentation documenting the numerical modeling and forward modeling work that we have performed at CIMSS in support of GOES-R research and development.  I also provided numerical modeling support to several other people who gave presentations at this conference.\r\n\r\nAttended the WRF Userâ€™s Workshop in Boulder, CO, where I gave two poster presentations describing several of the numerical modeling studies that I have performed with the WRF model.  Feedback was favorable for both posters with particular interest directed toward the study comparing the behavior of several cloud microphysics schemes during a severe weather event.\r\n\r\nAttended the 2nd Annual Summer Community Meeting in Boulder.  The purpose of this meeting was to discuss the weaknesses of the numerical modeling community and how best to remedy them.  Many aspects of numerical model development were discussed.\r\n\r\nWrote a flexible utility capable of generating clear-sky brightness temperatures and radiances for each of the current GOES sounder and imager channels using output from WRF model simulations.  WRF-simulated water vapor and temperature profiles and surface skin temperature, together with climatological ozone data, are passed through a clear-sky forward model to generate simulated GOES imagery.\r\n\r\nPrepared a 45-minute presentation that I will give at the CIMSS colloquium in July.  This presentation documents the numerical modeling work that I have performed during the last year in support of various GOES-R research activities.','2006 Q2 Report -- NWP',0,'','publish','open','closed','','2006-q2-report-nwp','','','2006-06-30 11:38:51','2006-06-30 16:38:51','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/06/30/2006-q2-report-nwp/',0),(150,10,'2006-06-30 08:41:00','2006-06-30 13:41:00','* Instructed our new employee, Rupali Mahajan, how to use the GIFTS fast model code and interpret the radiance fields produced by it\r\n\r\n* Returned to the bake-off. The code to do the RT model comparisons has been written. The only issue to be resolved is matching the cloud properties used to create the radiative property databases for the 2-layer model with the cloud properties input into the SOI model. A graduate student of Ping Yangâ€™s, Zhibo Zhang, has offered to help by providing a case and reference RT radiance calculations  \r\n','June 2006 Monthly Report - Tom Greenwald',0,'','publish','open','closed','','june-2006-monthly-report-tom-greenwald','','','2006-06-30 08:41:00','2006-06-30 13:41:00','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/06/30/june-2006-monthly-report-tom-greenwald/',0),(151,10,'2006-06-30 14:32:08','2006-06-30 19:32:08','Prepared by Tom Greenwald\r\n\r\n\r\nÂ· Significant modifications were made to the F90 version of the GIFTS fast model code:\r\n\r\n   - Improved reflection of downwelling radiance by the surface under clear skies\r\n   - Incorporated new ice cloud radiative properties into the two-layer model, which are based on the latest ice scattering property databases developed by Baum et al. \r\n  - Incorporated land surface emissivity database and associated interpolation code \r\n\r\nÂ· GIFTS fast model code was executed successfully on our new cluster zara (38 dual core nodes) using both the gnu 95 and Intel f90 compilers.\r\n\r\nÂ· Attended GOES-R Userâ€™s Conference in Broomfield, CO. Presented a poster that summarized our forward modeling capabilities in support of GOES-R measurement simulations.\r\n\r\n\r\n   \r\n\r\n','2006 Q2 Report - Cloudy FM',0,'','publish','closed','closed','','2006-q2-report-cloudy-fm','','','2006-07-17 14:32:45','2006-07-17 19:32:45','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/17/2006-q2-report-cloudy-fm/',0),(152,3,'2006-07-24 16:39:33','2006-07-24 21:39:33','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=35\">Q2_2006 Report - Sounding</a>','Q2 2006 Report - Sounding',0,'2nd Quarterly report  - Sounding Alog.','publish','closed','closed','','q2-2006-report-sounding','','','2006-07-24 16:39:33','2006-07-24 21:39:33','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/24/q2-2006-report-sounding/',0),(153,3,'2006-07-24 16:41:52','2006-07-24 21:41:52','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=36\">Q2_2006 Report - Composition</a>','Q2 2006 Report - Composition',0,'2nd Quarterly report - Composition','publish','closed','closed','','q2-2006-report-composition','','','2006-07-24 16:41:52','2006-07-24 21:41:52','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/24/q2-2006-report-composition/',0),(154,3,'2006-07-24 16:43:10','2006-07-24 21:43:10','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=37\">Q2_2006 Report - Surface Property</a>','Q2 2006 Report - Surface Property',0,'2nd Quarterly Report - Surface Property','publish','closed','closed','','q2-2006-report-surface-property','','','2006-07-24 16:43:10','2006-07-24 21:43:10','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/24/q2-2006-report-surface-property/',0),(155,3,'2006-07-24 16:47:31','2006-07-24 21:47:31','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=38\">Q2_2006 Report - FM</a>','Q2 2006 Report - FM',0,'2nd Quarterly Report - Forward Model','publish','closed','closed','','q2-2006-report-fm','','','2006-07-24 16:47:31','2006-07-24 21:47:31','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/24/q2-2006-report-fm/',0),(156,3,'2006-07-24 16:53:37','2006-07-24 21:53:37','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=39\">Group Leader Meeting Minutes - 30 May 2006</a>','Group Leader Meeting Minutes - 30 May 2006',0,'R3 AD Group Leader Meeting Minutes','publish','closed','closed','','group-leader-meeting-minutes-30-may-2006','','','2006-07-24 16:53:37','2006-07-24 21:53:37','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/24/group-leader-meeting-minutes-30-may-2006/',0),(157,3,'2006-07-26 18:46:13','2006-07-26 23:46:13','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=40\">STAR-DB_ATBD</a>','STAR/NESDIS ATBD DG',0,'ATBD Documentation Guidelines','publish','closed','closed','','starnesdis-atbd-dg','','','2006-07-26 18:46:13','2006-07-26 23:46:13','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/26/starnesdis-atbd-dg/',0),(158,3,'2006-07-26 18:49:45','2006-07-26 23:49:45','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=41\">STAR-DB_MDD</a>','STAR/NESDIS MDD DG',0,'Metadata Documentation Guidelines','publish','closed','closed','','starnesdis-mdd-dg','','','2006-07-26 18:49:45','2006-07-26 23:49:45','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/26/starnesdis-mdd-dg/',0),(159,3,'2006-07-26 18:51:00','2006-07-26 23:51:00','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=42\">STAR-DB_ICD</a>','STAR/NESDIS ICD DG',0,'Interface Control Documentation Guidelines','publish','closed','closed','','starnesdis-icd-dg','','','2006-07-26 18:51:00','2006-07-26 23:51:00','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/26/starnesdis-icd-dg/',0),(160,3,'2006-07-26 18:52:12','2006-07-26 23:52:12','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=43\">STAR-DB_SDD</a>','STAR/NESDIS SDD DG',0,'System Description Documentation Guidelines','publish','closed','closed','','starnesdis-sdd-dg','','','2006-07-26 18:52:12','2006-07-26 23:52:12','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/26/starnesdis-sdd-dg/',0),(161,3,'2006-07-26 18:53:13','2006-07-26 23:53:13','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=44\">STAR-DB_OM</a>','STAR/NESDIS OM DG',0,'Operations Manual Documentation Guidelines','publish','closed','closed','','starnesdis-om-dg','','','2006-07-26 18:53:13','2006-07-26 23:53:13','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/26/starnesdis-om-dg/',0),(162,3,'2006-07-26 18:54:14','2006-07-26 23:54:14','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=45\">STAR-DB_UM</a>','STAR/NESDIS UM DG',0,'Users Manual Documentation Guidelines','publish','closed','closed','','starnesdis-um-dg','','','2006-07-26 18:54:14','2006-07-26 23:54:14','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/26/starnesdis-um-dg/',0),(163,3,'2006-07-26 18:56:04','2006-07-26 23:56:04','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=46\">STAR-WI_Fortran-PS</a>','STAR/NESDIS WI Fortran',0,'Fortran Programming & Standards Guidelines Documentation','publish','closed','closed','','starnesdis-wi-fortran','','','2006-07-26 18:56:04','2006-07-26 23:56:04','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/26/starnesdis-wi-fortran/',0),(164,3,'2006-07-26 18:57:21','2006-07-26 23:57:21','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=47\">STAR-WI_C-PS</a>','STAR/NESDIS WI C',0,'C Programming & Standards Guidelines Documentation','publish','closed','closed','','starnesdis-wi-c','','','2006-07-26 18:57:21','2006-07-26 23:57:21','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/26/starnesdis-wi-c/',0),(165,18,'2006-08-07 11:05:37','2006-08-07 16:05:37','Attended the 12th Conference on Atmospheric Radiation and the 12th Conference on Cloud Physics held in Madison.\r\n\r\nThe journal article entitled â€œMesoscale Numerical Weather Prediction Models Used in Support of Infrared Hyperspectral Measurements Simulation and Product Algorithm Developmentâ€ was accepted for publication in the Journal of Atmospheric and Oceanic Technology.\r\n\r\nIn order to test the ability of the WRF model to generate realistic cloud features at very high resolutions, several simulations using different combinations of parameterization schemes were performed for a region surrounding the SGP ARM site.  These simulations employed a quadruple-nested domain configuration with 100-m resolution on the innermost domain.  Preliminary results indicate that the WRF model is capable of producing realistic cloud-scale features at this very high resolution and that it can be used to produce realistic simulated atmospheric profile datasets at sub 1-km resolution.\r\n\r\nI attempted to run the WRF-NMM model again.  Sensitivity tests that I performed recently have shown that there are actually several distinct problems with the NMM core that will need to be addressed before it will work correctly.  My discussions with the WRF-NMM developers have indicated that these problems are only occurring on the SGI Altix platform.  The developers are unsure when or how the problems can be fixed.','July 2006 Monthly Report â€” Jason Otkin',0,'','publish','closed','closed','','july-2006-monthly-report-%e2%80%94-jason-otkin','','','2006-08-07 11:05:37','2006-08-07 16:05:37','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/08/07/july-2006-monthly-report-%e2%80%94-jason-otkin/',0),(166,1,'2006-08-31 16:42:13','2006-08-31 21:42:13','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=48\">GOES-R Risk Reduction Plan (PDF)</a>','GOES-R Risk Reduction Plan',0,'','static','closed','closed','','goes-r-risk-reduction-plan','','','2006-08-31 16:54:59','2006-08-31 21:54:59','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/goes-r-risk-reduction-plan/',0),(169,1,'2006-08-31 17:01:34','2006-08-31 22:01:34','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=50\">Proposed Activies for 2007 (MS Powerpoint)</a>','Proposed 2007 Activies',0,'','static','closed','closed','','proposed-2007-activies','','','2006-08-31 17:01:34','2006-08-31 22:01:34','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/proposed-2007-activies/',0),(168,1,'2006-08-31 16:57:42','2006-08-31 21:57:42','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=49\">Major accomplishments in 2006 (MS Word)</a>','Major accomplishments in 2006',0,'','static','closed','closed','','major-accomplishments-2006','','','2006-08-31 16:59:23','2006-08-31 21:59:23','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/major-accomplishments-2006/',0),(170,1,'2006-08-31 17:22:37','2006-08-31 22:22:37','<a href=\"/goes_r/rr/wp-content/files/file.php?up_id=51\">GOES-R Risk Reduction CIMSS Activities (PDF)</a>','GOES-R Risk Reduction Activities',0,'','static','closed','closed','','goes-r-risk-reduction-activities','','','2006-08-31 17:22:37','2006-08-31 22:22:37','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/goes-r-risk-reduction-activities/',0),(171,10,'2006-07-31 14:54:57','2006-07-31 19:54:57','* Successfully compared calculations of TOA brightness temperatures (800-1300 cm-1) from 36-stream DISORT and 32-stream SOI model for a test case of a thin and a thick single-layer ice cloud at 12 km. Results showed the SOI model was within about 0.05 K with DISORT across the spectrum and demonstrated the SOI model may be used for reference calculations. The earlier trouble with the comparisons (SOI vs. 2-layer model) was that I had used a Henyey-Greenstein phase function in the SOI model and not the expansion coefficients generated from the full phase functions. It was the full phase functions that were used to compute the reflection/transmission tables for the 2-layer model.  \r\n\r\n* Wrote slant path version of SOI model to allow testing of the 2-layer model for zenith angles other than 0 degrees and modified SOI code to use generalized phase function expansion coefficients.\r\n\r\n* Attended the 12th Conference on Atmospheric Radiation and 12th Conference on Cloud Physics held jointly in Madison.\r\n\r\n','July 2006 Monthly Report - Tom G.',0,'','publish','closed','closed','','july-2006-monthly-report-tom-g','','','2006-09-05 14:58:34','2006-09-05 19:58:34','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/07/31/july-2006-monthly-report-tom-g/',0),(172,10,'2006-08-31 14:55:47','2006-08-31 19:55:47','* Performed our first extensive evaluation of the 2-layer model using WRF-generated cloud profiles and the 32-stream SOI model as a reference. The analysis involved 1440 profiles. At nadir, the bias errors were less than 0.5 K across the spectrum and the RMSEs were under 1.5 K. For clouds with visible optical depths less than 10, errors were found to increase for larger zenith angles (i.e., 55 degrees) with bias errors increasing to less than 1 K (RMSE < 2 K).   \r\n\r\n* Discovered that calculation of the reflection/transmission properties of cloud layers within the SOI model occasionally produced numerical over- or underflow exceptions. These numerical instabilities were traced to erroneous layer gas optical depths produced by PLOD. PLOD is used not only to provide the optical depths along the observation angle but also at the 16 quadrature points used in the 32-stream model. In some situations PLOD produced optical depths at the observation angle inconsistent with the optical depths at the quadrature points (this mainly occurred when the observation angle was 0 degrees). It appears that the erroneous optical depths are related to the switchover from one regression equation to another in the formulation of PLOD. An ad hoc fix is currently in place to correct for this problem. However, there is a need to investigate this further and find a better solution.\r\n\r\n* Worked with Jason Otkin to find ways of evaluating the cloud fields simulated by the WRF model and validating the simulated radiance fields. Our first idea is to assess the simulated cloud fields using the ISCCP cloud classification (based on cloud top pressure and visible optical depth) and to compare these fields to those observed from satellites. A case study was selected for a spring storm that occurred over the North Atlantic in 2005. Ultimately the plan is to use SEVIRI data as the source of satellite data; however, as a quick test of this idea I acquired MODIS data from Terra and Aqua. \r\n','August 2006 Monthly Report - Tom G.',0,'','publish','closed','closed','','august-2006-monthly-report-tom-g','','','2006-09-05 14:58:53','2006-09-05 19:58:53','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/08/31/august-2006-monthly-report-tom-g/',0),(173,18,'2006-08-31 09:28:12','2006-08-31 14:28:12','I gave a presentation as part of the CIMSS colloquium series in which I described the numerical modeling work that I have performed in support of various GOES-R research activities.\r\n\r\nI successfully ran the WRF-NMM model for the first time.  Gerardo Cisneros of SGI helped me determine the source of the problem that had prevented me from using the WRF-NMM model earlier this year.  The important thing to note here is that we now have the capability to run both versions of the WRF model.\r\n\r\nTom Greenwald and I have started a new model validation study in which we plan to compare various simulated cloud properties, such as cloud optical depth and cloud top pressure, to MODIS and SEVIRI satellite data.  The initial goal of this work is to conduct sensitivity simulations containing different combinations of PBL and microphysics parameterization schemes in order to identify which schemes most realistically simulate the cloud features associated with an extratropical cyclone that occurred over the North Atlantic.\r\n\r\nI performed several high-resolution (100-m) simulations of low-level cumulus clouds over the SGP ARM site.  Preliminary results indicate that the WRF model is able to produce realistic cloud structures at this very fine resolution.  Results also indicate that the Seifert and Beheng double moment microphysics performed best for this case.\r\n\r\nAs part of the model validation and cumulus studies, I wrote several programs that can be used to examine various properties of the WRF-simulated cloud fields.\r\n\r\nSome additional headway was made in developing the infrastructure to perform data assimilation studies with the Ensemble Kalman Filter.','August 2006 Monthly Report -- Jason Otkin',0,'','publish','closed','closed','','august-2006-monthly-report-jason-otkin','','','2006-09-11 09:28:58','2006-09-11 14:28:58','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/09/11/august-2006-monthly-report-jason-otkin/',0),(174,10,'2006-09-27 11:43:14','2006-09-27 16:43:14','*Produced netcdf files for selected MODIS Level 2 cloud products from Terra and Aqua for the validation work Jason and I are doing for the North Atlantic simulation. Also acquired AIRS Level 1B data for the same case.\r\n\r\n*Continued work on error analysis for FIRTM2. Code was written for the purpose of investigating what TOA radiance errors are introduced by the assumptions used in FIRTM2 for collapsing a multi-layer cloud system into a 2-layer cloud system. The reference radiance calculations used to evaluate FIRTM2 will be based on a 32-stream version of the SOI model. Plans are to use the North Atlantic simulation as a source of the atmospheric/cloud profiles.  \r\n\r\n','Sept 2006 Monthly Rpt - Tom Greenwald',0,'','publish','closed','closed','','sept-2006-monthly-rpt-tom-greenwald','','','2006-09-27 11:43:14','2006-09-27 16:43:14','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/09/27/sept-2006-monthly-rpt-tom-greenwald/',0),(175,18,'2006-09-29 08:43:21','2006-09-29 13:43:21','I continued to work on the model validation study that Tom Greenwald and I started last month.  Several WRF model simulations using different combinations of microphysics and planetary boundary layer schemes have been performed for an intense extratropical cyclone that developed over the northern Atlantic Ocean.  Cloud data from each of these simulations will be compared with MODIS-derived cloud information in order to assess the ability of the various parameterization schemes to realistically simulate the observed cloud features.  In support of this project, I have written several programs that will be used to evaluate the model and satellite data.\r\n\r\nI performed two additional high-resolution WRF model simulations of low-level cumulus clouds over the southern U. S. using single- and double-moment microphysics schemes.  Surprisingly large differences occurred in the overall cloud structure for each simulation.  The simulated cloud data will need to be examined in greater detail in order to determine which scheme performed better for this case.','September 2006 Monthly Report -- Jason Otkin',0,'','publish','closed','closed','','september-2006-monthly-report-jason-otkin','','','2006-09-29 08:43:21','2006-09-29 13:43:21','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/09/29/september-2006-monthly-report-jason-otkin/',0),(176,18,'2006-09-29 08:46:35','2006-09-29 13:46:35','GOES-R3 Progress Report for July â€“ September 2006\r\n\r\nProject Title:  GOES-R3 NWP Model\r\nAuthor:  Jason Otkin\r\n\r\n\r\nThe journal article entitled â€œMesoscale Numerical Weather Prediction Models Used in Support of Infrared Hyperspectral Measurements Simulation and Product Algorithm Developmentâ€ by Otkin et al. was accepted for publication in the Journal of Atmospheric and Oceanic Technology.\r\n\r\nI gave a presentation as part of the CIMSS colloquium series in which I described the numerical modeling work that has been performed during the last year in support of various GOES-R research activities.\r\n\r\nA new model validation study was started in which we plan to evaluate the ability of the WRF model to realistically simulate cloud properties, such as cloud top pressure and optical depth.  Several WRF model simulations using different combinations of microphysics and planetary boundary layer schemes have been performed for an intense extratropical cyclone that developed over the northern Atlantic Ocean.  Cloud data from each of these simulations will be compared to MODIS-derived cloud information in order to assess the ability of the various parameterization schemes to realistically simulate the observed cloud features.\r\n\r\nI successfully ran the WRF-NMM model for the first time.  This model is also known as the NCEP version of WRF.  Gerardo Cisneros of SGI helped me determine the source of the problem that had prevented me from using the model earlier this year.  The important thing to note is that we now have the capability to run both the NCAR (ARW) and NCEP (NMM) versions of the WRF model.\r\n\r\nIn order to test the ability of the WRF model to generate realistic cloud features at very high resolutions, several simulations using different combinations of parameterization schemes were performed for a region surrounding the SGP ARM site.  These simulations employed a quadruple-nested domain configuration with 100-m resolution on the innermost domain.  Preliminary results indicate that the WRF model is capable of producing realistic cloud-scale features at this very high resolution and that it can be used to produce realistic simulated atmospheric profile datasets at sub 1-km resolution.\r\n\r\nI attended the 12th Conference on Atmospheric Radiation and the 12th Conference on Cloud Physics held in Madison, WI.\r\n\r\nI began to develop the infrastructure to perform data assimilation studies with the Ensemble Kalman Filter.','2006 Q3 Report -- NWP',0,'','publish','closed','closed','','2006-q3-report-nwp','','','2006-09-29 08:47:44','2006-09-29 13:47:44','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/09/29/2006-q3-report-nwp/',0),(177,18,'2006-10-31 09:51:06','2006-10-31 14:51:06','I continued to work on the model validation study that Tom Greenwald and I started a couple months ago.  Several WRF model simulations using different combinations of microphysics and planetary boundary layer schemes have been performed for an intense extratropical cyclone that developed over the northern Atlantic Ocean.  Cloud data from each of these simulations will be compared with MODIS-derived cloud information in order to assess the ability of the various parameterization schemes to realistically simulate the observed cloud features.  Preliminary results indicate that the various microphysics parameterization schemes performed reasonably well but tended to overestimate the cloud microphysical content and, therefore, the cloud optical thickness.  It is also evident that the planetary boundary layer scheme has a substantial impact on the simulated cloud structure at all levels of the atmosphere.','October 2006 Monthly Report -- Jason Otkin',0,'','publish','closed','closed','','october-2006-monthly-report-jason-otkin','','','2006-10-31 09:51:06','2006-10-31 14:51:06','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2006/10/31/october-2006-monthly-report-jason-otkin/',0),(178,3,'2007-01-25 15:49:42','2007-01-25 20:49:42','','GOES-R3 Internal Meeting',0,'Tuesday 30 Jan. 2007 - 11 am, room 351','publish','closed','closed','','goes-r3-internal-meeting','','','2007-01-25 15:49:42','2007-01-25 20:49:42','',0,'http://cimss.ssec.wisc.edu/goes_r/rr/2007/01/25/goes-r3-internal-meeting/',0);
/*!40000 ALTER TABLE `wp_posts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_uploadplus`
--

DROP TABLE IF EXISTS `wp_uploadplus`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `wp_uploadplus` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) default NULL,
  `filename` varchar(255) default NULL,
  `description` varchar(255) default NULL,
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `checkedout` varchar(20) default NULL,
  `v2` varchar(255) default NULL,
  `v3` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=52 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `wp_uploadplus`
--

LOCK TABLES `wp_uploadplus` WRITE;
/*!40000 ALTER TABLE `wp_uploadplus` DISABLE KEYS */;
INSERT INTO `wp_uploadplus` VALUES (4,'GOES-R3 Rtv Strategy - Draft','HES_Retrieval_Strategy_Flow_Chart.ppt','Processing Flow Chart','2005-12-14 15:36:45','2005-12-14 15:36:45','',NULL,NULL),(5,'Wind Progress','Atrec1.ppt','Win Examples','2005-12-19 12:05:08','2005-12-19 12:05:08','',NULL,NULL),(6,'Sounding Progress','GOES-R3_sounding_19Dec2005Rpt.ppt','Progress as of 19 Dec. 2005','2005-12-19 12:12:42','2005-12-19 12:12:42','',NULL,NULL),(7,'IR Surface Emis Modeling','emissivity_meeting_16dec05.ppt','Progress as of Dec 2005','2005-12-19 12:26:17','2005-12-19 12:26:17','',NULL,NULL),(9,'19 Dec 2005 Meeting Agenda','GOESR3_ADMeeting-19Dec-2005.doc','Agenda','2005-12-19 12:45:17','2005-12-19 12:45:17','',NULL,NULL),(10,'Forward Model Status','Status_of_Forward_Models2.ppt','Progress So far - Dec 2005','2005-12-19 15:15:52','2005-12-19 15:15:52','',NULL,NULL),(11,'Q4-2005-FMReport','GOESR_fwd-modeling_QR4_2005.doc','Forward Model Group 2005 4th Quarterly report','2006-01-19 16:19:53','2006-01-19 16:19:53','',NULL,NULL),(12,'Surface Emissivity Modeling report','goes_r_quarterly_seemann_borbas_surface_13jan06.doc','2005 4th Quarterly Report','2006-01-19 16:21:45','2006-01-19 16:26:16','allenh',NULL,NULL),(13,'Internal Meeting Minutes','GOESR3_InternalMeeting-Dec19-2005-Minutes.doc','Meeting held at Dec19-2005','2006-01-19 17:13:13','2006-01-19 17:13:13','',NULL,NULL),(14,'Wind 2005 Q4 Report','GOES-RRR_QRPT_Jan06_Winds_Velden.doc','Wind Quarterly progress report','2006-01-20 15:09:58','2006-01-20 15:09:58','',NULL,NULL),(15,'Sounding ATBD - Table of Contents','ATBD010706.doc','Initial Draft of Table of Contents','2006-01-20 16:11:29','2006-01-20 16:11:29','',NULL,NULL),(16,'Initial Draft of PPT Version of Sounding ATBD','HES_ATBD_Draft-7Jan06.ppt','Power Point Version of HES Sounding ATBD','2006-01-20 16:15:04','2006-01-20 16:15:04','',NULL,NULL),(17,'2005 Q4 Report - Sounding','Rpt_Dec2005_sounding.doc','2005 4thQ Quarterly Sounding report','2006-01-20 16:21:14','2006-01-20 16:21:14','',NULL,NULL),(18,'2005 Q1 SOW - Wind Group','GOESR_SOW_2006_QR1_WindTeam.doc','Wind Team collective SOW','2006-01-20 16:50:37','2006-01-20 16:50:37','',NULL,NULL),(19,'2006 Q1 SOW - LeslieM','GOESR_SOW_2006_QR1_LeslieM.doc','LM&#039;s 2006 Q1 SOW','2006-01-20 16:51:48','2006-01-20 16:51:48','',NULL,NULL),(20,'2006 Q1 SOW - SteveA','GOESR_SOW_2006_QR1_SteveA.doc','SteveA&#039;s 2006 Q1 SOW','2006-01-20 16:52:41','2006-01-20 16:53:21','',NULL,NULL),(21,'2006 Q1 SOW - SteveA','GOESR_SOW_2006_QR1_SteveA.doc','SteveA&#039;s 2006 Q1 SOW','2006-01-20 16:53:37','2006-01-20 16:54:25','allenh',NULL,NULL),(22,'2006 Q1 SOW - TomG','GOESR_SOW_2006_QR1_tomg.doc','TomG&#039;s 2006 Q1 SOW','2006-01-20 16:55:10','2006-01-20 16:55:10','',NULL,NULL),(23,'Suumary of Cloudy FM','cloudy_RT_summary.ppt','PPT file for Jan. 23 2006 meeting','2006-01-23 10:02:04','2006-01-23 10:02:04','',NULL,NULL),(24,'2005 Q4 Report - NWP','GOES-R3_NWPModeling-QR4_2005.doc','NWP Quarterly Report for Q4 2005','2006-01-23 10:11:15','2006-01-23 10:11:15','',NULL,NULL),(25,'2006 Q1 SOW -  JasonO','GOESR_SOW_2006_QR1_JOtkin.doc','SOW of Jason O','2006-01-23 10:41:02','2006-01-23 10:41:02','',NULL,NULL),(26,'Quarterly Report Template','A_Report_Template.doc','Report Template','2006-01-23 12:04:15','2006-01-23 12:04:15','',NULL,NULL),(27,'2006 Q1 SOW - ErikO','GR3_TasksERO_2006a.doc','Statement of Work','2006-01-23 12:40:16','2006-01-23 12:44:47','',NULL,NULL),(28,'Meeting Minutes','GOESR3_InternalMeeting-Jan23-2006-Minutes.doc','For 23 Jan. 2006 Monthly Meeting','2006-02-14 15:30:29','2006-02-14 15:30:29','',NULL,NULL),(29,'Meeting Minutes','GOESR3_InternalMeeting-Feb20-2006-Minutes.doc','Feb. Group Leader Meeting','2006-03-08 13:08:15','2006-03-08 13:08:15','',NULL,NULL),(30,'Q1 2006 Report - Sounding','Rpt_March2006_GOES-R3_sounding_JunLi.doc','Quarterly Report - Sounding','2006-05-08 13:22:33','2006-05-08 13:22:33','',NULL,NULL),(31,'Q1 2006 Report - Surface Property','seemann_borbas_GoesR_quarterly_april2006.doc','Progress Report','2006-05-08 13:30:48','2006-05-08 13:30:48','',NULL,NULL),(32,'HES Sounding ATBD','ATBD_052206.doc','Working Version 1.0','2006-05-30 16:57:06','2006-05-30 16:57:06','',NULL,NULL),(33,'AD Group Leader Meeting Minutes','GroupLeader-Meeting_Minutes.doc','18 April 2006 AD GL Meeting','2006-05-30 17:04:19','2006-06-06 14:36:58','',NULL,NULL),(35,'Q2_2006 Report - Sounding','Rpt_June2006_GOES-R3_sounding.doc','2nd Q of 2006 Sounding algo. Report','2006-07-24 16:35:07','2006-07-24 16:35:07','',NULL,NULL),(36,'Q2_2006 Report - Composition','Rpt_June2006_GOES-R3_composition.doc','2nd Q of 2006 Composition algo. Report','2006-07-24 16:36:08','2006-07-24 16:36:08','',NULL,NULL),(37,'Q2_2006 Report - Surface Property','seemann_borbas_GoesR_quarterly_July2006.doc','2nd Q of 2006 Sfc. Pro. Report','2006-07-24 16:37:24','2006-07-24 16:37:24','',NULL,NULL),(38,'Q2_2006 Report - FM','GOESR_fwd-modeling_QR2_2006.doc','2nd Q of 2006 Forward Model Report','2006-07-24 16:46:21','2006-07-24 16:46:21','',NULL,NULL),(39,'Group Leader Meeting Minutes - 30 May 2006','GOESR3_InternalMeeting-20060530-Minutes_ver3.doc','Group Leader Meeting Minutes - May 30, 06','2006-07-24 16:52:21','2006-07-24 16:52:21','',NULL,NULL),(40,'STAR-DB_ATBD','STAR_DG-1.1_ATBD_v1r0.doc','ATBD Documentation Guideline of STAR-NESDIS','2006-07-26 18:32:57','2006-07-26 18:32:57','',NULL,NULL),(41,'STAR-DB_MDD','STAR_DG-11.4_MDD_v1r0.doc','Metadata Documentation Guideline of STAR-NESDIS','2006-07-26 18:34:37','2006-07-26 18:34:37','',NULL,NULL),(42,'STAR-DB_ICD','STAR_DG-11.5_ICD_v1r0.doc','Interface Control Documentation Guideline of STAR-NESDIS','2006-07-26 18:35:46','2006-07-26 18:35:46','',NULL,NULL),(43,'STAR-DB_SDD','STAR_DG-11.6_SDD_v1r0.doc','System Description Documentation Guideline of STAR-NESDIS','2006-07-26 18:36:57','2006-07-26 18:36:57','',NULL,NULL),(44,'STAR-DB_OM','STAR_DG-14.2_OM_v1r0.doc','Operations Manual Documentation Guideline of STAR-NESDIS','2006-07-26 18:38:17','2006-07-26 18:38:17','',NULL,NULL),(45,'STAR-DB_UM','STAR_DG-14.4_UM_v1r0.doc','Users Manual Documentation Guideline of STAR-NESDIS','2006-07-26 18:39:12','2006-07-26 18:39:12','',NULL,NULL),(46,'STAR-WI_Fortran-PS','STAR_WI-12.1.1_v1r1.doc','Fortran Programming Standards &amp; Guidelines','2006-07-26 18:41:34','2006-07-26 18:41:34','',NULL,NULL),(47,'STAR-WI_C-PS','STAR_WI-12.1.2_v1r0.doc','C Programming Standards &amp; Guidelines Documentation Guideline of STAR-NESDIS','2006-07-26 18:43:28','2006-07-26 18:43:28','',NULL,NULL),(48,'GOES-R Risk Reduction Plan','GOES_R3_Plan_Sep05.pdf','Version 7, September 2005','2006-08-31 16:39:08','2006-08-31 16:39:08','',NULL,NULL),(49,'Major accomplishments - 2006','Major_accomplishments_2006.doc','Working draft of risk reduction accomplishments in 2006','2006-08-31 16:56:50','2006-08-31 16:56:50','',NULL,NULL),(50,'Proposed Activies for 2007','Proposed_activities_in_FY07.ppt','Powerpoint of proposed 2007 activies','2006-08-31 17:00:52','2006-08-31 17:00:52','',NULL,NULL),(51,'GOES-R Risk Reduction CIMSS Activities','GOES_2006_CIMSS.pdf','Presented to the TAC','2006-08-31 17:21:19','2006-08-31 17:21:19','',NULL,NULL);
/*!40000 ALTER TABLE `wp_uploadplus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_users`
--

DROP TABLE IF EXISTS `wp_users`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `user_login` varchar(60) NOT NULL default '',
  `user_pass` varchar(64) NOT NULL default '',
  `user_firstname` varchar(50) NOT NULL default '',
  `user_lastname` varchar(50) NOT NULL default '',
  `user_nickname` varchar(50) NOT NULL default '',
  `user_nicename` varchar(50) NOT NULL default '',
  `user_icq` int(10) unsigned NOT NULL default '0',
  `user_email` varchar(100) NOT NULL default '',
  `user_url` varchar(100) NOT NULL default '',
  `user_ip` varchar(15) NOT NULL default '',
  `user_domain` varchar(200) NOT NULL default '',
  `user_browser` varchar(200) NOT NULL default '',
  `user_registered` datetime NOT NULL default '0000-00-00 00:00:00',
  `user_level` int(2) unsigned NOT NULL default '0',
  `user_aim` varchar(50) NOT NULL default '',
  `user_msn` varchar(100) NOT NULL default '',
  `user_yim` varchar(50) NOT NULL default '',
  `user_idmode` varchar(20) NOT NULL default '',
  `user_activation_key` varchar(60) NOT NULL default '',
  `user_status` int(11) NOT NULL default '0',
  `user_description` longtext NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `user_login` (`user_login`)
) ENGINE=MyISAM AUTO_INCREMENT=38 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `wp_users`
--

LOCK TABLES `wp_users` WRITE;
/*!40000 ALTER TABLE `wp_users` DISABLE KEYS */;
INSERT INTO `wp_users` VALUES (1,'admin','c3fc84c3041358507aebd5076d59d549','','','Administrator','administrator',0,'bill.bellon@ssec.wisc.edu','','','','','2005-10-13 13:37:22',10,'','','','nickname','',0,''),(5,'stevew','fe1058834e5be864f29ffe3b44ff0398','Steve','Wanzong','stevew','stevew',0,'steve.wanzong@ssec.wisc.edu','http://','','','','2005-11-08 21:29:13',5,'','','','nickname','',0,''),(6,'bryanb','a6fa8d1c54a85dbecc211aa308e90a97','Bryan','Baum','bryanb','bryanb',0,'bryan.baum@ssec.wisc.edu','http://','','','','2005-11-09 17:15:43',5,'','','','nickname','',0,''),(3,'allenh','674c9e165c7a2cae087ee7796ceea1ae','Allen','Huang','allenh','allenh',0,'allenh@ssec.wisc.edu','http://www.ssec.wisc.edu/~allenh/','','','','2005-10-13 19:19:56',5,'','','','nickname','',0,''),(4,'toma','e9f433068a8d127a47e2880ace628552','Tom','Achtor','toma','toma',0,'tom.achtor@ssec.wisc.edu','http://www.ssec.wisc.edu/~toma/','','','','2005-11-07 21:13:13',5,'','','','nickname','',0,''),(7,'evab','8a8fb731e666ce94ca5805c7fda8532b','Eva','Borbas','evab','evab',0,'eva.borbas@ssec.wisc.edu','http://','','','','2005-11-09 17:17:29',5,'','','','namefl','',0,''),(8,'stevea','95e5cd750be70afda89c41d0a6a11af0','Steve','Ackerman','stevea','stevea',0,'steve.ackerman@ssec.wisc.edu','http://','','','','2005-11-09 17:18:09',5,'','','','nickname','',0,''),(9,'dand','d38690bf48281b7a6b4e03ce7ceaca2c','Dan','Deslover','dand','dand',0,'deslover@ssec.wisc.edu','http://','','','','2005-11-09 17:18:36',5,'','','','nickname','',0,''),(10,'tomg','c7b4d833723ad9b1b9dc802ebe3caf11','Tom','Greenwald','tomg','tomg',0,'tomg@ssec.wisc.edu','http://','','','','2005-11-09 17:19:05',5,'','','','nickname','',0,''),(11,'andrewh','3340b8d8399c7a10086afc3066ccfcbf','Andrew','Heidinger','andrewh','andrewh',0,'andrewheidinger@ssec.wisc.edu','http://','','','','2005-11-09 17:19:31',5,'','','','nickname','',0,''),(12,'jeffk','e35c5b28c7ff55ba29dc655f46bf948f','Jeff','Key','jeffk','jeffk',0,'jeffkey@ssec.wisc.edu','http://','','','','2005-11-09 17:20:46',5,'','','','nickname','',0,''),(13,'jimk','a716003f33bc1264b0452bad6405cdfd','Jim','Kossin','jimk','jimk',0,'jimkossin@ssec.wisc.edu','http://','','','','2005-11-09 17:21:19',5,'','','','nickname','',0,''),(14,'junl','7d4e5480499d1760dd775be6872ed323','Jun','Li','junl','junl',0,'junli@ssec.wisc.edu','http://','','','','2005-11-09 17:21:50',5,'','','','nickname','',0,''),(15,'tiziano','27d27b9f3f12ed51c97fd905ea2a2850','Maestri','Tiziano','tiziano','tiziano',0,'tiziano@ssec.wisc.edu','http://','','','','2005-11-09 17:22:35',5,'','','','nickname','',0,''),(16,'lesliem','5a7383a49b098b37f14d2c11bb9f499c','Leslie','Moy','lesliem','lesliem',0,'lesliem@ssec.wisc.edu','http://','','','','2005-11-09 17:23:05',5,'','','','nickname','',0,''),(17,'eriko','68237e77e81b49c0fec8bba428e40247','Erik','Olson','eriko','eriko',0,'eriko@ssec.wisc.edu','http://','','','','2005-11-09 17:23:38',5,'','','','nickname','',0,''),(18,'jasono','be84bdb4099c855dc63e0d09f511471c','Jason','Otkin','jasono','jasono',0,'jasono@ssec.wisc.edu','http://','','','','2005-11-09 17:24:09',5,'','','','nickname','',0,''),(19,'mpav','e5af90773336ee43829cc1256bdd4190','Mike','Pavolonis','mpav','mpav',0,'mpav@ssec.wisc.edu','http://','','','','2005-11-09 17:24:42',5,'','','','nickname','',0,''),(20,'hankr','d69c24200fefbb0499fd6c23683f51c2','Hank','Revercomb','hankr','hankr',0,'hankr@ssec.wisc.edu','http://','','','','2005-11-09 17:25:24',5,'','','','nickname','',0,''),(21,'tims','d4cae8f0d6a460a0289a5198d6b05cbc','Tim','Schmit','tims','tims',0,'tims@ssec.wisc.edu','http://','','','','2005-11-09 17:26:05',5,'','','','nickname','',0,''),(22,'swetzel','58baaecbe0dce9892895c480f4872924','Suzanne','Seemann','swetzel','swetzel',0,'swetzel@ssec.wisc.edu','http://','','','','2005-11-09 17:26:41',5,'','','','nickname','',0,''),(23,'bills','255b732406032f6210ac194513bfb0c3','Bill','Smith','bills','bills',0,'bill.l.smith@cox.net','http://','','','','2005-11-09 17:27:22',5,'','','','nickname','',0,''),(24,'tobin','9a5a24001de064bf8dc330bb338e1ce3','Dave','Tobin','tobin','tobin',0,'davetobin@ssec.wisc.edu','http://','','','','2005-11-09 17:28:31',5,'','','','nickname','',0,''),(25,'dturner','ec104acd1dbdba5af09ed933814563f0','Dave','Turner','dturner','dturner',0,'daveturner@ssec.wisc.edu','http://','','','','2005-11-09 17:29:05',5,'','','','nickname','',0,''),(26,'chrisv','22e6cd325e6901a74c23673c5b3d522e','Chris','Velden','chrisv','chrisv',0,'chrisv@ssec.wisc.edu','http://','','','','2005-11-09 17:29:37',5,'','','','nickname','',0,''),(27,'xuanjiw','147928d88bfc4b3bebf40a6094d8c701','Xuanji','Wang','xuanjiw','xuanjiw',0,'xuanjiw@ssec.wisc.edu','http://','','','','2005-11-09 17:30:12',5,'','','','nickname','',0,''),(28,'xuebaow','65907a01f8a8c042cc3320c50e2098f8','Xuebao','Wu','xuebaow','xuebaow',0,'xuebaow@ssec.wisc.edu','http://','','','','2005-11-09 17:30:46',5,'','','','nickname','',0,''),(29,'hongz','d67f0e6f1c52a56c265a42419520a09c','Hong','Zhang','hongz','hongz',0,'hongz@ssec.wisc.edu','http://','','','','2005-11-09 17:32:00',5,'','','','login','',0,''),(31,'bobk','fa6239d8815d4c7ba14898901bdec057','Bob','Knuteson','bobk','bobk',0,'robert.knuteson@ssec.wisc.edu','http://','','','','2006-01-23 14:46:46',5,'','','','nickname','',0,''),(30,'leannea','03122d66498a27023f4f6e18c8d18ab5','Leanne','Avila','leannea','leannea',0,'leanne.avila@ssec.wisc.edu','http://','','','','2005-12-20 17:15:24',9,'','','','nickname','',0,''),(32,'paulm','5ed3091912dacc4b9871f06b237f7e6e','Paul','Menzel','paulm','paulm',0,'paul.menzel@ssec.wisc.edu','http://','','','','2006-01-30 16:36:02',5,'','','','nickname','',0,''),(33,'jinlongl','91c4a37555bd651b3c5ed7ea0b471963','Jinlong','Li','jinlongl','jinlongl',0,'jinlong.li@ssec.wisc.edu','http://','','','','2006-01-31 16:55:43',5,'','','','nickname','',0,''),(36,'waynef','b5a6b913367b23c44e1b432948ddcf9e','Wayne','Feltz','waynef','waynef',0,'waynef@ssec.wisc.edu','http://','','','','2007-01-19 20:29:42',5,'','','','nickname','',0,''),(35,'lkjernes','05e08121adad202f1c76732613e31f16','Lynn','Kjernes','lkjernes','lkjernes',0,'lmkjernes@wisc.edu','http://','','','','2006-06-07 18:11:24',0,'','','','nickname','',0,''),(37,'joleenf','c32601e10d4fefa19c108602eab83934','Joleen','Feltz','joleenf','joleenf',0,'joleen.feltz@ssec.wisc.edu','http://','','','','2010-04-01 15:05:17',9,'','','','nickname','',0,'');
/*!40000 ALTER TABLE `wp_users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Dumping routines for database 'goesr_blog'
--
DELIMITER ;;
DELIMITER ;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2011-05-30 23:02:12
